(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1800947,      29083]
NotebookOptionsPosition[   1783069,      28773]
NotebookOutlinePosition[   1800913,      29081]
CellTagsIndexPosition[   1800870,      29078]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[{
 RowBox[{
  RowBox[{"eye", "=", " ", 
   RowBox[{"EyeModel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"focus", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"focus", ",", "0"}], "}"}], ",", "30", ",", "5", ",", 
     RowBox[{"PupilData", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"10", ",", ".05"}], "}"}]}], ",", 
     RowBox[{"Resonate", "\[Rule]", "False"}], ",", 
     RowBox[{"Transmittance", "\[Rule]", "0"}], ",", 
     RowBox[{"CrossRendering", "\[Rule]", "Trace"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ManipulateSystem", "[", 
  RowBox[{
   RowBox[{"{", "\n", "\t", 
    RowBox[{
     RowBox[{"Move", "[", 
      RowBox[{
       RowBox[{"LineOfRays", "[", 
        RowBox[{"3", ",", 
         RowBox[{"NumberOfRays", "\[Rule]", "11"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"-", "5"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "0"}], "}"}]}], "]"}], ",", "eye"}], "}"}], ",", 
   "\n", "\t", 
   RowBox[{"Grid", "[", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"DynamicFrame", "[", 
        RowBox[{
         RowBox[{"PlotType", "->", "TopView"}], ",", 
         RowBox[{"PlotLabel", "\[Rule]", "\"\<Eye Model\>\""}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], ",", 
       RowBox[{"DynamicFrame", "[", 
        RowBox[{
         RowBox[{"PlotType", "\[Rule]", "Full3D"}], ",", 
         RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}]}], "}"}], "}"}], 
    "]"}], ",", 
   RowBox[{"Deployed", "\[Rule]", "False"}], ",", 
   RowBox[{"OutputType", "\[Rule]", "Notebook"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.434936150077825*^9, 3.434936180774835*^9}, {
  3.43493642366998*^9, 3.434936429455481*^9}}],

Cell[CellGroupData[{

Cell["\<\
Manipulate[
 Column[
  {Grid[{{OpenerView[{ToString[TopView], Show[{Graphics[{{Opacity[0.8], \
staticpolygons11230200811523132827920, staticpolygons12230200811523132833440, \

             staticpolygons13230200811523132837510, \
staticpolygons14230200811523132845095, staticpolygons15230200811523132847446, \

             staticpolygons16230200811523132852836, \
staticpolygons17230200811523132856751, staticpolygons18230200811523132905507, \
Opacity[1], 
             RGBColor[0.038747429704798886, 0.9161617552424038, \
0.039847212269181365], AbsoluteThickness[Medium], 
             Line[Dynamic[Refresh[({#1[[{1, 2}]], #1[[{4, 5}]]} & ) /@ \
Select[raytracefunction1230200811523132919248[th, x, y, focus], 
                  Length[#1] == 6 && #1[[1]] > -9.87654321*^8 & ], \
TrackedSymbols :> {th, x, y, focus}], SynchronousUpdating -> True]], 
             Arrowheads[Large], Thickness[Large], Dashing[{Small, Small}], \
RGBColor[1, 1, 0], 
             Arrow[Dynamic[If[laststartposth != {x, y} || lastth =!= th, \
laststartposth = {x, y}; lastth = th; {xth, yth} = laststartposth + 
                    radiusth*{Cos[th*Degree], Sin[th*Degree]}]; \
{laststartposth, {xth, yth}}, ({laststartposth, {xth, yth}} = #1) & ]], 
             Tooltip[Locator[Dynamic[BesselJ[1., 3.]; (If[{xth, yth} != \
lastlocposth || lastth != th, lastlocposth = {xth, yth}; lastth = th; 
                    {xth, yth} = laststartposth + radiusth*{Cos[th*Degree], \
Sin[th*Degree]}]; {xth, yth}), ({xth, yth} = #1; xoffth = xth - x; 
                  yoffth = yth - y; radiusth = Sqrt[xoffth^2 + yoffth^2]; th \
= Chop[ArcTan[xoffth, yoffth]/Degree]; {xth, yth}) & ], Graphics[
                {RGBColor[1/3, 1/3, 1], Disk[{0, 0}, 0.5]}, ImageSize -> \
10]], Dynamic[StringJoin[\"th = \", ToString[th]]]], 
             Tooltip[Locator[Dynamic[BesselJ[1., 3.]; {x, y}, ({x, y} = \
Chop[#1]) & ], Graphics[{RGBColor[1, 1/3, 1/3], Disk[{0, 0}, 0.8]}, 
                ImageSize -> 10]], Dynamic[StringJoin[\"{x, y} = \", \
ToString[Chop[{x, y}]]]]]}}]}, {PlotLabel -> \"Eye Model\", ImageSize -> 400, \

          ImageSize -> 800, AspectRatio -> Automatic}]}, True], 
      OpenerView[{ToString[Full3D], Show[{Graphics3D[{{Opacity[1], \
staticpolygons2123020081152326925122, staticpolygons2223020081152326930050, 
             staticpolygons2323020081152326934944, \
staticpolygons2423020081152326944061, staticpolygons2523020081152326945592, 
             staticpolygons2623020081152326970402, \
staticpolygons2723020081152326975689, staticpolygons2823020081152327012047, \
Opacity[1], 
             RGBColor[0.038747429704798886, 0.9161617552424038, \
0.039847212269181365], AbsoluteThickness[Medium], 
             Line[Dynamic[Refresh[({#1[[{1, 2, 3}]], #1[[{4, 5, 6}]]} & ) /@ \
Select[raytracefunction223020081152327020446[th, x, y, focus], 
                  Length[#1] == 6 && #1[[1]] > -9.87654321*^8 & ], \
TrackedSymbols :> {th, x, y, focus}], SynchronousUpdating -> True]]}}]}, 
         {PlotLabel -> None, ImageSize -> 400, ImageSize -> 800, AspectRatio \
-> Automatic}]}, True]}}], 
   Tooltip[Row[{Style[\"\", Italic, 10], Hyperlink[Style[\"<< Crafted with \
Optica\[Trademark] >>\", Italic, 10], \"http://www.opticasoftware.com\"], 
      Style[\"\", Italic, 10]}], \"Click here to visit www.opticasoftware.com\
\"]}, Center], {{th, 0.}, -180., 180., ControlType -> None}, 
 {{x, -5.}, -10, -0.05, ControlType -> None}, {{y, 0.}, -10, 10, ControlType \
-> None}, {{focus, 0}, -10, 10, ControlType -> None}, 
 Style[Grid[{{\"focus\", InputField[Dynamic[minfocus], Number, FieldSize -> \
5], 
     Manipulator[Dynamic[nonexistantvariable1593230200811523213626529; focus, \
(focus = #1) & ], {Dynamic[minfocus], Dynamic[maxfocus]}, 
      ImageSize -> 800], InputField[Dynamic[maxfocus], Number, FieldSize -> \
5], Dynamic[nonexistantvariable1593230200811523213626529; focus, 
      (focus = #1) & ]}}]], {{minfocus, -10}, ControlType -> None}, \
{{maxfocus, 10}, ControlType -> None}, {{minth, -180.}, ControlType -> None}, \

 {{maxth, 180.}, ControlType -> None}, {{minx, -10}, ControlType -> None}, \
{{maxx, -0.05}, ControlType -> None}, {{miny, -10}, ControlType -> None}, 
 {{maxy, 10}, ControlType -> None}, 
 Button[\"Report\", Print[InputForm[StringJoin[\"SymbolicValues -> \", \
ToString[MapThread[StringJoin[#1, \"->\", ToString[#2, InputForm]] & , 
       {{\"focus\", \"th\", \"x\", \"y\"}, {focus, th, x, y}}]]]]], ImageSize \
-> Automatic], {{xth, -4.4019925}, ControlType -> None}, 
 {{yth, 0.}, ControlType -> None}, {{radiusth, 0.5980074999999999}, \
ControlType -> None}, {{xoffth, 0.5980074999999999}, ControlType -> None}, 
 {{yoffth, 0.}, ControlType -> None}, {{laststartposth, {-5., 0.}}, \
ControlType -> None}, {{lastlocposth, {-4.4019925, 0.}}, ControlType -> \
None}, 
 {{lastth, 0}, ControlType -> None}, {{staticpolygons11230200811523132827920, \
{GrayLevel[0], AbsoluteThickness[0.5], 
    Line[{{{-0.654121133468629, -6.25}, {-1.6633250356081046, \
-5.208333333333334}, {-2.407409854982819, -4.166666666666667}, 
       {-2.9470796165773505, -3.1250000000000004}, {-3.3150010468778817, \
-2.083333333333334}, {-3.5294851698846217, -1.0416666666666679}, 
       {-3.5999999999999996, -8.881784197001252*^-16}, {-3.529485169884622, \
1.041666666666666}, {-3.315001046877882, 2.083333333333332}, 
       {-2.947079616577352, 3.1249999999999982}, {-2.40740985498282, \
4.166666666666664}, {-1.6633250356081057, 5.208333333333332}, 
       {-0.6541211334686317, 6.249999999999998}, {-0.654121133468629, 6.25}, \
{-1.6633250356081046, 5.208333333333334}, 
       {-2.407409854982819, 4.166666666666667}, {-2.9470796165773505, \
3.1250000000000004}, {-3.3150010468778817, 2.083333333333334}, 
       {-3.5294851698846217, 1.0416666666666679}, {-3.5999999999999996, \
8.881784197001252*^-16}, {-3.529485169884622, -1.041666666666666}, 
       {-3.315001046877882, -2.083333333333332}, {-2.947079616577352, \
-3.1249999999999982}, {-2.40740985498282, -4.166666666666664}, 
       {-1.6633250356081057, -5.208333333333332}, {-0.6541211334686317, \
-6.249999999999998}, {-0.654121133468629, -6.25}}}]}}, ControlType -> None}, 
 {{staticpolygons12230200811523132833440, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{-0.7033119314590373, -5.}, {-1.538876515698588, \
-4.166666666666667}, {-2.1302230142610687, -3.3333333333333335}, {-2.55, \
-2.5}, 
       {-2.8326922749902543, -1.666666666666667}, {-2.9963598686045723, \
-0.8333333333333339}, {-3.05, 0.}, {-2.9963598686045723, 0.833333333333333}, 
       {-2.8326922749902543, 1.666666666666666}, {-2.5500000000000007, \
2.499999999999999}, {-2.1302230142610696, 3.333333333333332}, 
       {-1.5388765156985889, 4.166666666666666}, {-0.7033119314590373, 5.}, \
{-0.7033119314590373, 5.}, {-1.538876515698588, 4.166666666666667}, 
       {-2.1302230142610687, 3.3333333333333335}, {-2.55, 2.5}, \
{-2.8326922749902543, 1.666666666666667}, {-2.9963598686045723, \
0.8333333333333339}, 
       {-3.05, 0.}, {-2.9963598686045723, -0.833333333333333}, \
{-2.8326922749902543, -1.666666666666666}, {-2.5500000000000007, \
-2.499999999999999}, 
       {-2.1302230142610696, -3.333333333333332}, {-1.5388765156985889, \
-4.166666666666666}, {-0.7033119314590373, -5.}, 
       {-0.7033119314590373, -5.}}}]}}, ControlType -> None}, 
 {{staticpolygons13230200811523132837510, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{-0.05, -2.5}, {-0.05, -2.0833333333333335}, {-0.05, \
-1.6666666666666667}, {-0.05, -1.25}, {-0.05, -0.8333333333333335}, 
       {-0.05, -0.41666666666666696}, {-0.05, 0.}, {-0.05, \
0.4166666666666665}, {-0.05, 0.833333333333333}, {-0.05, 1.2499999999999996}, \

       {-0.05, 1.666666666666666}, {-0.05, 2.083333333333333}, {-0.05, 2.5}, \
{-0.05, 2.5}, {-0.05, 2.0833333333333335}, {-0.05, 1.6666666666666667}, 
       {-0.05, 1.25}, {-0.05, 0.8333333333333335}, {-0.05, \
0.41666666666666696}, {-0.05, 0.}, {-0.05, -0.4166666666666665}, 
       {-0.05, -0.833333333333333}, {-0.05, -1.2499999999999996}, {-0.05, \
-1.666666666666666}, {-0.05, -2.083333333333333}, {-0.05, -2.5}, 
       {-0.05, -2.5}}}]}}, ControlType -> None}, 
 {{staticpolygons14230200811523132845095, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{-0.05, -5.}, {-0.05, -4.791666666666667}, {-0.05, \
-4.583333333333333}, {-0.05, -4.375}, {-0.05, -4.166666666666667}, 
       {-0.05, -3.9583333333333335}, {-0.05, -3.75}, {-0.05, \
-3.541666666666667}, {-0.05, -3.3333333333333335}, {-0.05, -3.125}, 
       {-0.05, -2.916666666666667}, {-0.05, -2.7083333333333335}, {-0.05, \
-2.5}, {-0.05, -2.5}, {-0.05, -2.7083333333333335}, 
       {-0.05, -2.9166666666666665}, {-0.05, -3.125}, {-0.05, \
-3.333333333333333}, {-0.05, -3.5416666666666665}, {-0.05, -3.75}, 
       {-0.05, -3.958333333333333}, {-0.05, -4.166666666666666}, {-0.05, \
-4.375}, {-0.05, -4.583333333333333}, {-0.05, -4.791666666666666}, 
       {-0.05, -5.}, {-0.05, -5.}}, {{-0.05, 2.5}, {-0.05, \
2.7083333333333335}, {-0.05, 2.9166666666666665}, {-0.05, 3.125}, 
       {-0.05, 3.333333333333333}, {-0.05, 3.5416666666666665}, {-0.05, \
3.75}, {-0.05, 3.958333333333333}, {-0.05, 4.166666666666666}, 
       {-0.05, 4.375}, {-0.05, 4.583333333333333}, {-0.05, \
4.791666666666666}, {-0.05, 5.}, {-0.05, 5.}, {-0.05, 4.791666666666667}, 
       {-0.05, 4.583333333333333}, {-0.05, 4.375}, {-0.05, \
4.166666666666667}, {-0.05, 3.9583333333333335}, {-0.05, 3.75}, 
       {-0.05, 3.541666666666667}, {-0.05, 3.3333333333333335}, {-0.05, \
3.125}, {-0.05, 2.916666666666667}, {-0.05, 2.7083333333333335}, 
       {-0.05, 2.5}, {-0.05, 2.5}}}]}}, ControlType -> None}, \
{{staticpolygons15230200811523132847446, {}}, ControlType -> None}, 
 {{staticpolygons16230200811523132852836, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{1.3689976525819987, -5.65}, {0.9852549276396352, \
-4.708333333333334}, {0.6511727483615684, -3.766666666666667}, 
       {0.3764030171799524, -2.825}, {0.17082082737962523, \
-1.8833333333333337}, {0.043271803862861, -0.9416666666666673}, {0., 0.}, 
       {0.04327180386286091, 0.9416666666666664}, {0.17082082737962506, \
1.8833333333333329}, {0.3764030171799522, 2.8249999999999993}, 
       {0.6511727483615678, 3.7666666666666657}, {0.9852549276396345, \
4.708333333333332}, {1.3689976525819987, 5.65}, {1.3689976525819987, 5.65}, 
       {0.9852549276396352, 4.708333333333334}, {0.6511727483615684, \
3.766666666666667}, {0.3764030171799524, 2.825}, 
       {0.17082082737962523, 1.8833333333333337}, {0.043271803862861, \
0.9416666666666673}, {0., 0.}, {0.04327180386286091, -0.9416666666666664}, 
       {0.17082082737962506, -1.8833333333333329}, {0.3764030171799522, \
-2.8249999999999993}, {0.6511727483615678, -3.7666666666666657}, 
       {0.9852549276396345, -4.708333333333332}, {1.3689976525819987, -5.65}, \
{1.3689976525819987, -5.65}}}]}}, ControlType -> None}, 
 {{staticpolygons17230200811523132856751, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{1.3397916666666667, -5.65}, {2.1526331018518516, \
-4.708333333333334}, {2.817685185185185, -3.766666666666667}, 
       {3.3349479166666667, -2.825}, {3.7044212962962964, \
-1.8833333333333337}, {3.926105324074074, -0.9416666666666673}, {4., 0.}, 
       {3.926105324074074, 0.9416666666666664}, {3.7044212962962964, \
1.8833333333333329}, {3.334947916666667, 2.8249999999999993}, 
       {2.817685185185186, 3.7666666666666657}, {2.152633101851853, \
4.708333333333332}, {1.3397916666666667, 5.65}, {1.3397916666666667, 5.65}, 
       {2.1526331018518516, 4.708333333333334}, {2.817685185185185, \
3.766666666666667}, {3.3349479166666667, 2.825}, 
       {3.7044212962962964, 1.8833333333333337}, {3.926105324074074, \
0.9416666666666673}, {4., 0.}, {3.926105324074074, -0.9416666666666664}, 
       {3.7044212962962964, -1.8833333333333329}, {3.334947916666667, \
-2.8249999999999993}, {2.817685185185186, -3.7666666666666657}, 
       {2.152633101851853, -4.708333333333332}, {1.3397916666666667, -5.65}, \
{1.3397916666666667, -5.65}}}]}}, ControlType -> None}, 
 {{staticpolygons18230200811523132905507, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{9.414603431411972, -11.95}, {12.208840053799115, -11.3525}, \
{13.642891004388748, -10.754999999999999}, 
       {14.709759581999093, -10.157499999999999}, {15.573326954313629, \
-9.559999999999999}, {16.299873531837402, -8.962499999999999}, 
       {16.924181391558115, -8.364999999999998}, {17.46720897243435, \
-7.767499999999999}, {17.942726928795043, -7.169999999999999}, 
       {18.360332059211764, -6.572499999999999}, {18.726998563905845, \
-5.974999999999999}, {19.04795089616548, -5.377499999999999}, 
       {19.327188752049782, -4.779999999999999}, {19.567819448749578, \
-4.182499999999999}, {19.772276903574333, -3.584999999999999}, 
       {19.942470354542216, -2.987499999999999}, {20.079887577802207, \
-2.389999999999999}, {20.18566740897643, -1.7924999999999986}, 
       {20.260650706742243, -1.1949999999999985}, {20.305415508412924, \
-0.5974999999999984}, {20.3203, 1.7763568394002505*^-15}, 
       {20.305415508412924, 0.5975000000000019}, {20.260650706742243, \
1.195000000000002}, {20.18566740897643, 1.7925000000000022}, 
       {20.079887577802207, 2.3900000000000006}, {19.942470354542216, \
2.9875000000000007}, {19.772276903574333, 3.585000000000001}, 
       {19.567819448749574, 4.182500000000001}, {19.32718875204978, \
4.780000000000001}, {19.047950896165478, 5.377500000000001}, 
       {18.726998563905845, 5.975000000000001}, {18.360332059211764, \
6.572500000000002}, {17.94272692879504, 7.170000000000002}, 
       {17.46720897243435, 7.767500000000002}, {16.924181391558115, \
8.365000000000002}, {16.2998735318374, 8.962500000000002}, 
       {15.573326954313622, 9.560000000000002}, {14.709759581999087, \
10.157500000000002}, {13.64289100438874, 10.755000000000003}, 
       {12.208840053799104, 11.352500000000003}, {9.414603431411933, \
11.950000000000003}, {9.414603431411972, 11.95}, {12.208840053799115, \
11.3525}, 
       {13.642891004388748, 10.754999999999999}, {14.709759581999093, \
10.157499999999999}, {15.573326954313629, 9.559999999999999}, 
       {16.299873531837402, 8.962499999999999}, {16.924181391558115, \
8.364999999999998}, {17.46720897243435, 7.767499999999999}, 
       {17.942726928795043, 7.169999999999999}, {18.360332059211764, \
6.572499999999999}, {18.726998563905845, 5.974999999999999}, 
       {19.04795089616548, 5.377499999999999}, {19.327188752049782, \
4.779999999999999}, {19.567819448749578, 4.182499999999999}, 
       {19.772276903574333, 3.584999999999999}, {19.942470354542216, \
2.987499999999999}, {20.079887577802207, 2.389999999999999}, 
       {20.18566740897643, 1.7924999999999986}, {20.260650706742243, \
1.1949999999999985}, {20.305415508412924, 0.5974999999999984}, 
       {20.3203, -1.7763568394002505*^-15}, {20.305415508412924, \
-0.5975000000000019}, {20.260650706742243, -1.195000000000002}, 
       {20.18566740897643, -1.7925000000000022}, {20.079887577802207, \
-2.3900000000000006}, {19.942470354542216, -2.9875000000000007}, 
       {19.772276903574333, -3.585000000000001}, {19.567819448749574, \
-4.182500000000001}, {19.32718875204978, -4.780000000000001}, 
       {19.047950896165478, -5.377500000000001}, {18.726998563905845, \
-5.975000000000001}, {18.360332059211764, -6.572500000000002}, 
       {17.94272692879504, -7.170000000000002}, {17.46720897243435, \
-7.767500000000002}, {16.924181391558115, -8.365000000000002}, 
       {16.2998735318374, -8.962500000000002}, {15.573326954313622, \
-9.560000000000002}, {14.709759581999087, -10.157500000000002}, 
       {13.64289100438874, -10.755000000000003}, {12.208840053799104, \
-11.352500000000003}, {9.414603431411933, -11.950000000000003}, 
       {9.414603431411972, -11.95}}}]}}, ControlType -> None}, 
 {{staticpolygons2123020081152326925122, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{-0.654121133468629, -6.25, 0.}, {-1.6633250356081046, \
-5.208333333333334, 0.}, {-2.407409854982819, -4.166666666666667, 0.}, 
       {-2.9470796165773505, -3.1250000000000004, 0.}, {-3.3150010468778817, \
-2.083333333333334, 0.}, {-3.5294851698846217, -1.0416666666666679, 0.}, 
       {-3.5999999999999996, -8.881784197001252*^-16, 0.}, \
{-3.529485169884622, 1.041666666666666, 0.}, {-3.315001046877882, \
2.083333333333332, 0.}, 
       {-2.947079616577352, 3.1249999999999982, 0.}, {-2.40740985498282, \
4.166666666666664, 0.}, {-1.6633250356081057, 5.208333333333332, 0.}, 
       {-0.6541211334686317, 6.249999999999998, 0.}, {-0.654121133468629, \
6.25, 0.}, {-1.6633250356081046, 5.208333333333334, 0.}, 
       {-2.407409854982819, 4.166666666666667, 0.}, {-2.9470796165773505, \
3.1250000000000004, 0.}, {-3.3150010468778817, 2.083333333333334, 0.}, 
       {-3.5294851698846217, 1.0416666666666679, 0.}, {-3.5999999999999996, \
8.881784197001252*^-16, 0.}, 
       {-3.529485169884622, -1.041666666666666, 0.}, {-3.315001046877882, \
-2.083333333333332, 0.}, {-2.947079616577352, -3.1249999999999982, 0.}, 
       {-2.40740985498282, -4.166666666666664, 0.}, {-1.6633250356081057, \
-5.208333333333332, 0.}, {-0.6541211334686317, -6.249999999999998, 0.}, 
       {-0.654121133468629, -6.25, 0.}}, {{-0.654121133468629, 0., -6.25}, \
{-1.6633250356081046, 0., -5.208333333333334}, 
       {-2.407409854982819, 0., -4.166666666666667}, {-2.9470796165773505, \
0., -3.1250000000000004}, {-3.3150010468778817, 0., -2.083333333333334}, 
       {-3.5294851698846217, 0., -1.0416666666666679}, {-3.5999999999999996, \
0., -8.881784197001252*^-16}, 
       {-3.529485169884622, 0., 1.041666666666666}, {-3.315001046877882, 0., \
2.083333333333332}, {-2.947079616577352, 0., 3.1249999999999982}, 
       {-2.40740985498282, 0., 4.166666666666664}, {-1.6633250356081057, 0., \
5.208333333333332}, {-0.6541211334686317, 0., 6.249999999999998}, 
       {-0.654121133468629, 0., 6.25}, {-1.6633250356081046, 0., \
5.208333333333334}, {-2.407409854982819, 0., 4.166666666666667}, 
       {-2.9470796165773505, 0., 3.1250000000000004}, {-3.3150010468778817, \
0., 2.083333333333334}, {-3.5294851698846217, 0., 1.0416666666666679}, 
       {-3.5999999999999996, 0., 8.881784197001252*^-16}, \
{-3.529485169884622, 0., -1.041666666666666}, {-3.315001046877882, 0., \
-2.083333333333332}, 
       {-2.947079616577352, 0., -3.1249999999999982}, {-2.40740985498282, 0., \
-4.166666666666664}, {-1.6633250356081057, 0., -5.208333333333332}, 
       {-0.6541211334686317, 0., -6.249999999999998}, {-0.654121133468629, \
0., -6.25}}, {{-0.654121133468629, 6.25, 0.}, 
       {-0.6541211334686294, 6.196530383586315, 0.8157887013753223}, \
{-0.6541211334686303, 6.037036414306677, 1.6176190318907546}, 
       {-0.654121133468629, 5.774247078195542, 2.391771452281811}, \
{-0.654121133468629, 5.412658773652742, 3.125}, 
       {-0.654121133468629, 4.958458376820221, 3.8047589313045034}, \
{-0.6541211334686308, 4.419417382415921, 4.419417382415922}, 
       {-0.654121133468629, 3.8047589313045043, 4.95845837682022}, \
{-0.654121133468629, 3.125000000000001, 5.412658773652741}, 
       {-0.654121133468629, 2.3917714522818114, 5.774247078195542}, \
{-0.6541211334686294, 1.617619031890756, 6.037036414306677}, 
       {-0.6541211334686294, 0.8157887013753232, 6.196530383586315}, \
{-0.654121133468629, 3.827021247335479*^-16, 6.25}, 
       {-0.654121133468629, -0.8157887013753211, 6.196530383586316}, \
{-0.6541211334686303, -1.617619031890754, 6.037036414306677}, 
       {-0.6541211334686303, -2.391771452281809, 5.774247078195542}, \
{-0.6541211334686294, -3.124999999999999, 5.412658773652742}, 
       {-0.654121133468629, -3.804758931304502, 4.9584583768202215}, \
{-0.6541211334686308, -4.419417382415921, 4.419417382415922}, 
       {-0.654121133468629, -4.958458376820219, 3.8047589313045056}, \
{-0.6541211334686299, -5.41265877365274, 3.125000000000002}, 
       {-0.654121133468629, -5.774247078195542, 2.391771452281812}, \
{-0.6541211334686294, -6.037036414306677, 1.6176190318907564}, 
       {-0.654121133468629, -6.196530383586315, 0.8157887013753251}, \
{-0.654121133468629, -6.25, 7.654042494670958*^-16}, 
       {-0.654121133468629, -6.196530383586316, -0.8157887013753208}, \
{-0.6541211334686294, -6.0370364143066775, -1.6176190318907522}, 
       {-0.6541211334686294, -5.774247078195543, -2.391771452281808}, \
{-0.6541211334686294, -5.412658773652742, -3.1249999999999987}, 
       {-0.654121133468629, -4.9584583768202215, -3.804758931304502}, \
{-0.6541211334686294, -4.419417382415924, -4.4194173824159195}, 
       {-0.654121133468629, -3.8047589313045056, -4.958458376820219}, \
{-0.6541211334686299, -3.1250000000000027, -5.41265877365274}, 
       {-0.6541211334686299, -2.3917714522818145, -5.774247078195541}, \
{-0.654121133468629, -1.6176190318907595, -6.037036414306676}, 
       {-0.6541211334686299, -0.8157887013753282, -6.196530383586314}, \
{-0.654121133468629, -1.1481063742006436*^-15, -6.25}, 
       {-0.6541211334686294, 0.8157887013753204, -6.196530383586316}, \
{-0.6541211334686294, 1.6176190318907517, -6.0370364143066775}, 
       {-0.6541211334686294, 2.3917714522818074, -5.774247078195543}, \
{-0.654121133468629, 3.124999999999996, -5.412658773652744}, 
       {-0.654121133468629, 3.8047589313044994, -4.958458376820223}, \
{-0.654121133468629, 4.419417382415921, -4.419417382415923}, 
       {-0.6541211334686294, 4.958458376820218, -3.804758931304506}, \
{-0.6541211334686299, 5.41265877365274, -3.1250000000000027}, 
       {-0.6541211334686294, 5.774247078195541, -2.391771452281815}, \
{-0.654121133468629, 6.037036414306676, -1.6176190318907597}, 
       {-0.6541211334686299, 6.196530383586314, -0.8157887013753286}, \
{-0.654121133468629, 6.25, -1.5308084989341915*^-15}}}]}}, 
  ControlType -> None}, {{staticpolygons2223020081152326930050, \
{GrayLevel[0], AbsoluteThickness[0.5], 
    Line[{{{-0.7033119314590373, -5., 0.}, {-1.538876515698588, \
-4.166666666666667, 0.}, {-2.1302230142610687, -3.3333333333333335, 0.}, 
       {-2.55, -2.5, 0.}, {-2.8326922749902543, -1.666666666666667, 0.}, \
{-2.9963598686045723, -0.8333333333333339, 0.}, {-3.05, 0., 0.}, 
       {-2.9963598686045723, 0.833333333333333, 0.}, {-2.8326922749902543, \
1.666666666666666, 0.}, {-2.5500000000000007, 2.499999999999999, 0.}, 
       {-2.1302230142610696, 3.333333333333332, 0.}, {-1.5388765156985889, \
4.166666666666666, 0.}, {-0.7033119314590373, 5., 0.}, 
       {-0.7033119314590373, 5., 0.}, {-1.538876515698588, 4.166666666666667, \
0.}, {-2.1302230142610687, 3.3333333333333335, 0.}, {-2.55, 2.5, 0.}, 
       {-2.8326922749902543, 1.666666666666667, 0.}, {-2.9963598686045723, \
0.8333333333333339, 0.}, {-3.05, 0., 0.}, 
       {-2.9963598686045723, -0.833333333333333, 0.}, {-2.8326922749902543, \
-1.666666666666666, 0.}, {-2.5500000000000007, -2.499999999999999, 0.}, 
       {-2.1302230142610696, -3.333333333333332, 0.}, {-1.5388765156985889, \
-4.166666666666666, 0.}, {-0.7033119314590373, -5., 0.}, 
       {-0.7033119314590373, -5., 0.}}, {{-0.7033119314590373, 0., -5.}, \
{-1.538876515698588, 0., -4.166666666666667}, 
       {-2.1302230142610687, 0., -3.3333333333333335}, {-2.55, 0., -2.5}, \
{-2.8326922749902543, 0., -1.666666666666667}, 
       {-2.9963598686045723, 0., -0.8333333333333339}, {-3.05, 0., 0.}, \
{-2.9963598686045723, 0., 0.833333333333333}, 
       {-2.8326922749902543, 0., 1.666666666666666}, {-2.5500000000000007, \
0., 2.499999999999999}, {-2.1302230142610696, 0., 3.333333333333332}, 
       {-1.5388765156985889, 0., 4.166666666666666}, {-0.7033119314590373, \
0., 5.}, {-0.7033119314590373, 0., 5.}, 
       {-1.538876515698588, 0., 4.166666666666667}, {-2.1302230142610687, 0., \
3.3333333333333335}, {-2.55, 0., 2.5}, 
       {-2.8326922749902543, 0., 1.666666666666667}, {-2.9963598686045723, \
0., 0.8333333333333339}, {-3.05, 0., 0.}, 
       {-2.9963598686045723, 0., -0.833333333333333}, {-2.8326922749902543, \
0., -1.666666666666666}, {-2.5500000000000007, 0., -2.499999999999999}, 
       {-2.1302230142610696, 0., -3.333333333333332}, {-1.5388765156985889, \
0., -4.166666666666666}, {-0.7033119314590373, 0., -5.}, 
       {-0.7033119314590373, 0., -5.}}, {{-0.7033119314590373, 5., 0.}, \
{-0.7033119314590373, 4.957224306869052, 0.6526309611002579}, 
       {-0.7033119314590373, 4.8296291314453415, 1.2940952255126037}, \
{-0.7033119314590373, 4.619397662556434, 1.913417161825449}, 
       {-0.7033119314590373, 4.330127018922194, 2.5}, {-0.7033119314590373, \
3.9667667014561765, 3.0438071450436026}, 
       {-0.7033119314590373, 3.5355339059327373, 3.5355339059327378}, \
{-0.7033119314590373, 3.043807145043603, 3.9667667014561756}, 
       {-0.7033119314590373, 2.5000000000000004, 4.330127018922193}, \
{-0.7033119314590373, 1.9134171618254492, 4.619397662556434}, 
       {-0.7033119314590381, 1.2940952255126048, 4.829629131445341}, \
{-0.7033119314590373, 0.6526309611002585, 4.957224306869052}, 
       {-0.7033119314590373, 3.061616997868383*^-16, 5.}, \
{-0.7033119314590373, -0.6526309611002569, 4.957224306869053}, 
       {-0.7033119314590373, -1.2940952255126033, 4.8296291314453415}, \
{-0.7033119314590373, -1.9134171618254476, 4.619397662556434}, 
       {-0.7033119314590373, -2.499999999999999, 4.330127018922194}, \
{-0.7033119314590373, -3.0438071450436017, 3.966766701456177}, 
       {-0.7033119314590373, -3.5355339059327373, 3.5355339059327378}, \
{-0.7033119314590373, -3.966766701456175, 3.0438071450436044}, 
       {-0.7033119314590373, -4.330127018922192, 2.5000000000000018}, \
{-0.7033119314590373, -4.619397662556434, 1.9134171618254494}, 
       {-0.7033119314590381, -4.829629131445341, 1.294095225512605}, \
{-0.7033119314590373, -4.957224306869052, 0.6526309611002601}, 
       {-0.7033119314590373, -5., 6.123233995736766*^-16}, \
{-0.7033119314590373, -4.957224306869053, -0.6526309611002566}, 
       {-0.7033119314590373, -4.829629131445342, -1.2940952255126017}, \
{-0.7033119314590373, -4.619397662556435, -1.913417161825446}, 
       {-0.7033119314590364, -4.3301270189221945, -2.499999999999999}, \
{-0.7033119314590373, -3.9667667014561774, -3.0438071450436017}, 
       {-0.7033119314590373, -3.5355339059327395, -3.5355339059327355}, \
{-0.7033119314590373, -3.0438071450436044, -3.966766701456175}, 
       {-0.7033119314590373, -2.500000000000002, -4.330127018922192}, \
{-0.7033119314590373, -1.9134171618254516, -4.619397662556432}, 
       {-0.7033119314590373, -1.2940952255126077, -4.829629131445341}, \
{-0.7033119314590373, -0.6526309611002625, -4.957224306869051}, 
       {-0.7033119314590373, -9.184850993605148*^-16, -5.}, \
{-0.7033119314590373, 0.6526309611002563, -4.957224306869053}, 
       {-0.7033119314590373, 1.2940952255126015, -4.829629131445342}, \
{-0.7033119314590373, 1.9134171618254459, -4.619397662556435}, 
       {-0.7033119314590373, 2.4999999999999964, -4.330127018922195}, \
{-0.7033119314590373, 3.0438071450435995, -3.9667667014561787}, 
       {-0.7033119314590373, 3.535533905932737, -3.5355339059327386}, \
{-0.7033119314590373, 3.9667667014561747, -3.043807145043605}, 
       {-0.7033119314590373, 4.330127018922192, -2.500000000000002}, \
{-0.7033119314590373, 4.619397662556432, -1.913417161825452}, 
       {-0.7033119314590373, 4.829629131445341, -1.294095225512608}, \
{-0.7033119314590373, 4.957224306869051, -0.6526309611002629}, 
       {-0.7033119314590373, 5., -1.2246467991473533*^-15}}}]}}, ControlType \
-> None}, 
 {{staticpolygons2323020081152326934944, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{-0.05, -2.5, 0.}, {-0.05, -2.0833333333333335, 0.}, {-0.05, \
-1.6666666666666667, 0.}, {-0.05, -1.25, 0.}, 
       {-0.05, -0.8333333333333335, 0.}, {-0.05, -0.41666666666666696, 0.}, \
{-0.05, 0., 0.}, {-0.05, 0.4166666666666665, 0.}, 
       {-0.05, 0.833333333333333, 0.}, {-0.05, 1.2499999999999996, 0.}, \
{-0.05, 1.666666666666666, 0.}, {-0.05, 2.083333333333333, 0.}, 
       {-0.05, 2.5, 0.}, {-0.05, 2.5, 0.}, {-0.05, 2.0833333333333335, 0.}, \
{-0.05, 1.6666666666666667, 0.}, {-0.05, 1.25, 0.}, 
       {-0.05, 0.8333333333333335, 0.}, {-0.05, 0.41666666666666696, 0.}, \
{-0.05, 0., 0.}, {-0.05, -0.4166666666666665, 0.}, 
       {-0.05, -0.833333333333333, 0.}, {-0.05, -1.2499999999999996, 0.}, \
{-0.05, -1.666666666666666, 0.}, {-0.05, -2.083333333333333, 0.}, 
       {-0.05, -2.5, 0.}, {-0.05, -2.5, 0.}}, {{-0.05, 0., -2.5}, {-0.05, 0., \
-2.0833333333333335}, {-0.05, 0., -1.6666666666666667}, 
       {-0.05, 0., -1.25}, {-0.05, 0., -0.8333333333333335}, {-0.05, 0., \
-0.41666666666666696}, {-0.05, 0., 0.}, {-0.05, 0., 0.4166666666666665}, 
       {-0.05, 0., 0.833333333333333}, {-0.05, 0., 1.2499999999999996}, \
{-0.05, 0., 1.666666666666666}, {-0.05, 0., 2.083333333333333}, 
       {-0.05, 0., 2.5}, {-0.05, 0., 2.5}, {-0.05, 0., 2.0833333333333335}, \
{-0.05, 0., 1.6666666666666667}, {-0.05, 0., 1.25}, 
       {-0.05, 0., 0.8333333333333335}, {-0.05, 0., 0.41666666666666696}, \
{-0.05, 0., 0.}, {-0.05, 0., -0.4166666666666665}, 
       {-0.05, 0., -0.833333333333333}, {-0.05, 0., -1.2499999999999996}, \
{-0.05, 0., -1.666666666666666}, {-0.05, 0., -2.083333333333333}, 
       {-0.05, 0., -2.5}, {-0.05, 0., -2.5}}, {{-0.05, 2.5, 0.}, {-0.05, \
2.478612153434526, 0.32631548055012893}, 
       {-0.05, 2.4148145657226707, 0.6470476127563018}, {-0.05, \
2.309698831278217, 0.9567085809127245}, {-0.05, 2.165063509461097, 1.25}, 
       {-0.05, 1.9833833507280882, 1.5219035725218013}, {-0.05, \
1.7677669529663687, 1.7677669529663689}, 
       {-0.05, 1.5219035725218015, 1.9833833507280878}, {-0.05, \
1.2500000000000002, 2.1650635094610964}, 
       {-0.05, 0.9567085809127246, 2.309698831278217}, {-0.05, \
0.6470476127563024, 2.4148145657226703}, 
       {-0.05, 0.32631548055012927, 2.478612153434526}, {-0.05, \
1.5308084989341916*^-16, 2.5}, {-0.05, -0.32631548055012843, \
2.4786121534345265}, 
       {-0.05, -0.6470476127563016, 2.4148145657226707}, {-0.05, \
-0.9567085809127238, 2.309698831278217}, 
       {-0.05, -1.2499999999999996, 2.165063509461097}, {-0.05, \
-1.5219035725218009, 1.9833833507280885}, 
       {-0.05, -1.7677669529663687, 1.7677669529663689}, {-0.05, \
-1.9833833507280876, 1.5219035725218022}, 
       {-0.05, -2.165063509461096, 1.2500000000000009}, {-0.05, \
-2.309698831278217, 0.9567085809127247}, 
       {-0.05, -2.4148145657226703, 0.6470476127563025}, {-0.05, \
-2.478612153434526, 0.32631548055013004}, {-0.05, -2.5, \
3.061616997868383*^-16}, 
       {-0.05, -2.4786121534345265, -0.3263154805501283}, {-0.05, \
-2.414814565722671, -0.6470476127563008}, 
       {-0.05, -2.3096988312782174, -0.956708580912723}, {-0.05, \
-2.1650635094610973, -1.2499999999999996}, 
       {-0.05, -1.9833833507280887, -1.5219035725218009}, {-0.05, \
-1.7677669529663698, -1.7677669529663678}, 
       {-0.05, -1.5219035725218022, -1.9833833507280876}, {-0.05, \
-1.250000000000001, -2.165063509461096}, 
       {-0.05, -0.9567085809127258, -2.309698831278216}, {-0.05, \
-0.6470476127563038, -2.4148145657226703}, 
       {-0.05, -0.32631548055013126, -2.4786121534345256}, {-0.05, \
-4.592425496802574*^-16, -2.5}, {-0.05, 0.32631548055012816, \
-2.4786121534345265}, 
       {-0.05, 0.6470476127563007, -2.414814565722671}, {-0.05, \
0.9567085809127229, -2.3096988312782174}, 
       {-0.05, 1.2499999999999982, -2.1650635094610977}, {-0.05, \
1.5219035725217998, -1.9833833507280894}, 
       {-0.05, 1.7677669529663684, -1.7677669529663693}, {-0.05, \
1.9833833507280874, -1.5219035725218024}, 
       {-0.05, 2.165063509461096, -1.250000000000001}, {-0.05, \
2.309698831278216, -0.956708580912726}, 
       {-0.05, 2.4148145657226703, -0.647047612756304}, {-0.05, \
2.4786121534345256, -0.32631548055013143}, 
       {-0.05, 2.5, -6.123233995736766*^-16}}}]}}, ControlType -> None}, 
 {{staticpolygons2423020081152326944061, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{-0.05, -5., 0.}, {-0.05, -4.791666666666667, 0.}, {-0.05, \
-4.583333333333333, 0.}, {-0.05, -4.375, 0.}, {-0.05, -4.166666666666667, \
0.}, 
       {-0.05, -3.9583333333333335, 0.}, {-0.05, -3.75, 0.}, {-0.05, \
-3.541666666666667, 0.}, {-0.05, -3.3333333333333335, 0.}, {-0.05, -3.125, \
0.}, 
       {-0.05, -2.916666666666667, 0.}, {-0.05, -2.7083333333333335, 0.}, \
{-0.05, -2.5, 0.}, {-0.05, -2.5, 0.}, {-0.05, -2.7083333333333335, 0.}, 
       {-0.05, -2.9166666666666665, 0.}, {-0.05, -3.125, 0.}, {-0.05, \
-3.333333333333333, 0.}, {-0.05, -3.5416666666666665, 0.}, {-0.05, -3.75, \
0.}, 
       {-0.05, -3.958333333333333, 0.}, {-0.05, -4.166666666666666, 0.}, \
{-0.05, -4.375, 0.}, {-0.05, -4.583333333333333, 0.}, 
       {-0.05, -4.791666666666666, 0.}, {-0.05, -5., 0.}, {-0.05, -5., 0.}}, \
{{-0.05, 2.5, 0.}, {-0.05, 2.7083333333333335, 0.}, 
       {-0.05, 2.9166666666666665, 0.}, {-0.05, 3.125, 0.}, {-0.05, \
3.333333333333333, 0.}, {-0.05, 3.5416666666666665, 0.}, {-0.05, 3.75, 0.}, 
       {-0.05, 3.958333333333333, 0.}, {-0.05, 4.166666666666666, 0.}, \
{-0.05, 4.375, 0.}, {-0.05, 4.583333333333333, 0.}, 
       {-0.05, 4.791666666666666, 0.}, {-0.05, 5., 0.}, {-0.05, 5., 0.}, \
{-0.05, 4.791666666666667, 0.}, {-0.05, 4.583333333333333, 0.}, 
       {-0.05, 4.375, 0.}, {-0.05, 4.166666666666667, 0.}, {-0.05, \
3.9583333333333335, 0.}, {-0.05, 3.75, 0.}, {-0.05, 3.541666666666667, 0.}, 
       {-0.05, 3.3333333333333335, 0.}, {-0.05, 3.125, 0.}, {-0.05, \
2.916666666666667, 0.}, {-0.05, 2.7083333333333335, 0.}, {-0.05, 2.5, 0.}, 
       {-0.05, 2.5, 0.}}, {{-0.05, 0., -5.}, {-0.05, 0., -4.791666666666667}, \
{-0.05, 0., -4.583333333333333}, {-0.05, 0., -4.375}, 
       {-0.05, 0., -4.166666666666667}, {-0.05, 0., -3.9583333333333335}, \
{-0.05, 0., -3.75}, {-0.05, 0., -3.541666666666667}, 
       {-0.05, 0., -3.3333333333333335}, {-0.05, 0., -3.125}, {-0.05, 0., \
-2.916666666666667}, {-0.05, 0., -2.7083333333333335}, {-0.05, 0., -2.5}, 
       {-0.05, 0., -2.5}, {-0.05, 0., -2.7083333333333335}, {-0.05, 0., \
-2.9166666666666665}, {-0.05, 0., -3.125}, {-0.05, 0., -3.333333333333333}, 
       {-0.05, 0., -3.5416666666666665}, {-0.05, 0., -3.75}, {-0.05, 0., \
-3.958333333333333}, {-0.05, 0., -4.166666666666666}, {-0.05, 0., -4.375}, 
       {-0.05, 0., -4.583333333333333}, {-0.05, 0., -4.791666666666666}, \
{-0.05, 0., -5.}, {-0.05, 0., -5.}}, 
      {{-0.05, 0., 2.5}, {-0.05, 0., 2.7083333333333335}, {-0.05, 0., \
2.9166666666666665}, {-0.05, 0., 3.125}, {-0.05, 0., 3.333333333333333}, 
       {-0.05, 0., 3.5416666666666665}, {-0.05, 0., 3.75}, {-0.05, 0., \
3.958333333333333}, {-0.05, 0., 4.166666666666666}, {-0.05, 0., 4.375}, 
       {-0.05, 0., 4.583333333333333}, {-0.05, 0., 4.791666666666666}, \
{-0.05, 0., 5.}, {-0.05, 0., 5.}, {-0.05, 0., 4.791666666666667}, 
       {-0.05, 0., 4.583333333333333}, {-0.05, 0., 4.375}, {-0.05, 0., \
4.166666666666667}, {-0.05, 0., 3.9583333333333335}, {-0.05, 0., 3.75}, 
       {-0.05, 0., 3.541666666666667}, {-0.05, 0., 3.3333333333333335}, \
{-0.05, 0., 3.125}, {-0.05, 0., 2.916666666666667}, 
       {-0.05, 0., 2.7083333333333335}, {-0.05, 0., 2.5}, {-0.05, 0., 2.5}}, \
{{-0.05, 2.5, 0.}, {-0.05, 2.478612153434526, 0.32631548055012893}, 
       {-0.05, 2.4148145657226707, 0.6470476127563018}, {-0.05, \
2.309698831278217, 0.9567085809127245}, {-0.05, 2.165063509461097, 1.25}, 
       {-0.05, 1.9833833507280882, 1.5219035725218013}, {-0.05, \
1.7677669529663687, 1.7677669529663689}, 
       {-0.05, 1.5219035725218015, 1.9833833507280878}, {-0.05, \
1.2500000000000002, 2.1650635094610964}, 
       {-0.05, 0.9567085809127246, 2.309698831278217}, {-0.05, \
0.6470476127563024, 2.4148145657226703}, 
       {-0.05, 0.32631548055012927, 2.478612153434526}, {-0.05, \
1.5308084989341916*^-16, 2.5}, {-0.05, -0.32631548055012843, \
2.4786121534345265}, 
       {-0.05, -0.6470476127563016, 2.4148145657226707}, {-0.05, \
-0.9567085809127238, 2.309698831278217}, 
       {-0.05, -1.2499999999999996, 2.165063509461097}, {-0.05, \
-1.5219035725218009, 1.9833833507280885}, 
       {-0.05, -1.7677669529663687, 1.7677669529663689}, {-0.05, \
-1.9833833507280876, 1.5219035725218022}, 
       {-0.05, -2.165063509461096, 1.2500000000000009}, {-0.05, \
-2.309698831278217, 0.9567085809127247}, 
       {-0.05, -2.4148145657226703, 0.6470476127563025}, {-0.05, \
-2.478612153434526, 0.32631548055013004}, {-0.05, -2.5, \
3.061616997868383*^-16}, 
       {-0.05, -2.4786121534345265, -0.3263154805501283}, {-0.05, \
-2.414814565722671, -0.6470476127563008}, 
       {-0.05, -2.3096988312782174, -0.956708580912723}, {-0.05, \
-2.1650635094610973, -1.2499999999999996}, 
       {-0.05, -1.9833833507280887, -1.5219035725218009}, {-0.05, \
-1.7677669529663698, -1.7677669529663678}, 
       {-0.05, -1.5219035725218022, -1.9833833507280876}, {-0.05, \
-1.250000000000001, -2.165063509461096}, 
       {-0.05, -0.9567085809127258, -2.309698831278216}, {-0.05, \
-0.6470476127563038, -2.4148145657226703}, 
       {-0.05, -0.32631548055013126, -2.4786121534345256}, {-0.05, \
-4.592425496802574*^-16, -2.5}, {-0.05, 0.32631548055012816, \
-2.4786121534345265}, 
       {-0.05, 0.6470476127563007, -2.414814565722671}, {-0.05, \
0.9567085809127229, -2.3096988312782174}, 
       {-0.05, 1.2499999999999982, -2.1650635094610977}, {-0.05, \
1.5219035725217998, -1.9833833507280894}, 
       {-0.05, 1.7677669529663684, -1.7677669529663693}, {-0.05, \
1.9833833507280874, -1.5219035725218024}, 
       {-0.05, 2.165063509461096, -1.250000000000001}, {-0.05, \
2.309698831278216, -0.956708580912726}, 
       {-0.05, 2.4148145657226703, -0.647047612756304}, {-0.05, \
2.4786121534345256, -0.32631548055013143}, {-0.05, 2.5, \
-6.123233995736766*^-16}}, 
      {{-0.05, 5., 0.}, {-0.05, 4.957224306869052, 0.6526309611002579}, \
{-0.05, 4.8296291314453415, 1.2940952255126037}, 
       {-0.05, 4.619397662556434, 1.913417161825449}, {-0.05, \
4.330127018922194, 2.5}, {-0.05, 3.9667667014561765, 3.0438071450436026}, 
       {-0.05, 3.5355339059327373, 3.5355339059327378}, {-0.05, \
3.043807145043603, 3.9667667014561756}, 
       {-0.05, 2.5000000000000004, 4.330127018922193}, {-0.05, \
1.9134171618254492, 4.619397662556434}, 
       {-0.05, 1.2940952255126048, 4.829629131445341}, {-0.05, \
0.6526309611002585, 4.957224306869052}, {-0.05, 3.061616997868383*^-16, 5.}, 
       {-0.05, -0.6526309611002569, 4.957224306869053}, {-0.05, \
-1.2940952255126033, 4.8296291314453415}, 
       {-0.05, -1.9134171618254476, 4.619397662556434}, {-0.05, \
-2.499999999999999, 4.330127018922194}, 
       {-0.05, -3.0438071450436017, 3.966766701456177}, {-0.05, \
-3.5355339059327373, 3.5355339059327378}, 
       {-0.05, -3.966766701456175, 3.0438071450436044}, {-0.05, \
-4.330127018922192, 2.5000000000000018}, 
       {-0.05, -4.619397662556434, 1.9134171618254494}, {-0.05, \
-4.829629131445341, 1.294095225512605}, 
       {-0.05, -4.957224306869052, 0.6526309611002601}, {-0.05, -5., \
6.123233995736766*^-16}, {-0.05, -4.957224306869053, -0.6526309611002566}, 
       {-0.05, -4.829629131445342, -1.2940952255126017}, {-0.05, \
-4.619397662556435, -1.913417161825446}, 
       {-0.05, -4.3301270189221945, -2.499999999999999}, {-0.05, \
-3.9667667014561774, -3.0438071450436017}, 
       {-0.05, -3.5355339059327395, -3.5355339059327355}, {-0.05, \
-3.0438071450436044, -3.966766701456175}, 
       {-0.05, -2.500000000000002, -4.330127018922192}, {-0.05, \
-1.9134171618254516, -4.619397662556432}, 
       {-0.05, -1.2940952255126077, -4.829629131445341}, {-0.05, \
-0.6526309611002625, -4.957224306869051}, {-0.05, -9.184850993605148*^-16, \
-5.}, 
       {-0.05, 0.6526309611002563, -4.957224306869053}, {-0.05, \
1.2940952255126015, -4.829629131445342}, 
       {-0.05, 1.9134171618254459, -4.619397662556435}, {-0.05, \
2.4999999999999964, -4.330127018922195}, 
       {-0.05, 3.0438071450435995, -3.9667667014561787}, {-0.05, \
3.535533905932737, -3.5355339059327386}, 
       {-0.05, 3.9667667014561747, -3.043807145043605}, {-0.05, \
4.330127018922192, -2.500000000000002}, 
       {-0.05, 4.619397662556432, -1.913417161825452}, {-0.05, \
4.829629131445341, -1.294095225512608}, 
       {-0.05, 4.957224306869051, -0.6526309611002629}, {-0.05, 5., \
-1.2246467991473533*^-15}}}]}}, ControlType -> None}, 
 {{staticpolygons2523020081152326945592, {}}, ControlType -> None}, 
 {{staticpolygons2623020081152326970402, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{1.3689976525819987, -5.65, 0.}, {0.9852549276396352, \
-4.708333333333334, 0.}, {0.6511727483615684, -3.766666666666667, 0.}, 
       {0.3764030171799524, -2.825, 0.}, {0.17082082737962523, \
-1.8833333333333337, 0.}, {0.043271803862861, -0.9416666666666673, 0.}, {0., \
0., 0.}, 
       {0.04327180386286091, 0.9416666666666664, 0.}, {0.17082082737962506, \
1.8833333333333329, 0.}, {0.3764030171799522, 2.8249999999999993, 0.}, 
       {0.6511727483615678, 3.7666666666666657, 0.}, {0.9852549276396345, \
4.708333333333332, 0.}, {1.3689976525819987, 5.65, 0.}, 
       {1.3689976525819987, 5.65, 0.}, {0.9852549276396352, \
4.708333333333334, 0.}, {0.6511727483615684, 3.766666666666667, 0.}, 
       {0.3764030171799524, 2.825, 0.}, {0.17082082737962523, \
1.8833333333333337, 0.}, {0.043271803862861, 0.9416666666666673, 0.}, {0., \
0., 0.}, 
       {0.04327180386286091, -0.9416666666666664, 0.}, {0.17082082737962506, \
-1.8833333333333329, 0.}, {0.3764030171799522, -2.8249999999999993, 0.}, 
       {0.6511727483615678, -3.7666666666666657, 0.}, {0.9852549276396345, \
-4.708333333333332, 0.}, {1.3689976525819987, -5.65, 0.}, 
       {1.3689976525819987, -5.65, 0.}}, {{1.3689976525819987, 0., -5.65}, \
{0.9852549276396352, 0., -4.708333333333334}, 
       {0.6511727483615684, 0., -3.766666666666667}, {0.3764030171799524, 0., \
-2.825}, {0.17082082737962523, 0., -1.8833333333333337}, 
       {0.043271803862861, 0., -0.9416666666666673}, {0., 0., 0.}, \
{0.04327180386286091, 0., 0.9416666666666664}, 
       {0.17082082737962506, 0., 1.8833333333333329}, {0.3764030171799522, \
0., 2.8249999999999993}, {0.6511727483615678, 0., 3.7666666666666657}, 
       {0.9852549276396345, 0., 4.708333333333332}, {1.3689976525819987, 0., \
5.65}, {1.3689976525819987, 0., 5.65}, 
       {0.9852549276396352, 0., 4.708333333333334}, {0.6511727483615684, 0., \
3.766666666666667}, {0.3764030171799524, 0., 2.825}, 
       {0.17082082737962523, 0., 1.8833333333333337}, {0.043271803862861, 0., \
0.9416666666666673}, {0., 0., 0.}, 
       {0.04327180386286091, 0., -0.9416666666666664}, {0.17082082737962506, \
0., -1.8833333333333329}, {0.3764030171799522, 0., -2.8249999999999993}, 
       {0.6511727483615678, 0., -3.7666666666666657}, {0.9852549276396345, \
0., -4.708333333333332}, {1.3689976525819987, 0., -5.65}, 
       {1.3689976525819987, 0., -5.65}}, {{1.3689976525819987, 5.65, 0.}, \
{1.3689976525819987, 5.601663466762029, 0.7374729860432915}, 
       {1.3689976525819987, 5.4574809185332365, 1.4623276048292422}, \
{1.3689976525819987, 5.21991935868877, 2.162161392862757}, 
       {1.368997652581999, 4.893043531382079, 2.825}, {1.3689976525819987, \
4.482446372645479, 3.439502073899271}, 
       {1.3689976525819987, 3.9951533137039936, 3.995153313703994}, \
{1.3689976525819987, 3.439502073899272, 4.482446372645479}, 
       {1.3689976525819987, 2.8250000000000006, 4.893043531382078}, \
{1.3689976525819987, 2.1621613928627577, 5.21991935868877}, 
       {1.3689976525819987, 1.4623276048292435, 5.457480918533236}, \
{1.3689976525819987, 0.7374729860432923, 5.601663466762029}, 
       {1.3689976525819987, 3.459627207591273*^-16, 5.65}, \
{1.3689976525819987, -0.7374729860432904, 5.601663466762029}, 
       {1.3689976525819987, -1.4623276048292417, 5.4574809185332365}, \
{1.3689976525819987, -2.162161392862756, 5.219919358688771}, 
       {1.3689976525819987, -2.8249999999999993, 4.893043531382079}, \
{1.3689976525819987, -3.43950207389927, 4.48244637264548}, 
       {1.3689976525819987, -3.9951533137039936, 3.995153313703994}, \
{1.3689976525819987, -4.482446372645478, 3.439502073899273}, 
       {1.3689976525819987, -4.8930435313820775, 2.825000000000002}, \
{1.3689976525819987, -5.21991935868877, 2.162161392862758}, 
       {1.3689976525819987, -5.457480918533236, 1.4623276048292437}, \
{1.3689976525819987, -5.601663466762029, 0.7374729860432939}, 
       {1.3689976525819987, -5.65, 6.919254415182546*^-16}, \
{1.3689976525819987, -5.601663466762029, -0.73747298604329}, 
       {1.368997652581999, -5.457480918533237, -1.4623276048292402}, \
{1.3689976525819987, -5.219919358688772, -2.162161392862754}, 
       {1.3689976525819987, -4.893043531382079, -2.824999999999999}, \
{1.368997652581999, -4.482446372645481, -3.43950207389927}, 
       {1.3689976525819987, -3.995153313703996, -3.9951533137039914}, \
{1.3689976525819987, -3.439502073899273, -4.482446372645478}, 
       {1.3689976525819987, -2.825000000000003, -4.8930435313820775}, \
{1.3689976525819987, -2.1621613928627603, -5.219919358688769}, 
       {1.3689976525819987, -1.4623276048292466, -5.457480918533235}, \
{1.3689976525819987, -0.7374729860432968, -5.601663466762028}, 
       {1.3689976525819987, -1.0378881622773818*^-15, -5.65}, \
{1.3689976525819987, 0.7374729860432897, -5.601663466762029}, 
       {1.368997652581999, 1.4623276048292397, -5.457480918533237}, \
{1.3689976525819987, 2.162161392862754, -5.219919358688772}, 
       {1.368997652581999, 2.8249999999999966, -4.893043531382081}, \
{1.3689976525819987, 3.4395020738992677, -4.482446372645482}, 
       {1.3689976525819987, 3.9951533137039927, -3.9951533137039945}, \
{1.3689976525819987, 4.4824463726454775, -3.439502073899274}, 
       {1.3689976525819987, 4.8930435313820775, -2.825000000000003}, \
{1.3689976525819987, 5.219919358688769, -2.1621613928627608}, 
       {1.3689976525819987, 5.457480918533235, -1.462327604829247}, \
{1.3689976525819987, 5.601663466762028, -0.737472986043297}, 
       {1.3689976525819987, 5.65, -1.3838508830365093*^-15}}}]}}, ControlType \
-> None}, 
 {{staticpolygons2723020081152326975689, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{1.3397916666666667, -5.65, 0.}, {2.1526331018518516, \
-4.708333333333334, 0.}, {2.817685185185185, -3.766666666666667, 0.}, 
       {3.3349479166666667, -2.825, 0.}, {3.7044212962962964, \
-1.8833333333333337, 0.}, {3.926105324074074, -0.9416666666666673, 0.}, {4., \
0., 0.}, 
       {3.926105324074074, 0.9416666666666664, 0.}, {3.7044212962962964, \
1.8833333333333329, 0.}, {3.334947916666667, 2.8249999999999993, 0.}, 
       {2.817685185185186, 3.7666666666666657, 0.}, {2.152633101851853, \
4.708333333333332, 0.}, {1.3397916666666667, 5.65, 0.}, 
       {1.3397916666666667, 5.65, 0.}, {2.1526331018518516, \
4.708333333333334, 0.}, {2.817685185185185, 3.766666666666667, 0.}, 
       {3.3349479166666667, 2.825, 0.}, {3.7044212962962964, \
1.8833333333333337, 0.}, {3.926105324074074, 0.9416666666666673, 0.}, {4., \
0., 0.}, 
       {3.926105324074074, -0.9416666666666664, 0.}, {3.7044212962962964, \
-1.8833333333333329, 0.}, {3.334947916666667, -2.8249999999999993, 0.}, 
       {2.817685185185186, -3.7666666666666657, 0.}, {2.152633101851853, \
-4.708333333333332, 0.}, {1.3397916666666667, -5.65, 0.}, 
       {1.3397916666666667, -5.65, 0.}}, {{1.3397916666666667, 0., -5.65}, \
{2.1526331018518516, 0., -4.708333333333334}, 
       {2.817685185185185, 0., -3.766666666666667}, {3.3349479166666667, 0., \
-2.825}, {3.7044212962962964, 0., -1.8833333333333337}, 
       {3.926105324074074, 0., -0.9416666666666673}, {4., 0., 0.}, \
{3.926105324074074, 0., 0.9416666666666664}, 
       {3.7044212962962964, 0., 1.8833333333333329}, {3.334947916666667, 0., \
2.8249999999999993}, {2.817685185185186, 0., 3.7666666666666657}, 
       {2.152633101851853, 0., 4.708333333333332}, {1.3397916666666667, 0., \
5.65}, {1.3397916666666667, 0., 5.65}, 
       {2.1526331018518516, 0., 4.708333333333334}, {2.817685185185185, 0., \
3.766666666666667}, {3.3349479166666667, 0., 2.825}, 
       {3.7044212962962964, 0., 1.8833333333333337}, {3.926105324074074, 0., \
0.9416666666666673}, {4., 0., 0.}, 
       {3.926105324074074, 0., -0.9416666666666664}, {3.7044212962962964, 0., \
-1.8833333333333329}, {3.334947916666667, 0., -2.8249999999999993}, 
       {2.817685185185186, 0., -3.7666666666666657}, {2.152633101851853, 0., \
-4.708333333333332}, {1.3397916666666667, 0., -5.65}, 
       {1.3397916666666667, 0., -5.65}}, {{1.3397916666666667, 5.65, 0.}, \
{1.3397916666666663, 5.601663466762029, 0.7374729860432915}, 
       {1.3397916666666663, 5.4574809185332365, 1.4623276048292422}, \
{1.3397916666666667, 5.21991935868877, 2.162161392862757}, 
       {1.3397916666666658, 4.893043531382079, 2.825}, {1.3397916666666667, \
4.482446372645479, 3.439502073899271}, 
       {1.3397916666666663, 3.9951533137039936, 3.995153313703994}, \
{1.3397916666666663, 3.439502073899272, 4.482446372645479}, 
       {1.3397916666666667, 2.8250000000000006, 4.893043531382078}, \
{1.3397916666666667, 2.1621613928627577, 5.21991935868877}, 
       {1.3397916666666667, 1.4623276048292435, 5.457480918533236}, \
{1.3397916666666663, 0.7374729860432923, 5.601663466762029}, 
       {1.3397916666666667, 3.459627207591273*^-16, 5.65}, \
{1.3397916666666667, -0.7374729860432904, 5.601663466762029}, 
       {1.3397916666666663, -1.4623276048292417, 5.4574809185332365}, \
{1.3397916666666663, -2.162161392862756, 5.219919358688771}, 
       {1.3397916666666663, -2.8249999999999993, 4.893043531382079}, \
{1.3397916666666667, -3.43950207389927, 4.48244637264548}, 
       {1.3397916666666663, -3.9951533137039936, 3.995153313703994}, \
{1.3397916666666663, -4.482446372645478, 3.439502073899273}, 
       {1.3397916666666667, -4.8930435313820775, 2.825000000000002}, \
{1.3397916666666663, -5.21991935868877, 2.162161392862758}, 
       {1.3397916666666667, -5.457480918533236, 1.4623276048292437}, \
{1.3397916666666663, -5.601663466762029, 0.7374729860432939}, 
       {1.3397916666666667, -5.65, 6.919254415182546*^-16}, \
{1.3397916666666667, -5.601663466762029, -0.73747298604329}, 
       {1.3397916666666658, -5.457480918533237, -1.4623276048292402}, \
{1.3397916666666658, -5.219919358688772, -2.162161392862754}, 
       {1.3397916666666663, -4.893043531382079, -2.824999999999999}, \
{1.3397916666666658, -4.482446372645481, -3.43950207389927}, 
       {1.3397916666666667, -3.995153313703996, -3.9951533137039914}, \
{1.3397916666666663, -3.439502073899273, -4.482446372645478}, 
       {1.3397916666666658, -2.825000000000003, -4.8930435313820775}, \
{1.3397916666666667, -2.1621613928627603, -5.219919358688769}, 
       {1.3397916666666667, -1.4623276048292466, -5.457480918533235}, \
{1.3397916666666667, -0.7374729860432968, -5.601663466762028}, 
       {1.3397916666666667, -1.0378881622773818*^-15, -5.65}, \
{1.3397916666666667, 0.7374729860432897, -5.601663466762029}, 
       {1.3397916666666658, 1.4623276048292397, -5.457480918533237}, \
{1.3397916666666658, 2.162161392862754, -5.219919358688772}, 
       {1.3397916666666658, 2.8249999999999966, -4.893043531382081}, \
{1.3397916666666667, 3.4395020738992677, -4.482446372645482}, 
       {1.3397916666666667, 3.9951533137039927, -3.9951533137039945}, \
{1.3397916666666663, 4.4824463726454775, -3.439502073899274}, 
       {1.3397916666666658, 4.8930435313820775, -2.825000000000003}, \
{1.3397916666666663, 5.219919358688769, -2.1621613928627608}, 
       {1.3397916666666663, 5.457480918533235, -1.462327604829247}, \
{1.3397916666666667, 5.601663466762028, -0.737472986043297}, 
       {1.3397916666666667, 5.65, -1.3838508830365093*^-15}}}]}}, ControlType \
-> None}, 
 {{staticpolygons2823020081152327012047, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{9.414603431411972, -11.95, 0.}, {12.208840053799115, -11.3525, \
0.}, {13.642891004388748, -10.754999999999999, 0.}, 
       {14.709759581999093, -10.157499999999999, 0.}, {15.573326954313629, \
-9.559999999999999, 0.}, {16.299873531837402, -8.962499999999999, 0.}, 
       {16.924181391558115, -8.364999999999998, 0.}, {17.46720897243435, \
-7.767499999999999, 0.}, {17.942726928795043, -7.169999999999999, 0.}, 
       {18.360332059211764, -6.572499999999999, 0.}, {18.726998563905845, \
-5.974999999999999, 0.}, {19.04795089616548, -5.377499999999999, 0.}, 
       {19.327188752049782, -4.779999999999999, 0.}, {19.567819448749578, \
-4.182499999999999, 0.}, {19.772276903574333, -3.584999999999999, 0.}, 
       {19.942470354542216, -2.987499999999999, 0.}, {20.079887577802207, \
-2.389999999999999, 0.}, {20.18566740897643, -1.7924999999999986, 0.}, 
       {20.260650706742243, -1.1949999999999985, 0.}, {20.305415508412924, \
-0.5974999999999984, 0.}, {20.3203, 1.7763568394002505*^-15, 0.}, 
       {20.305415508412924, 0.5975000000000019, 0.}, {20.260650706742243, \
1.195000000000002, 0.}, {20.18566740897643, 1.7925000000000022, 0.}, 
       {20.079887577802207, 2.3900000000000006, 0.}, {19.942470354542216, \
2.9875000000000007, 0.}, {19.772276903574333, 3.585000000000001, 0.}, 
       {19.567819448749574, 4.182500000000001, 0.}, {19.32718875204978, \
4.780000000000001, 0.}, {19.047950896165478, 5.377500000000001, 0.}, 
       {18.726998563905845, 5.975000000000001, 0.}, {18.360332059211764, \
6.572500000000002, 0.}, {17.94272692879504, 7.170000000000002, 0.}, 
       {17.46720897243435, 7.767500000000002, 0.}, {16.924181391558115, \
8.365000000000002, 0.}, {16.2998735318374, 8.962500000000002, 0.}, 
       {15.573326954313622, 9.560000000000002, 0.}, {14.709759581999087, \
10.157500000000002, 0.}, {13.64289100438874, 10.755000000000003, 0.}, 
       {12.208840053799104, 11.352500000000003, 0.}, {9.414603431411933, \
11.950000000000003, 0.}, {9.414603431411972, 11.95, 0.}, 
       {12.208840053799115, 11.3525, 0.}, {13.642891004388748, \
10.754999999999999, 0.}, {14.709759581999093, 10.157499999999999, 0.}, 
       {15.573326954313629, 9.559999999999999, 0.}, {16.299873531837402, \
8.962499999999999, 0.}, {16.924181391558115, 8.364999999999998, 0.}, 
       {17.46720897243435, 7.767499999999999, 0.}, {17.942726928795043, \
7.169999999999999, 0.}, {18.360332059211764, 6.572499999999999, 0.}, 
       {18.726998563905845, 5.974999999999999, 0.}, {19.04795089616548, \
5.377499999999999, 0.}, {19.327188752049782, 4.779999999999999, 0.}, 
       {19.567819448749578, 4.182499999999999, 0.}, {19.772276903574333, \
3.584999999999999, 0.}, {19.942470354542216, 2.987499999999999, 0.}, 
       {20.079887577802207, 2.389999999999999, 0.}, {20.18566740897643, \
1.7924999999999986, 0.}, {20.260650706742243, 1.1949999999999985, 0.}, 
       {20.305415508412924, 0.5974999999999984, 0.}, {20.3203, \
-1.7763568394002505*^-15, 0.}, {20.305415508412924, -0.5975000000000019, 0.}, \

       {20.260650706742243, -1.195000000000002, 0.}, {20.18566740897643, \
-1.7925000000000022, 0.}, {20.079887577802207, -2.3900000000000006, 0.}, 
       {19.942470354542216, -2.9875000000000007, 0.}, {19.772276903574333, \
-3.585000000000001, 0.}, {19.567819448749574, -4.182500000000001, 0.}, 
       {19.32718875204978, -4.780000000000001, 0.}, {19.047950896165478, \
-5.377500000000001, 0.}, {18.726998563905845, -5.975000000000001, 0.}, 
       {18.360332059211764, -6.572500000000002, 0.}, {17.94272692879504, \
-7.170000000000002, 0.}, {17.46720897243435, -7.767500000000002, 0.}, 
       {16.924181391558115, -8.365000000000002, 0.}, {16.2998735318374, \
-8.962500000000002, 0.}, {15.573326954313622, -9.560000000000002, 0.}, 
       {14.709759581999087, -10.157500000000002, 0.}, {13.64289100438874, \
-10.755000000000003, 0.}, {12.208840053799104, -11.352500000000003, 0.}, 
       {9.414603431411933, -11.950000000000003, 0.}, {9.414603431411972, \
-11.95, 0.}}, {{9.414603431411972, 0., -11.95}, 
       {12.208840053799115, 0., -11.3525}, {13.642891004388748, 0., \
-10.754999999999999}, {14.709759581999093, 0., -10.157499999999999}, 
       {15.573326954313629, 0., -9.559999999999999}, {16.299873531837402, 0., \
-8.962499999999999}, {16.924181391558115, 0., -8.364999999999998}, 
       {17.46720897243435, 0., -7.767499999999999}, {17.942726928795043, 0., \
-7.169999999999999}, {18.360332059211764, 0., -6.572499999999999}, 
       {18.726998563905845, 0., -5.974999999999999}, {19.04795089616548, 0., \
-5.377499999999999}, {19.327188752049782, 0., -4.779999999999999}, 
       {19.567819448749578, 0., -4.182499999999999}, {19.772276903574333, 0., \
-3.584999999999999}, {19.942470354542216, 0., -2.987499999999999}, 
       {20.079887577802207, 0., -2.389999999999999}, {20.18566740897643, 0., \
-1.7924999999999986}, {20.260650706742243, 0., -1.1949999999999985}, 
       {20.305415508412924, 0., -0.5974999999999984}, {20.3203, 0., \
1.7763568394002505*^-15}, {20.305415508412924, 0., 0.5975000000000019}, 
       {20.260650706742243, 0., 1.195000000000002}, {20.18566740897643, 0., \
1.7925000000000022}, {20.079887577802207, 0., 2.3900000000000006}, 
       {19.942470354542216, 0., 2.9875000000000007}, {19.772276903574333, 0., \
3.585000000000001}, {19.567819448749574, 0., 4.182500000000001}, 
       {19.32718875204978, 0., 4.780000000000001}, {19.047950896165478, 0., \
5.377500000000001}, {18.726998563905845, 0., 5.975000000000001}, 
       {18.360332059211764, 0., 6.572500000000002}, {17.94272692879504, 0., \
7.170000000000002}, {17.46720897243435, 0., 7.767500000000002}, 
       {16.924181391558115, 0., 8.365000000000002}, {16.2998735318374, 0., \
8.962500000000002}, {15.573326954313622, 0., 9.560000000000002}, 
       {14.709759581999087, 0., 10.157500000000002}, {13.64289100438874, 0., \
10.755000000000003}, {12.208840053799104, 0., 11.352500000000003}, 
       {9.414603431411933, 0., 11.950000000000003}, {9.414603431411972, 0., \
11.95}, {12.208840053799115, 0., 11.3525}, 
       {13.642891004388748, 0., 10.754999999999999}, {14.709759581999093, 0., \
10.157499999999999}, {15.573326954313629, 0., 9.559999999999999}, 
       {16.299873531837402, 0., 8.962499999999999}, {16.924181391558115, 0., \
8.364999999999998}, {17.46720897243435, 0., 7.767499999999999}, 
       {17.942726928795043, 0., 7.169999999999999}, {18.360332059211764, 0., \
6.572499999999999}, {18.726998563905845, 0., 5.974999999999999}, 
       {19.04795089616548, 0., 5.377499999999999}, {19.327188752049782, 0., \
4.779999999999999}, {19.567819448749578, 0., 4.182499999999999}, 
       {19.772276903574333, 0., 3.584999999999999}, {19.942470354542216, 0., \
2.987499999999999}, {20.079887577802207, 0., 2.389999999999999}, 
       {20.18566740897643, 0., 1.7924999999999986}, {20.260650706742243, 0., \
1.1949999999999985}, {20.305415508412924, 0., 0.5974999999999984}, 
       {20.3203, 0., -1.7763568394002505*^-15}, {20.305415508412924, 0., \
-0.5975000000000019}, {20.260650706742243, 0., -1.195000000000002}, 
       {20.18566740897643, 0., -1.7925000000000022}, {20.079887577802207, 0., \
-2.3900000000000006}, {19.942470354542216, 0., -2.9875000000000007}, 
       {19.772276903574333, 0., -3.585000000000001}, {19.567819448749574, 0., \
-4.182500000000001}, {19.32718875204978, 0., -4.780000000000001}, 
       {19.047950896165478, 0., -5.377500000000001}, {18.726998563905845, 0., \
-5.975000000000001}, {18.360332059211764, 0., -6.572500000000002}, 
       {17.94272692879504, 0., -7.170000000000002}, {17.46720897243435, 0., \
-7.767500000000002}, {16.924181391558115, 0., -8.365000000000002}, 
       {16.2998735318374, 0., -8.962500000000002}, {15.573326954313622, 0., \
-9.560000000000002}, {14.709759581999087, 0., -10.157500000000002}, 
       {13.64289100438874, 0., -10.755000000000003}, {12.208840053799104, 0., \
-11.352500000000003}, {9.414603431411933, 0., -11.950000000000003}, 
       {9.414603431411972, 0., -11.95}}, {{9.414603431411972, 11.95, 0.}, \
{9.414603431411987, 11.940786983076638, 0.46915479832086987}, 
       {9.414603431411972, 11.913162138110879, 0.937586193947747}, \
{9.414603431411972, 11.867168060611368, 1.4045718996211598}, 
       {9.414603431411972, 11.802875670111895, 1.8693918572307588}, \
{9.414603431411972, 11.720384100818602, 2.3313293480927326}, 
       {9.414603431411972, 11.619820548752234, 2.7896720980780696}, \
{9.414603431411987, 11.501340075621084, 3.243713375887637}, 
       {9.414603431411987, 11.365125369727084, 3.6927530827806216}, \
{9.41460343141196, 11.211386464273685, 4.136098832076041}, 
       {9.41460343141196, 11.040360413509877, 4.573067016762822}, \
{9.41460343141196, 10.852310927209722, 5.002983863572266}, 
       {9.41460343141196, 10.647527964050996, 5.425186471887584}, \
{9.41460343141196, 10.426327284519926, 5.839023835888612}, 
       {9.41460343141196, 10.189049964031401, 6.2438578483555895}, \
{9.414603431411987, 9.936061867015415, 6.639064284584245}, 
       {9.414603431411972, 9.66775308278062, 7.024033764895053}, \
{9.414603431411972, 9.384537324024901, 7.398172694252516}, 
       {9.41460343141196, 9.08685128892037, 7.760904177545695}, \
{9.414603431411972, 8.775153987756442, 8.111668909118654}, 
       {9.414603431411972, 8.449926035179242, 8.449926035179242}, \
{9.414603431411972, 8.111668909118654, 8.775153987756442}, 
       {9.41460343141196, 7.760904177545695, 9.08685128892037}, \
{9.414603431411972, 7.398172694252516, 9.384537324024901}, 
       {9.414603431411972, 7.024033764895053, 9.66775308278062}, \
{9.414603431411972, 6.639064284584247, 9.936061867015415}, 
       {9.41460343141196, 6.2438578483555895, 10.189049964031401}, \
{9.414603431411972, 5.839023835888612, 10.426327284519925}, 
       {9.414603431411987, 5.425186471887585, 10.647527964050994}, \
{9.414603431411987, 5.002983863572266, 10.85231092720972}, 
       {9.41460343141196, 4.573067016762823, 11.040360413509877}, \
{9.41460343141196, 4.1360988320760415, 11.211386464273685}, 
       {9.414603431411987, 3.6927530827806225, 11.365125369727084}, \
{9.414603431411972, 3.243713375887638, 11.501340075621084}, 
       {9.414603431411972, 2.78967209807807, 11.619820548752234}, \
{9.414603431411972, 2.3313293480927335, 11.720384100818602}, 
       {9.414603431411972, 1.8693918572307595, 11.802875670111895}, \
{9.414603431411972, 1.4045718996211605, 11.867168060611368}, 
       {9.414603431411972, 0.9375861939477477, 11.913162138110879}, \
{9.414603431411987, 0.46915479832087054, 11.940786983076638}, 
       {9.414603431411972, 7.317264624905435*^-16, 11.95}, \
{9.414603431411987, -0.4691547983208691, 11.940786983076638}, 
       {9.414603431411972, -0.9375861939477463, 11.913162138110879}, \
{9.414603431411972, -1.404571899621159, 11.867168060611368}, 
       {9.414603431411972, -1.8693918572307582, 11.802875670111895}, \
{9.414603431411972, -2.331329348092732, 11.720384100818602}, 
       {9.41460343141196, -2.7896720980780687, 11.619820548752235}, \
{9.414603431411987, -3.2437133758876366, 11.501340075621084}, 
       {9.414603431411972, -3.6927530827806203, 11.365125369727085}, \
{9.414603431411972, -4.13609883207604, 11.211386464273685}, 
       {9.41460343141196, -4.573067016762822, 11.040360413509877}, \
{9.41460343141196, -5.002983863572262, 10.852310927209723}, 
       {9.414603431411972, -5.425186471887583, 10.647527964050996}, \
{9.41460343141196, -5.839023835888613, 10.426327284519925}, 
       {9.41460343141196, -6.243857848355588, 10.189049964031403}, \
{9.41460343141196, -6.639064284584243, 9.936061867015418}, 
       {9.414603431411972, -7.024033764895053, 9.66775308278062}, \
{9.414603431411972, -7.398172694252517, 9.384537324024901}, 
       {9.41460343141196, -7.760904177545695, 9.08685128892037}, \
{9.414603431411987, -8.11166890911865, 8.775153987756443}, 
       {9.414603431411972, -8.449926035179242, 8.449926035179242}, \
{9.414603431411987, -8.775153987756442, 8.111668909118652}, 
       {9.414603431411972, -9.086851288920368, 7.7609041775456955}, \
{9.41460343141196, -9.3845373240249, 7.398172694252519}, 
       {9.41460343141196, -9.66775308278062, 7.024033764895055}, \
{9.41460343141196, -9.936061867015416, 6.639064284584245}, 
       {9.41460343141196, -10.189049964031401, 6.24385784835559}, \
{9.414603431411972, -10.426327284519923, 5.839023835888614}, 
       {9.414603431411987, -10.647527964050994, 5.425186471887585}, \
{9.41460343141196, -10.852310927209722, 5.002983863572265}, 
       {9.41460343141196, -11.040360413509877, 4.573067016762824}, \
{9.414603431411972, -11.211386464273684, 4.136098832076045}, 
       {9.414603431411972, -11.365125369727084, 3.692753082780623}, \
{9.414603431411987, -11.501340075621084, 3.2437133758876358}, 
       {9.414603431411972, -11.619820548752234, 2.789672098078071}, \
{9.414603431411972, -11.720384100818602, 2.3313293480927366}, 
       {9.414603431411972, -11.802875670111895, 1.8693918572307602}, \
{9.414603431411987, -11.867168060611368, 1.4045718996211587}, 
       {9.414603431411972, -11.913162138110879, 0.9375861939477486}, \
{9.414603431411987, -11.940786983076638, 0.4691547983208739}, 
       {9.414603431411972, -11.95, 1.463452924981087*^-15}, \
{9.414603431411987, -11.940786983076638, -0.46915479832087104}, 
       {9.414603431411972, -11.913162138110879, -0.9375861939477456}, \
{9.414603431411987, -11.867168060611368, -1.4045718996211556}, 
       {9.414603431411987, -11.802875670111895, -1.8693918572307575}, \
{9.414603431411972, -11.720384100818602, -2.331329348092734}, 
       {9.414603431411972, -11.619820548752235, -2.789672098078068}, \
{9.414603431411987, -11.501340075621085, -3.243713375887633}, 
       {9.414603431411972, -11.365125369727085, -3.69275308278062}, \
{9.414603431411987, -11.211386464273684, -4.136098832076042}, 
       {9.414603431411972, -11.040360413509877, -4.573067016762821}, \
{9.414603431411972, -10.852310927209723, -5.002983863572261}, 
       {9.414603431411972, -10.647527964050996, -5.425186471887582}, \
{9.414603431411972, -10.426327284519925, -5.839023835888612}, 
       {9.41460343141196, -10.189049964031403, -6.243857848355588}, \
{9.41460343141196, -9.936061867015418, -6.639064284584243}, 
       {9.41460343141196, -9.667753082780623, -7.024033764895052}, \
{9.414603431411972, -9.384537324024901, -7.398172694252517}, 
       {9.414603431411987, -9.08685128892037, -7.760904177545693}, \
{9.41460343141196, -8.775153987756445, -8.11166890911865}, 
       {9.414603431411972, -8.449926035179244, -8.44992603517924}, \
{9.414603431411987, -8.111668909118652, -8.775153987756442}, 
       {9.414603431411972, -7.7609041775457, -9.086851288920364}, \
{9.41460343141196, -7.398172694252519, -9.3845373240249}, 
       {9.41460343141196, -7.024033764895055, -9.66775308278062}, \
{9.414603431411987, -6.639064284584245, -9.936061867015415}, 
       {9.41460343141196, -6.243857848355587, -10.189049964031403}, \
{9.414603431411972, -5.839023835888615, -10.426327284519923}, 
       {9.414603431411972, -5.425186471887586, -10.647527964050994}, \
{9.41460343141196, -5.002983863572266, -10.852310927209722}, 
       {9.414603431411972, -4.573067016762829, -11.040360413509873}, \
{9.414603431411972, -4.136098832076045, -11.211386464273684}, 
       {9.414603431411972, -3.692753082780624, -11.365125369727084}, \
{9.414603431411987, -3.2437133758876366, -11.501340075621084}, 
       {9.414603431411972, -2.7896720980780665, -11.619820548752235}, \
{9.414603431411972, -2.3313293480927375, -11.720384100818602}, 
       {9.414603431411972, -1.869391857230761, -11.802875670111895}, \
{9.414603431411972, -1.4045718996211594, -11.867168060611368}, 
       {9.41460343141196, -0.9375861939477544, -11.913162138110879}, \
{9.414603431411972, -0.46915479832087464, -11.940786983076638}, 
       {9.414603431411972, -2.1951793874716302*^-15, -11.95}, \
{9.414603431411987, 0.46915479832087026, -11.940786983076638}, 
       {9.414603431411972, 0.9375861939477502, -11.913162138110879}, \
{9.414603431411987, 1.404571899621155, -11.867168060611368}, 
       {9.414603431411987, 1.8693918572307564, -11.802875670111895}, \
{9.414603431411972, 2.331329348092733, -11.720384100818602}, 
       {9.414603431411972, 2.7896720980780625, -11.619820548752237}, \
{9.414603431411987, 3.2437133758876326, -11.501340075621085}, 
       {9.414603431411972, 3.692753082780619, -11.365125369727085}, \
{9.41460343141196, 4.1360988320760415, -11.211386464273685}, 
       {9.414603431411972, 4.573067016762825, -11.040360413509875}, \
{9.414603431411972, 5.00298386357226, -10.852310927209723}, 
       {9.414603431411972, 5.425186471887582, -10.647527964050996}, \
{9.414603431411972, 5.839023835888612, -10.426327284519925}, 
       {9.41460343141196, 6.243857848355582, -10.189049964031407}, \
{9.414603431411972, 6.639064284584242, -9.936061867015418}, 
       {9.41460343141196, 7.024033764895052, -9.667753082780623}, \
{9.414603431411972, 7.398172694252516, -9.384537324024901}, 
       {9.41460343141196, 7.760904177545697, -9.086851288920368}, \
{9.41460343141196, 8.11166890911865, -8.775153987756445}, 
       {9.414603431411972, 8.44992603517924, -8.449926035179244}, \
{9.414603431411972, 8.775153987756442, -8.111668909118654}, 
       {9.41460343141196, 9.086851288920364, -7.760904177545701}, \
{9.41460343141196, 9.3845373240249, -7.398172694252521}, 
       {9.414603431411972, 9.667753082780619, -7.024033764895056}, \
{9.414603431411972, 9.936061867015415, -6.639064284584247}, 
       {9.41460343141196, 10.189049964031403, -6.243857848355587}, \
{9.41460343141196, 10.426327284519923, -5.839023835888616}, 
       {9.414603431411972, 10.647527964050994, -5.425186471887587}, \
{9.414603431411987, 10.85231092720972, -5.002983863572266}, 
       {9.414603431411972, 11.040360413509873, -4.57306701676283}, \
{9.414603431411987, 11.211386464273682, -4.136098832076046}, 
       {9.414603431411972, 11.365125369727084, -3.6927530827806243}, \
{9.414603431411987, 11.501340075621084, -3.243713375887637}, 
       {9.414603431411972, 11.619820548752235, -2.7896720980780674}, \
{9.41460343141196, 11.720384100818602, -2.331329348092738}, 
       {9.414603431411972, 11.802875670111895, -1.8693918572307617}, \
{9.414603431411972, 11.867168060611368, -1.40457189962116}, 
       {9.41460343141196, 11.913162138110879, -0.9375861939477551}, \
{9.414603431411972, 11.940786983076638, -0.4691547983208754}, 
       {9.414603431411972, 11.95, -2.926905849962174*^-15}}}]}}, ControlType \
-> None}, 
 Initialization :> (raytracefunction1230200811523132919248 = Compile[{{th, \
_Real}, {x, _Real}, {y, _Real}, {focus, _Real}}, 
     Module[{activeregion, allcreatedamplitudes, allcreatedrays, \
allowzeroraylength, alternateindex, amplitude, axismagnitude, axismatrix, \
clonedata, 
       clonegenerationnumber, cloneinput, clonenumber, cloneposition, \
clonereportedrays, clonerotation, clonescale, clonescalevector, 
       clonesorthistogram, clonetraceinput, clonetraceoutput, \
closestdistances, closestposition, closestpositions, closestraylength, \
completedray, 
       componentnumber, cosangle, crossmatrix, deflecteddummyrayspresent, \
deflectedlocalrays, deflectedrays, deflectedrayspresent, dr1, dummymatrix, 
       dummymatrixlist, dummyvector, exitvalue, frontid, generationlimit, \
generationnumber, holeintersections, holeQ, holeQlist, hor, index, index1, 
       index2, inrays, intensity, intensityscale, intersectionnumber, \
intersections, intersectionslist, intersectionspresent, 
       localdummyoutrayspresent, localoutrays, localoutrayspresent, \
magnitude, maxclonegenerationnumber, maximumposition, minimumraylength, 
       minresonateraylength, n12, newcomponentnumber, newdeflectedrays, \
newdistance, newsurfaceid, newsurfacenumber, nonintersectingrays, 
       normalizedpolarization, oldgenerationnumber, opticallength, \
originalray, originalraytilt, originalrotation, originalsurfnorm, outrays, 
       parallelamplitude, PAxis, perpendicularamplitude, phaseshift, pol1, \
pol2, pol3, previoustilt, propagate, propagatedrays, r1, r2, r3, r4, r5, 
       r6, r7, r8, r9, ray1, ray2, ray3, LocRayL, rayslot, raysreported, \
raytiltx, raytiltz, reporteddummyrayspresent, reportedlocalrays, 
       reportedrays, reportedrayspresent, resonateintersections, \
resonatenumber, resonateraylength, rex, rey, rez, rotationaxis, rsx, LocRSx, \
rsy, 
       LocRSy, rsz, LocRSz, RTx, LocRTy, LocRTz, rx, rxhlp, ry, ryhlp, rz, \
rzhlp, LocSCx, LocSCy, sid, sinangle, sno1, sno2, sno3, sno4, surfaceid, 
       surfacenumber, surfacerotationmatrix, surfacetranslationvector, \
surfnorm, symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9, 
       tempclonedata, terminatedeflection, thresholdintensity, tiltmagnitude, \
transmatrix, LocTV1, LocTV10, LocTV2, LocTV3, LocTV4, LocTV5, LocTV6, 
       LocTV7, LocTV8, LocTV9, u, unfilteredintersections, unit, uu, ver, \
wavelength, XAxis, xunit, YAxis, yunit, ZAxis, zunit}, 
      activeregion = 1.; allcreatedamplitudes = {{0. + 0.*I, 0. + 0.*I, 0. + \
0.*I}}; allcreatedrays = {{1.}}; allowzeroraylength = True; 
       alternateindex = 1.; amplitude = {1. + 0.*I, 0. + 0.*I, 0. + 0.*I}; \
axismagnitude = 1.; 
       axismatrix = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; clonedata = \
{{1.}}; clonegenerationnumber = 1.; cloneinput = {1.}; clonenumber = 1; 
       cloneposition = {0., 0., 0.}; clonereportedrays = {{1.}}; \
clonerotation = {{1.}}; clonescale = 1.; clonescalevector = {1.}; 
       clonesorthistogram = {1}; clonetraceinput = {{1.}}; clonetraceoutput = \
{{1.}}; closestdistances = {1.}; closestposition = 0; 
       closestpositions = {0}; closestraylength = 1.; completedray = {1.}; \
componentnumber = -1.; cosangle = 1.; 
       crossmatrix = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; \
deflecteddummyrayspresent = False; deflectedlocalrays = {{1.}}; 
       deflectedrays = {{1.}}; deflectedrayspresent = False; dummymatrix = \
{{1.}}; dummymatrixlist = {{{1.}}}; dummyvector = {1.}; exitvalue = 1.; 
       frontid = 1.; generationlimit = 200.; generationnumber = 1.; \
holeintersections = {{-1., 0., 0.}}; holeQ = False; holeQlist = {0}; 
       hor = 1. + 0.*I; index = 1.; index1 = 1.; index2 = 1.; inrays = \
{{1.}}; intensity = 1.; intensityscale = 1.; intersectionnumber = 1.; 
       intersections = {{-1., 0., 0.}}; intersectionslist = {{{-1., 0., \
0.}}}; intersectionspresent = False; localdummyoutrayspresent = False; 
       localoutrays = {{1.}}; localoutrayspresent = False; magnitude = 1.; \
maxclonegenerationnumber = 1.; maximumposition = 1; 
       minimumraylength = 0.0001; minresonateraylength = 1.; n12 = 1.; \
newcomponentnumber = -1.; newdeflectedrays = {{1.}}; newdistance = 1.; 
       newsurfaceid = -1.; newsurfacenumber = -1.; nonintersectingrays = \
{{1.}}; normalizedpolarization = {1., 1.}; oldgenerationnumber = 1.; 
       opticallength = 1.; originalray = {1.}; originalraytilt = {1.}; \
originalrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; 
       originalsurfnorm = {{1.}}; outrays = {{1.}}; parallelamplitude = 1. + \
0.*I; PAxis = {1., 0., 0.}; perpendicularamplitude = 1. + 0.*I; 
       phaseshift = 0.; pol1 = 1.; pol2 = 1.; pol3 = 1.; previoustilt = {1., \
0., 0.}; propagate = True; propagatedrays = {{1.}}; r1 = 1.; r2 = 1.; 
       r3 = 1.; r4 = 1.; r5 = 1.; r6 = 1.; r7 = 1.; r8 = 1.; r9 = 1.; ray1 = \
1.; ray2 = 1.; ray3 = 1.; LocRayL = 1.; rayslot = 1.; 
       raysreported = False; raytiltx = 1.; raytiltz = 1.; \
reporteddummyrayspresent = False; reportedlocalrays = {{1.}}; reportedrays = \
{{1.}}; 
       reportedrayspresent = False; resonateintersections = {{-1., 0., 0.}}; \
resonatenumber = 0; resonateraylength = 1.; rex = 1.; rey = 1.; 
       rez = 1.; rsx = 1.; LocRSx = 1.; rsy = 1.; LocRSy = 1.; rsz = 1.; \
LocRSz = 1.; RTx = 1.; LocRTy = 1.; LocRTz = 1.; rx = 1.; rxhlp = 1.; 
       ry = 1.; ryhlp = 1.; rz = 1.; rzhlp = 1.; LocSCx = 1.; LocSCy = 1.; \
sid = 1.; sinangle = 1.; sno1 = 1.; sno2 = 1.; sno3 = 1.; sno4 = 1.; 
       surfaceid = -1.; surfacenumber = -1.; surfacerotationmatrix = {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; 
       surfacetranslationvector = {0., 0., 0.}; surfnorm = {{1.}}; symr1 = \
1.; symr2 = 1.; symr3 = 1.; symr4 = 1.; symr5 = 1.; symr6 = 1.; 
       symr7 = 1.; symr8 = 1.; symr9 = 1.; tempclonedata = {{1.}}; \
terminatedeflection = False; thresholdintensity = 1.; tiltmagnitude = 1.; 
       transmatrix = {{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}}; LocTV1 = \
1.; LocTV10 = 1.; LocTV2 = 1.; LocTV3 = 1.; LocTV4 = 1.; LocTV5 = 1.; 
       LocTV6 = 1.; LocTV7 = 1.; LocTV8 = 1.; LocTV9 = 1.; u = {{1., 0., 0.}, \
{0., 1., 0.}, {0., 0., 1.}}; unfilteredintersections = {{-1., 0., 0.}}; 
       unit = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; uu = {{1., 0., 0.}, \
{0., 1., 0.}, {0., 0., 1.}}; ver = 0. + 0.*I; wavelength = 1.; 
       XAxis = {1., 0., 0.}; xunit = 1.; YAxis = {1., 0., 0.}; yunit = 1.; \
ZAxis = {1., 0., 0.}; zunit = 1.; {r1, dr1} = {1., 1.}; 
       {rx, ry, rz} = {1., 1., 1.}; {xunit, yunit, zunit} = {1., 1., 1.}; \
propagatedrays = 
        Join[{symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} \
= Re[{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], 
             Cos[Degree*th], 0, 0, 0, 1}]; (({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
               intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, 
               sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {LocTV1, LocTV2, LocTV3} = 
              {rsx*symr1 + rsy*symr4 + rsz*symr7 + x, rsx*symr2 + rsy*symr5 + \
rsz*symr8 + y, rsx*symr3 + rsy*symr6 + rsz*symr9}; 
             {rsx, rsy, rsz} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, \
LocTV3} = {rex*symr1 + rey*symr4 + rez*symr7 + x, rex*symr2 + rey*symr5 + 
                rez*symr8 + y, rex*symr3 + rey*symr6 + rez*symr9}; {rex, rey, \
rez} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
              {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + \
r3*symr8, r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = 
              {r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + \
r6*symr8, r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = 
              {r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + \
r9*symr8, r7*symr3 + r8*symr6 + r9*symr9}; 
             {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = {{LocTV1, LocTV2, \
LocTV3}, {LocTV4, LocTV5, LocTV6}, {LocTV7, LocTV8, LocTV9}}; 
             {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, \
r9, wavelength, intensity, intensityscale, ray1, index, opticallength, 
              phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
              intersectionnumber, pol1, pol2, pol3}) & ) /@ {{0., -1.5, 0., \
0., -1.5, 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 
             0.09090909090909091, 0., 1.00026945145708, 0., 0., 1., 0., 0., \
0., 0., 25069., 25069., 1., 11., 1., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., -1.2, 0., 0., -1.2, 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., \
0.532, 100., 0.09090909090909091, 0., 1.00026945145708, 0., 0., 1., 0., 
             0., 0., 0., 25069., 25069., 2., 11., 2., 0., 1., 0., 0., 0., 1., \
0.}, {0., -0.8999999999999999, 0., 0., -0.8999999999999999, 0., 1., 0., 
             0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, \
0., 1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., 3., 11., 
             3., 0., 1., 0., 0., 0., 1., 0.}, {0., -0.5999999999999999, 0., \
0., -0.5999999999999999, 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 
             100., 0.09090909090909091, 0., 1.00026945145708, 0., 0., 1., 0., \
0., 0., 0., 25069., 25069., 4., 11., 4., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., -0.2999999999999998, 0., 0., -0.2999999999999998, 0., 1., \
0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
5., 11., 5., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 2.220446049250313*^-16, 0., 0., 2.220446049250313*^-16, 0., \
1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 
             0., 1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., \
25069., 6., 11., 6., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 0.30000000000000027, 0., 0., 0.30000000000000027, 0., 1., \
0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
7., 11., 7., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 0.6000000000000003, 0., 0., 0.6000000000000003, 0., 1., 0., \
0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
8., 11., 8., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 0.9000000000000004, 0., 0., 0.9000000000000004, 0., 1., 0., \
0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
9., 11., 9., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 1.2000000000000004, 0., 0., 1.2000000000000004, 0., 1., 0., \
0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
10., 11., 10., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 1.5000000000000004, 0., 0., 1.5000000000000004, 0., 1., 0., \
0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
11., 11., 11., 0., 1., 0., 0., 0., 1., 0.}}]; 
       propagatedrays = (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
             opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
             oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; \
componentnumber = 1.; frontid = 1.; 
           {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, 
            phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
            intersectionnumber, pol1, pol2, pol3}) & ) /@ propagatedrays; \
thresholdintensity = 1.; generationlimit = 200.; 
       reportedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
          opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
          generationnumber, intersectionnumber, pol1, pol2, pol3}}; \
generationnumber = 0.; (generationnumber += 1.; 
        reportedlocalrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, r7, r8, r9, wavelength, 0, intensityscale, ray1, index, 
           opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
           generationnumber, intersectionnumber, pol1, pol2, pol3}}; \
deflectedlocalrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, 
           r8, r9, wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
           ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 3.5999999999999996 + rex; ry = rey; rz = 
                rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1. + I*0.; 
                    LocSCx = 1. + I*0.; LocSCy = 1. + I*0.; Re[Select[{{-1. + \
0.*I, 0. + 0.*I, 0. + 0.*I}, {(386.*xunit - 37.*rx*xunit - 
                          50.*ry*yunit - 50.*rz*zunit - \
1.4142135623730951*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - \
925.*rz^2*xunit^2 - 
                             19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit \
+ 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 1250.*rz^2*yunit^2 - 
                             19300.*rz*xunit*zunit + 1850.*rx*rz*xunit*zunit \
+ 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 925.*rx^2*zunit^2 - 
                             1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 \
+ 50.*zunit^2), (37.*ry*xunit^2 + 386.*xunit*yunit - 37.*rx*xunit*
                           yunit - 50.*rz*yunit*zunit + 50.*ry*zunit^2 - \
1.4142135623730951*yunit*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - 
                             925.*rz^2*xunit^2 - 19300.*ry*xunit*yunit + \
1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2), \
(37.*rz*xunit^2 + 50.*rz*yunit^2 + 
                          386.*xunit*zunit - 37.*rx*xunit*zunit - \
50.*ry*yunit*zunit - 1.4142135623730951*zunit*Sqrt[74498.*xunit^2 - \
925.*ry^2*
                              xunit^2 - 925.*rz^2*xunit^2 - \
19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - \
925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2)}, {(386.*xunit \
- 37.*rx*xunit - 
                          50.*ry*yunit - 50.*rz*zunit + \
1.4142135623730951*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - \
925.*rz^2*xunit^2 - 
                             19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit \
+ 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 1250.*rz^2*yunit^2 - 
                             19300.*rz*xunit*zunit + 1850.*rx*rz*xunit*zunit \
+ 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 925.*rx^2*zunit^2 - 
                             1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 \
+ 50.*zunit^2), (37.*ry*xunit^2 + 386.*xunit*yunit - 37.*rx*xunit*
                           yunit - 50.*rz*yunit*zunit + 50.*ry*zunit^2 + \
1.4142135623730951*yunit*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - 
                             925.*rz^2*xunit^2 - 19300.*ry*xunit*yunit + \
1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2), \
(37.*rz*xunit^2 + 50.*rz*yunit^2 + 
                          386.*xunit*zunit - 37.*rx*xunit*zunit - \
50.*ry*yunit*zunit + 1.4142135623730951*zunit*Sqrt[74498.*xunit^2 - \
925.*ry^2*
                              xunit^2 - 925.*rz^2*xunit^2 - \
19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - \
925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2)}}, ({LocRayL, \
LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
(Chop[Im[#1]] == {0, 0, 0} && N[Chop[Re[LocRayL]]] >= 0. && 
                          Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[rx + LocRayL*xunit - (25*(LocSCx^2 + \
LocSCy^2))/
                               (193*(1 + Sqrt[1 - (925*(LocSCx^2 + \
LocSCy^2))/74498]))] < 1.*^-7 && Re[LocSCx]^2 + Re[LocSCy]^2 <= 39.0625)) & \
]]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24990.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 1., 24990.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 1., 24990.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
-3.5999999999999996 + rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; 
                   rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = \
intersectionnumber + 1.; opticallength = opticallength + ray1*index1; 
                   completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                     index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                     rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., \
(-0.0016083472422043674*ray2^3)/(Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*
                            (1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])^2) - (0.0016083472422043674*ray2*ray3^2)/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) - 
                          (0.2590673575129534*ray2)/(1. + Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]), \
(-0.0016083472422043674*ray2^2*ray3)/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) - 
                          (0.0016083472422043674*ray3^3)/(Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*
                                 (ray2^2 + ray3^2)])^2) - \
(0.2590673575129534*ray3)/(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])}, 
                        {(0.0016083472422043674*ray2*(ray2^2 + \
ray3^2))/(Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)]*
                            (1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])^2) + (0.2590673575129534*ray2)/(1. + Sqrt[1. - 
                              0.012416440709817716*(ray2^2 + ray3^2)]), 1., \
0.}, {(0.0016083472422043674*ray3*(ray2^2 + ray3^2))/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) + 
                          (0.2590673575129534*ray3)/(1. + Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]), 0., 1.}}]; 
                    If[surfnorm[[1]] == {0., 0., 0.} || surfnorm[[2]] == {0., \
0., 0.} || surfnorm[[3]] == {0., 0., 0.}, 
                     surfnorm = 1.*Re[{{1., (-0.0016083472422043674*(1.*^-6 + \
ray2)^3)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.0016083472422043674*(1.*^-6 + ray2)*(1.*^-6 + \
ray3)^2)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.2590673575129534*(1.*^-6 + ray2))/(1. + \
Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 
                           (-0.0016083472422043674*(1.*^-6 + ray2)^2*(1.*^-6 \
+ ray3))/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.0016083472422043674*(1.*^-6 + \
ray3)^3)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2)]*
                              (1. + Sqrt[1. - 0.012416440709817716*((1.*^-6 + \
ray2)^2 + (1.*^-6 + ray3)^2)])^2) - (0.2590673575129534*(1.*^-6 + 
                               ray3))/(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])}, \
{(0.0016083472422043674*
                              (1.*^-6 + ray2)*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2))/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.2590673575129534*(1.*^-6 + ray2))/(1. + \
Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 1., \

                           0.}, {(0.0016083472422043674*(1.*^-6 + \
ray3)*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2))/(Sqrt[1. - \
0.012416440709817716*
                                 ((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*(1. \
+ Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^
                                     2)])^2) + (0.2590673575129534*(1.*^-6 + \
ray3))/(1. + Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]), 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1., 0, 0}, {0, \
1., 0}, {0, 0, 1.}}; surfacetranslationvector = {-3.5999999999999996, 0, 
                      0}; activeregion = 1.; completedray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.5392664079785716 - 0.7232199521994117*wavelength + 
                        1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                           2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                          2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                     index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                         2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                      index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = 1.5392664079785716 - 0.7232199521994117*wavelength + 
                          1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3; If[Abs[alternateindex - index1] > Abs[index2 \
- index1], 
                         index1 = index2; index2 = alternateindex, index1 = \
alternateindex], index1 = 1.5392664079785716 - 0.7232199521994117*
                          wavelength + 1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3]]; n12 = index1/index2; index = index2; 
                    If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, \
r3} + ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); 
                      {r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . \
surfnorm[[1]] > 0, phaseshift = phaseshift + 0.5, 1.]; index2 = index1; 
                      index = index1; dummyvector = {r1, r2, r3} - \
2*ZAxis*ZAxis . {r1, r2, r3}; {r1, r2, r3} = dummyvector; dummyvector = 
                       {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} \
= dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, 
                       r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}}; \
originalrotation = Partition[Take[originalray, {7, 15}], 3]; previoustilt = 
                     originalrotation[[1]]; transmatrix = MapIndexed[({rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        rotationaxis = Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; 
                        If[Chop[axismagnitude] != 0., rotationaxis = \
rotationaxis/axismagnitude; axismatrix = (#1*rotationaxis & ) /@ \
rotationaxis; 
                          crossmatrix = {{0., -rotationaxis[[3]], \
rotationaxis[[2]]}, {rotationaxis[[3]], 0., -rotationaxis[[1]]}, 
                            {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; \
cosangle = previoustilt . {r1, r2, r3}; If[1. - cosangle < 
                            2.220446049250313*^-16, cosangle = 1.]; sinangle \
= 1 - cosangle^2; If[sinangle < 2.220446049250313*^-16, sinangle = 0., 
                           sinangle = Sqrt[sinangle]]; axismatrix + ({{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + 
                           crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, 
                           {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., \
0., 0.}, {0., -1., 0.}, {0., 0., -1.}}]]) & , allcreatedrays]; 
                    allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
Function[mm, (mm . #1 & ) /@ originalrotation][transmatrix[[First[#2]]]]; 
                        tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, r3}/
                            Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; \
dummymatrix = (#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, 
                             {r7, r8, r9}}; {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = dummymatrix; 1., 1.]; If[allcreatedamplitudes != 
                          {{I*0., I*0., I*0.}}, amplitude = \
allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . amplitude; ver = {r7, \
r8, r9} . 
                            amplitude; If[Abs[hor] > 0. || Abs[ver] > 0., \
{pol1, pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = 
                             {pol1, pol2, pol3}/Sqrt[{pol1, pol2, pol3} . \
{pol1, pol2, pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = 
                             ReplacePart[{pol1, pol2, pol3}, (If[ver == 0., \
0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 3.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{TempVar, TempVar1, TempVar2, TempVar3, LocRayL, 
                    LocSCx, LocSCy}, TempVar1 = 1.; TempVar2 = 1.; TempVar3 = \
1.; TempVar = {{-1., 0., 0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; 
                    TempVar1 = rx^2 + ry^2 + rz^2; TempVar2 = rx*xunit + \
ry*yunit + rz*zunit - 6.5*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 
                      2*rx*6.5; TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] \
>= 0., TempVar3 = Sqrt[TempVar3]; TempVar = 
                       {{LocRayL, LocSCx, LocSCy} = {-TempVar2 - TempVar3, ry \
- (TempVar2 + TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; 
                         If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
25. && Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - 
                               LocSCy] + Abs[-6.5 + rx + LocRayL*xunit + \
Sqrt[42.25 - LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, LocSCy}, 
                          {-1., 0., 0.}], {LocRayL, LocSCx, LocSCy} = \
{-TempVar2 + TempVar3, ry + (-TempVar2 + TempVar3)*yunit, 
                           rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 25. && 
                           Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[-6.5 + rx + LocRayL*xunit + Sqrt[42.25 - 
                                 LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, \
LocSCx, LocSCy}, {-1., 0., 0.}]}; If[TempVar[[1]] == TempVar[[2]], 
                       {TempVar[[1]]}, TempVar], {{-1., 0., 0.}}]]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24991.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 2., 24991.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 2., 24991.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -3.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., \
-(ray2/(42.25 - ray2^2 - ray3^2)^2^(-1)), -(ray3/(42.25 - ray2^2 - ray3^2)^
                            2^(-1))}, {ray2/(42.25 - ray2^2 - ray3^2)^2^(-1), \
1., 0.}, {ray3/(42.25 - ray2^2 - ray3^2)^2^(-1), 0., 1.}}]; 
                    dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 \
. #1] & ) /@ dummymatrix; surfacerotationmatrix = {{1., 0, 0}, 
                      {0, 1., 0}, {0, 0, 1.}}; surfacetranslationvector = \
{-3.05, 0, 0}; activeregion = 1.; completedray = {rsx, rsy, rsz, rex, rey, 
                      rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                      componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                      intersectionnumber, pol1, pol2, pol3}; componentnumber \
= newcomponentnumber; surfacenumber = newsurfacenumber; 
                    surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; ZAxis = First[surfnorm]*
                      Sign[First[surfnorm] . {r1, r2, r3}]; raytiltz = ZAxis \
. {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.5532682085813037 - 1.0054245500503685*wavelength + 
                        1.6027810806802343*wavelength^2 - \
0.8794405514298376*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.5392664079785716 - \
0.7232199521994117*wavelength + 1.0984449372267269*wavelength^2 - \
0.5792106405020717*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = \
1.5392664079785716 - 0.7232199521994117*wavelength + \
1.0984449372267269*wavelength^2 - 
                         0.5792106405020717*wavelength^3], index2 = \
1.5392664079785716 - 0.7232199521994117*wavelength + 1.0984449372267269*
                         wavelength^2 - 0.5792106405020717*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.5532682085813037 - 1.0054245500503685*wavelength + \
1.6027810806802343*wavelength^2 - 0.8794405514298376*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.5532682085813037 - \
1.0054245500503685*wavelength + 1.6027810806802343*wavelength^2 - \
0.8794405514298376*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 0.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = If[Chop[xunit] != 0, 
                   {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= \
6.25, {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                      ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., \
0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24992.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 3., 24992.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 3., 24992.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -0.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1., 0, 0}, {0, 1., 0}, {0, 0, 1.}}; 
                    surfacetranslationvector = {-0.05, 0, 0}; activeregion = \
0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, r3}]; 
                    raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - \
raytiltz^2; If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., 
                     raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - \
ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], 
                     XAxis = XAxis/raytiltx]; YAxis = \
{-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*
                        XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + \
ZAxis[[1]]*XAxis[[2]]}; YAxis = YAxis/Sqrt[YAxis . YAxis]; 
                    PAxis = ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . \
ZAxis; PAxis = PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = 
                     {pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = \
normalizedpolarization/Sqrt[normalizedpolarization . 
                        normalizedpolarization]; allcreatedamplitudes = \
{{I*0., I*0., I*0.}}; amplitude = Sqrt[intensity]*
                      (normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*Exp[I*pol3*0.017453292519943295]); 
                    perpendicularamplitude = amplitude . YAxis; \
parallelamplitude = amplitude . PAxis; {rx, ry, rz} = ({rex, rey, rez} - 
                       {-0.05, 0, 0}) . {{1., 0., 0.}, {0., 1., 0.}, {0., 0., \
1.}}; {xunit, yunit, zunit} = {r1, r2, r3} . {{1., 0., 0.}, 
                       {0., 1., 0.}, {0., 0., 1.}}; {xunit, yunit, zunit} = \
{xunit, yunit, zunit}/Sqrt[{xunit, yunit, zunit} . {xunit, yunit, 
                         zunit}]; r1 = ry; dr1 = yunit/Abs[xunit]; ry = \
Plus[r1]; dry = (-(focus/1000))*r1 + dr1; r1 = rz; dr1 = zunit/Abs[xunit]; 
                    rz = Plus[r1]; drz = (-(focus/1000))*r1 + dr1; exitvalue \
= (0 & )[First[{ray2, ray3}], Last[{ray2, ray3}]]*1.0000001; 
                    opticallength = opticallength + exitvalue; {rex, rey, \
rez} = {Sign[xunit]*exitvalue, ry, rz} . {{1., 0, 0}, {0, 1., 0}, 
                        {0, 0, 1.}} + {-0.05, 0, 0}; {r1, r2, r3} = \
{Sign[xunit]/(Sqrt[1 + dry^2]*Sqrt[1 + drz^2]), dry/Sqrt[1 + dry^2], 
                       drz/(Sqrt[1 + drz^2]*Sqrt[1 + dry^2])} . {{1., 0, 0}, \
{0, 1., 0}, {0, 0, 1.}}; dummyvector = {r1, r2, r3}/
                      Sqrt[{r1, r2, r3} . {r1, r2, r3}]; {r1, r2, r3} = \
dummyvector; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \

                       r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                       surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                       pol1, pol2, pol3}}; originalrotation = \
Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; 
                    transmatrix = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        rotationaxis = Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; 
                        If[Chop[axismagnitude] != 0., rotationaxis = \
rotationaxis/axismagnitude; axismatrix = (#1*rotationaxis & ) /@ \
rotationaxis; 
                          crossmatrix = {{0., -rotationaxis[[3]], \
rotationaxis[[2]]}, {rotationaxis[[3]], 0., -rotationaxis[[1]]}, 
                            {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; \
cosangle = previoustilt . {r1, r2, r3}; If[1. - cosangle < 
                            2.220446049250313*^-16, cosangle = 1.]; sinangle \
= 1 - cosangle^2; If[sinangle < 2.220446049250313*^-16, sinangle = 0., 
                           sinangle = Sqrt[sinangle]]; axismatrix + ({{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + 
                           crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, 
                           {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., \
0., 0.}, {0., -1., 0.}, {0., 0., -1.}}]]) & , allcreatedrays]; 
                    allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
Function[mm, (mm . #1 & ) /@ originalrotation][transmatrix[[First[#2]]]]; 
                        tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, r3}/
                            Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; \
dummymatrix = (#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, 
                             {r7, r8, r9}}; {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = dummymatrix; 1., 1.]; If[allcreatedamplitudes != 
                          {{I*0., I*0., I*0.}}, amplitude = \
allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . amplitude; ver = {r7, \
r8, r9} . 
                            amplitude; If[Abs[hor] > 0. || Abs[ver] > 0., \
{pol1, pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = 
                             {pol1, pol2, pol3}/Sqrt[{pol1, pol2, pol3} . \
{pol1, pol2, pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = 
                             ReplacePart[{pol1, pol2, pol3}, (If[ver == 0., \
0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 0.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = If[Chop[xunit] != 0, 
                   {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= \
25., {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                      ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., \
0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24993.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                 intersections = Union[(If[#1[[2]]^2 + #1[[3]]^2 <= 6.25, \
holeQ = True; {-1., 0., 0.}, #1] & ) /@ unfilteredintersections]; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 4., 24993.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 4., 24993.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -0.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1., 0, 0}, {0, 1., 0}, {0, 0, 1.}}; 
                    surfacetranslationvector = {-0.05, 0, 0}; activeregion = \
0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                       rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}})); \
{First[allcreatedrays], completedray}, reporteddummyrayspresent = True; 
                  {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                    opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                    generationnumber, intersectionnumber, pol1, pol2, pol3}, \
{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}], 
               reporteddummyrayspresent = True; deflecteddummyrayspresent = \
True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                  -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = 
                Chop[ry]; rz = Chop[rz]; terminatedeflection = False; \
intersections = {{-1., 0., 0.}}); If[intensity > thresholdintensity, 
               deflectedrayspresent = True; (intersections = If[Chop[xunit] \
!= 0, {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= 
                         35.19455625000001, {#1[[1]], #1[[2]], #1[[3]]}, \
{-1., 0., 0.}] & )[{-(rx/xunit), ry - (rx*yunit)/xunit, 
                      rz - (rx*zunit)/xunit}]}, {{-1., 0., 0.}}]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24994.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                 intersections = Union[(If[#1[[2]]^2 + #1[[3]]^2 <= \
28.810056249999995, holeQ = True; {-1., 0., 0.}, #1] & ) /@ 
                    unfilteredintersections]; If[Length[intersections] > 1, \
dummymatrix = Take[intersections, {2}]; intersections = dummymatrix; 1., 
                  1.]); If[intersections != {{-1., 0., 0.}}, \
intersectionspresent = True; ({newcomponentnumber, newsurfacenumber, \
newsurfaceid} = 
                    {1., 5., 24994.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 5., 24994.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}; 
                    surfacetranslationvector = {0, 0, 0}; activeregion = 0.; \
completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                       rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}})); \
{First[allcreatedrays], completedray}, reporteddummyrayspresent = True; 
                  {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                    opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                    generationnumber, intersectionnumber, pol1, pol2, pol3}, \
{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}], 
               reporteddummyrayspresent = True; deflecteddummyrayspresent = \
True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                  -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = 
                Chop[ry]; rz = Chop[rz]; terminatedeflection = False; \
intersections = {{-1., 0., 0.}}); If[intensity > thresholdintensity, 
               deflectedrayspresent = True; (intersections = \
Block[{surfaceapprox, tempapprox, intersects, LocRayL, LocSCx, LocSCy}, 
                   LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; surfaceapprox = \
{{-1., 0., 0.}}; tempapprox = {{-1., 0., 0.}}; intersects = 
                     {{-1., 0., 0.}}; surfaceapprox = Block[{TempVar, \
TempVar1, TempVar2, TempVar3, LocRayL, LocSCx, LocSCy}, TempVar1 = 1.; 
                       TempVar2 = 1.; TempVar3 = 1.; TempVar = {{-1., 0., \
0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; TempVar1 = rx^2 + ry^2 + 
                         rz^2; TempVar2 = rx*xunit + ry*yunit + rz*zunit - \
10.2*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 2*rx*10.2; 
                       TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] >= 0., \
TempVar3 = Sqrt[TempVar3]; TempVar = {{LocRayL, LocSCx, LocSCy} = 
                             {-TempVar2 - TempVar3, ry - (TempVar2 + \
TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; If[N[Chop[LocRayL]] >= 0. \
&& 
                              LocSCx^2 + LocSCy^2 <= 31.922500000000003 && \
Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - LocSCy] + 
                                Abs[-10.2 + rx + LocRayL*xunit + \
Sqrt[104.03999999999999 - LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, \
LocSCy}, 
                             {-1., 0., 0.}], {LocRayL, LocSCx, LocSCy} = \
{-TempVar2 + TempVar3, ry + (-TempVar2 + TempVar3)*yunit, 
                              rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 31.922500000000003 && 
                              Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[-10.2 + rx + LocRayL*xunit + 
                                  Sqrt[104.03999999999999 - LocSCx^2 - \
LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, LocSCy}, {-1., 0., 0.}]}; 
                         If[TempVar[[1]] == TempVar[[2]], {TempVar[[1]]}, \
TempVar], {{-1., 0., 0.}}]]; tempapprox = Union[Join[(Take[#1, 3] & ) /@ 
                        surfaceapprox, {{-1., 0., 0.}}]]; \
If[Length[Select[tempapprox, Chop[First[#1]] <= 0 & ]] != Length[tempapprox], \

                     surfaceapprox = Select[tempapprox, Chop[First[#1]] > 0 & \
], surfaceapprox = {{-1., 0., 0.}}]; If[surfaceapprox != 
                      {{-1., 0., 0.}}, intersects = {{-1., 0., 0.}}; \
Scan[(AppendTo[intersects, {LocRayL, LocSCx, LocSCy} = {#1[[1]], #1[[2]], 
                             #1[[3]]}; If[Plus @@ Abs[{rx + LocRayL*xunit, ry \
+ LocRayL*yunit, rz + LocRayL*zunit} - {(0.09803921568627452*
                                   (LocSCx^2 + LocSCy^2))/(1 + Sqrt[1 + \
0.020488273740868906*(LocSCx^2 + LocSCy^2)]), LocSCx, LocSCy}] < 1.*^-9, 
                            {LocRayL, LocSCx, LocSCy}, LocRayL = \
0.99*LocRayL; Function[{rx, ry, rz, xunit, yunit, zunit, startpoint}, 
                               Block[{values, stepsizes, fvector, success, \
steps, denominator}, values = {1.}; stepsizes = {1.}; fvector = {1.}; 
                                 success = False; steps = 0; denominator = \
1.; stepsizes = Table[1.0000000000000001*^-7, {3}]; values = startpoint; 
                                 While[steps < 50 && (success = True; \
(If[Abs[#1] > 1.*^-9, success = False; 1., 1.] & ) /@ stepsizes;  !success), 
                                  steps = steps + 1; fvector = {rx + \
xunit*values[[1]], ry + yunit*values[[1]], rz + zunit*values[[1]]} - 
                                     {(0.09803921568627452*(values[[2]]^2 + \
values[[3]]^2))/(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + 
                                            values[[3]]^2)]), values[[2]], \
values[[3]]}; denominator = xunit - yunit*(((0.002008654288320481*
                                          values[[2]]*(values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                               2)]*(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                          values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*-1) - zunit*
                                      (((0.002008654288320481*values[[3]]*(\
values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*
                                             (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^2)])^
                                           2) - \
(0.19607843137254904*values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                               2)]))*-1); \
If[Chop[denominator] != 0, denominator, denominator = 1.]; stepsizes = 
                                    -(#1 . fvector & ) /@ ({{1, \
-(((0.002008654288320481*values[[2]]*(values[[2]]^2 + values[[3]]^2))/
                                             (Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]*(1 + Sqrt[1 + \
0.020488273740868906*
                                                  (values[[2]]^2 + \
values[[3]]^2)])^2) - (0.19607843137254904*values[[2]])/(1 + Sqrt[1 + 
                                                0.020488273740868906*(values[[\
2]]^2 + values[[3]]^2)]))*-1), -(((0.002008654288320481*values[[3]]*
                                              (values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^2)]*
                                              (1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                              values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*-1)}, {yunit, 
                                         -xunit - \
((0.002008654288320481*values[[3]]*(values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + \
0.020488273740868906*
                                                 (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^
                                                  2)])^2) - \
(0.19607843137254904*values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + 
                                                  values[[3]]^2)]))*zunit, \
((0.002008654288320481*values[[3]]*(values[[2]]^2 + values[[3]]^2))/
                                            (Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]*(1 + Sqrt[1 + \
0.020488273740868906*
                                                  (values[[2]]^2 + \
values[[3]]^2)])^2) - (0.19607843137254904*values[[3]])/(1 + Sqrt[1 + 
                                               0.020488273740868906*(values[[\
2]]^2 + values[[3]]^2)]))*yunit}, {zunit, ((0.002008654288320481*
                                             values[[2]]*(values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                                  2)]*(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                             values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*zunit, -xunit - 
                                          ((0.002008654288320481*values[[2]]*(\
values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*
                                                 (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^
                                                  2)])^2) - \
(0.19607843137254904*values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + 
                                                  values[[3]]^2)]))*yunit}}/\
denominator); values = values + stepsizes]; If[steps >= 50, 
                                  If[First[values] > 0, values = -values; 1., \
1.]; denominator = 1., 1.]; values]][rx, ry, rz, xunit, yunit, zunit, 
                              {LocRayL, LocSCx, LocSCy}]]]; {-1., 0., 0.}) & \
, surfaceapprox]; Union[Re[Select[intersects, 
                         ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || (Chop[Im[#1]] == {0, 0, 0} && 
                             N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
31.922500000000003 && Plus @@ Abs[{rx + LocRayL*xunit, 
                                  ry + LocRayL*yunit, rz + LocRayL*zunit} - \
{(0.09803921568627452*(LocSCx^2 + LocSCy^2))/(1 + Sqrt[1 + 
                                      0.020488273740868906*(LocSCx^2 + \
LocSCy^2)]), LocSCx, LocSCy}] < 1.*^-9)) & ]]], {{-1., 0., 0.}}]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24995.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 6., 24995.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 6., 24995.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                   rez = Chop[rez]; intersectionnumber = intersectionnumber + \
1.; opticallength = opticallength + ray1*index1; completedray = 
                    {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                     opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                     generationnumber, intersectionnumber, pol1, pol2, \
pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., \
(0.002008654288320481*ray2^3)/(Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*
                            (1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])^2) + (0.002008654288320481*ray2*ray3^2)/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) - 
                          (0.19607843137254904*ray2)/(1. + Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]), (0.002008654288320481*ray2^2*ray3)/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) + 
                          (0.002008654288320481*ray3^3)/(Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*
                                 (ray2^2 + ray3^2)])^2) - \
(0.19607843137254904*ray3)/(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])}, 
                        {(-0.002008654288320481*ray2*(ray2^2 + \
ray3^2))/(Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)]*
                            (1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])^2) + (0.19607843137254904*ray2)/(1. + Sqrt[
                             1. + 0.020488273740868906*(ray2^2 + ray3^2)]), \
1., 0.}, {(-0.002008654288320481*ray3*(ray2^2 + ray3^2))/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) + 
                          (0.19607843137254904*ray3)/(1. + Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]), 0., 1.}}]; 
                    If[surfnorm[[1]] == {0., 0., 0.} || surfnorm[[2]] == {0., \
0., 0.} || surfnorm[[3]] == {0., 0., 0.}, 
                     surfnorm = 1.*Re[{{1., (0.002008654288320481*(1.*^-6 + \
ray2)^3)/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.002008654288320481*(1.*^-6 + ray2)*(1.*^-6 + \
ray3)^2)/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.19607843137254904*(1.*^-6 + ray2))/(1. + \
Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 
                           (0.002008654288320481*(1.*^-6 + ray2)^2*(1.*^-6 + \
ray3))/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.002008654288320481*(1.*^-6 + ray3)^3)/(Sqrt[1. \
+ 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*
                              (1. + Sqrt[1. + 0.020488273740868906*((1.*^-6 + \
ray2)^2 + (1.*^-6 + ray3)^2)])^2) - (0.19607843137254904*(1.*^-6 + 
                               ray3))/(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])}, \
{(-0.002008654288320481*
                              (1.*^-6 + ray2)*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2))/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.19607843137254904*(1.*^-6 + ray2))/(1. + \
Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 1., \

                           0.}, {(-0.002008654288320481*(1.*^-6 + \
ray3)*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2))/(Sqrt[1. + \
0.020488273740868906*
                                 ((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*(1. \
+ Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^
                                     2)])^2) + (0.19607843137254904*(1.*^-6 + \
ray3))/(1. + Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]), 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1, 0, 0}, {0, 1, \
0}, {0, 0, 1}}; surfacetranslationvector = {0, 0, 0}; 
                    activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.676591682864066 - 1.1701284013479643*wavelength + 
                        1.824530254455512*wavelength^2 - \
0.9804493049167423*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.5532682085813037 - \
1.0054245500503685*wavelength + 1.6027810806802343*wavelength^2 - \
0.8794405514298376*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = \
1.5532682085813037 - 1.0054245500503685*wavelength + \
1.6027810806802343*wavelength^2 - 
                         0.8794405514298376*wavelength^3], index2 = \
1.5532682085813037 - 1.0054245500503685*wavelength + 1.6027810806802343*
                         wavelength^2 - 0.8794405514298376*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.676591682864066 - 1.1701284013479643*wavelength + \
1.824530254455512*wavelength^2 - 0.9804493049167423*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.676591682864066 - \
1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - \
0.9804493049167423*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = -4. + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1. + I*0.; 
                    LocSCx = 1. + I*0.; LocSCy = 1. + I*0.; \
Re[Select[If[yunit^2 + zunit^2 == 0., {{-1. + 0.*I, 0. + 0.*I, 0. + 0.*I}, 
                        {(-0.08333333333333333*(12.*rx + ry^2 + \
rz^2)*Sqrt[xunit^2])/xunit^2, (ry*Sqrt[xunit^2])/xunit, rz}}, 
                       {{-1. + 0.*I, 0. + 0.*I, 0. + 0.*I}, {(-6.*xunit - \
1.*ry*yunit - 1.*rz*zunit - 1.*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2), (-6.*xunit*yunit - \
1.*rz*yunit*zunit + ry*zunit^2 - 1.*yunit*Sqrt[36.*xunit^2 + \
12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2), (rz*yunit^2 - 6.*xunit*zunit - \
1.*ry*yunit*zunit - 1.*zunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2)}, {(-6.*xunit - 1.*ry*yunit - \
1.*rz*zunit + Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                             1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + \
zunit^2), 
                         (-6.*xunit*yunit - 1.*rz*yunit*zunit + ry*zunit^2 + \
yunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                              1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + \
zunit^2), 
                         (rz*yunit^2 - 6.*xunit*zunit - 1.*ry*yunit*zunit + \
zunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                              1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + 
                           zunit^2)}}], ({LocRayL, LocSCx, LocSCy} = #1; \
{LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || (Chop[Im[#1]] == {0, 0, 0} && 
                          N[Chop[Re[LocRayL]]] >= 0. && Abs[ry + \
LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - LocSCy] + 
                            Abs[rx + LocRayL*xunit + (LocSCx^2 + \
LocSCy^2)/12] < 1.*^-7 && Re[LocSCx]^2 + Re[LocSCy]^2 <= 31.922500000000003)) \
& ]]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24996.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 7., 24996.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 7., 24996.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = 4. \
+ rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                   rez = Chop[rez]; intersectionnumber = intersectionnumber + \
1.; opticallength = opticallength + ray1*index1; completedray = 
                    {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                     opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                     generationnumber, intersectionnumber, pol1, pol2, \
pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., Plus[(0.3333333333333333*ray2)/(1. \
+ Sqrt[Plus[1.]])], Plus[(0.3333333333333333*ray3)/
                           (1. + Sqrt[Plus[1.]])]}, \
{Plus[(-0.3333333333333333*ray2)/(1. + Sqrt[Plus[1.]])], 1., 0.}, 
                        {Plus[(-0.3333333333333333*ray3)/(1. + \
Sqrt[Plus[1.]])], 0., 1.}}]; If[surfnorm[[1]] == {0., 0., 0.} || \
surfnorm[[2]] == 
                       {0., 0., 0.} || surfnorm[[3]] == {0., 0., 0.}, \
surfnorm = 1.*Re[{{1., Plus[(0.3333333333333333*(1.*^-6 + ray2))/
                             (1. + Sqrt[Plus[1.]])], \
Plus[(0.3333333333333333*(1.*^-6 + ray3))/(1. + Sqrt[Plus[1.]])]}, 
                          {Plus[(-0.3333333333333333*(1.*^-6 + ray2))/(1. + \
Sqrt[Plus[1.]])], 1., 0.}, {Plus[(-0.3333333333333333*(1.*^-6 + ray3))/
                             (1. + Sqrt[Plus[1.]])], 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1., 0, 0}, {0, \
1., 0}, {0, 0, 1.}}; surfacetranslationvector = {4., 0, 0}; 
                    activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.4992664079787237 - 0.7232199522002112*wavelength + 
                        1.0984449372281133*wavelength^2 - \
0.5792106405034075*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.676591682864066 - \
1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - \
0.9804493049167423*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = 1.676591682864066 \
- 1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - 
                         0.9804493049167423*wavelength^3], index2 = \
1.676591682864066 - 1.1701284013479643*wavelength + 1.824530254455512*
                         wavelength^2 - 0.9804493049167423*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.4992664079787237 - 0.7232199522002112*wavelength + \
1.0984449372281133*wavelength^2 - 0.5792106405034075*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.4992664079787237 - \
0.7232199522002112*wavelength + 1.0984449372281133*wavelength^2 - \
0.5792106405034075*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = -20.3203 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{TempVar, TempVar1, TempVar2, TempVar3, LocRayL, 
                    LocSCx, LocSCy}, TempVar1 = 1.; TempVar2 = 1.; TempVar3 = \
1.; TempVar = {{-1., 0., 0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; 
                    TempVar1 = rx^2 + ry^2 + rz^2; TempVar2 = rx*xunit + \
ry*yunit + rz*zunit - -12*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 
                      2*rx*-12; TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] \
>= 0., TempVar3 = Sqrt[TempVar3]; TempVar = 
                       {{LocRayL, LocSCx, LocSCy} = {-TempVar2 - TempVar3, ry \
- (TempVar2 + TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; 
                         If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
142.80249999999998 && Abs[ry + LocRayL*yunit - LocSCx] + 
                             Abs[rz + LocRayL*zunit - LocSCy] + Abs[12 + rx + \
LocRayL*xunit - Sqrt[144 - LocSCx^2 - LocSCy^2]] < 1.*^-7, 
                          {LocRayL, LocSCx, LocSCy}, {-1., 0., 0.}], \
{LocRayL, LocSCx, LocSCy} = {-TempVar2 + TempVar3, ry + (-TempVar2 + \
TempVar3)*
                             yunit, rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 142.80249999999998 && 
                           Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[12 + rx + LocRayL*xunit - Sqrt[144 - LocSCx^2 - \

                                 LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, \
LocSCy}, {-1., 0., 0.}]}; If[TempVar[[1]] == TempVar[[2]], {TempVar[[1]]}, 
                       TempVar], {{-1., 0., 0.}}]]; AppendTo[intersections, \
{-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24997.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 8., 24997.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 8., 24997.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = 20.3203 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., \
-(-(ray2/(144 - ray2^2 - ray3^2)^2^(-1))), -(-(ray3/(144 - ray2^2 - ray3^2)^
                             2^(-1)))}, {-(ray2/(144 - ray2^2 - \
ray3^2)^2^(-1)), 1., 0.}, {-(ray3/(144 - ray2^2 - ray3^2)^2^(-1)), 0., 1.}}]; \

                    dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 \
. #1] & ) /@ dummymatrix; surfacerotationmatrix = {{1., 0, 0}, 
                      {0, 1., 0}, {0, 0, 1.}}; surfacetranslationvector = \
{20.3203, 0, 0}; activeregion = 0.; completedray = {rsx, rsy, rsz, rex, 
                      rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, 
                      componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                      intersectionnumber, pol1, pol2, pol3}; componentnumber \
= newcomponentnumber; surfacenumber = newsurfacenumber; 
                    surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; intensity = 0.; allcreatedrays = 
                     {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                       opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}})); {First[allcreatedrays], completedray}, 
                 reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                    intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                    sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., \
1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1.}}], reporteddummyrayspresent = True; \
deflecteddummyrayspresent = True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 
                  1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., \
-1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = -4. + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1. + I*0.; 
                    LocSCx = 1. + I*0.; LocSCy = 1. + I*0.; \
Re[Select[If[yunit^2 + zunit^2 == 0., {{-1. + 0.*I, 0. + 0.*I, 0. + 0.*I}, 
                        {(-0.08333333333333333*(12.*rx + ry^2 + \
rz^2)*Sqrt[xunit^2])/xunit^2, (ry*Sqrt[xunit^2])/xunit, rz}}, 
                       {{-1. + 0.*I, 0. + 0.*I, 0. + 0.*I}, {(-6.*xunit - \
1.*ry*yunit - 1.*rz*zunit - 1.*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2), (-6.*xunit*yunit - \
1.*rz*yunit*zunit + ry*zunit^2 - 1.*yunit*Sqrt[36.*xunit^2 + \
12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2), (rz*yunit^2 - 6.*xunit*zunit - \
1.*ry*yunit*zunit - 1.*zunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2)}, {(-6.*xunit - 1.*ry*yunit - \
1.*rz*zunit + Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                             1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + \
zunit^2), 
                         (-6.*xunit*yunit - 1.*rz*yunit*zunit + ry*zunit^2 + \
yunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                              1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + \
zunit^2), 
                         (rz*yunit^2 - 6.*xunit*zunit - 1.*ry*yunit*zunit + \
zunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                              1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + 
                           zunit^2)}}], ({LocRayL, LocSCx, LocSCy} = #1; \
{LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || (Chop[Im[#1]] == {0, 0, 0} && 
                          N[Chop[Re[LocRayL]]] >= 0. && Abs[ry + \
LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - LocSCy] + 
                            Abs[rx + LocRayL*xunit + (LocSCx^2 + \
LocSCy^2)/12] < 1.*^-7 && Re[LocSCx]^2 + Re[LocSCy]^2 <= 31.922500000000003)) \
& ]]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24998.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 9., 24998.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 9., 24998.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = 4. \
+ rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                   rez = Chop[rez]; intersectionnumber = intersectionnumber + \
1.; opticallength = opticallength + ray1*index1; completedray = 
                    {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                     opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                     generationnumber, intersectionnumber, pol1, pol2, \
pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., Plus[(0.3333333333333333*ray2)/(1. \
+ Sqrt[Plus[1.]])], Plus[(0.3333333333333333*ray3)/
                           (1. + Sqrt[Plus[1.]])]}, \
{Plus[(-0.3333333333333333*ray2)/(1. + Sqrt[Plus[1.]])], 1., 0.}, 
                        {Plus[(-0.3333333333333333*ray3)/(1. + \
Sqrt[Plus[1.]])], 0., 1.}}]; If[surfnorm[[1]] == {0., 0., 0.} || \
surfnorm[[2]] == 
                       {0., 0., 0.} || surfnorm[[3]] == {0., 0., 0.}, \
surfnorm = 1.*Re[{{1., Plus[(0.3333333333333333*(1.*^-6 + ray2))/
                             (1. + Sqrt[Plus[1.]])], \
Plus[(0.3333333333333333*(1.*^-6 + ray3))/(1. + Sqrt[Plus[1.]])]}, 
                          {Plus[(-0.3333333333333333*(1.*^-6 + ray2))/(1. + \
Sqrt[Plus[1.]])], 1., 0.}, {Plus[(-0.3333333333333333*(1.*^-6 + ray3))/
                             (1. + Sqrt[Plus[1.]])], 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1., 0, 0}, {0, \
1., 0}, {0, 0, 1.}}; surfacetranslationvector = {4., 0, 0}; 
                    activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.4992664079787237 - 0.7232199522002112*wavelength + 
                        1.0984449372281133*wavelength^2 - \
0.5792106405034075*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.676591682864066 - \
1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - \
0.9804493049167423*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = 1.676591682864066 \
- 1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - 
                         0.9804493049167423*wavelength^3], index2 = \
1.676591682864066 - 1.1701284013479643*wavelength + 1.824530254455512*
                         wavelength^2 - 0.9804493049167423*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.4992664079787237 - 0.7232199522002112*wavelength + \
1.0984449372281133*wavelength^2 - 0.5792106405034075*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.4992664079787237 - \
0.7232199522002112*wavelength + 1.0984449372281133*wavelength^2 - \
0.5792106405034075*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = 
                Chop[ry]; rz = Chop[rz]; terminatedeflection = False; \
intersections = {{-1., 0., 0.}}); If[intensity > thresholdintensity, 
               deflectedrayspresent = True; (intersections = \
Block[{surfaceapprox, tempapprox, intersects, LocRayL, LocSCx, LocSCy}, 
                   LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; surfaceapprox = \
{{-1., 0., 0.}}; tempapprox = {{-1., 0., 0.}}; intersects = 
                     {{-1., 0., 0.}}; surfaceapprox = Block[{TempVar, \
TempVar1, TempVar2, TempVar3, LocRayL, LocSCx, LocSCy}, TempVar1 = 1.; 
                       TempVar2 = 1.; TempVar3 = 1.; TempVar = {{-1., 0., \
0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; TempVar1 = rx^2 + ry^2 + 
                         rz^2; TempVar2 = rx*xunit + ry*yunit + rz*zunit - \
10.2*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 2*rx*10.2; 
                       TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] >= 0., \
TempVar3 = Sqrt[TempVar3]; TempVar = {{LocRayL, LocSCx, LocSCy} = 
                             {-TempVar2 - TempVar3, ry - (TempVar2 + \
TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; If[N[Chop[LocRayL]] >= 0. \
&& 
                              LocSCx^2 + LocSCy^2 <= 31.922500000000003 && \
Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - LocSCy] + 
                                Abs[-10.2 + rx + LocRayL*xunit + \
Sqrt[104.03999999999999 - LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, \
LocSCy}, 
                             {-1., 0., 0.}], {LocRayL, LocSCx, LocSCy} = \
{-TempVar2 + TempVar3, ry + (-TempVar2 + TempVar3)*yunit, 
                              rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 31.922500000000003 && 
                              Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[-10.2 + rx + LocRayL*xunit + 
                                  Sqrt[104.03999999999999 - LocSCx^2 - \
LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, LocSCy}, {-1., 0., 0.}]}; 
                         If[TempVar[[1]] == TempVar[[2]], {TempVar[[1]]}, \
TempVar], {{-1., 0., 0.}}]]; tempapprox = Union[Join[(Take[#1, 3] & ) /@ 
                        surfaceapprox, {{-1., 0., 0.}}]]; \
If[Length[Select[tempapprox, Chop[First[#1]] <= 0 & ]] != Length[tempapprox], \

                     surfaceapprox = Select[tempapprox, Chop[First[#1]] > 0 & \
], surfaceapprox = {{-1., 0., 0.}}]; If[surfaceapprox != 
                      {{-1., 0., 0.}}, intersects = {{-1., 0., 0.}}; \
Scan[(AppendTo[intersects, {LocRayL, LocSCx, LocSCy} = {#1[[1]], #1[[2]], 
                             #1[[3]]}; If[Plus @@ Abs[{rx + LocRayL*xunit, ry \
+ LocRayL*yunit, rz + LocRayL*zunit} - {(0.09803921568627452*
                                   (LocSCx^2 + LocSCy^2))/(1 + Sqrt[1 + \
0.020488273740868906*(LocSCx^2 + LocSCy^2)]), LocSCx, LocSCy}] < 1.*^-9, 
                            {LocRayL, LocSCx, LocSCy}, LocRayL = \
0.99*LocRayL; Function[{rx, ry, rz, xunit, yunit, zunit, startpoint}, 
                               Block[{values, stepsizes, fvector, success, \
steps, denominator}, values = {1.}; stepsizes = {1.}; fvector = {1.}; 
                                 success = False; steps = 0; denominator = \
1.; stepsizes = Table[1.0000000000000001*^-7, {3}]; values = startpoint; 
                                 While[steps < 50 && (success = True; \
(If[Abs[#1] > 1.*^-9, success = False; 1., 1.] & ) /@ stepsizes;  !success), 
                                  steps = steps + 1; fvector = {rx + \
xunit*values[[1]], ry + yunit*values[[1]], rz + zunit*values[[1]]} - 
                                     {(0.09803921568627452*(values[[2]]^2 + \
values[[3]]^2))/(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + 
                                            values[[3]]^2)]), values[[2]], \
values[[3]]}; denominator = xunit - yunit*(((0.002008654288320481*
                                          values[[2]]*(values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                               2)]*(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                          values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*-1) - zunit*
                                      (((0.002008654288320481*values[[3]]*(\
values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*
                                             (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^2)])^
                                           2) - \
(0.19607843137254904*values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                               2)]))*-1); \
If[Chop[denominator] != 0, denominator, denominator = 1.]; stepsizes = 
                                    -(#1 . fvector & ) /@ ({{1, \
-(((0.002008654288320481*values[[2]]*(values[[2]]^2 + values[[3]]^2))/
                                             (Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]*(1 + Sqrt[1 + \
0.020488273740868906*
                                                  (values[[2]]^2 + \
values[[3]]^2)])^2) - (0.19607843137254904*values[[2]])/(1 + Sqrt[1 + 
                                                0.020488273740868906*(values[[\
2]]^2 + values[[3]]^2)]))*-1), -(((0.002008654288320481*values[[3]]*
                                              (values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^2)]*
                                              (1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                              values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*-1)}, {yunit, 
                                         -xunit - \
((0.002008654288320481*values[[3]]*(values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + \
0.020488273740868906*
                                                 (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^
                                                  2)])^2) - \
(0.19607843137254904*values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + 
                                                  values[[3]]^2)]))*zunit, \
((0.002008654288320481*values[[3]]*(values[[2]]^2 + values[[3]]^2))/
                                            (Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]*(1 + Sqrt[1 + \
0.020488273740868906*
                                                  (values[[2]]^2 + \
values[[3]]^2)])^2) - (0.19607843137254904*values[[3]])/(1 + Sqrt[1 + 
                                               0.020488273740868906*(values[[\
2]]^2 + values[[3]]^2)]))*yunit}, {zunit, ((0.002008654288320481*
                                             values[[2]]*(values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                                  2)]*(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                             values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*zunit, -xunit - 
                                          ((0.002008654288320481*values[[2]]*(\
values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*
                                                 (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^
                                                  2)])^2) - \
(0.19607843137254904*values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + 
                                                  values[[3]]^2)]))*yunit}}/\
denominator); values = values + stepsizes]; If[steps >= 50, 
                                  If[First[values] > 0, values = -values; 1., \
1.]; denominator = 1., 1.]; values]][rx, ry, rz, xunit, yunit, zunit, 
                              {LocRayL, LocSCx, LocSCy}]]]; {-1., 0., 0.}) & \
, surfaceapprox]; Union[Re[Select[intersects, 
                         ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || (Chop[Im[#1]] == {0, 0, 0} && 
                             N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
31.922500000000003 && Plus @@ Abs[{rx + LocRayL*xunit, 
                                  ry + LocRayL*yunit, rz + LocRayL*zunit} - \
{(0.09803921568627452*(LocSCx^2 + LocSCy^2))/(1 + Sqrt[1 + 
                                      0.020488273740868906*(LocSCx^2 + \
LocSCy^2)]), LocSCx, LocSCy}] < 1.*^-9)) & ]]], {{-1., 0., 0.}}]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24999.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 10., 24999.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 10., 24999.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                   rez = Chop[rez]; intersectionnumber = intersectionnumber + \
1.; opticallength = opticallength + ray1*index1; completedray = 
                    {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                     opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                     generationnumber, intersectionnumber, pol1, pol2, \
pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., \
(0.002008654288320481*ray2^3)/(Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*
                            (1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])^2) + (0.002008654288320481*ray2*ray3^2)/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) - 
                          (0.19607843137254904*ray2)/(1. + Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]), (0.002008654288320481*ray2^2*ray3)/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) + 
                          (0.002008654288320481*ray3^3)/(Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*
                                 (ray2^2 + ray3^2)])^2) - \
(0.19607843137254904*ray3)/(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])}, 
                        {(-0.002008654288320481*ray2*(ray2^2 + \
ray3^2))/(Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)]*
                            (1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])^2) + (0.19607843137254904*ray2)/(1. + Sqrt[
                             1. + 0.020488273740868906*(ray2^2 + ray3^2)]), \
1., 0.}, {(-0.002008654288320481*ray3*(ray2^2 + ray3^2))/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) + 
                          (0.19607843137254904*ray3)/(1. + Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]), 0., 1.}}]; 
                    If[surfnorm[[1]] == {0., 0., 0.} || surfnorm[[2]] == {0., \
0., 0.} || surfnorm[[3]] == {0., 0., 0.}, 
                     surfnorm = 1.*Re[{{1., (0.002008654288320481*(1.*^-6 + \
ray2)^3)/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.002008654288320481*(1.*^-6 + ray2)*(1.*^-6 + \
ray3)^2)/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.19607843137254904*(1.*^-6 + ray2))/(1. + \
Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 
                           (0.002008654288320481*(1.*^-6 + ray2)^2*(1.*^-6 + \
ray3))/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.002008654288320481*(1.*^-6 + ray3)^3)/(Sqrt[1. \
+ 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*
                              (1. + Sqrt[1. + 0.020488273740868906*((1.*^-6 + \
ray2)^2 + (1.*^-6 + ray3)^2)])^2) - (0.19607843137254904*(1.*^-6 + 
                               ray3))/(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])}, \
{(-0.002008654288320481*
                              (1.*^-6 + ray2)*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2))/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.19607843137254904*(1.*^-6 + ray2))/(1. + \
Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 1., \

                           0.}, {(-0.002008654288320481*(1.*^-6 + \
ray3)*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2))/(Sqrt[1. + \
0.020488273740868906*
                                 ((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*(1. \
+ Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^
                                     2)])^2) + (0.19607843137254904*(1.*^-6 + \
ray3))/(1. + Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]), 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1, 0, 0}, {0, 1, \
0}, {0, 0, 1}}; surfacetranslationvector = {0, 0, 0}; 
                    activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.676591682864066 - 1.1701284013479643*wavelength + 
                        1.824530254455512*wavelength^2 - \
0.9804493049167423*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.5532682085813037 - \
1.0054245500503685*wavelength + 1.6027810806802343*wavelength^2 - \
0.8794405514298376*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = \
1.5532682085813037 - 1.0054245500503685*wavelength + \
1.6027810806802343*wavelength^2 - 
                         0.8794405514298376*wavelength^3], index2 = \
1.5532682085813037 - 1.0054245500503685*wavelength + 1.6027810806802343*
                         wavelength^2 - 0.8794405514298376*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.676591682864066 - 1.1701284013479643*wavelength + \
1.824530254455512*wavelength^2 - 0.9804493049167423*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.676591682864066 - \
1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - \
0.9804493049167423*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = 
                Chop[ry]; rz = Chop[rz]; terminatedeflection = False; \
intersections = {{-1., 0., 0.}}); If[intensity > thresholdintensity, 
               deflectedrayspresent = True; (intersections = If[Chop[xunit] \
!= 0, {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= 
                         32.56414225, {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., \
0.}] & )[{-(rx/xunit), ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, 
                   {{-1., 0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; \
holeQ = False; If[ !(Chop[surfaceid - 25000.] == 0. || 
                     N[Chop[ray1]] < 0.0001) || generationnumber == 1., \
minresonateraylength = 0., minresonateraylength = 0.0001]; 
                 Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1.; LocSCx = 1.; \
LocSCy = 1.; dummymatrix = Union[Select[intersections, 
                      ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= minresonateraylength) & ]]; 
                   intersections = dummymatrix]; unfilteredintersections = \
intersections; If[Length[intersections] > 1, 
                  dummymatrix = Take[intersections, {2}]; intersections = \
dummymatrix; 1., 1.]; intersections = 
                  Union[(If[#1[[2]]^2 + #1[[3]]^2 <= 31.287242250000006, \
holeQ = True; {-1., 0., 0.}, #1] & ) /@ unfilteredintersections]; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 11., 25000.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 11., 25000.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}; 
                    surfacetranslationvector = {0, 0, 0}; activeregion = 0.; \
completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                       rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}})); \
{First[allcreatedrays], completedray}, reporteddummyrayspresent = True; 
                  {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                    opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                    generationnumber, intersectionnumber, pol1, pol2, pol3}, \
{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}], 
               reporteddummyrayspresent = True; deflecteddummyrayspresent = \
True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                  -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 0.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = If[Chop[xunit] != 0, 
                   {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= \
6.25, {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                      ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., \
0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 25001.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 12., 25001.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 12., 25001.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -0.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1., 0, 0}, {0, 1., 0}, {0, 0, 1.}}; 
                    surfacetranslationvector = {-0.05, 0, 0}; activeregion = \
0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, r3}]; 
                    raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - \
raytiltz^2; If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., 
                     raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - \
ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], 
                     XAxis = XAxis/raytiltx]; YAxis = \
{-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*
                        XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + \
ZAxis[[1]]*XAxis[[2]]}; YAxis = YAxis/Sqrt[YAxis . YAxis]; 
                    PAxis = ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . \
ZAxis; PAxis = PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = 
                     {pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = \
normalizedpolarization/Sqrt[normalizedpolarization . 
                        normalizedpolarization]; allcreatedamplitudes = \
{{I*0., I*0., I*0.}}; amplitude = Sqrt[intensity]*
                      (normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*Exp[I*pol3*0.017453292519943295]); 
                    perpendicularamplitude = amplitude . YAxis; \
parallelamplitude = amplitude . PAxis; {rx, ry, rz} = ({rex, rey, rez} - 
                       {-0.05, 0, 0}) . {{1., 0., 0.}, {0., 1., 0.}, {0., 0., \
1.}}; {xunit, yunit, zunit} = {r1, r2, r3} . {{1., 0., 0.}, 
                       {0., 1., 0.}, {0., 0., 1.}}; {xunit, yunit, zunit} = \
{xunit, yunit, zunit}/Sqrt[{xunit, yunit, zunit} . {xunit, yunit, 
                         zunit}]; r1 = ry; dr1 = yunit/Abs[xunit]; ry = \
Plus[r1]; dry = (-(focus/1000))*r1 + dr1; r1 = rz; dr1 = zunit/Abs[xunit]; 
                    rz = Plus[r1]; drz = (-(focus/1000))*r1 + dr1; exitvalue \
= (0 & )[First[{ray2, ray3}], Last[{ray2, ray3}]]*1.0000001; 
                    opticallength = opticallength + exitvalue; {rex, rey, \
rez} = {Sign[xunit]*exitvalue, ry, rz} . {{1., 0, 0}, {0, 1., 0}, 
                        {0, 0, 1.}} + {-0.05, 0, 0}; {r1, r2, r3} = \
{Sign[xunit]/(Sqrt[1 + dry^2]*Sqrt[1 + drz^2]), dry/Sqrt[1 + dry^2], 
                       drz/(Sqrt[1 + drz^2]*Sqrt[1 + dry^2])} . {{1., 0, 0}, \
{0, 1., 0}, {0, 0, 1.}}; dummyvector = {r1, r2, r3}/
                      Sqrt[{r1, r2, r3} . {r1, r2, r3}]; {r1, r2, r3} = \
dummyvector; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \

                       r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                       surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                       pol1, pol2, pol3}}; originalrotation = \
Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; 
                    transmatrix = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        rotationaxis = Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; 
                        If[Chop[axismagnitude] != 0., rotationaxis = \
rotationaxis/axismagnitude; axismatrix = (#1*rotationaxis & ) /@ \
rotationaxis; 
                          crossmatrix = {{0., -rotationaxis[[3]], \
rotationaxis[[2]]}, {rotationaxis[[3]], 0., -rotationaxis[[1]]}, 
                            {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; \
cosangle = previoustilt . {r1, r2, r3}; If[1. - cosangle < 
                            2.220446049250313*^-16, cosangle = 1.]; sinangle \
= 1 - cosangle^2; If[sinangle < 2.220446049250313*^-16, sinangle = 0., 
                           sinangle = Sqrt[sinangle]]; axismatrix + ({{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + 
                           crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, 
                           {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., \
0., 0.}, {0., -1., 0.}, {0., 0., -1.}}]]) & , allcreatedrays]; 
                    allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
Function[mm, (mm . #1 & ) /@ originalrotation][transmatrix[[First[#2]]]]; 
                        tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, r3}/
                            Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; \
dummymatrix = (#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, 
                             {r7, r8, r9}}; {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = dummymatrix; 1., 1.]; If[allcreatedamplitudes != 
                          {{I*0., I*0., I*0.}}, amplitude = \
allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . amplitude; ver = {r7, \
r8, r9} . 
                            amplitude; If[Abs[hor] > 0. || Abs[ver] > 0., \
{pol1, pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = 
                             {pol1, pol2, pol3}/Sqrt[{pol1, pol2, pol3} . \
{pol1, pol2, pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = 
                             ReplacePart[{pol1, pol2, pol3}, (If[ver == 0., \
0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 0.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = If[Chop[xunit] != 0, 
                   {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= \
25., {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                      ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., \
0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 25002.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                 intersections = Union[(If[#1[[2]]^2 + #1[[3]]^2 <= 6.25, \
holeQ = True; {-1., 0., 0.}, #1] & ) /@ unfilteredintersections]; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 13., 25002.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 13., 25002.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -0.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1., 0, 0}, {0, 1., 0}, {0, 0, 1.}}; 
                    surfacetranslationvector = {-0.05, 0, 0}; activeregion = \
0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                       rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}})); \
{First[allcreatedrays], completedray}, reporteddummyrayspresent = True; 
                  {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                    opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                    generationnumber, intersectionnumber, pol1, pol2, pol3}, \
{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}], 
               reporteddummyrayspresent = True; deflecteddummyrayspresent = \
True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                  -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 3.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{TempVar, TempVar1, TempVar2, TempVar3, LocRayL, 
                    LocSCx, LocSCy}, TempVar1 = 1.; TempVar2 = 1.; TempVar3 = \
1.; TempVar = {{-1., 0., 0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; 
                    TempVar1 = rx^2 + ry^2 + rz^2; TempVar2 = rx*xunit + \
ry*yunit + rz*zunit - 6.5*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 
                      2*rx*6.5; TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] \
>= 0., TempVar3 = Sqrt[TempVar3]; TempVar = 
                       {{LocRayL, LocSCx, LocSCy} = {-TempVar2 - TempVar3, ry \
- (TempVar2 + TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; 
                         If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
25. && Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - 
                               LocSCy] + Abs[-6.5 + rx + LocRayL*xunit + \
Sqrt[42.25 - LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, LocSCy}, 
                          {-1., 0., 0.}], {LocRayL, LocSCx, LocSCy} = \
{-TempVar2 + TempVar3, ry + (-TempVar2 + TempVar3)*yunit, 
                           rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 25. && 
                           Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[-6.5 + rx + LocRayL*xunit + Sqrt[42.25 - 
                                 LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, \
LocSCx, LocSCy}, {-1., 0., 0.}]}; If[TempVar[[1]] == TempVar[[2]], 
                       {TempVar[[1]]}, TempVar], {{-1., 0., 0.}}]]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 25003.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 14., 25003.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 14., 25003.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -3.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., \
-(ray2/(42.25 - ray2^2 - ray3^2)^2^(-1)), -(ray3/(42.25 - ray2^2 - ray3^2)^
                            2^(-1))}, {ray2/(42.25 - ray2^2 - ray3^2)^2^(-1), \
1., 0.}, {ray3/(42.25 - ray2^2 - ray3^2)^2^(-1), 0., 1.}}]; 
                    dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 \
. #1] & ) /@ dummymatrix; surfacerotationmatrix = {{1., 0, 0}, 
                      {0, 1., 0}, {0, 0, 1.}}; surfacetranslationvector = \
{-3.05, 0, 0}; activeregion = 1.; completedray = {rsx, rsy, rsz, rex, rey, 
                      rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                      componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                      intersectionnumber, pol1, pol2, pol3}; componentnumber \
= newcomponentnumber; surfacenumber = newsurfacenumber; 
                    surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; ZAxis = First[surfnorm]*
                      Sign[First[surfnorm] . {r1, r2, r3}]; raytiltz = ZAxis \
. {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.5532682085813037 - 1.0054245500503685*wavelength + 
                        1.6027810806802343*wavelength^2 - \
0.8794405514298376*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.5392664079785716 - \
0.7232199521994117*wavelength + 1.0984449372267269*wavelength^2 - \
0.5792106405020717*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = \
1.5392664079785716 - 0.7232199521994117*wavelength + \
1.0984449372267269*wavelength^2 - 
                         0.5792106405020717*wavelength^3], index2 = \
1.5392664079785716 - 0.7232199521994117*wavelength + 1.0984449372267269*
                         wavelength^2 - 0.5792106405020717*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.5532682085813037 - 1.0054245500503685*wavelength + \
1.6027810806802343*wavelength^2 - 0.8794405514298376*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.5532682085813037 - \
1.0054245500503685*wavelength + 1.6027810806802343*wavelength^2 - \
0.8794405514298376*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 3.5999999999999996 + rex; ry = rey; rz = 
                rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1. + I*0.; 
                    LocSCx = 1. + I*0.; LocSCy = 1. + I*0.; Re[Select[{{-1. + \
0.*I, 0. + 0.*I, 0. + 0.*I}, {(386.*xunit - 37.*rx*xunit - 
                          50.*ry*yunit - 50.*rz*zunit - \
1.4142135623730951*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - \
925.*rz^2*xunit^2 - 
                             19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit \
+ 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 1250.*rz^2*yunit^2 - 
                             19300.*rz*xunit*zunit + 1850.*rx*rz*xunit*zunit \
+ 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 925.*rx^2*zunit^2 - 
                             1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 \
+ 50.*zunit^2), (37.*ry*xunit^2 + 386.*xunit*yunit - 37.*rx*xunit*
                           yunit - 50.*rz*yunit*zunit + 50.*ry*zunit^2 - \
1.4142135623730951*yunit*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - 
                             925.*rz^2*xunit^2 - 19300.*ry*xunit*yunit + \
1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2), \
(37.*rz*xunit^2 + 50.*rz*yunit^2 + 
                          386.*xunit*zunit - 37.*rx*xunit*zunit - \
50.*ry*yunit*zunit - 1.4142135623730951*zunit*Sqrt[74498.*xunit^2 - \
925.*ry^2*
                              xunit^2 - 925.*rz^2*xunit^2 - \
19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - \
925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2)}, {(386.*xunit \
- 37.*rx*xunit - 
                          50.*ry*yunit - 50.*rz*zunit + \
1.4142135623730951*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - \
925.*rz^2*xunit^2 - 
                             19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit \
+ 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 1250.*rz^2*yunit^2 - 
                             19300.*rz*xunit*zunit + 1850.*rx*rz*xunit*zunit \
+ 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 925.*rx^2*zunit^2 - 
                             1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 \
+ 50.*zunit^2), (37.*ry*xunit^2 + 386.*xunit*yunit - 37.*rx*xunit*
                           yunit - 50.*rz*yunit*zunit + 50.*ry*zunit^2 + \
1.4142135623730951*yunit*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - 
                             925.*rz^2*xunit^2 - 19300.*ry*xunit*yunit + \
1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2), \
(37.*rz*xunit^2 + 50.*rz*yunit^2 + 
                          386.*xunit*zunit - 37.*rx*xunit*zunit - \
50.*ry*yunit*zunit + 1.4142135623730951*zunit*Sqrt[74498.*xunit^2 - \
925.*ry^2*
                              xunit^2 - 925.*rz^2*xunit^2 - \
19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - \
925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2)}}, ({LocRayL, \
LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
(Chop[Im[#1]] == {0, 0, 0} && N[Chop[Re[LocRayL]]] >= 0. && 
                          Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[rx + LocRayL*xunit - (25*(LocSCx^2 + \
LocSCy^2))/
                               (193*(1 + Sqrt[1 - (925*(LocSCx^2 + \
LocSCy^2))/74498]))] < 1.*^-7 && Re[LocSCx]^2 + Re[LocSCy]^2 <= 39.0625)) & \
]]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 25004.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 15., 25004.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 15., 25004.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
-3.5999999999999996 + rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; 
                   rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = \
intersectionnumber + 1.; opticallength = opticallength + ray1*index1; 
                   completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                     index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                     rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., \
(-0.0016083472422043674*ray2^3)/(Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*
                            (1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])^2) - (0.0016083472422043674*ray2*ray3^2)/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) - 
                          (0.2590673575129534*ray2)/(1. + Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]), \
(-0.0016083472422043674*ray2^2*ray3)/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) - 
                          (0.0016083472422043674*ray3^3)/(Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*
                                 (ray2^2 + ray3^2)])^2) - \
(0.2590673575129534*ray3)/(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])}, 
                        {(0.0016083472422043674*ray2*(ray2^2 + \
ray3^2))/(Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)]*
                            (1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])^2) + (0.2590673575129534*ray2)/(1. + Sqrt[1. - 
                              0.012416440709817716*(ray2^2 + ray3^2)]), 1., \
0.}, {(0.0016083472422043674*ray3*(ray2^2 + ray3^2))/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) + 
                          (0.2590673575129534*ray3)/(1. + Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]), 0., 1.}}]; 
                    If[surfnorm[[1]] == {0., 0., 0.} || surfnorm[[2]] == {0., \
0., 0.} || surfnorm[[3]] == {0., 0., 0.}, 
                     surfnorm = 1.*Re[{{1., (-0.0016083472422043674*(1.*^-6 + \
ray2)^3)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.0016083472422043674*(1.*^-6 + ray2)*(1.*^-6 + \
ray3)^2)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.2590673575129534*(1.*^-6 + ray2))/(1. + \
Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 
                           (-0.0016083472422043674*(1.*^-6 + ray2)^2*(1.*^-6 \
+ ray3))/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.0016083472422043674*(1.*^-6 + \
ray3)^3)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2)]*
                              (1. + Sqrt[1. - 0.012416440709817716*((1.*^-6 + \
ray2)^2 + (1.*^-6 + ray3)^2)])^2) - (0.2590673575129534*(1.*^-6 + 
                               ray3))/(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])}, \
{(0.0016083472422043674*
                              (1.*^-6 + ray2)*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2))/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.2590673575129534*(1.*^-6 + ray2))/(1. + \
Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 1., \

                           0.}, {(0.0016083472422043674*(1.*^-6 + \
ray3)*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2))/(Sqrt[1. - \
0.012416440709817716*
                                 ((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*(1. \
+ Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^
                                     2)])^2) + (0.2590673575129534*(1.*^-6 + \
ray3))/(1. + Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]), 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1., 0, 0}, {0, \
1., 0}, {0, 0, 1.}}; surfacetranslationvector = {-3.5999999999999996, 0, 
                      0}; activeregion = 1.; completedray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.5392664079785716 - 0.7232199521994117*wavelength + 
                        1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                           2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                          2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                     index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                         2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                      index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = 1.5392664079785716 - 0.7232199521994117*wavelength + 
                          1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3; If[Abs[alternateindex - index1] > Abs[index2 \
- index1], 
                         index1 = index2; index2 = alternateindex, index1 = \
alternateindex], index1 = 1.5392664079785716 - 0.7232199521994117*
                          wavelength + 1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3]]; n12 = index1/index2; index = index2; 
                    If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, \
r3} + ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); 
                      {r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . \
surfnorm[[1]] > 0, phaseshift = phaseshift + 0.5, 1.]; index2 = index1; 
                      index = index1; dummyvector = {r1, r2, r3} - \
2*ZAxis*ZAxis . {r1, r2, r3}; {r1, r2, r3} = dummyvector; dummyvector = 
                       {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} \
= dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, 
                       r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}}; \
originalrotation = Partition[Take[originalray, {7, 15}], 3]; previoustilt = 
                     originalrotation[[1]]; transmatrix = MapIndexed[({rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        rotationaxis = Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; 
                        If[Chop[axismagnitude] != 0., rotationaxis = \
rotationaxis/axismagnitude; axismatrix = (#1*rotationaxis & ) /@ \
rotationaxis; 
                          crossmatrix = {{0., -rotationaxis[[3]], \
rotationaxis[[2]]}, {rotationaxis[[3]], 0., -rotationaxis[[1]]}, 
                            {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; \
cosangle = previoustilt . {r1, r2, r3}; If[1. - cosangle < 
                            2.220446049250313*^-16, cosangle = 1.]; sinangle \
= 1 - cosangle^2; If[sinangle < 2.220446049250313*^-16, sinangle = 0., 
                           sinangle = Sqrt[sinangle]]; axismatrix + ({{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + 
                           crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, 
                           {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., \
0., 0.}, {0., -1., 0.}, {0., 0., -1.}}]]) & , allcreatedrays]; 
                    allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
Function[mm, (mm . #1 & ) /@ originalrotation][transmatrix[[First[#2]]]]; 
                        tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, r3}/
                            Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; \
dummymatrix = (#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, 
                             {r7, r8, r9}}; {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = dummymatrix; 1., 1.]; If[allcreatedamplitudes != 
                          {{I*0., I*0., I*0.}}, amplitude = \
allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . amplitude; ver = {r7, \
r8, r9} . 
                            amplitude; If[Abs[hor] > 0. || Abs[ver] > 0., \
{pol1, pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = 
                             {pol1, pol2, pol3}/Sqrt[{pol1, pol2, pol3} . \
{pol1, pol2, pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = 
                             ReplacePart[{pol1, pol2, pol3}, (If[ver == 0., \
0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); If[Length[reportedrays] > 2, \
reportedrays = Drop[reportedrays, 2], reportedrays]; 
       ({#1[[1]], #1[[2]], #1[[3]], #1[[4]], #1[[5]], #1[[6]]} & ) /@ \
reportedrays]]; raytracefunction223020081152327020446 = 
    Compile[{{th, _Real}, {x, _Real}, {y, _Real}, {focus, _Real}}, \
Module[{activeregion, allcreatedamplitudes, allcreatedrays, \
allowzeroraylength, 
       alternateindex, amplitude, axismagnitude, axismatrix, clonedata, \
clonegenerationnumber, cloneinput, clonenumber, cloneposition, 
       clonereportedrays, clonerotation, clonescale, clonescalevector, \
clonesorthistogram, clonetraceinput, clonetraceoutput, closestdistances, 
       closestposition, closestpositions, closestraylength, completedray, \
componentnumber, cosangle, crossmatrix, deflecteddummyrayspresent, 
       deflectedlocalrays, deflectedrays, deflectedrayspresent, dr1, \
dummymatrix, dummymatrixlist, dummyvector, exitvalue, frontid, \
generationlimit, 
       generationnumber, holeintersections, holeQ, holeQlist, hor, index, \
index1, index2, inrays, intensity, intensityscale, intersectionnumber, 
       intersections, intersectionslist, intersectionspresent, \
localdummyoutrayspresent, localoutrays, localoutrayspresent, magnitude, 
       maxclonegenerationnumber, maximumposition, minimumraylength, \
minresonateraylength, n12, newcomponentnumber, newdeflectedrays, newdistance, \

       newsurfaceid, newsurfacenumber, nonintersectingrays, \
normalizedpolarization, oldgenerationnumber, opticallength, originalray, \
originalraytilt, 
       originalrotation, originalsurfnorm, outrays, parallelamplitude, PAxis, \
perpendicularamplitude, phaseshift, pol1, pol2, pol3, previoustilt, 
       propagate, propagatedrays, r1, r2, r3, r4, r5, r6, r7, r8, r9, ray1, \
ray2, ray3, LocRayL, rayslot, raysreported, raytiltx, raytiltz, 
       reporteddummyrayspresent, reportedlocalrays, reportedrays, \
reportedrayspresent, resonateintersections, resonatenumber, \
resonateraylength, rex, 
       rey, rez, rotationaxis, rsx, LocRSx, rsy, LocRSy, rsz, LocRSz, RTx, \
LocRTy, LocRTz, rx, rxhlp, ry, ryhlp, rz, rzhlp, LocSCx, LocSCy, sid, 
       sinangle, sno1, sno2, sno3, sno4, surfaceid, surfacenumber, \
surfacerotationmatrix, surfacetranslationvector, surfnorm, symr1, symr2, \
symr3, 
       symr4, symr5, symr6, symr7, symr8, symr9, tempclonedata, \
terminatedeflection, thresholdintensity, tiltmagnitude, transmatrix, LocTV1, \
LocTV10, 
       LocTV2, LocTV3, LocTV4, LocTV5, LocTV6, LocTV7, LocTV8, LocTV9, u, \
unfilteredintersections, unit, uu, ver, wavelength, XAxis, xunit, YAxis, 
       yunit, ZAxis, zunit}, activeregion = 1.; allcreatedamplitudes = {{0. + \
0.*I, 0. + 0.*I, 0. + 0.*I}}; allcreatedrays = {{1.}}; 
       allowzeroraylength = True; alternateindex = 1.; amplitude = {1. + \
0.*I, 0. + 0.*I, 0. + 0.*I}; axismagnitude = 1.; 
       axismatrix = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; clonedata = \
{{1.}}; clonegenerationnumber = 1.; cloneinput = {1.}; clonenumber = 1; 
       cloneposition = {0., 0., 0.}; clonereportedrays = {{1.}}; \
clonerotation = {{1.}}; clonescale = 1.; clonescalevector = {1.}; 
       clonesorthistogram = {1}; clonetraceinput = {{1.}}; clonetraceoutput = \
{{1.}}; closestdistances = {1.}; closestposition = 0; 
       closestpositions = {0}; closestraylength = 1.; completedray = {1.}; \
componentnumber = -1.; cosangle = 1.; 
       crossmatrix = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; \
deflecteddummyrayspresent = False; deflectedlocalrays = {{1.}}; 
       deflectedrays = {{1.}}; deflectedrayspresent = False; dummymatrix = \
{{1.}}; dummymatrixlist = {{{1.}}}; dummyvector = {1.}; exitvalue = 1.; 
       frontid = 1.; generationlimit = 200.; generationnumber = 1.; \
holeintersections = {{-1., 0., 0.}}; holeQ = False; holeQlist = {0}; 
       hor = 1. + 0.*I; index = 1.; index1 = 1.; index2 = 1.; inrays = \
{{1.}}; intensity = 1.; intensityscale = 1.; intersectionnumber = 1.; 
       intersections = {{-1., 0., 0.}}; intersectionslist = {{{-1., 0., \
0.}}}; intersectionspresent = False; localdummyoutrayspresent = False; 
       localoutrays = {{1.}}; localoutrayspresent = False; magnitude = 1.; \
maxclonegenerationnumber = 1.; maximumposition = 1; 
       minimumraylength = 0.0001; minresonateraylength = 1.; n12 = 1.; \
newcomponentnumber = -1.; newdeflectedrays = {{1.}}; newdistance = 1.; 
       newsurfaceid = -1.; newsurfacenumber = -1.; nonintersectingrays = \
{{1.}}; normalizedpolarization = {1., 1.}; oldgenerationnumber = 1.; 
       opticallength = 1.; originalray = {1.}; originalraytilt = {1.}; \
originalrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; 
       originalsurfnorm = {{1.}}; outrays = {{1.}}; parallelamplitude = 1. + \
0.*I; PAxis = {1., 0., 0.}; perpendicularamplitude = 1. + 0.*I; 
       phaseshift = 0.; pol1 = 1.; pol2 = 1.; pol3 = 1.; previoustilt = {1., \
0., 0.}; propagate = True; propagatedrays = {{1.}}; r1 = 1.; r2 = 1.; 
       r3 = 1.; r4 = 1.; r5 = 1.; r6 = 1.; r7 = 1.; r8 = 1.; r9 = 1.; ray1 = \
1.; ray2 = 1.; ray3 = 1.; LocRayL = 1.; rayslot = 1.; 
       raysreported = False; raytiltx = 1.; raytiltz = 1.; \
reporteddummyrayspresent = False; reportedlocalrays = {{1.}}; reportedrays = \
{{1.}}; 
       reportedrayspresent = False; resonateintersections = {{-1., 0., 0.}}; \
resonatenumber = 0; resonateraylength = 1.; rex = 1.; rey = 1.; 
       rez = 1.; rsx = 1.; LocRSx = 1.; rsy = 1.; LocRSy = 1.; rsz = 1.; \
LocRSz = 1.; RTx = 1.; LocRTy = 1.; LocRTz = 1.; rx = 1.; rxhlp = 1.; 
       ry = 1.; ryhlp = 1.; rz = 1.; rzhlp = 1.; LocSCx = 1.; LocSCy = 1.; \
sid = 1.; sinangle = 1.; sno1 = 1.; sno2 = 1.; sno3 = 1.; sno4 = 1.; 
       surfaceid = -1.; surfacenumber = -1.; surfacerotationmatrix = {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; 
       surfacetranslationvector = {0., 0., 0.}; surfnorm = {{1.}}; symr1 = \
1.; symr2 = 1.; symr3 = 1.; symr4 = 1.; symr5 = 1.; symr6 = 1.; 
       symr7 = 1.; symr8 = 1.; symr9 = 1.; tempclonedata = {{1.}}; \
terminatedeflection = False; thresholdintensity = 1.; tiltmagnitude = 1.; 
       transmatrix = {{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}}; LocTV1 = \
1.; LocTV10 = 1.; LocTV2 = 1.; LocTV3 = 1.; LocTV4 = 1.; LocTV5 = 1.; 
       LocTV6 = 1.; LocTV7 = 1.; LocTV8 = 1.; LocTV9 = 1.; u = {{1., 0., 0.}, \
{0., 1., 0.}, {0., 0., 1.}}; unfilteredintersections = {{-1., 0., 0.}}; 
       unit = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; uu = {{1., 0., 0.}, \
{0., 1., 0.}, {0., 0., 1.}}; ver = 0. + 0.*I; wavelength = 1.; 
       XAxis = {1., 0., 0.}; xunit = 1.; YAxis = {1., 0., 0.}; yunit = 1.; \
ZAxis = {1., 0., 0.}; zunit = 1.; {r1, dr1} = {1., 1.}; 
       {rx, ry, rz} = {1., 1., 1.}; {xunit, yunit, zunit} = {1., 1., 1.}; \
propagatedrays = 
        Join[{symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} \
= Re[{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], 
             Cos[Degree*th], 0, 0, 0, 1}]; (({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
               intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, 
               sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {LocTV1, LocTV2, LocTV3} = 
              {rsx*symr1 + rsy*symr4 + rsz*symr7 + x, rsx*symr2 + rsy*symr5 + \
rsz*symr8 + y, rsx*symr3 + rsy*symr6 + rsz*symr9}; 
             {rsx, rsy, rsz} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, \
LocTV3} = {rex*symr1 + rey*symr4 + rez*symr7 + x, rex*symr2 + rey*symr5 + 
                rez*symr8 + y, rex*symr3 + rey*symr6 + rez*symr9}; {rex, rey, \
rez} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
              {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + \
r3*symr8, r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = 
              {r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + \
r6*symr8, r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = 
              {r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + \
r9*symr8, r7*symr3 + r8*symr6 + r9*symr9}; 
             {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = {{LocTV1, LocTV2, \
LocTV3}, {LocTV4, LocTV5, LocTV6}, {LocTV7, LocTV8, LocTV9}}; 
             {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, \
r9, wavelength, intensity, intensityscale, ray1, index, opticallength, 
              phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
              intersectionnumber, pol1, pol2, pol3}) & ) /@ {{0., -1.5, 0., \
0., -1.5, 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 
             0.09090909090909091, 0., 1.00026945145708, 0., 0., 1., 0., 0., \
0., 0., 25069., 25069., 1., 11., 1., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., -1.2, 0., 0., -1.2, 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., \
0.532, 100., 0.09090909090909091, 0., 1.00026945145708, 0., 0., 1., 0., 
             0., 0., 0., 25069., 25069., 2., 11., 2., 0., 1., 0., 0., 0., 1., \
0.}, {0., -0.8999999999999999, 0., 0., -0.8999999999999999, 0., 1., 0., 
             0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, \
0., 1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., 3., 11., 
             3., 0., 1., 0., 0., 0., 1., 0.}, {0., -0.5999999999999999, 0., \
0., -0.5999999999999999, 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 
             100., 0.09090909090909091, 0., 1.00026945145708, 0., 0., 1., 0., \
0., 0., 0., 25069., 25069., 4., 11., 4., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., -0.2999999999999998, 0., 0., -0.2999999999999998, 0., 1., \
0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
5., 11., 5., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 2.220446049250313*^-16, 0., 0., 2.220446049250313*^-16, 0., \
1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 
             0., 1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., \
25069., 6., 11., 6., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 0.30000000000000027, 0., 0., 0.30000000000000027, 0., 1., \
0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
7., 11., 7., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 0.6000000000000003, 0., 0., 0.6000000000000003, 0., 1., 0., \
0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
8., 11., 8., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 0.9000000000000004, 0., 0., 0.9000000000000004, 0., 1., 0., \
0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
9., 11., 9., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 1.2000000000000004, 0., 0., 1.2000000000000004, 0., 1., 0., \
0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
10., 11., 10., 0., 1., 0., 0., 0., 1., 0.}, 
            {0., 1.5000000000000004, 0., 0., 1.5000000000000004, 0., 1., 0., \
0., 0., 1., 0., 0., 0., 1., 0.532, 100., 0.09090909090909091, 0., 
             1.00026945145708, 0., 0., 1., 0., 0., 0., 0., 25069., 25069., \
11., 11., 11., 0., 1., 0., 0., 0., 1., 0.}}]; 
       propagatedrays = (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
             opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
             oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; \
componentnumber = 1.; frontid = 1.; 
           {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, 
            phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
            intersectionnumber, pol1, pol2, pol3}) & ) /@ propagatedrays; \
thresholdintensity = 1.; generationlimit = 200.; 
       reportedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
          opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
          generationnumber, intersectionnumber, pol1, pol2, pol3}}; \
generationnumber = 0.; (generationnumber += 1.; 
        reportedlocalrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, r7, r8, r9, wavelength, 0, intensityscale, ray1, index, 
           opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
           generationnumber, intersectionnumber, pol1, pol2, pol3}}; \
deflectedlocalrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, 
           r8, r9, wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
           ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 3.5999999999999996 + rex; ry = rey; rz = 
                rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1. + I*0.; 
                    LocSCx = 1. + I*0.; LocSCy = 1. + I*0.; Re[Select[{{-1. + \
0.*I, 0. + 0.*I, 0. + 0.*I}, {(386.*xunit - 37.*rx*xunit - 
                          50.*ry*yunit - 50.*rz*zunit - \
1.4142135623730951*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - \
925.*rz^2*xunit^2 - 
                             19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit \
+ 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 1250.*rz^2*yunit^2 - 
                             19300.*rz*xunit*zunit + 1850.*rx*rz*xunit*zunit \
+ 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 925.*rx^2*zunit^2 - 
                             1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 \
+ 50.*zunit^2), (37.*ry*xunit^2 + 386.*xunit*yunit - 37.*rx*xunit*
                           yunit - 50.*rz*yunit*zunit + 50.*ry*zunit^2 - \
1.4142135623730951*yunit*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - 
                             925.*rz^2*xunit^2 - 19300.*ry*xunit*yunit + \
1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2), \
(37.*rz*xunit^2 + 50.*rz*yunit^2 + 
                          386.*xunit*zunit - 37.*rx*xunit*zunit - \
50.*ry*yunit*zunit - 1.4142135623730951*zunit*Sqrt[74498.*xunit^2 - \
925.*ry^2*
                              xunit^2 - 925.*rz^2*xunit^2 - \
19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - \
925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2)}, {(386.*xunit \
- 37.*rx*xunit - 
                          50.*ry*yunit - 50.*rz*zunit + \
1.4142135623730951*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - \
925.*rz^2*xunit^2 - 
                             19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit \
+ 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 1250.*rz^2*yunit^2 - 
                             19300.*rz*xunit*zunit + 1850.*rx*rz*xunit*zunit \
+ 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 925.*rx^2*zunit^2 - 
                             1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 \
+ 50.*zunit^2), (37.*ry*xunit^2 + 386.*xunit*yunit - 37.*rx*xunit*
                           yunit - 50.*rz*yunit*zunit + 50.*ry*zunit^2 + \
1.4142135623730951*yunit*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - 
                             925.*rz^2*xunit^2 - 19300.*ry*xunit*yunit + \
1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2), \
(37.*rz*xunit^2 + 50.*rz*yunit^2 + 
                          386.*xunit*zunit - 37.*rx*xunit*zunit - \
50.*ry*yunit*zunit + 1.4142135623730951*zunit*Sqrt[74498.*xunit^2 - \
925.*ry^2*
                              xunit^2 - 925.*rz^2*xunit^2 - \
19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - \
925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2)}}, ({LocRayL, \
LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
(Chop[Im[#1]] == {0, 0, 0} && N[Chop[Re[LocRayL]]] >= 0. && 
                          Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[rx + LocRayL*xunit - (25*(LocSCx^2 + \
LocSCy^2))/
                               (193*(1 + Sqrt[1 - (925*(LocSCx^2 + \
LocSCy^2))/74498]))] < 1.*^-7 && Re[LocSCx]^2 + Re[LocSCy]^2 <= 39.0625)) & \
]]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24990.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 1., 24990.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 1., 24990.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
-3.5999999999999996 + rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; 
                   rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = \
intersectionnumber + 1.; opticallength = opticallength + ray1*index1; 
                   completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                     index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                     rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., \
(-0.0016083472422043674*ray2^3)/(Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*
                            (1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])^2) - (0.0016083472422043674*ray2*ray3^2)/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) - 
                          (0.2590673575129534*ray2)/(1. + Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]), \
(-0.0016083472422043674*ray2^2*ray3)/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) - 
                          (0.0016083472422043674*ray3^3)/(Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*
                                 (ray2^2 + ray3^2)])^2) - \
(0.2590673575129534*ray3)/(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])}, 
                        {(0.0016083472422043674*ray2*(ray2^2 + \
ray3^2))/(Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)]*
                            (1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])^2) + (0.2590673575129534*ray2)/(1. + Sqrt[1. - 
                              0.012416440709817716*(ray2^2 + ray3^2)]), 1., \
0.}, {(0.0016083472422043674*ray3*(ray2^2 + ray3^2))/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) + 
                          (0.2590673575129534*ray3)/(1. + Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]), 0., 1.}}]; 
                    If[surfnorm[[1]] == {0., 0., 0.} || surfnorm[[2]] == {0., \
0., 0.} || surfnorm[[3]] == {0., 0., 0.}, 
                     surfnorm = 1.*Re[{{1., (-0.0016083472422043674*(1.*^-6 + \
ray2)^3)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.0016083472422043674*(1.*^-6 + ray2)*(1.*^-6 + \
ray3)^2)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.2590673575129534*(1.*^-6 + ray2))/(1. + \
Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 
                           (-0.0016083472422043674*(1.*^-6 + ray2)^2*(1.*^-6 \
+ ray3))/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.0016083472422043674*(1.*^-6 + \
ray3)^3)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2)]*
                              (1. + Sqrt[1. - 0.012416440709817716*((1.*^-6 + \
ray2)^2 + (1.*^-6 + ray3)^2)])^2) - (0.2590673575129534*(1.*^-6 + 
                               ray3))/(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])}, \
{(0.0016083472422043674*
                              (1.*^-6 + ray2)*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2))/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.2590673575129534*(1.*^-6 + ray2))/(1. + \
Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 1., \

                           0.}, {(0.0016083472422043674*(1.*^-6 + \
ray3)*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2))/(Sqrt[1. - \
0.012416440709817716*
                                 ((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*(1. \
+ Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^
                                     2)])^2) + (0.2590673575129534*(1.*^-6 + \
ray3))/(1. + Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]), 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1., 0, 0}, {0, \
1., 0}, {0, 0, 1.}}; surfacetranslationvector = {-3.5999999999999996, 0, 
                      0}; activeregion = 1.; completedray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.5392664079785716 - 0.7232199521994117*wavelength + 
                        1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                           2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                          2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                     index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                         2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                      index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = 1.5392664079785716 - 0.7232199521994117*wavelength + 
                          1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3; If[Abs[alternateindex - index1] > Abs[index2 \
- index1], 
                         index1 = index2; index2 = alternateindex, index1 = \
alternateindex], index1 = 1.5392664079785716 - 0.7232199521994117*
                          wavelength + 1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3]]; n12 = index1/index2; index = index2; 
                    If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, \
r3} + ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); 
                      {r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . \
surfnorm[[1]] > 0, phaseshift = phaseshift + 0.5, 1.]; index2 = index1; 
                      index = index1; dummyvector = {r1, r2, r3} - \
2*ZAxis*ZAxis . {r1, r2, r3}; {r1, r2, r3} = dummyvector; dummyvector = 
                       {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} \
= dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, 
                       r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}}; \
originalrotation = Partition[Take[originalray, {7, 15}], 3]; previoustilt = 
                     originalrotation[[1]]; transmatrix = MapIndexed[({rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        rotationaxis = Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; 
                        If[Chop[axismagnitude] != 0., rotationaxis = \
rotationaxis/axismagnitude; axismatrix = (#1*rotationaxis & ) /@ \
rotationaxis; 
                          crossmatrix = {{0., -rotationaxis[[3]], \
rotationaxis[[2]]}, {rotationaxis[[3]], 0., -rotationaxis[[1]]}, 
                            {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; \
cosangle = previoustilt . {r1, r2, r3}; If[1. - cosangle < 
                            2.220446049250313*^-16, cosangle = 1.]; sinangle \
= 1 - cosangle^2; If[sinangle < 2.220446049250313*^-16, sinangle = 0., 
                           sinangle = Sqrt[sinangle]]; axismatrix + ({{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + 
                           crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, 
                           {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., \
0., 0.}, {0., -1., 0.}, {0., 0., -1.}}]]) & , allcreatedrays]; 
                    allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
Function[mm, (mm . #1 & ) /@ originalrotation][transmatrix[[First[#2]]]]; 
                        tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, r3}/
                            Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; \
dummymatrix = (#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, 
                             {r7, r8, r9}}; {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = dummymatrix; 1., 1.]; If[allcreatedamplitudes != 
                          {{I*0., I*0., I*0.}}, amplitude = \
allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . amplitude; ver = {r7, \
r8, r9} . 
                            amplitude; If[Abs[hor] > 0. || Abs[ver] > 0., \
{pol1, pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = 
                             {pol1, pol2, pol3}/Sqrt[{pol1, pol2, pol3} . \
{pol1, pol2, pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = 
                             ReplacePart[{pol1, pol2, pol3}, (If[ver == 0., \
0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 3.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{TempVar, TempVar1, TempVar2, TempVar3, LocRayL, 
                    LocSCx, LocSCy}, TempVar1 = 1.; TempVar2 = 1.; TempVar3 = \
1.; TempVar = {{-1., 0., 0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; 
                    TempVar1 = rx^2 + ry^2 + rz^2; TempVar2 = rx*xunit + \
ry*yunit + rz*zunit - 6.5*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 
                      2*rx*6.5; TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] \
>= 0., TempVar3 = Sqrt[TempVar3]; TempVar = 
                       {{LocRayL, LocSCx, LocSCy} = {-TempVar2 - TempVar3, ry \
- (TempVar2 + TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; 
                         If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
25. && Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - 
                               LocSCy] + Abs[-6.5 + rx + LocRayL*xunit + \
Sqrt[42.25 - LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, LocSCy}, 
                          {-1., 0., 0.}], {LocRayL, LocSCx, LocSCy} = \
{-TempVar2 + TempVar3, ry + (-TempVar2 + TempVar3)*yunit, 
                           rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 25. && 
                           Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[-6.5 + rx + LocRayL*xunit + Sqrt[42.25 - 
                                 LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, \
LocSCx, LocSCy}, {-1., 0., 0.}]}; If[TempVar[[1]] == TempVar[[2]], 
                       {TempVar[[1]]}, TempVar], {{-1., 0., 0.}}]]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24991.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 2., 24991.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 2., 24991.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -3.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., \
-(ray2/(42.25 - ray2^2 - ray3^2)^2^(-1)), -(ray3/(42.25 - ray2^2 - ray3^2)^
                            2^(-1))}, {ray2/(42.25 - ray2^2 - ray3^2)^2^(-1), \
1., 0.}, {ray3/(42.25 - ray2^2 - ray3^2)^2^(-1), 0., 1.}}]; 
                    dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 \
. #1] & ) /@ dummymatrix; surfacerotationmatrix = {{1., 0, 0}, 
                      {0, 1., 0}, {0, 0, 1.}}; surfacetranslationvector = \
{-3.05, 0, 0}; activeregion = 1.; completedray = {rsx, rsy, rsz, rex, rey, 
                      rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                      componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                      intersectionnumber, pol1, pol2, pol3}; componentnumber \
= newcomponentnumber; surfacenumber = newsurfacenumber; 
                    surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; ZAxis = First[surfnorm]*
                      Sign[First[surfnorm] . {r1, r2, r3}]; raytiltz = ZAxis \
. {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.5532682085813037 - 1.0054245500503685*wavelength + 
                        1.6027810806802343*wavelength^2 - \
0.8794405514298376*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.5392664079785716 - \
0.7232199521994117*wavelength + 1.0984449372267269*wavelength^2 - \
0.5792106405020717*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = \
1.5392664079785716 - 0.7232199521994117*wavelength + \
1.0984449372267269*wavelength^2 - 
                         0.5792106405020717*wavelength^3], index2 = \
1.5392664079785716 - 0.7232199521994117*wavelength + 1.0984449372267269*
                         wavelength^2 - 0.5792106405020717*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.5532682085813037 - 1.0054245500503685*wavelength + \
1.6027810806802343*wavelength^2 - 0.8794405514298376*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.5532682085813037 - \
1.0054245500503685*wavelength + 1.6027810806802343*wavelength^2 - \
0.8794405514298376*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 0.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = If[Chop[xunit] != 0, 
                   {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= \
6.25, {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                      ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., \
0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24992.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 3., 24992.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 3., 24992.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -0.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1., 0, 0}, {0, 1., 0}, {0, 0, 1.}}; 
                    surfacetranslationvector = {-0.05, 0, 0}; activeregion = \
0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, r3}]; 
                    raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - \
raytiltz^2; If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., 
                     raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - \
ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], 
                     XAxis = XAxis/raytiltx]; YAxis = \
{-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*
                        XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + \
ZAxis[[1]]*XAxis[[2]]}; YAxis = YAxis/Sqrt[YAxis . YAxis]; 
                    PAxis = ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . \
ZAxis; PAxis = PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = 
                     {pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = \
normalizedpolarization/Sqrt[normalizedpolarization . 
                        normalizedpolarization]; allcreatedamplitudes = \
{{I*0., I*0., I*0.}}; amplitude = Sqrt[intensity]*
                      (normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*Exp[I*pol3*0.017453292519943295]); 
                    perpendicularamplitude = amplitude . YAxis; \
parallelamplitude = amplitude . PAxis; {rx, ry, rz} = ({rex, rey, rez} - 
                       {-0.05, 0, 0}) . {{1., 0., 0.}, {0., 1., 0.}, {0., 0., \
1.}}; {xunit, yunit, zunit} = {r1, r2, r3} . {{1., 0., 0.}, 
                       {0., 1., 0.}, {0., 0., 1.}}; {xunit, yunit, zunit} = \
{xunit, yunit, zunit}/Sqrt[{xunit, yunit, zunit} . {xunit, yunit, 
                         zunit}]; r1 = ry; dr1 = yunit/Abs[xunit]; ry = \
Plus[r1]; dry = (-(focus/1000))*r1 + dr1; r1 = rz; dr1 = zunit/Abs[xunit]; 
                    rz = Plus[r1]; drz = (-(focus/1000))*r1 + dr1; exitvalue \
= (0 & )[First[{ray2, ray3}], Last[{ray2, ray3}]]*1.0000001; 
                    opticallength = opticallength + exitvalue; {rex, rey, \
rez} = {Sign[xunit]*exitvalue, ry, rz} . {{1., 0, 0}, {0, 1., 0}, 
                        {0, 0, 1.}} + {-0.05, 0, 0}; {r1, r2, r3} = \
{Sign[xunit]/(Sqrt[1 + dry^2]*Sqrt[1 + drz^2]), dry/Sqrt[1 + dry^2], 
                       drz/(Sqrt[1 + drz^2]*Sqrt[1 + dry^2])} . {{1., 0, 0}, \
{0, 1., 0}, {0, 0, 1.}}; dummyvector = {r1, r2, r3}/
                      Sqrt[{r1, r2, r3} . {r1, r2, r3}]; {r1, r2, r3} = \
dummyvector; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \

                       r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                       surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                       pol1, pol2, pol3}}; originalrotation = \
Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; 
                    transmatrix = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        rotationaxis = Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; 
                        If[Chop[axismagnitude] != 0., rotationaxis = \
rotationaxis/axismagnitude; axismatrix = (#1*rotationaxis & ) /@ \
rotationaxis; 
                          crossmatrix = {{0., -rotationaxis[[3]], \
rotationaxis[[2]]}, {rotationaxis[[3]], 0., -rotationaxis[[1]]}, 
                            {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; \
cosangle = previoustilt . {r1, r2, r3}; If[1. - cosangle < 
                            2.220446049250313*^-16, cosangle = 1.]; sinangle \
= 1 - cosangle^2; If[sinangle < 2.220446049250313*^-16, sinangle = 0., 
                           sinangle = Sqrt[sinangle]]; axismatrix + ({{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + 
                           crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, 
                           {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., \
0., 0.}, {0., -1., 0.}, {0., 0., -1.}}]]) & , allcreatedrays]; 
                    allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
Function[mm, (mm . #1 & ) /@ originalrotation][transmatrix[[First[#2]]]]; 
                        tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, r3}/
                            Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; \
dummymatrix = (#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, 
                             {r7, r8, r9}}; {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = dummymatrix; 1., 1.]; If[allcreatedamplitudes != 
                          {{I*0., I*0., I*0.}}, amplitude = \
allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . amplitude; ver = {r7, \
r8, r9} . 
                            amplitude; If[Abs[hor] > 0. || Abs[ver] > 0., \
{pol1, pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = 
                             {pol1, pol2, pol3}/Sqrt[{pol1, pol2, pol3} . \
{pol1, pol2, pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = 
                             ReplacePart[{pol1, pol2, pol3}, (If[ver == 0., \
0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 0.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = If[Chop[xunit] != 0, 
                   {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= \
25., {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                      ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., \
0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24993.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                 intersections = Union[(If[#1[[2]]^2 + #1[[3]]^2 <= 6.25, \
holeQ = True; {-1., 0., 0.}, #1] & ) /@ unfilteredintersections]; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 4., 24993.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 4., 24993.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -0.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1., 0, 0}, {0, 1., 0}, {0, 0, 1.}}; 
                    surfacetranslationvector = {-0.05, 0, 0}; activeregion = \
0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                       rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}})); \
{First[allcreatedrays], completedray}, reporteddummyrayspresent = True; 
                  {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                    opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                    generationnumber, intersectionnumber, pol1, pol2, pol3}, \
{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}], 
               reporteddummyrayspresent = True; deflecteddummyrayspresent = \
True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                  -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = 
                Chop[ry]; rz = Chop[rz]; terminatedeflection = False; \
intersections = {{-1., 0., 0.}}); If[intensity > thresholdintensity, 
               deflectedrayspresent = True; (intersections = If[Chop[xunit] \
!= 0, {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= 
                         35.19455625000001, {#1[[1]], #1[[2]], #1[[3]]}, \
{-1., 0., 0.}] & )[{-(rx/xunit), ry - (rx*yunit)/xunit, 
                      rz - (rx*zunit)/xunit}]}, {{-1., 0., 0.}}]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24994.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                 intersections = Union[(If[#1[[2]]^2 + #1[[3]]^2 <= \
28.810056249999995, holeQ = True; {-1., 0., 0.}, #1] & ) /@ 
                    unfilteredintersections]; If[Length[intersections] > 1, \
dummymatrix = Take[intersections, {2}]; intersections = dummymatrix; 1., 
                  1.]); If[intersections != {{-1., 0., 0.}}, \
intersectionspresent = True; ({newcomponentnumber, newsurfacenumber, \
newsurfaceid} = 
                    {1., 5., 24994.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 5., 24994.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}; 
                    surfacetranslationvector = {0, 0, 0}; activeregion = 0.; \
completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                       rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}})); \
{First[allcreatedrays], completedray}, reporteddummyrayspresent = True; 
                  {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                    opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                    generationnumber, intersectionnumber, pol1, pol2, pol3}, \
{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}], 
               reporteddummyrayspresent = True; deflecteddummyrayspresent = \
True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                  -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = 
                Chop[ry]; rz = Chop[rz]; terminatedeflection = False; \
intersections = {{-1., 0., 0.}}); If[intensity > thresholdintensity, 
               deflectedrayspresent = True; (intersections = \
Block[{surfaceapprox, tempapprox, intersects, LocRayL, LocSCx, LocSCy}, 
                   LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; surfaceapprox = \
{{-1., 0., 0.}}; tempapprox = {{-1., 0., 0.}}; intersects = 
                     {{-1., 0., 0.}}; surfaceapprox = Block[{TempVar, \
TempVar1, TempVar2, TempVar3, LocRayL, LocSCx, LocSCy}, TempVar1 = 1.; 
                       TempVar2 = 1.; TempVar3 = 1.; TempVar = {{-1., 0., \
0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; TempVar1 = rx^2 + ry^2 + 
                         rz^2; TempVar2 = rx*xunit + ry*yunit + rz*zunit - \
10.2*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 2*rx*10.2; 
                       TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] >= 0., \
TempVar3 = Sqrt[TempVar3]; TempVar = {{LocRayL, LocSCx, LocSCy} = 
                             {-TempVar2 - TempVar3, ry - (TempVar2 + \
TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; If[N[Chop[LocRayL]] >= 0. \
&& 
                              LocSCx^2 + LocSCy^2 <= 31.922500000000003 && \
Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - LocSCy] + 
                                Abs[-10.2 + rx + LocRayL*xunit + \
Sqrt[104.03999999999999 - LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, \
LocSCy}, 
                             {-1., 0., 0.}], {LocRayL, LocSCx, LocSCy} = \
{-TempVar2 + TempVar3, ry + (-TempVar2 + TempVar3)*yunit, 
                              rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 31.922500000000003 && 
                              Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[-10.2 + rx + LocRayL*xunit + 
                                  Sqrt[104.03999999999999 - LocSCx^2 - \
LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, LocSCy}, {-1., 0., 0.}]}; 
                         If[TempVar[[1]] == TempVar[[2]], {TempVar[[1]]}, \
TempVar], {{-1., 0., 0.}}]]; tempapprox = Union[Join[(Take[#1, 3] & ) /@ 
                        surfaceapprox, {{-1., 0., 0.}}]]; \
If[Length[Select[tempapprox, Chop[First[#1]] <= 0 & ]] != Length[tempapprox], \

                     surfaceapprox = Select[tempapprox, Chop[First[#1]] > 0 & \
], surfaceapprox = {{-1., 0., 0.}}]; If[surfaceapprox != 
                      {{-1., 0., 0.}}, intersects = {{-1., 0., 0.}}; \
Scan[(AppendTo[intersects, {LocRayL, LocSCx, LocSCy} = {#1[[1]], #1[[2]], 
                             #1[[3]]}; If[Plus @@ Abs[{rx + LocRayL*xunit, ry \
+ LocRayL*yunit, rz + LocRayL*zunit} - {(0.09803921568627452*
                                   (LocSCx^2 + LocSCy^2))/(1 + Sqrt[1 + \
0.020488273740868906*(LocSCx^2 + LocSCy^2)]), LocSCx, LocSCy}] < 1.*^-9, 
                            {LocRayL, LocSCx, LocSCy}, LocRayL = \
0.99*LocRayL; Function[{rx, ry, rz, xunit, yunit, zunit, startpoint}, 
                               Block[{values, stepsizes, fvector, success, \
steps, denominator}, values = {1.}; stepsizes = {1.}; fvector = {1.}; 
                                 success = False; steps = 0; denominator = \
1.; stepsizes = Table[1.0000000000000001*^-7, {3}]; values = startpoint; 
                                 While[steps < 50 && (success = True; \
(If[Abs[#1] > 1.*^-9, success = False; 1., 1.] & ) /@ stepsizes;  !success), 
                                  steps = steps + 1; fvector = {rx + \
xunit*values[[1]], ry + yunit*values[[1]], rz + zunit*values[[1]]} - 
                                     {(0.09803921568627452*(values[[2]]^2 + \
values[[3]]^2))/(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + 
                                            values[[3]]^2)]), values[[2]], \
values[[3]]}; denominator = xunit - yunit*(((0.002008654288320481*
                                          values[[2]]*(values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                               2)]*(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                          values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*-1) - zunit*
                                      (((0.002008654288320481*values[[3]]*(\
values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*
                                             (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^2)])^
                                           2) - \
(0.19607843137254904*values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                               2)]))*-1); \
If[Chop[denominator] != 0, denominator, denominator = 1.]; stepsizes = 
                                    -(#1 . fvector & ) /@ ({{1, \
-(((0.002008654288320481*values[[2]]*(values[[2]]^2 + values[[3]]^2))/
                                             (Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]*(1 + Sqrt[1 + \
0.020488273740868906*
                                                  (values[[2]]^2 + \
values[[3]]^2)])^2) - (0.19607843137254904*values[[2]])/(1 + Sqrt[1 + 
                                                0.020488273740868906*(values[[\
2]]^2 + values[[3]]^2)]))*-1), -(((0.002008654288320481*values[[3]]*
                                              (values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^2)]*
                                              (1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                              values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*-1)}, {yunit, 
                                         -xunit - \
((0.002008654288320481*values[[3]]*(values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + \
0.020488273740868906*
                                                 (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^
                                                  2)])^2) - \
(0.19607843137254904*values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + 
                                                  values[[3]]^2)]))*zunit, \
((0.002008654288320481*values[[3]]*(values[[2]]^2 + values[[3]]^2))/
                                            (Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]*(1 + Sqrt[1 + \
0.020488273740868906*
                                                  (values[[2]]^2 + \
values[[3]]^2)])^2) - (0.19607843137254904*values[[3]])/(1 + Sqrt[1 + 
                                               0.020488273740868906*(values[[\
2]]^2 + values[[3]]^2)]))*yunit}, {zunit, ((0.002008654288320481*
                                             values[[2]]*(values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                                  2)]*(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                             values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*zunit, -xunit - 
                                          ((0.002008654288320481*values[[2]]*(\
values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*
                                                 (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^
                                                  2)])^2) - \
(0.19607843137254904*values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + 
                                                  values[[3]]^2)]))*yunit}}/\
denominator); values = values + stepsizes]; If[steps >= 50, 
                                  If[First[values] > 0, values = -values; 1., \
1.]; denominator = 1., 1.]; values]][rx, ry, rz, xunit, yunit, zunit, 
                              {LocRayL, LocSCx, LocSCy}]]]; {-1., 0., 0.}) & \
, surfaceapprox]; Union[Re[Select[intersects, 
                         ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || (Chop[Im[#1]] == {0, 0, 0} && 
                             N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
31.922500000000003 && Plus @@ Abs[{rx + LocRayL*xunit, 
                                  ry + LocRayL*yunit, rz + LocRayL*zunit} - \
{(0.09803921568627452*(LocSCx^2 + LocSCy^2))/(1 + Sqrt[1 + 
                                      0.020488273740868906*(LocSCx^2 + \
LocSCy^2)]), LocSCx, LocSCy}] < 1.*^-9)) & ]]], {{-1., 0., 0.}}]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24995.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 6., 24995.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 6., 24995.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                   rez = Chop[rez]; intersectionnumber = intersectionnumber + \
1.; opticallength = opticallength + ray1*index1; completedray = 
                    {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                     opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                     generationnumber, intersectionnumber, pol1, pol2, \
pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., \
(0.002008654288320481*ray2^3)/(Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*
                            (1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])^2) + (0.002008654288320481*ray2*ray3^2)/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) - 
                          (0.19607843137254904*ray2)/(1. + Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]), (0.002008654288320481*ray2^2*ray3)/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) + 
                          (0.002008654288320481*ray3^3)/(Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*
                                 (ray2^2 + ray3^2)])^2) - \
(0.19607843137254904*ray3)/(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])}, 
                        {(-0.002008654288320481*ray2*(ray2^2 + \
ray3^2))/(Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)]*
                            (1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])^2) + (0.19607843137254904*ray2)/(1. + Sqrt[
                             1. + 0.020488273740868906*(ray2^2 + ray3^2)]), \
1., 0.}, {(-0.002008654288320481*ray3*(ray2^2 + ray3^2))/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) + 
                          (0.19607843137254904*ray3)/(1. + Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]), 0., 1.}}]; 
                    If[surfnorm[[1]] == {0., 0., 0.} || surfnorm[[2]] == {0., \
0., 0.} || surfnorm[[3]] == {0., 0., 0.}, 
                     surfnorm = 1.*Re[{{1., (0.002008654288320481*(1.*^-6 + \
ray2)^3)/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.002008654288320481*(1.*^-6 + ray2)*(1.*^-6 + \
ray3)^2)/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.19607843137254904*(1.*^-6 + ray2))/(1. + \
Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 
                           (0.002008654288320481*(1.*^-6 + ray2)^2*(1.*^-6 + \
ray3))/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.002008654288320481*(1.*^-6 + ray3)^3)/(Sqrt[1. \
+ 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*
                              (1. + Sqrt[1. + 0.020488273740868906*((1.*^-6 + \
ray2)^2 + (1.*^-6 + ray3)^2)])^2) - (0.19607843137254904*(1.*^-6 + 
                               ray3))/(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])}, \
{(-0.002008654288320481*
                              (1.*^-6 + ray2)*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2))/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.19607843137254904*(1.*^-6 + ray2))/(1. + \
Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 1., \

                           0.}, {(-0.002008654288320481*(1.*^-6 + \
ray3)*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2))/(Sqrt[1. + \
0.020488273740868906*
                                 ((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*(1. \
+ Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^
                                     2)])^2) + (0.19607843137254904*(1.*^-6 + \
ray3))/(1. + Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]), 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1, 0, 0}, {0, 1, \
0}, {0, 0, 1}}; surfacetranslationvector = {0, 0, 0}; 
                    activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.676591682864066 - 1.1701284013479643*wavelength + 
                        1.824530254455512*wavelength^2 - \
0.9804493049167423*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.5532682085813037 - \
1.0054245500503685*wavelength + 1.6027810806802343*wavelength^2 - \
0.8794405514298376*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = \
1.5532682085813037 - 1.0054245500503685*wavelength + \
1.6027810806802343*wavelength^2 - 
                         0.8794405514298376*wavelength^3], index2 = \
1.5532682085813037 - 1.0054245500503685*wavelength + 1.6027810806802343*
                         wavelength^2 - 0.8794405514298376*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.676591682864066 - 1.1701284013479643*wavelength + \
1.824530254455512*wavelength^2 - 0.9804493049167423*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.676591682864066 - \
1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - \
0.9804493049167423*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = -4. + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1. + I*0.; 
                    LocSCx = 1. + I*0.; LocSCy = 1. + I*0.; \
Re[Select[If[yunit^2 + zunit^2 == 0., {{-1. + 0.*I, 0. + 0.*I, 0. + 0.*I}, 
                        {(-0.08333333333333333*(12.*rx + ry^2 + \
rz^2)*Sqrt[xunit^2])/xunit^2, (ry*Sqrt[xunit^2])/xunit, rz}}, 
                       {{-1. + 0.*I, 0. + 0.*I, 0. + 0.*I}, {(-6.*xunit - \
1.*ry*yunit - 1.*rz*zunit - 1.*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2), (-6.*xunit*yunit - \
1.*rz*yunit*zunit + ry*zunit^2 - 1.*yunit*Sqrt[36.*xunit^2 + \
12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2), (rz*yunit^2 - 6.*xunit*zunit - \
1.*ry*yunit*zunit - 1.*zunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2)}, {(-6.*xunit - 1.*ry*yunit - \
1.*rz*zunit + Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                             1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + \
zunit^2), 
                         (-6.*xunit*yunit - 1.*rz*yunit*zunit + ry*zunit^2 + \
yunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                              1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + \
zunit^2), 
                         (rz*yunit^2 - 6.*xunit*zunit - 1.*ry*yunit*zunit + \
zunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                              1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + 
                           zunit^2)}}], ({LocRayL, LocSCx, LocSCy} = #1; \
{LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || (Chop[Im[#1]] == {0, 0, 0} && 
                          N[Chop[Re[LocRayL]]] >= 0. && Abs[ry + \
LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - LocSCy] + 
                            Abs[rx + LocRayL*xunit + (LocSCx^2 + \
LocSCy^2)/12] < 1.*^-7 && Re[LocSCx]^2 + Re[LocSCy]^2 <= 31.922500000000003)) \
& ]]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24996.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 7., 24996.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 7., 24996.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = 4. \
+ rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                   rez = Chop[rez]; intersectionnumber = intersectionnumber + \
1.; opticallength = opticallength + ray1*index1; completedray = 
                    {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                     opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                     generationnumber, intersectionnumber, pol1, pol2, \
pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., Plus[(0.3333333333333333*ray2)/(1. \
+ Sqrt[Plus[1.]])], Plus[(0.3333333333333333*ray3)/
                           (1. + Sqrt[Plus[1.]])]}, \
{Plus[(-0.3333333333333333*ray2)/(1. + Sqrt[Plus[1.]])], 1., 0.}, 
                        {Plus[(-0.3333333333333333*ray3)/(1. + \
Sqrt[Plus[1.]])], 0., 1.}}]; If[surfnorm[[1]] == {0., 0., 0.} || \
surfnorm[[2]] == 
                       {0., 0., 0.} || surfnorm[[3]] == {0., 0., 0.}, \
surfnorm = 1.*Re[{{1., Plus[(0.3333333333333333*(1.*^-6 + ray2))/
                             (1. + Sqrt[Plus[1.]])], \
Plus[(0.3333333333333333*(1.*^-6 + ray3))/(1. + Sqrt[Plus[1.]])]}, 
                          {Plus[(-0.3333333333333333*(1.*^-6 + ray2))/(1. + \
Sqrt[Plus[1.]])], 1., 0.}, {Plus[(-0.3333333333333333*(1.*^-6 + ray3))/
                             (1. + Sqrt[Plus[1.]])], 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1., 0, 0}, {0, \
1., 0}, {0, 0, 1.}}; surfacetranslationvector = {4., 0, 0}; 
                    activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.4992664079787237 - 0.7232199522002112*wavelength + 
                        1.0984449372281133*wavelength^2 - \
0.5792106405034075*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.676591682864066 - \
1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - \
0.9804493049167423*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = 1.676591682864066 \
- 1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - 
                         0.9804493049167423*wavelength^3], index2 = \
1.676591682864066 - 1.1701284013479643*wavelength + 1.824530254455512*
                         wavelength^2 - 0.9804493049167423*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.4992664079787237 - 0.7232199522002112*wavelength + \
1.0984449372281133*wavelength^2 - 0.5792106405034075*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.4992664079787237 - \
0.7232199522002112*wavelength + 1.0984449372281133*wavelength^2 - \
0.5792106405034075*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = -20.3203 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{TempVar, TempVar1, TempVar2, TempVar3, LocRayL, 
                    LocSCx, LocSCy}, TempVar1 = 1.; TempVar2 = 1.; TempVar3 = \
1.; TempVar = {{-1., 0., 0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; 
                    TempVar1 = rx^2 + ry^2 + rz^2; TempVar2 = rx*xunit + \
ry*yunit + rz*zunit - -12*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 
                      2*rx*-12; TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] \
>= 0., TempVar3 = Sqrt[TempVar3]; TempVar = 
                       {{LocRayL, LocSCx, LocSCy} = {-TempVar2 - TempVar3, ry \
- (TempVar2 + TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; 
                         If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
142.80249999999998 && Abs[ry + LocRayL*yunit - LocSCx] + 
                             Abs[rz + LocRayL*zunit - LocSCy] + Abs[12 + rx + \
LocRayL*xunit - Sqrt[144 - LocSCx^2 - LocSCy^2]] < 1.*^-7, 
                          {LocRayL, LocSCx, LocSCy}, {-1., 0., 0.}], \
{LocRayL, LocSCx, LocSCy} = {-TempVar2 + TempVar3, ry + (-TempVar2 + \
TempVar3)*
                             yunit, rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 142.80249999999998 && 
                           Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[12 + rx + LocRayL*xunit - Sqrt[144 - LocSCx^2 - \

                                 LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, \
LocSCy}, {-1., 0., 0.}]}; If[TempVar[[1]] == TempVar[[2]], {TempVar[[1]]}, 
                       TempVar], {{-1., 0., 0.}}]]; AppendTo[intersections, \
{-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 24997.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 8., 24997.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 8., 24997.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = 20.3203 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., \
-(-(ray2/(144 - ray2^2 - ray3^2)^2^(-1))), -(-(ray3/(144 - ray2^2 - ray3^2)^
                             2^(-1)))}, {-(ray2/(144 - ray2^2 - \
ray3^2)^2^(-1)), 1., 0.}, {-(ray3/(144 - ray2^2 - ray3^2)^2^(-1)), 0., 1.}}]; \

                    dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 \
. #1] & ) /@ dummymatrix; surfacerotationmatrix = {{1., 0, 0}, 
                      {0, 1., 0}, {0, 0, 1.}}; surfacetranslationvector = \
{20.3203, 0, 0}; activeregion = 0.; completedray = {rsx, rsy, rsz, rex, 
                      rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, 
                      componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                      intersectionnumber, pol1, pol2, pol3}; componentnumber \
= newcomponentnumber; surfacenumber = newsurfacenumber; 
                    surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; intensity = 0.; allcreatedrays = 
                     {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                       opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}})); {First[allcreatedrays], completedray}, 
                 reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                    intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                    sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., \
1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1.}}], reporteddummyrayspresent = True; \
deflecteddummyrayspresent = True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 
                  1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., \
-1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = -4. + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1. + I*0.; 
                    LocSCx = 1. + I*0.; LocSCy = 1. + I*0.; \
Re[Select[If[yunit^2 + zunit^2 == 0., {{-1. + 0.*I, 0. + 0.*I, 0. + 0.*I}, 
                        {(-0.08333333333333333*(12.*rx + ry^2 + \
rz^2)*Sqrt[xunit^2])/xunit^2, (ry*Sqrt[xunit^2])/xunit, rz}}, 
                       {{-1. + 0.*I, 0. + 0.*I, 0. + 0.*I}, {(-6.*xunit - \
1.*ry*yunit - 1.*rz*zunit - 1.*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2), (-6.*xunit*yunit - \
1.*rz*yunit*zunit + ry*zunit^2 - 1.*yunit*Sqrt[36.*xunit^2 + \
12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2), (rz*yunit^2 - 6.*xunit*zunit - \
1.*ry*yunit*zunit - 1.*zunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 
                              12.*rx*yunit^2 - 1.*rz^2*yunit^2 + \
12.*rz*xunit*zunit + 2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - \
1.*ry^2*zunit^2])/
                          (yunit^2 + zunit^2)}, {(-6.*xunit - 1.*ry*yunit - \
1.*rz*zunit + Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                             1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + \
zunit^2), 
                         (-6.*xunit*yunit - 1.*rz*yunit*zunit + ry*zunit^2 + \
yunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                              1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + \
zunit^2), 
                         (rz*yunit^2 - 6.*xunit*zunit - 1.*ry*yunit*zunit + \
zunit*Sqrt[36.*xunit^2 + 12.*ry*xunit*yunit - 12.*rx*yunit^2 - 
                              1.*rz^2*yunit^2 + 12.*rz*xunit*zunit + \
2.*ry*rz*yunit*zunit - 12.*rx*zunit^2 - 1.*ry^2*zunit^2])/(yunit^2 + 
                           zunit^2)}}], ({LocRayL, LocSCx, LocSCy} = #1; \
{LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || (Chop[Im[#1]] == {0, 0, 0} && 
                          N[Chop[Re[LocRayL]]] >= 0. && Abs[ry + \
LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - LocSCy] + 
                            Abs[rx + LocRayL*xunit + (LocSCx^2 + \
LocSCy^2)/12] < 1.*^-7 && Re[LocSCx]^2 + Re[LocSCy]^2 <= 31.922500000000003)) \
& ]]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24998.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 9., 24998.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 9., 24998.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = 4. \
+ rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                   rez = Chop[rez]; intersectionnumber = intersectionnumber + \
1.; opticallength = opticallength + ray1*index1; completedray = 
                    {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                     opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                     generationnumber, intersectionnumber, pol1, pol2, \
pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., Plus[(0.3333333333333333*ray2)/(1. \
+ Sqrt[Plus[1.]])], Plus[(0.3333333333333333*ray3)/
                           (1. + Sqrt[Plus[1.]])]}, \
{Plus[(-0.3333333333333333*ray2)/(1. + Sqrt[Plus[1.]])], 1., 0.}, 
                        {Plus[(-0.3333333333333333*ray3)/(1. + \
Sqrt[Plus[1.]])], 0., 1.}}]; If[surfnorm[[1]] == {0., 0., 0.} || \
surfnorm[[2]] == 
                       {0., 0., 0.} || surfnorm[[3]] == {0., 0., 0.}, \
surfnorm = 1.*Re[{{1., Plus[(0.3333333333333333*(1.*^-6 + ray2))/
                             (1. + Sqrt[Plus[1.]])], \
Plus[(0.3333333333333333*(1.*^-6 + ray3))/(1. + Sqrt[Plus[1.]])]}, 
                          {Plus[(-0.3333333333333333*(1.*^-6 + ray2))/(1. + \
Sqrt[Plus[1.]])], 1., 0.}, {Plus[(-0.3333333333333333*(1.*^-6 + ray3))/
                             (1. + Sqrt[Plus[1.]])], 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1., 0, 0}, {0, \
1., 0}, {0, 0, 1.}}; surfacetranslationvector = {4., 0, 0}; 
                    activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.4992664079787237 - 0.7232199522002112*wavelength + 
                        1.0984449372281133*wavelength^2 - \
0.5792106405034075*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.676591682864066 - \
1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - \
0.9804493049167423*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = 1.676591682864066 \
- 1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - 
                         0.9804493049167423*wavelength^3], index2 = \
1.676591682864066 - 1.1701284013479643*wavelength + 1.824530254455512*
                         wavelength^2 - 0.9804493049167423*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.4992664079787237 - 0.7232199522002112*wavelength + \
1.0984449372281133*wavelength^2 - 0.5792106405034075*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.4992664079787237 - \
0.7232199522002112*wavelength + 1.0984449372281133*wavelength^2 - \
0.5792106405034075*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = 
                Chop[ry]; rz = Chop[rz]; terminatedeflection = False; \
intersections = {{-1., 0., 0.}}); If[intensity > thresholdintensity, 
               deflectedrayspresent = True; (intersections = \
Block[{surfaceapprox, tempapprox, intersects, LocRayL, LocSCx, LocSCy}, 
                   LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; surfaceapprox = \
{{-1., 0., 0.}}; tempapprox = {{-1., 0., 0.}}; intersects = 
                     {{-1., 0., 0.}}; surfaceapprox = Block[{TempVar, \
TempVar1, TempVar2, TempVar3, LocRayL, LocSCx, LocSCy}, TempVar1 = 1.; 
                       TempVar2 = 1.; TempVar3 = 1.; TempVar = {{-1., 0., \
0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; TempVar1 = rx^2 + ry^2 + 
                         rz^2; TempVar2 = rx*xunit + ry*yunit + rz*zunit - \
10.2*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 2*rx*10.2; 
                       TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] >= 0., \
TempVar3 = Sqrt[TempVar3]; TempVar = {{LocRayL, LocSCx, LocSCy} = 
                             {-TempVar2 - TempVar3, ry - (TempVar2 + \
TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; If[N[Chop[LocRayL]] >= 0. \
&& 
                              LocSCx^2 + LocSCy^2 <= 31.922500000000003 && \
Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - LocSCy] + 
                                Abs[-10.2 + rx + LocRayL*xunit + \
Sqrt[104.03999999999999 - LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, \
LocSCy}, 
                             {-1., 0., 0.}], {LocRayL, LocSCx, LocSCy} = \
{-TempVar2 + TempVar3, ry + (-TempVar2 + TempVar3)*yunit, 
                              rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 31.922500000000003 && 
                              Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[-10.2 + rx + LocRayL*xunit + 
                                  Sqrt[104.03999999999999 - LocSCx^2 - \
LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, LocSCy}, {-1., 0., 0.}]}; 
                         If[TempVar[[1]] == TempVar[[2]], {TempVar[[1]]}, \
TempVar], {{-1., 0., 0.}}]]; tempapprox = Union[Join[(Take[#1, 3] & ) /@ 
                        surfaceapprox, {{-1., 0., 0.}}]]; \
If[Length[Select[tempapprox, Chop[First[#1]] <= 0 & ]] != Length[tempapprox], \

                     surfaceapprox = Select[tempapprox, Chop[First[#1]] > 0 & \
], surfaceapprox = {{-1., 0., 0.}}]; If[surfaceapprox != 
                      {{-1., 0., 0.}}, intersects = {{-1., 0., 0.}}; \
Scan[(AppendTo[intersects, {LocRayL, LocSCx, LocSCy} = {#1[[1]], #1[[2]], 
                             #1[[3]]}; If[Plus @@ Abs[{rx + LocRayL*xunit, ry \
+ LocRayL*yunit, rz + LocRayL*zunit} - {(0.09803921568627452*
                                   (LocSCx^2 + LocSCy^2))/(1 + Sqrt[1 + \
0.020488273740868906*(LocSCx^2 + LocSCy^2)]), LocSCx, LocSCy}] < 1.*^-9, 
                            {LocRayL, LocSCx, LocSCy}, LocRayL = \
0.99*LocRayL; Function[{rx, ry, rz, xunit, yunit, zunit, startpoint}, 
                               Block[{values, stepsizes, fvector, success, \
steps, denominator}, values = {1.}; stepsizes = {1.}; fvector = {1.}; 
                                 success = False; steps = 0; denominator = \
1.; stepsizes = Table[1.0000000000000001*^-7, {3}]; values = startpoint; 
                                 While[steps < 50 && (success = True; \
(If[Abs[#1] > 1.*^-9, success = False; 1., 1.] & ) /@ stepsizes;  !success), 
                                  steps = steps + 1; fvector = {rx + \
xunit*values[[1]], ry + yunit*values[[1]], rz + zunit*values[[1]]} - 
                                     {(0.09803921568627452*(values[[2]]^2 + \
values[[3]]^2))/(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + 
                                            values[[3]]^2)]), values[[2]], \
values[[3]]}; denominator = xunit - yunit*(((0.002008654288320481*
                                          values[[2]]*(values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                               2)]*(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                          values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*-1) - zunit*
                                      (((0.002008654288320481*values[[3]]*(\
values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*
                                             (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^2)])^
                                           2) - \
(0.19607843137254904*values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                               2)]))*-1); \
If[Chop[denominator] != 0, denominator, denominator = 1.]; stepsizes = 
                                    -(#1 . fvector & ) /@ ({{1, \
-(((0.002008654288320481*values[[2]]*(values[[2]]^2 + values[[3]]^2))/
                                             (Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]*(1 + Sqrt[1 + \
0.020488273740868906*
                                                  (values[[2]]^2 + \
values[[3]]^2)])^2) - (0.19607843137254904*values[[2]])/(1 + Sqrt[1 + 
                                                0.020488273740868906*(values[[\
2]]^2 + values[[3]]^2)]))*-1), -(((0.002008654288320481*values[[3]]*
                                              (values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^2)]*
                                              (1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                              values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*-1)}, {yunit, 
                                         -xunit - \
((0.002008654288320481*values[[3]]*(values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + \
0.020488273740868906*
                                                 (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^
                                                  2)])^2) - \
(0.19607843137254904*values[[3]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + 
                                                  values[[3]]^2)]))*zunit, \
((0.002008654288320481*values[[3]]*(values[[2]]^2 + values[[3]]^2))/
                                            (Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]*(1 + Sqrt[1 + \
0.020488273740868906*
                                                  (values[[2]]^2 + \
values[[3]]^2)])^2) - (0.19607843137254904*values[[3]])/(1 + Sqrt[1 + 
                                               0.020488273740868906*(values[[\
2]]^2 + values[[3]]^2)]))*yunit}, {zunit, ((0.002008654288320481*
                                             values[[2]]*(values[[2]]^2 + \
values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + values[[3]]^
                                                  2)]*(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)])^2) - \
(0.19607843137254904*
                                             values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + values[[3]]^2)]))*zunit, -xunit - 
                                          ((0.002008654288320481*values[[2]]*(\
values[[2]]^2 + values[[3]]^2))/(Sqrt[1 + 0.020488273740868906*
                                                 (values[[2]]^2 + \
values[[3]]^2)]*(1 + Sqrt[1 + 0.020488273740868906*(values[[2]]^2 + \
values[[3]]^
                                                  2)])^2) - \
(0.19607843137254904*values[[2]])/(1 + Sqrt[1 + \
0.020488273740868906*(values[[2]]^2 + 
                                                  values[[3]]^2)]))*yunit}}/\
denominator); values = values + stepsizes]; If[steps >= 50, 
                                  If[First[values] > 0, values = -values; 1., \
1.]; denominator = 1., 1.]; values]][rx, ry, rz, xunit, yunit, zunit, 
                              {LocRayL, LocSCx, LocSCy}]]]; {-1., 0., 0.}) & \
, surfaceapprox]; Union[Re[Select[intersects, 
                         ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || (Chop[Im[#1]] == {0, 0, 0} && 
                             N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
31.922500000000003 && Plus @@ Abs[{rx + LocRayL*xunit, 
                                  ry + LocRayL*yunit, rz + LocRayL*zunit} - \
{(0.09803921568627452*(LocSCx^2 + LocSCy^2))/(1 + Sqrt[1 + 
                                      0.020488273740868906*(LocSCx^2 + \
LocSCy^2)]), LocSCx, LocSCy}] < 1.*^-9)) & ]]], {{-1., 0., 0.}}]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 24999.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 10., 24999.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 10., 24999.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                   rez = Chop[rez]; intersectionnumber = intersectionnumber + \
1.; opticallength = opticallength + ray1*index1; completedray = 
                    {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                     opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                     generationnumber, intersectionnumber, pol1, pol2, \
pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., \
(0.002008654288320481*ray2^3)/(Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*
                            (1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])^2) + (0.002008654288320481*ray2*ray3^2)/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) - 
                          (0.19607843137254904*ray2)/(1. + Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]), (0.002008654288320481*ray2^2*ray3)/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) + 
                          (0.002008654288320481*ray3^3)/(Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*
                                 (ray2^2 + ray3^2)])^2) - \
(0.19607843137254904*ray3)/(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])}, 
                        {(-0.002008654288320481*ray2*(ray2^2 + \
ray3^2))/(Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)]*
                            (1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)])^2) + (0.19607843137254904*ray2)/(1. + Sqrt[
                             1. + 0.020488273740868906*(ray2^2 + ray3^2)]), \
1., 0.}, {(-0.002008654288320481*ray3*(ray2^2 + ray3^2))/
                           (Sqrt[1. + 0.020488273740868906*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. + 0.020488273740868906*(ray2^2 + ray3^2)])^2) + 
                          (0.19607843137254904*ray3)/(1. + Sqrt[1. + \
0.020488273740868906*(ray2^2 + ray3^2)]), 0., 1.}}]; 
                    If[surfnorm[[1]] == {0., 0., 0.} || surfnorm[[2]] == {0., \
0., 0.} || surfnorm[[3]] == {0., 0., 0.}, 
                     surfnorm = 1.*Re[{{1., (0.002008654288320481*(1.*^-6 + \
ray2)^3)/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.002008654288320481*(1.*^-6 + ray2)*(1.*^-6 + \
ray3)^2)/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.19607843137254904*(1.*^-6 + ray2))/(1. + \
Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 
                           (0.002008654288320481*(1.*^-6 + ray2)^2*(1.*^-6 + \
ray3))/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.002008654288320481*(1.*^-6 + ray3)^3)/(Sqrt[1. \
+ 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*
                              (1. + Sqrt[1. + 0.020488273740868906*((1.*^-6 + \
ray2)^2 + (1.*^-6 + ray3)^2)])^2) - (0.19607843137254904*(1.*^-6 + 
                               ray3))/(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])}, \
{(-0.002008654288320481*
                              (1.*^-6 + ray2)*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2))/(Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. + \
0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.19607843137254904*(1.*^-6 + ray2))/(1. + \
Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 1., \

                           0.}, {(-0.002008654288320481*(1.*^-6 + \
ray3)*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2))/(Sqrt[1. + \
0.020488273740868906*
                                 ((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*(1. \
+ Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^
                                     2)])^2) + (0.19607843137254904*(1.*^-6 + \
ray3))/(1. + Sqrt[1. + 0.020488273740868906*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]), 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1, 0, 0}, {0, 1, \
0}, {0, 0, 1}}; surfacetranslationvector = {0, 0, 0}; 
                    activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.676591682864066 - 1.1701284013479643*wavelength + 
                        1.824530254455512*wavelength^2 - \
0.9804493049167423*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.5532682085813037 - \
1.0054245500503685*wavelength + 1.6027810806802343*wavelength^2 - \
0.8794405514298376*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = \
1.5532682085813037 - 1.0054245500503685*wavelength + \
1.6027810806802343*wavelength^2 - 
                         0.8794405514298376*wavelength^3], index2 = \
1.5532682085813037 - 1.0054245500503685*wavelength + 1.6027810806802343*
                         wavelength^2 - 0.8794405514298376*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.676591682864066 - 1.1701284013479643*wavelength + \
1.824530254455512*wavelength^2 - 0.9804493049167423*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.676591682864066 - \
1.1701284013479643*wavelength + 1.824530254455512*wavelength^2 - \
0.9804493049167423*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = 
                Chop[ry]; rz = Chop[rz]; terminatedeflection = False; \
intersections = {{-1., 0., 0.}}); If[intensity > thresholdintensity, 
               deflectedrayspresent = True; (intersections = If[Chop[xunit] \
!= 0, {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= 
                         32.56414225, {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., \
0.}] & )[{-(rx/xunit), ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, 
                   {{-1., 0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; \
holeQ = False; If[ !(Chop[surfaceid - 25000.] == 0. || 
                     N[Chop[ray1]] < 0.0001) || generationnumber == 1., \
minresonateraylength = 0., minresonateraylength = 0.0001]; 
                 Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1.; LocSCx = 1.; \
LocSCy = 1.; dummymatrix = Union[Select[intersections, 
                      ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= minresonateraylength) & ]]; 
                   intersections = dummymatrix]; unfilteredintersections = \
intersections; If[Length[intersections] > 1, 
                  dummymatrix = Take[intersections, {2}]; intersections = \
dummymatrix; 1., 1.]; intersections = 
                  Union[(If[#1[[2]]^2 + #1[[3]]^2 <= 31.287242250000006, \
holeQ = True; {-1., 0., 0.}, #1] & ) /@ unfilteredintersections]; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 11., 25000.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 11., 25000.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}; 
                    surfacetranslationvector = {0, 0, 0}; activeregion = 0.; \
completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                       rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}})); \
{First[allcreatedrays], completedray}, reporteddummyrayspresent = True; 
                  {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                    opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                    generationnumber, intersectionnumber, pol1, pol2, pol3}, \
{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}], 
               reporteddummyrayspresent = True; deflecteddummyrayspresent = \
True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                  -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 0.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = If[Chop[xunit] != 0, 
                   {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= \
6.25, {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                      ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., \
0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 25001.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 12., 25001.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 12., 25001.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -0.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1., 0, 0}, {0, 1., 0}, {0, 0, 1.}}; 
                    surfacetranslationvector = {-0.05, 0, 0}; activeregion = \
0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, r3}]; 
                    raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - \
raytiltz^2; If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., 
                     raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - \
ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], 
                     XAxis = XAxis/raytiltx]; YAxis = \
{-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*
                        XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + \
ZAxis[[1]]*XAxis[[2]]}; YAxis = YAxis/Sqrt[YAxis . YAxis]; 
                    PAxis = ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . \
ZAxis; PAxis = PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = 
                     {pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = \
normalizedpolarization/Sqrt[normalizedpolarization . 
                        normalizedpolarization]; allcreatedamplitudes = \
{{I*0., I*0., I*0.}}; amplitude = Sqrt[intensity]*
                      (normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*Exp[I*pol3*0.017453292519943295]); 
                    perpendicularamplitude = amplitude . YAxis; \
parallelamplitude = amplitude . PAxis; {rx, ry, rz} = ({rex, rey, rez} - 
                       {-0.05, 0, 0}) . {{1., 0., 0.}, {0., 1., 0.}, {0., 0., \
1.}}; {xunit, yunit, zunit} = {r1, r2, r3} . {{1., 0., 0.}, 
                       {0., 1., 0.}, {0., 0., 1.}}; {xunit, yunit, zunit} = \
{xunit, yunit, zunit}/Sqrt[{xunit, yunit, zunit} . {xunit, yunit, 
                         zunit}]; r1 = ry; dr1 = yunit/Abs[xunit]; ry = \
Plus[r1]; dry = (-(focus/1000))*r1 + dr1; r1 = rz; dr1 = zunit/Abs[xunit]; 
                    rz = Plus[r1]; drz = (-(focus/1000))*r1 + dr1; exitvalue \
= (0 & )[First[{ray2, ray3}], Last[{ray2, ray3}]]*1.0000001; 
                    opticallength = opticallength + exitvalue; {rex, rey, \
rez} = {Sign[xunit]*exitvalue, ry, rz} . {{1., 0, 0}, {0, 1., 0}, 
                        {0, 0, 1.}} + {-0.05, 0, 0}; {r1, r2, r3} = \
{Sign[xunit]/(Sqrt[1 + dry^2]*Sqrt[1 + drz^2]), dry/Sqrt[1 + dry^2], 
                       drz/(Sqrt[1 + drz^2]*Sqrt[1 + dry^2])} . {{1., 0, 0}, \
{0, 1., 0}, {0, 0, 1.}}; dummyvector = {r1, r2, r3}/
                      Sqrt[{r1, r2, r3} . {r1, r2, r3}]; {r1, r2, r3} = \
dummyvector; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \

                       r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                       surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                       pol1, pol2, pol3}}; originalrotation = \
Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; 
                    transmatrix = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        rotationaxis = Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; 
                        If[Chop[axismagnitude] != 0., rotationaxis = \
rotationaxis/axismagnitude; axismatrix = (#1*rotationaxis & ) /@ \
rotationaxis; 
                          crossmatrix = {{0., -rotationaxis[[3]], \
rotationaxis[[2]]}, {rotationaxis[[3]], 0., -rotationaxis[[1]]}, 
                            {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; \
cosangle = previoustilt . {r1, r2, r3}; If[1. - cosangle < 
                            2.220446049250313*^-16, cosangle = 1.]; sinangle \
= 1 - cosangle^2; If[sinangle < 2.220446049250313*^-16, sinangle = 0., 
                           sinangle = Sqrt[sinangle]]; axismatrix + ({{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + 
                           crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, 
                           {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., \
0., 0.}, {0., -1., 0.}, {0., 0., -1.}}]]) & , allcreatedrays]; 
                    allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
Function[mm, (mm . #1 & ) /@ originalrotation][transmatrix[[First[#2]]]]; 
                        tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, r3}/
                            Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; \
dummymatrix = (#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, 
                             {r7, r8, r9}}; {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = dummymatrix; 1., 1.]; If[allcreatedamplitudes != 
                          {{I*0., I*0., I*0.}}, amplitude = \
allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . amplitude; ver = {r7, \
r8, r9} . 
                            amplitude; If[Abs[hor] > 0. || Abs[ver] > 0., \
{pol1, pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = 
                             {pol1, pol2, pol3}/Sqrt[{pol1, pol2, pol3} . \
{pol1, pol2, pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = 
                             ReplacePart[{pol1, pol2, pol3}, (If[ver == 0., \
0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 0.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = If[Chop[xunit] != 0, 
                   {(If[N[Chop[#1[[1]]]] >= 0. && #1[[2]]^2 + #1[[3]]^2 <= \
25., {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                      ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., \
0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 25002.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                 intersections = Union[(If[#1[[2]]^2 + #1[[3]]^2 <= 6.25, \
holeQ = True; {-1., 0., 0.}, #1] & ) /@ unfilteredintersections]; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 13., 25002.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 13., 25002.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -0.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = (#1 & ) /@ surfnorm; 
                    surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; \
surfacerotationmatrix = {{1., 0, 0}, {0, 1., 0}, {0, 0, 1.}}; 
                    surfacetranslationvector = {-0.05, 0, 0}; activeregion = \
0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    componentnumber = newcomponentnumber; surfacenumber = \
newsurfacenumber; surfaceid = newsurfaceid; originalray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                       rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}})); \
{First[allcreatedrays], completedray}, reporteddummyrayspresent = True; 
                  {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                    opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, 
                    generationnumber, intersectionnumber, pol1, pol2, pol3}, \
{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}], 
               reporteddummyrayspresent = True; deflecteddummyrayspresent = \
True; {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                  -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, 
                 {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}]) & ) /@ \
propagatedrays]; If[deflectedrayspresent && deflecteddummyrayspresent, 
          deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]; If[reportedrayspresent && reporteddummyrayspresent, 
          reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; \
1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 3.05 + rex; ry = rey; rz = rez; rx = 
                Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{TempVar, TempVar1, TempVar2, TempVar3, LocRayL, 
                    LocSCx, LocSCy}, TempVar1 = 1.; TempVar2 = 1.; TempVar3 = \
1.; TempVar = {{-1., 0., 0.}}; LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; 
                    TempVar1 = rx^2 + ry^2 + rz^2; TempVar2 = rx*xunit + \
ry*yunit + rz*zunit - 6.5*xunit; TempVar3 = -TempVar1 + TempVar2^2 + 
                      2*rx*6.5; TempVar3 = Re[TempVar3]; If[N[Chop[TempVar3]] \
>= 0., TempVar3 = Sqrt[TempVar3]; TempVar = 
                       {{LocRayL, LocSCx, LocSCy} = {-TempVar2 - TempVar3, ry \
- (TempVar2 + TempVar3)*yunit, rz - (TempVar2 + TempVar3)*zunit}; 
                         If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= \
25. && Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + LocRayL*zunit - 
                               LocSCy] + Abs[-6.5 + rx + LocRayL*xunit + \
Sqrt[42.25 - LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, LocSCx, LocSCy}, 
                          {-1., 0., 0.}], {LocRayL, LocSCx, LocSCy} = \
{-TempVar2 + TempVar3, ry + (-TempVar2 + TempVar3)*yunit, 
                           rz + (-TempVar2 + TempVar3)*zunit}; \
If[N[Chop[LocRayL]] >= 0. && LocSCx^2 + LocSCy^2 <= 25. && 
                           Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[-6.5 + rx + LocRayL*xunit + Sqrt[42.25 - 
                                 LocSCx^2 - LocSCy^2]] < 1.*^-7, {LocRayL, \
LocSCx, LocSCy}, {-1., 0., 0.}]}; If[TempVar[[1]] == TempVar[[2]], 
                       {TempVar[[1]]}, TempVar], {{-1., 0., 0.}}]]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                 If[ !(Chop[surfaceid - 25003.] == 0. || N[Chop[ray1]] < \
0.0001) || generationnumber == 1., minresonateraylength = 0., 
                  minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, \
LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                    Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = \
#1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                          minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                 If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]); 
                If[intersections != {{-1., 0., 0.}}, intersectionspresent = \
True; ({newcomponentnumber, newsurfacenumber, newsurfaceid} = 
                    {1., 14., 25003.}; {componentnumber, surfacenumber, \
surfaceid} = {1., 14., 25003.}; {ray1, ray2, ray3} = intersections[[1]]; 
                   rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = -3.05 + rxhlp; 
                   rey = ryhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                   opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                     wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                     ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}); 
                  (reportedrayspresent = True; (surfnorm = 1.*Re[{{1., \
-(ray2/(42.25 - ray2^2 - ray3^2)^2^(-1)), -(ray3/(42.25 - ray2^2 - ray3^2)^
                            2^(-1))}, {ray2/(42.25 - ray2^2 - ray3^2)^2^(-1), \
1., 0.}, {ray3/(42.25 - ray2^2 - ray3^2)^2^(-1), 0., 1.}}]; 
                    dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 \
. #1] & ) /@ dummymatrix; surfacerotationmatrix = {{1., 0, 0}, 
                      {0, 1., 0}, {0, 0, 1.}}; surfacetranslationvector = \
{-3.05, 0, 0}; activeregion = 1.; completedray = {rsx, rsy, rsz, rex, rey, 
                      rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                      componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                      intersectionnumber, pol1, pol2, pol3}; componentnumber \
= newcomponentnumber; surfacenumber = newsurfacenumber; 
                    surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; ZAxis = First[surfnorm]*
                      Sign[First[surfnorm] . {r1, r2, r3}]; raytiltz = ZAxis \
. {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.5532682085813037 - 1.0054245500503685*wavelength + 
                        1.6027810806802343*wavelength^2 - \
0.8794405514298376*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = 1.5392664079785716 - \
0.7232199521994117*wavelength + 1.0984449372267269*wavelength^2 - \
0.5792106405020717*
                           wavelength^3; If[Abs[alternateindex - index1] > \
Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                         index1 = alternateindex], index1 = \
1.5392664079785716 - 0.7232199521994117*wavelength + \
1.0984449372267269*wavelength^2 - 
                         0.5792106405020717*wavelength^3], index2 = \
1.5392664079785716 - 0.7232199521994117*wavelength + 1.0984449372267269*
                         wavelength^2 - 0.5792106405020717*wavelength^3; \
index1 = index; If[Abs[index2 - index1] < 0.01, alternateindex = 
                         1.5532682085813037 - 1.0054245500503685*wavelength + \
1.6027810806802343*wavelength^2 - 0.8794405514298376*wavelength^3; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = 1.5532682085813037 - \
1.0054245500503685*wavelength + 1.6027810806802343*wavelength^2 - \
0.8794405514298376*
                          wavelength^3]]; n12 = index1/index2; index = \
index2; If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + 
                        ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                       phaseshift = phaseshift + 0.5, 1.]; index2 = index1; \
index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                          {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                       dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                     Partition[Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                      ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, {r1, r2, r3}]; 
                        axismagnitude = Sqrt[rotationaxis . rotationaxis]; \
If[Chop[axismagnitude] != 0., rotationaxis = rotationaxis/axismagnitude; 
                          axismatrix = (#1*rotationaxis & ) /@ rotationaxis; \
crossmatrix = {{0., -rotationaxis[[3]], rotationaxis[[2]]}, 
                            {rotationaxis[[3]], 0., -rotationaxis[[1]]}, \
{-rotationaxis[[2]], rotationaxis[[1]], 0.}}; cosangle = previoustilt . 
                            {r1, r2, r3}; If[1. - cosangle < \
2.220446049250313*^-16, cosangle = 1.]; sinangle = 1 - cosangle^2; 
                          If[sinangle < 2.220446049250313*^-16, sinangle = \
0., sinangle = Sqrt[sinangle]]; axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, 
                              {0., 0., 1.}} - axismatrix)*cosangle + \
crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
                          If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, 
                            {0., 0., -1.}}]]) & , allcreatedrays]; \
allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, 
                          r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                          surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                          intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                            originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                          1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                        If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                            amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                              0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                            dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); (generationnumber += 1.; \
reportedlocalrays = 
         {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, 0, intensityscale, ray1, index, opticallength, phaseshift, 
           componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}}; deflectedlocalrays = \
{{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
           wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
           frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; 
        (deflectedrayspresent = False; reportedrayspresent = False; \
deflecteddummyrayspresent = False; reporteddummyrayspresent = False; 
         {deflectedlocalrays, reportedlocalrays} = Transpose[((({rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                 intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                 frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; index1 = \
index; xunit = 
                r1; yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                 2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; \
zunit = zunit/magnitude; rx = 3.5999999999999996 + rex; ry = rey; rz = 
                rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}); 
              If[intensity > thresholdintensity, deflectedrayspresent = True; \
(intersections = Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1. + I*0.; 
                    LocSCx = 1. + I*0.; LocSCy = 1. + I*0.; Re[Select[{{-1. + \
0.*I, 0. + 0.*I, 0. + 0.*I}, {(386.*xunit - 37.*rx*xunit - 
                          50.*ry*yunit - 50.*rz*zunit - \
1.4142135623730951*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - \
925.*rz^2*xunit^2 - 
                             19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit \
+ 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 1250.*rz^2*yunit^2 - 
                             19300.*rz*xunit*zunit + 1850.*rx*rz*xunit*zunit \
+ 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 925.*rx^2*zunit^2 - 
                             1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 \
+ 50.*zunit^2), (37.*ry*xunit^2 + 386.*xunit*yunit - 37.*rx*xunit*
                           yunit - 50.*rz*yunit*zunit + 50.*ry*zunit^2 - \
1.4142135623730951*yunit*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - 
                             925.*rz^2*xunit^2 - 19300.*ry*xunit*yunit + \
1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2), \
(37.*rz*xunit^2 + 50.*rz*yunit^2 + 
                          386.*xunit*zunit - 37.*rx*xunit*zunit - \
50.*ry*yunit*zunit - 1.4142135623730951*zunit*Sqrt[74498.*xunit^2 - \
925.*ry^2*
                              xunit^2 - 925.*rz^2*xunit^2 - \
19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - \
925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2)}, {(386.*xunit \
- 37.*rx*xunit - 
                          50.*ry*yunit - 50.*rz*zunit + \
1.4142135623730951*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - \
925.*rz^2*xunit^2 - 
                             19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit \
+ 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 1250.*rz^2*yunit^2 - 
                             19300.*rz*xunit*zunit + 1850.*rx*rz*xunit*zunit \
+ 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 925.*rx^2*zunit^2 - 
                             1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 \
+ 50.*zunit^2), (37.*ry*xunit^2 + 386.*xunit*yunit - 37.*rx*xunit*
                           yunit - 50.*rz*yunit*zunit + 50.*ry*zunit^2 + \
1.4142135623730951*yunit*Sqrt[74498.*xunit^2 - 925.*ry^2*xunit^2 - 
                             925.*rz^2*xunit^2 - 19300.*ry*xunit*yunit + \
1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - 925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2), \
(37.*rz*xunit^2 + 50.*rz*yunit^2 + 
                          386.*xunit*zunit - 37.*rx*xunit*zunit - \
50.*ry*yunit*zunit + 1.4142135623730951*zunit*Sqrt[74498.*xunit^2 - \
925.*ry^2*
                              xunit^2 - 925.*rz^2*xunit^2 - \
19300.*ry*xunit*yunit + 1850.*rx*ry*xunit*yunit + 19300.*rx*yunit^2 - \
925.*rx^2*yunit^2 - 
                             1250.*rz^2*yunit^2 - 19300.*rz*xunit*zunit + \
1850.*rx*rz*xunit*zunit + 2500.*ry*rz*yunit*zunit + 19300.*rx*zunit^2 - 
                             925.*rx^2*zunit^2 - \
1250.*ry^2*zunit^2])/(37.*xunit^2 + 50.*yunit^2 + 50.*zunit^2)}}, ({LocRayL, \
LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
(Chop[Im[#1]] == {0, 0, 0} && N[Chop[Re[LocRayL]]] >= 0. && 
                          Abs[ry + LocRayL*yunit - LocSCx] + Abs[rz + \
LocRayL*zunit - LocSCy] + Abs[rx + LocRayL*xunit - (25*(LocSCx^2 + \
LocSCy^2))/
                               (193*(1 + Sqrt[1 - (925*(LocSCx^2 + \
LocSCy^2))/74498]))] < 1.*^-7 && Re[LocSCx]^2 + Re[LocSCy]^2 <= 39.0625)) & \
]]]; 
                 AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; If[ \
!(Chop[surfaceid - 25004.] == 0. || N[Chop[ray1]] < 0.0001) || 
                   generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                  LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                        {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = dummymatrix]; \

                 unfilteredintersections = intersections; \
If[Length[intersections] > 1, dummymatrix = Take[intersections, {2}]; 
                   intersections = dummymatrix; 1., 1.]); If[intersections != \
{{-1., 0., 0.}}, intersectionspresent = True; 
                  ({newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 15., 25004.}; {componentnumber, surfacenumber, surfaceid} = 
                    {1., 15., 25004.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                   ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
-3.5999999999999996 + rxhlp; rey = ryhlp; rez = rzhlp; rex = Chop[rex]; 
                   rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = \
intersectionnumber + 1.; opticallength = opticallength + ray1*index1; 
                   completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                     index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                     rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}); (reportedrayspresent = True; 
                   (surfnorm = 1.*Re[{{1., \
(-0.0016083472422043674*ray2^3)/(Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*
                            (1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])^2) - (0.0016083472422043674*ray2*ray3^2)/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) - 
                          (0.2590673575129534*ray2)/(1. + Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]), \
(-0.0016083472422043674*ray2^2*ray3)/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) - 
                          (0.0016083472422043674*ray3^3)/(Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*
                                 (ray2^2 + ray3^2)])^2) - \
(0.2590673575129534*ray3)/(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])}, 
                        {(0.0016083472422043674*ray2*(ray2^2 + \
ray3^2))/(Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)]*
                            (1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)])^2) + (0.2590673575129534*ray2)/(1. + Sqrt[1. - 
                              0.012416440709817716*(ray2^2 + ray3^2)]), 1., \
0.}, {(0.0016083472422043674*ray3*(ray2^2 + ray3^2))/
                           (Sqrt[1. - 0.012416440709817716*(ray2^2 + \
ray3^2)]*(1. + Sqrt[1. - 0.012416440709817716*(ray2^2 + ray3^2)])^2) + 
                          (0.2590673575129534*ray3)/(1. + Sqrt[1. - \
0.012416440709817716*(ray2^2 + ray3^2)]), 0., 1.}}]; 
                    If[surfnorm[[1]] == {0., 0., 0.} || surfnorm[[2]] == {0., \
0., 0.} || surfnorm[[3]] == {0., 0., 0.}, 
                     surfnorm = 1.*Re[{{1., (-0.0016083472422043674*(1.*^-6 + \
ray2)^3)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.0016083472422043674*(1.*^-6 + ray2)*(1.*^-6 + \
ray3)^2)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.2590673575129534*(1.*^-6 + ray2))/(1. + \
Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 
                           (-0.0016083472422043674*(1.*^-6 + ray2)^2*(1.*^-6 \
+ ray3))/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) - 
                            (0.0016083472422043674*(1.*^-6 + \
ray3)^3)/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2)]*
                              (1. + Sqrt[1. - 0.012416440709817716*((1.*^-6 + \
ray2)^2 + (1.*^-6 + ray3)^2)])^2) - (0.2590673575129534*(1.*^-6 + 
                               ray3))/(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])}, \
{(0.0016083472422043674*
                              (1.*^-6 + ray2)*((1.*^-6 + ray2)^2 + (1.*^-6 + \
ray3)^2))/(Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]*(1. + Sqrt[1. - \
0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)])^2) + 
                            (0.2590673575129534*(1.*^-6 + ray2))/(1. + \
Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]), 1., \

                           0.}, {(0.0016083472422043674*(1.*^-6 + \
ray3)*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2))/(Sqrt[1. - \
0.012416440709817716*
                                 ((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^2)]*(1. \
+ Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + (1.*^-6 + ray3)^
                                     2)])^2) + (0.2590673575129534*(1.*^-6 + \
ray3))/(1. + Sqrt[1. - 0.012416440709817716*((1.*^-6 + ray2)^2 + 
                                  (1.*^-6 + ray3)^2)]), 0., 1.}}]; 1., 1.]; \
dummymatrix = (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                      dummymatrix; surfacerotationmatrix = {{1., 0, 0}, {0, \
1., 0}, {0, 0, 1.}}; surfacetranslationvector = {-3.5999999999999996, 0, 
                      0}; activeregion = 1.; completedray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = newcomponentnumber; 
                    surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, 
                      r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                    If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                    If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis = \
XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                       ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                    YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                     PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                     normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                    amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                        Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                    If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = 1.5392664079785716 - 0.7232199521994117*wavelength + 
                        1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3; index1 = index; If[Abs[index2 - index1] < \
0.01, 
                       alternateindex = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                           2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                        If[Abs[alternateindex - index1] > Abs[index2 - \
index1], index1 = index2; index2 = alternateindex, index1 = alternateindex], 
                       index1 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                          2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                     index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                         2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                      index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = 1.5392664079785716 - 0.7232199521994117*wavelength + 
                          1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3; If[Abs[alternateindex - index1] > Abs[index2 \
- index1], 
                         index1 = index2; index2 = alternateindex, index1 = \
alternateindex], index1 = 1.5392664079785716 - 0.7232199521994117*
                          wavelength + 1.0984449372267269*wavelength^2 - \
0.5792106405020717*wavelength^3]]; n12 = index1/index2; index = index2; 
                    If[1 - n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, \
r3} + ZAxis*(-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); 
                      {r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . \
surfnorm[[1]] > 0, phaseshift = phaseshift + 0.5, 1.]; index2 = index1; 
                      index = index1; dummyvector = {r1, r2, r3} - \
2*ZAxis*ZAxis . {r1, r2, r3}; {r1, r2, r3} = dummyvector; dummyvector = 
                       {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} \
= dummyvector; 1.]; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, 
                       r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}}; \
originalrotation = Partition[Take[originalray, {7, 15}], 3]; previoustilt = 
                     originalrotation[[1]]; transmatrix = MapIndexed[({rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        rotationaxis = Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; 
                        If[Chop[axismagnitude] != 0., rotationaxis = \
rotationaxis/axismagnitude; axismatrix = (#1*rotationaxis & ) /@ \
rotationaxis; 
                          crossmatrix = {{0., -rotationaxis[[3]], \
rotationaxis[[2]]}, {rotationaxis[[3]], 0., -rotationaxis[[1]]}, 
                            {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; \
cosangle = previoustilt . {r1, r2, r3}; If[1. - cosangle < 
                            2.220446049250313*^-16, cosangle = 1.]; sinangle \
= 1 - cosangle^2; If[sinangle < 2.220446049250313*^-16, sinangle = 0., 
                           sinangle = Sqrt[sinangle]]; axismatrix + ({{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + 
                           crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, 
                           {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., \
0., 0.}, {0., -1., 0.}, {0., 0., -1.}}]]) & , allcreatedrays]; 
                    allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                          intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                          frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
Function[mm, (mm . #1 & ) /@ originalrotation][transmatrix[[First[#2]]]]; 
                        tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, r3}/
                            Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; \
dummymatrix = (#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, 
                             {r7, r8, r9}}; {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = dummymatrix; 1., 1.]; If[allcreatedamplitudes != 
                          {{I*0., I*0., I*0.}}, amplitude = \
allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . amplitude; ver = {r7, \
r8, r9} . 
                            amplitude; If[Abs[hor] > 0. || Abs[ver] > 0., \
{pol1, pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = 
                             {pol1, pol2, pol3}/Sqrt[{pol1, pol2, pol3} . \
{pol1, pol2, pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = 
                             ReplacePart[{pol1, pol2, pol3}, (If[ver == 0., \
0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                            {pol1, pol2, pol3} = dummyvector]; 1., 1.]; {rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                         wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                         ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                      allcreatedrays])); {First[allcreatedrays], \
completedray}, reporteddummyrayspresent = True; {{rsx, rsy, rsz, rex, rey, \
rez, r1, 
                    r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                    surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, pol1, 
                    pol2, pol3}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1.}}], reporteddummyrayspresent = True; deflecteddummyrayspresent = True; 
                {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
                  1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 
                  1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1.}}]) & ) /@ propagatedrays]; 
         If[deflectedrayspresent && deflecteddummyrayspresent, \
deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & ]; 1., 1.]; 
         If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
        (If[reportedrayspresent, reportedrays = Join[reportedrays, \
{{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8}}, reportedlocalrays]; 1., 1.]; \
propagatedrays = deflectedlocalrays); 
        raysreported = reportedrayspresent; 1.); If[Length[reportedrays] > 2, \
reportedrays = Drop[reportedrays, 2], reportedrays]; 
       ({#1[[1]], #1[[2]], #1[[3]], #1[[4]], #1[[5]], #1[[6]]} & ) /@ \
reportedrays]]), Deployed -> False, AutorunSequencing -> {1, 2, 3, 4}, 
 SynchronousInitialization -> True, SynchronousUpdating -> True]\
\>", "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`focus$$ = 
    0, $CellContext`lastlocposth$$ = {-4.3355456973007716`, 
    1.0700160179314686`}, $CellContext`laststartposth$$ = {-4.933553197300771,
     1.0700160179314686`}, $CellContext`lastth$$ = 
    0., $CellContext`maxfocus$$ = 10, $CellContext`maxth$$ = 
    180., $CellContext`maxx$$ = -0.05, $CellContext`maxy$$ = 
    10, $CellContext`minfocus$$ = -10, $CellContext`minth$$ = -180., \
$CellContext`minx$$ = -10, $CellContext`miny$$ = -10, $CellContext`radiusth$$ \
= 0.5980074999999999, $CellContext`staticpolygons11230200811523132827920$$ = {
    
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{-0.654121133468629, -6.25}, {-1.6633250356081046`, \
-5.208333333333334}, {-2.407409854982819, -4.166666666666667}, \
{-2.9470796165773505`, -3.1250000000000004`}, {-3.3150010468778817`, \
-2.083333333333334}, {-3.5294851698846217`, -1.0416666666666679`}, \
{-3.5999999999999996`, -8.881784197001252*^-16}, {-3.529485169884622, 
      1.041666666666666}, {-3.315001046877882, 
      2.083333333333332}, {-2.947079616577352, 
      3.1249999999999982`}, {-2.40740985498282, 
      4.166666666666664}, {-1.6633250356081057`, 
      5.208333333333332}, {-0.6541211334686317, 
      6.249999999999998}, {-0.654121133468629, 6.25}, {-1.6633250356081046`, 
      5.208333333333334}, {-2.407409854982819, 
      4.166666666666667}, {-2.9470796165773505`, 
      3.1250000000000004`}, {-3.3150010468778817`, 
      2.083333333333334}, {-3.5294851698846217`, 
      1.0416666666666679`}, {-3.5999999999999996`, 
      8.881784197001252*^-16}, {-3.529485169884622, -1.041666666666666}, \
{-3.315001046877882, -2.083333333333332}, {-2.947079616577352, \
-3.1249999999999982`}, {-2.40740985498282, -4.166666666666664}, \
{-1.6633250356081057`, -5.208333333333332}, {-0.6541211334686317, \
-6.249999999999998}, {-0.654121133468629, -6.25}}}]}, \
$CellContext`staticpolygons12230200811523132833440$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{-0.7033119314590373, -5.}, {-1.538876515698588, \
-4.166666666666667}, {-2.1302230142610687`, -3.3333333333333335`}, {-2.55, \
-2.5}, {-2.8326922749902543`, -1.666666666666667}, {-2.9963598686045723`, \
-0.8333333333333339}, {-3.05, 0.}, {-2.9963598686045723`, 
      0.833333333333333}, {-2.8326922749902543`, 
      1.666666666666666}, {-2.5500000000000007`, 
      2.499999999999999}, {-2.1302230142610696`, 
      3.333333333333332}, {-1.5388765156985889`, 
      4.166666666666666}, {-0.7033119314590373, 5.}, {-0.7033119314590373, 
      5.}, {-1.538876515698588, 4.166666666666667}, {-2.1302230142610687`, 
      3.3333333333333335`}, {-2.55, 2.5}, {-2.8326922749902543`, 
      1.666666666666667}, {-2.9963598686045723`, 0.8333333333333339}, {-3.05, 
      0.}, {-2.9963598686045723`, -0.833333333333333}, {-2.8326922749902543`, \
-1.666666666666666}, {-2.5500000000000007`, -2.499999999999999}, \
{-2.1302230142610696`, -3.333333333333332}, {-1.5388765156985889`, \
-4.166666666666666}, {-0.7033119314590373, -5.}, {-0.7033119314590373, \
-5.}}}]}, $CellContext`staticpolygons13230200811523132837510$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{-0.05, -2.5}, {-0.05, -2.0833333333333335`}, {-0.05, \
-1.6666666666666667`}, {-0.05, -1.25}, {-0.05, -0.8333333333333335}, {-0.05, \
-0.41666666666666696`}, {-0.05, 0.}, {-0.05, 0.4166666666666665}, {-0.05, 
      0.833333333333333}, {-0.05, 1.2499999999999996`}, {-0.05, 
      1.666666666666666}, {-0.05, 2.083333333333333}, {-0.05, 2.5}, {-0.05, 
      2.5}, {-0.05, 2.0833333333333335`}, {-0.05, 
      1.6666666666666667`}, {-0.05, 1.25}, {-0.05, 
      0.8333333333333335}, {-0.05, 0.41666666666666696`}, {-0.05, 
      0.}, {-0.05, -0.4166666666666665}, {-0.05, -0.833333333333333}, {-0.05, \
-1.2499999999999996`}, {-0.05, -1.666666666666666}, {-0.05, \
-2.083333333333333}, {-0.05, -2.5}, {-0.05, -2.5}}}]}, \
$CellContext`staticpolygons14230200811523132845095$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{-0.05, -5.}, {-0.05, -4.791666666666667}, {-0.05, \
-4.583333333333333}, {-0.05, -4.375}, {-0.05, -4.166666666666667}, {-0.05, \
-3.9583333333333335`}, {-0.05, -3.75}, {-0.05, -3.541666666666667}, {-0.05, \
-3.3333333333333335`}, {-0.05, -3.125}, {-0.05, -2.916666666666667}, {-0.05, \
-2.7083333333333335`}, {-0.05, -2.5}, {-0.05, -2.5}, {-0.05, \
-2.7083333333333335`}, {-0.05, -2.9166666666666665`}, {-0.05, -3.125}, \
{-0.05, -3.333333333333333}, {-0.05, -3.5416666666666665`}, {-0.05, -3.75}, \
{-0.05, -3.958333333333333}, {-0.05, -4.166666666666666}, {-0.05, -4.375}, \
{-0.05, -4.583333333333333}, {-0.05, -4.791666666666666}, {-0.05, -5.}, \
{-0.05, -5.}}, {{-0.05, 2.5}, {-0.05, 2.7083333333333335`}, {-0.05, 
      2.9166666666666665`}, {-0.05, 3.125}, {-0.05, 
      3.333333333333333}, {-0.05, 3.5416666666666665`}, {-0.05, 3.75}, {-0.05,
       3.958333333333333}, {-0.05, 4.166666666666666}, {-0.05, 4.375}, {-0.05,
       4.583333333333333}, {-0.05, 4.791666666666666}, {-0.05, 5.}, {-0.05, 
      5.}, {-0.05, 4.791666666666667}, {-0.05, 4.583333333333333}, {-0.05, 
      4.375}, {-0.05, 4.166666666666667}, {-0.05, 
      3.9583333333333335`}, {-0.05, 3.75}, {-0.05, 3.541666666666667}, {-0.05,
       3.3333333333333335`}, {-0.05, 3.125}, {-0.05, 
      2.916666666666667}, {-0.05, 2.7083333333333335`}, {-0.05, 2.5}, {-0.05, 
      2.5}}}]}, $CellContext`staticpolygons15230200811523132847446$$ = {}, \
$CellContext`staticpolygons16230200811523132852836$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{1.3689976525819987`, -5.65}, {
      0.9852549276396352, -4.708333333333334}, {
      0.6511727483615684, -3.766666666666667}, {0.3764030171799524, -2.825}, {
      0.17082082737962523`, -1.8833333333333337`}, {
      0.043271803862861, -0.9416666666666673}, {0., 0.}, {0.04327180386286091,
       0.9416666666666664}, {0.17082082737962506`, 1.8833333333333329`}, {
      0.3764030171799522, 2.8249999999999993`}, {0.6511727483615678, 
      3.7666666666666657`}, {0.9852549276396345, 4.708333333333332}, {
      1.3689976525819987`, 5.65}, {1.3689976525819987`, 5.65}, {
      0.9852549276396352, 4.708333333333334}, {0.6511727483615684, 
      3.766666666666667}, {0.3764030171799524, 2.825}, {0.17082082737962523`, 
      1.8833333333333337`}, {0.043271803862861, 0.9416666666666673}, {0., 
      0.}, {0.04327180386286091, -0.9416666666666664}, {
      0.17082082737962506`, -1.8833333333333329`}, {
      0.3764030171799522, -2.8249999999999993`}, {
      0.6511727483615678, -3.7666666666666657`}, {
      0.9852549276396345, -4.708333333333332}, {1.3689976525819987`, -5.65}, {
      1.3689976525819987`, -5.65}}}]}, \
$CellContext`staticpolygons17230200811523132856751$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{1.3397916666666667`, -5.65}, {
      2.1526331018518516`, -4.708333333333334}, {
      2.817685185185185, -3.766666666666667}, {3.3349479166666667`, -2.825}, {
      3.7044212962962964`, -1.8833333333333337`}, {
      3.926105324074074, -0.9416666666666673}, {4., 0.}, {3.926105324074074, 
      0.9416666666666664}, {3.7044212962962964`, 1.8833333333333329`}, {
      3.334947916666667, 2.8249999999999993`}, {2.817685185185186, 
      3.7666666666666657`}, {2.152633101851853, 4.708333333333332}, {
      1.3397916666666667`, 5.65}, {1.3397916666666667`, 5.65}, {
      2.1526331018518516`, 4.708333333333334}, {2.817685185185185, 
      3.766666666666667}, {3.3349479166666667`, 2.825}, {3.7044212962962964`, 
      1.8833333333333337`}, {3.926105324074074, 0.9416666666666673}, {4., 
      0.}, {3.926105324074074, -0.9416666666666664}, {
      3.7044212962962964`, -1.8833333333333329`}, {
      3.334947916666667, -2.8249999999999993`}, {
      2.817685185185186, -3.7666666666666657`}, {
      2.152633101851853, -4.708333333333332}, {1.3397916666666667`, -5.65}, {
      1.3397916666666667`, -5.65}}}]}, \
$CellContext`staticpolygons18230200811523132905507$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[CompressedData["
1:eJxd1F9I01EUB/DNSZHswXBmxLCttWmEbboZWNnvW5D9oWS68CHWy2pRFiQW
FGtBaCMwIiKoBwkKi3owCdIYQ/gdxV4ifEnQIKgIRqCF0p8nobbfvb+X74X7
MO7vnnPuOR/mT13sTrscDoeztBOlXVHaD/qfFTvmtuBMeRUbZLU7VfujtxGe
sYNfM+Mhqcper9h2eDum/zQm7w4E5XPvk+H0+Sb0tVfNj8S3ytXUMe/tYBj1
ucWufH1ArjVVDs4cjeB9eS355UR8LvRwKYJMOWDBJwuOj87hK80ofZxbXL9Z
JnbH7/SsNONlKZ1nzCuzrnf5vckWrJsf6Ws/skl+7ly+7y20IG3VVye7FoYG
OtxRTFn11Mq+0ZNPpxNRnb9GcueGHiXvRXW+avnQeWH59dsoRq34bulpfTN5
YCWK01a8tXKqMjR4yROD17rvksfZtuKtcAwvrO9XTX+g1VnYH8NG6/yX6U/8
ngh3xlBt/f5mPv9+aMe/rhgc1vqyxz6PqHPDvt+o7ht2/LyKb9j5fSo/7PrO
qvpg1/9K1Y+b+n1Z9T5Av1/dr0Gb7s+M6g/s/ql4dbD761b9xbjuv4rvhT2f
42o+sOen8vmQ0fOdVfPFZT1/lT+AT9pHv/KBNdqPqieIv9rXBuULN7Q/VV8D
yCPII8gjyCPII8gjyCPII8gjyCPII8gjyCPII8gjyCPII8ijQR4N8miQx0ny
aJJHkzya5FHIo5BHIY9CHoU8CnkU8ijkUcijkEchj0IehTwKeRTyKORR+P/x
P4VLPns=
      "]]}, $CellContext`staticpolygons2123020081152326925122$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{-0.654121133468629, -6.25, 
       0.}, {-1.6633250356081046`, -5.208333333333334, 
       0.}, {-2.407409854982819, -4.166666666666667, 
       0.}, {-2.9470796165773505`, -3.1250000000000004`, 
       0.}, {-3.3150010468778817`, -2.083333333333334, 
       0.}, {-3.5294851698846217`, -1.0416666666666679`, 
       0.}, {-3.5999999999999996`, -8.881784197001252*^-16, 
       0.}, {-3.529485169884622, 1.041666666666666, 0.}, {-3.315001046877882, 
       2.083333333333332, 0.}, {-2.947079616577352, 3.1249999999999982`, 
       0.}, {-2.40740985498282, 4.166666666666664, 0.}, {-1.6633250356081057`,
        5.208333333333332, 0.}, {-0.6541211334686317, 6.249999999999998, 
       0.}, {-0.654121133468629, 6.25, 0.}, {-1.6633250356081046`, 
       5.208333333333334, 0.}, {-2.407409854982819, 4.166666666666667, 
       0.}, {-2.9470796165773505`, 3.1250000000000004`, 
       0.}, {-3.3150010468778817`, 2.083333333333334, 
       0.}, {-3.5294851698846217`, 1.0416666666666679`, 
       0.}, {-3.5999999999999996`, 8.881784197001252*^-16, 
       0.}, {-3.529485169884622, -1.041666666666666, 0.}, {-3.315001046877882,
        -2.083333333333332, 0.}, {-2.947079616577352, -3.1249999999999982`, 
       0.}, {-2.40740985498282, -4.166666666666664, 
       0.}, {-1.6633250356081057`, -5.208333333333332, 
       0.}, {-0.6541211334686317, -6.249999999999998, 
       0.}, {-0.654121133468629, -6.25, 0.}}, {{-0.654121133468629, 
       0., -6.25}, {-1.6633250356081046`, 
       0., -5.208333333333334}, {-2.407409854982819, 
       0., -4.166666666666667}, {-2.9470796165773505`, 
       0., -3.1250000000000004`}, {-3.3150010468778817`, 
       0., -2.083333333333334}, {-3.5294851698846217`, 
       0., -1.0416666666666679`}, {-3.5999999999999996`, 
       0., -8.881784197001252*^-16}, {-3.529485169884622, 0., 
       1.041666666666666}, {-3.315001046877882, 0., 
       2.083333333333332}, {-2.947079616577352, 0., 
       3.1249999999999982`}, {-2.40740985498282, 0., 
       4.166666666666664}, {-1.6633250356081057`, 0., 
       5.208333333333332}, {-0.6541211334686317, 0., 
       6.249999999999998}, {-0.654121133468629, 0., 
       6.25}, {-1.6633250356081046`, 0., 
       5.208333333333334}, {-2.407409854982819, 0., 
       4.166666666666667}, {-2.9470796165773505`, 0., 
       3.1250000000000004`}, {-3.3150010468778817`, 0., 
       2.083333333333334}, {-3.5294851698846217`, 0., 
       1.0416666666666679`}, {-3.5999999999999996`, 0., 
       8.881784197001252*^-16}, {-3.529485169884622, 
       0., -1.041666666666666}, {-3.315001046877882, 
       0., -2.083333333333332}, {-2.947079616577352, 
       0., -3.1249999999999982`}, {-2.40740985498282, 
       0., -4.166666666666664}, {-1.6633250356081057`, 
       0., -5.208333333333332}, {-0.6541211334686317, 
       0., -6.249999999999998}, {-0.654121133468629, 
       0., -6.25}}, CompressedData["
1:eJxdlN8rg1Ecxt+IuFGMbEhR+wOURMkON+OCIgw1lpo7IT9uVrtyb0wuyK07
v4pso5ziYtpqLrZaTS1hLQl3kvw+z7PaOfX21tOz532+n/NtDZMzA+4CwzCa
fp/C3yec9MytPN+fG//HIgycKPTgYbjLdmUW7r7a7GvNoy0OvTtxkH6ymkVn
aNF7eftuY86EN90WN1eLoYXWitHGQkE987Fc5NupQn5pTvdX3tQtJUyi7mVk
3jpbJpLQT6ZM0rNbLgJ4018P3xp+R70AuQ/4DvVh9GAvzmVHb85BfRpzcm7m
RGKx/S3/aTs5UR9T/vMQ/OTTofJznKj3qz5S7/P1/XdKZEbrb1HzynXMq/GR
Op9V5ZMN4HQN/U7lyiKNP3pIBzhF8+9X9mj3Cy7SC07a/kjFKdJOHVykA5yY
34P8FnCi7kKfPnCK5u+P/AQn5oOLJCf6Q+BzjDf94CLJiXyKFRdJTtSd6OFE
L+Y40NuOOejfxJwBzE1/MpW6ONqLn5ETew6CIzlRbwZ3cqLei3tyaX3eFBeR
RX/qJuzBBuYN5++PCIIP833Ys0Zw0vZHkBP94CLGwYn54CJGwIk54CK2wUn/
/1H7kzr7ASJqdIk=
       
       "]}]}, $CellContext`staticpolygons2223020081152326930050$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{-0.7033119314590373, -5., 
       0.}, {-1.538876515698588, -4.166666666666667, 
       0.}, {-2.1302230142610687`, -3.3333333333333335`, 0.}, {-2.55, -2.5, 
       0.}, {-2.8326922749902543`, -1.666666666666667, 
       0.}, {-2.9963598686045723`, -0.8333333333333339, 0.}, {-3.05, 0., 
       0.}, {-2.9963598686045723`, 0.833333333333333, 
       0.}, {-2.8326922749902543`, 1.666666666666666, 
       0.}, {-2.5500000000000007`, 2.499999999999999, 
       0.}, {-2.1302230142610696`, 3.333333333333332, 
       0.}, {-1.5388765156985889`, 4.166666666666666, 
       0.}, {-0.7033119314590373, 5., 0.}, {-0.7033119314590373, 5., 
       0.}, {-1.538876515698588, 4.166666666666667, 
       0.}, {-2.1302230142610687`, 3.3333333333333335`, 0.}, {-2.55, 2.5, 
       0.}, {-2.8326922749902543`, 1.666666666666667, 
       0.}, {-2.9963598686045723`, 0.8333333333333339, 0.}, {-3.05, 0., 
       0.}, {-2.9963598686045723`, -0.833333333333333, 
       0.}, {-2.8326922749902543`, -1.666666666666666, 
       0.}, {-2.5500000000000007`, -2.499999999999999, 
       0.}, {-2.1302230142610696`, -3.333333333333332, 
       0.}, {-1.5388765156985889`, -4.166666666666666, 
       0.}, {-0.7033119314590373, -5., 0.}, {-0.7033119314590373, -5., 
       0.}}, {{-0.7033119314590373, 0., -5.}, {-1.538876515698588, 
       0., -4.166666666666667}, {-2.1302230142610687`, 
       0., -3.3333333333333335`}, {-2.55, 0., -2.5}, {-2.8326922749902543`, 
       0., -1.666666666666667}, {-2.9963598686045723`, 
       0., -0.8333333333333339}, {-3.05, 0., 0.}, {-2.9963598686045723`, 0., 
       0.833333333333333}, {-2.8326922749902543`, 0., 
       1.666666666666666}, {-2.5500000000000007`, 0., 
       2.499999999999999}, {-2.1302230142610696`, 0., 
       3.333333333333332}, {-1.5388765156985889`, 0., 
       4.166666666666666}, {-0.7033119314590373, 0., 
       5.}, {-0.7033119314590373, 0., 5.}, {-1.538876515698588, 0., 
       4.166666666666667}, {-2.1302230142610687`, 0., 
       3.3333333333333335`}, {-2.55, 0., 2.5}, {-2.8326922749902543`, 0., 
       1.666666666666667}, {-2.9963598686045723`, 0., 
       0.8333333333333339}, {-3.05, 0., 0.}, {-2.9963598686045723`, 
       0., -0.833333333333333}, {-2.8326922749902543`, 
       0., -1.666666666666666}, {-2.5500000000000007`, 
       0., -2.499999999999999}, {-2.1302230142610696`, 
       0., -3.333333333333332}, {-1.5388765156985889`, 
       0., -4.166666666666666}, {-0.7033119314590373, 
       0., -5.}, {-0.7033119314590373, 0., -5.}}, CompressedData["
1:eJxdk8srhGEUxj8GuZVrykq2iExKpLyl3KJcNi4bpuwYC0VYSFmIZDul+RdM
inGZYV6XJBtEoixcJrehLBQrDO/zfOW89fXVrzPne87vPZPvGmzri7UsqzT6
OKLPdW56wvTkfcj6O9nKwiHv3T5dcJ5lqamUhvau23A1+cDIXNNMa5YqO/go
9S6/27zJM9FbM5apgu1dLd3eL5tHSspPUtsy0D9Oka+9FhW/BdLUXcfY/Gpn
os1DyXnWfn2q0niTh1Hnx+/IY9D3Gd8h30QO5noEr0DufszB+hnMybnJk4Yu
Q740fxU9kY+b+pBL1DtNf9sTud/ksT2Rf33/HoeOiPw3Zl69LuaFHy39rJg6
/SB8Ppm+Ok74Rw69BU/0Ay+6UtwvvGiP2Ad40cbTfhU5vOhReCJ3o38hPJE3
I48Pni7AX5Cfnli/gXnpiXwPfgJ4k8OLpifyeONF0xP5AXI0Ihd5LXLTE/ki
5uzB3HZ9zt3R7uxxkJ7Ih+HRJeoL4N0t++OemkWeT+NFvYr8V9iDTTHvFvZm
R/hZxp49Cp/wouiJHF7UITxd/98fVSfuF17UktgH/q/M/pwHfwCgXQqn
       
       "]}]}, $CellContext`staticpolygons2323020081152326934944$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{-0.05, -2.5, 0.}, {-0.05, -2.0833333333333335`, 
       0.}, {-0.05, -1.6666666666666667`, 0.}, {-0.05, -1.25, 
       0.}, {-0.05, -0.8333333333333335, 0.}, {-0.05, -0.41666666666666696`, 
       0.}, {-0.05, 0., 0.}, {-0.05, 0.4166666666666665, 0.}, {-0.05, 
       0.833333333333333, 0.}, {-0.05, 1.2499999999999996`, 0.}, {-0.05, 
       1.666666666666666, 0.}, {-0.05, 2.083333333333333, 0.}, {-0.05, 2.5, 
       0.}, {-0.05, 2.5, 0.}, {-0.05, 2.0833333333333335`, 0.}, {-0.05, 
       1.6666666666666667`, 0.}, {-0.05, 1.25, 0.}, {-0.05, 
       0.8333333333333335, 0.}, {-0.05, 0.41666666666666696`, 0.}, {-0.05, 0.,
        0.}, {-0.05, -0.4166666666666665, 0.}, {-0.05, -0.833333333333333, 
       0.}, {-0.05, -1.2499999999999996`, 0.}, {-0.05, -1.666666666666666, 
       0.}, {-0.05, -2.083333333333333, 0.}, {-0.05, -2.5, 0.}, {-0.05, -2.5, 
       0.}}, {{-0.05, 0., -2.5}, {-0.05, 0., -2.0833333333333335`}, {-0.05, 
       0., -1.6666666666666667`}, {-0.05, 0., -1.25}, {-0.05, 
       0., -0.8333333333333335}, {-0.05, 0., -0.41666666666666696`}, {-0.05, 
       0., 0.}, {-0.05, 0., 0.4166666666666665}, {-0.05, 0., 
       0.833333333333333}, {-0.05, 0., 1.2499999999999996`}, {-0.05, 0., 
       1.666666666666666}, {-0.05, 0., 2.083333333333333}, {-0.05, 0., 
       2.5}, {-0.05, 0., 2.5}, {-0.05, 0., 2.0833333333333335`}, {-0.05, 0., 
       1.6666666666666667`}, {-0.05, 0., 1.25}, {-0.05, 0., 
       0.8333333333333335}, {-0.05, 0., 0.41666666666666696`}, {-0.05, 0., 
       0.}, {-0.05, 0., -0.4166666666666665}, {-0.05, 
       0., -0.833333333333333}, {-0.05, 0., -1.2499999999999996`}, {-0.05, 
       0., -1.666666666666666}, {-0.05, 0., -2.083333333333333}, {-0.05, 
       0., -2.5}, {-0.05, 0., -2.5}}, CompressedData["
1:eJxdkzlIA1EURSdGCxewsxVbFSUiiCJkQHAjAZfGpdGAnUshKMbCxkoR26jY
CjYGIcYlifNdELERMY1g4wKuEUHBFGKM/nt/8T4MA4eXl/vOf1MWGOsayrEs
y5N93NlneenvrDvW/8m1LRzywYPLlZqk254tbOvuu016yUcmF3xznW679vTL
sxq5N9wXmhlsCubY8e6+jv7VN8Nfqusuirpc6P9p+E6qsuo9lvHe9QQXt3vT
hjsFpdZJ67dX4U1+j7oofkfuQt9n/A95AjmYi7weuYcxB/kc5uTc5PnjV064
eK2Rnsindb0TEPU1ur/xRB7VeRyZ5yfzdz6MJ/IbPa+zK+aFH0f62dJ1zoPw
+aT7qlzhHznUvrgveFEN4n7hRYXEPsCL0p6ijeTwoqbgiXwU/SvgidyPPGF4
In9Ffnoi38O89ER+DD8xvMnhxXgiz9NejCfyU+RoRy7yZuSmJ/INzDmAuU19
yd350byK0xP5BDwGRH05vI/K/rgnv8iT1l68KZH/GnuQEPPuY28OhZ8I9uxR
+IQXm57I4cU+E/fF76pF3C+82JtiH/hd6f05if8CUaliEQ==
       
       "]}]}, $CellContext`staticpolygons2423020081152326944061$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{-0.05, -5., 0.}, {-0.05, -4.791666666666667, 
       0.}, {-0.05, -4.583333333333333, 0.}, {-0.05, -4.375, 
       0.}, {-0.05, -4.166666666666667, 0.}, {-0.05, -3.9583333333333335`, 
       0.}, {-0.05, -3.75, 0.}, {-0.05, -3.541666666666667, 
       0.}, {-0.05, -3.3333333333333335`, 0.}, {-0.05, -3.125, 
       0.}, {-0.05, -2.916666666666667, 0.}, {-0.05, -2.7083333333333335`, 
       0.}, {-0.05, -2.5, 0.}, {-0.05, -2.5, 
       0.}, {-0.05, -2.7083333333333335`, 0.}, {-0.05, -2.9166666666666665`, 
       0.}, {-0.05, -3.125, 0.}, {-0.05, -3.333333333333333, 
       0.}, {-0.05, -3.5416666666666665`, 0.}, {-0.05, -3.75, 
       0.}, {-0.05, -3.958333333333333, 0.}, {-0.05, -4.166666666666666, 
       0.}, {-0.05, -4.375, 0.}, {-0.05, -4.583333333333333, 
       0.}, {-0.05, -4.791666666666666, 0.}, {-0.05, -5., 0.}, {-0.05, -5., 
       0.}}, {{-0.05, 2.5, 0.}, {-0.05, 2.7083333333333335`, 0.}, {-0.05, 
       2.9166666666666665`, 0.}, {-0.05, 3.125, 0.}, {-0.05, 
       3.333333333333333, 0.}, {-0.05, 3.5416666666666665`, 0.}, {-0.05, 3.75,
        0.}, {-0.05, 3.958333333333333, 0.}, {-0.05, 4.166666666666666, 
       0.}, {-0.05, 4.375, 0.}, {-0.05, 4.583333333333333, 0.}, {-0.05, 
       4.791666666666666, 0.}, {-0.05, 5., 0.}, {-0.05, 5., 0.}, {-0.05, 
       4.791666666666667, 0.}, {-0.05, 4.583333333333333, 0.}, {-0.05, 4.375, 
       0.}, {-0.05, 4.166666666666667, 0.}, {-0.05, 3.9583333333333335`, 
       0.}, {-0.05, 3.75, 0.}, {-0.05, 3.541666666666667, 0.}, {-0.05, 
       3.3333333333333335`, 0.}, {-0.05, 3.125, 0.}, {-0.05, 
       2.916666666666667, 0.}, {-0.05, 2.7083333333333335`, 0.}, {-0.05, 2.5, 
       0.}, {-0.05, 2.5, 0.}}, {{-0.05, 0., -5.}, {-0.05, 
       0., -4.791666666666667}, {-0.05, 0., -4.583333333333333}, {-0.05, 
       0., -4.375}, {-0.05, 0., -4.166666666666667}, {-0.05, 
       0., -3.9583333333333335`}, {-0.05, 0., -3.75}, {-0.05, 
       0., -3.541666666666667}, {-0.05, 0., -3.3333333333333335`}, {-0.05, 
       0., -3.125}, {-0.05, 0., -2.916666666666667}, {-0.05, 
       0., -2.7083333333333335`}, {-0.05, 0., -2.5}, {-0.05, 
       0., -2.5}, {-0.05, 0., -2.7083333333333335`}, {-0.05, 
       0., -2.9166666666666665`}, {-0.05, 0., -3.125}, {-0.05, 
       0., -3.333333333333333}, {-0.05, 0., -3.5416666666666665`}, {-0.05, 
       0., -3.75}, {-0.05, 0., -3.958333333333333}, {-0.05, 
       0., -4.166666666666666}, {-0.05, 0., -4.375}, {-0.05, 
       0., -4.583333333333333}, {-0.05, 0., -4.791666666666666}, {-0.05, 
       0., -5.}, {-0.05, 0., -5.}}, {{-0.05, 0., 2.5}, {-0.05, 0., 
       2.7083333333333335`}, {-0.05, 0., 2.9166666666666665`}, {-0.05, 0., 
       3.125}, {-0.05, 0., 3.333333333333333}, {-0.05, 0., 
       3.5416666666666665`}, {-0.05, 0., 3.75}, {-0.05, 0., 
       3.958333333333333}, {-0.05, 0., 4.166666666666666}, {-0.05, 0., 
       4.375}, {-0.05, 0., 4.583333333333333}, {-0.05, 0., 
       4.791666666666666}, {-0.05, 0., 5.}, {-0.05, 0., 5.}, {-0.05, 0., 
       4.791666666666667}, {-0.05, 0., 4.583333333333333}, {-0.05, 0., 
       4.375}, {-0.05, 0., 4.166666666666667}, {-0.05, 0., 
       3.9583333333333335`}, {-0.05, 0., 3.75}, {-0.05, 0., 
       3.541666666666667}, {-0.05, 0., 3.3333333333333335`}, {-0.05, 0., 
       3.125}, {-0.05, 0., 2.916666666666667}, {-0.05, 0., 
       2.7083333333333335`}, {-0.05, 0., 2.5}, {-0.05, 0., 
       2.5}}, CompressedData["
1:eJxdkzlIA1EURSdGCxewsxVbFSUiiCJkQHAjAZfGpdGAnUshKMbCxkoR26jY
CjYGIcYlifNdELERMY1g4wKuEUHBFGKM/nt/8T4MA4eXl/vOf1MWGOsayrEs
y5N93NlneenvrDvW/8m1LRzywYPLlZqk254tbOvuu016yUcmF3xznW679vTL
sxq5N9wXmhlsCubY8e6+jv7VN8Nfqusuirpc6P9p+E6qsuo9lvHe9QQXt3vT
hjsFpdZJ67dX4U1+j7oofkfuQt9n/A95AjmYi7weuYcxB/kc5uTc5PnjV064
eK2Rnsindb0TEPU1ur/xRB7VeRyZ5yfzdz6MJ/IbPa+zK+aFH0f62dJ1zoPw
+aT7qlzhHznUvrgveFEN4n7hRYXEPsCL0p6ijeTwoqbgiXwU/SvgidyPPGF4
In9Ffnoi38O89ER+DD8xvMnhxXgiz9NejCfyU+RoRy7yZuSmJ/INzDmAuU19
yd350byK0xP5BDwGRH05vI/K/rgnv8iT1l68KZH/GnuQEPPuY28OhZ8I9uxR
+IQXm57I4cU+E/fF76pF3C+82JtiH/hd6f05if8CUaliEQ==
       "], CompressedData["
1:eJxdk8srRGEYxg9GuUzJJVvZIhopkfKVcmummNkwNmbKzmWhCAsbK5KtS/MH
2JAa4zLD+VyaJhtEStm4lHtZKFau3/OcxfvV6dSvd9553t/3ntLwkL8v3bIs
z++T8fssLvydZdv6P0XKwiEP7Z0tVZ8XqqnctkDw5q6RfGB01jvdWahqUh+e
SPTd4d75yVDTeIFKBIIdPZEvhz9X1Z66/fno71Lkm68VlW/xPHXbNT630Z3l
cDunxEq2upXGm/wOdTH8jjwNfZ/wP+Q7yMFc5HXI3Y85yKcxJ+cmzx6+tFfz
Yg30RD5h6u2wqK82/R1P5DGTx5Z5vr7/ToZ+Fvmvzbx6S8wLP1r6WTd1+l74
fDR9tUv4Rw69K+4LXnS9uF940fNiH+BFG0/JBnJ40WPwRD6I/uXwRO5DnlV4
In9Bfnoi38a89ER+CD9xvMnhRdMTeabxoumJPIUc7chF3ozc9ES+gjl7MbdT
X3x7fDBzkqAn8hF4DIv6MngflP1xTz6R59N4Ua8i/xX2YEfMu4u92Rd+otiz
B+ETXhQ9kcOLOhL3xe+qRdwvvKg1sQ/8rsz+XCR+AHt0SEE=
       
       "]}]}, $CellContext`staticpolygons2523020081152326945592$$ = {}, \
$CellContext`staticpolygons2623020081152326970402$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{1.3689976525819987`, -5.65, 0.}, {
       0.9852549276396352, -4.708333333333334, 0.}, {
       0.6511727483615684, -3.766666666666667, 0.}, {
       0.3764030171799524, -2.825, 0.}, {
       0.17082082737962523`, -1.8833333333333337`, 0.}, {
       0.043271803862861, -0.9416666666666673, 0.}, {0., 0., 0.}, {
       0.04327180386286091, 0.9416666666666664, 0.}, {0.17082082737962506`, 
       1.8833333333333329`, 0.}, {0.3764030171799522, 2.8249999999999993`, 
       0.}, {0.6511727483615678, 3.7666666666666657`, 0.}, {
       0.9852549276396345, 4.708333333333332, 0.}, {1.3689976525819987`, 5.65,
        0.}, {1.3689976525819987`, 5.65, 0.}, {0.9852549276396352, 
       4.708333333333334, 0.}, {0.6511727483615684, 3.766666666666667, 0.}, {
       0.3764030171799524, 2.825, 0.}, {0.17082082737962523`, 
       1.8833333333333337`, 0.}, {0.043271803862861, 0.9416666666666673, 
       0.}, {0., 0., 0.}, {0.04327180386286091, -0.9416666666666664, 0.}, {
       0.17082082737962506`, -1.8833333333333329`, 0.}, {
       0.3764030171799522, -2.8249999999999993`, 0.}, {
       0.6511727483615678, -3.7666666666666657`, 0.}, {
       0.9852549276396345, -4.708333333333332, 0.}, {
       1.3689976525819987`, -5.65, 0.}, {1.3689976525819987`, -5.65, 0.}}, {{
       1.3689976525819987`, 0., -5.65}, {0.9852549276396352, 
       0., -4.708333333333334}, {0.6511727483615684, 
       0., -3.766666666666667}, {0.3764030171799524, 0., -2.825}, {
       0.17082082737962523`, 0., -1.8833333333333337`}, {0.043271803862861, 
       0., -0.9416666666666673}, {0., 0., 0.}, {0.04327180386286091, 0., 
       0.9416666666666664}, {0.17082082737962506`, 0., 1.8833333333333329`}, {
       0.3764030171799522, 0., 2.8249999999999993`}, {0.6511727483615678, 0., 
       3.7666666666666657`}, {0.9852549276396345, 0., 4.708333333333332}, {
       1.3689976525819987`, 0., 5.65}, {1.3689976525819987`, 0., 5.65}, {
       0.9852549276396352, 0., 4.708333333333334}, {0.6511727483615684, 0., 
       3.766666666666667}, {0.3764030171799524, 0., 2.825}, {
       0.17082082737962523`, 0., 1.8833333333333337`}, {0.043271803862861, 0.,
        0.9416666666666673}, {0., 0., 0.}, {0.04327180386286091, 
       0., -0.9416666666666664}, {0.17082082737962506`, 
       0., -1.8833333333333329`}, {0.3764030171799522, 
       0., -2.8249999999999993`}, {0.6511727483615678, 
       0., -3.7666666666666657`}, {0.9852549276396345, 
       0., -4.708333333333332}, {1.3689976525819987`, 0., -5.65}, {
       1.3689976525819987`, 0., -5.65}}, CompressedData["
1:eJxdlD1IQmEYhW8FLg1hf1AR9DM0NRQtmeUH4mRWFFIRYQVCSNAUka1NjTaY
BtLPkmNNDpKfBtEWRENB9A9BUJRirRXfOYLvhcuFw7nvPef5Xm77wvJ4sNKy
rJ6/u+rv9rk6GkKvRVc89n81KgsX9fXT09XmxUbVnYzm52KvLurZrZOHlasG
5Vlb2jsK/pT0OZ9/s/exXu11pTwtwxVqBHoh92KFI3XKfMem6B+YqlyyfdjV
ROAi2bRRXdLv3s4+a79r1D2e1P3w8T3qO5ibx3eo7yMHc1H3IrdGD+p96Mne
1HuKmezTe8pJTtQ7jT8j/W4zP5MV8xMmj54XebZNfl0Q+cdMX+0UfcFHSz4O
49OTgueXmasTgj+46ANwog4uelicL3pqt9gHcNGG07lT+tvAifuQw3wnONG/
gDxxcPKV74+OghPnDKIvOdH/DD43eFIHF01O1Hcxl5yoHyJHALmoTyN3Bj2o
z6JnGL2pv/yM2kPHl2lyot5avm+lXg5wz4n54KLIif4IzrUo8nuxB0Oi7y32
5kHw6ceeTQue4KLIiTq4qKQ4L3BRM+J8wUUFwEn+f8z+XKd/AdLmInA=
       
       "]}]}, $CellContext`staticpolygons2723020081152326975689$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{1.3397916666666667`, -5.65, 0.}, {
       2.1526331018518516`, -4.708333333333334, 0.}, {
       2.817685185185185, -3.766666666666667, 0.}, {
       3.3349479166666667`, -2.825, 0.}, {
       3.7044212962962964`, -1.8833333333333337`, 0.}, {
       3.926105324074074, -0.9416666666666673, 0.}, {4., 0., 0.}, {
       3.926105324074074, 0.9416666666666664, 0.}, {3.7044212962962964`, 
       1.8833333333333329`, 0.}, {3.334947916666667, 2.8249999999999993`, 
       0.}, {2.817685185185186, 3.7666666666666657`, 0.}, {2.152633101851853, 
       4.708333333333332, 0.}, {1.3397916666666667`, 5.65, 0.}, {
       1.3397916666666667`, 5.65, 0.}, {2.1526331018518516`, 
       4.708333333333334, 0.}, {2.817685185185185, 3.766666666666667, 0.}, {
       3.3349479166666667`, 2.825, 0.}, {3.7044212962962964`, 
       1.8833333333333337`, 0.}, {3.926105324074074, 0.9416666666666673, 
       0.}, {4., 0., 0.}, {3.926105324074074, -0.9416666666666664, 0.}, {
       3.7044212962962964`, -1.8833333333333329`, 0.}, {
       3.334947916666667, -2.8249999999999993`, 0.}, {
       2.817685185185186, -3.7666666666666657`, 0.}, {
       2.152633101851853, -4.708333333333332, 0.}, {
       1.3397916666666667`, -5.65, 0.}, {1.3397916666666667`, -5.65, 0.}}, {{
       1.3397916666666667`, 0., -5.65}, {2.1526331018518516`, 
       0., -4.708333333333334}, {2.817685185185185, 0., -3.766666666666667}, {
       3.3349479166666667`, 0., -2.825}, {3.7044212962962964`, 
       0., -1.8833333333333337`}, {3.926105324074074, 
       0., -0.9416666666666673}, {4., 0., 0.}, {3.926105324074074, 0., 
       0.9416666666666664}, {3.7044212962962964`, 0., 1.8833333333333329`}, {
       3.334947916666667, 0., 2.8249999999999993`}, {2.817685185185186, 0., 
       3.7666666666666657`}, {2.152633101851853, 0., 4.708333333333332}, {
       1.3397916666666667`, 0., 5.65}, {1.3397916666666667`, 0., 5.65}, {
       2.1526331018518516`, 0., 4.708333333333334}, {2.817685185185185, 0., 
       3.766666666666667}, {3.3349479166666667`, 0., 2.825}, {
       3.7044212962962964`, 0., 1.8833333333333337`}, {3.926105324074074, 0., 
       0.9416666666666673}, {4., 0., 0.}, {3.926105324074074, 
       0., -0.9416666666666664}, {3.7044212962962964`, 
       0., -1.8833333333333329`}, {3.334947916666667, 
       0., -2.8249999999999993`}, {2.817685185185186, 
       0., -3.7666666666666657`}, {2.152633101851853, 
       0., -4.708333333333332}, {1.3397916666666667`, 0., -5.65}, {
       1.3397916666666667`, 0., -5.65}}, CompressedData["
1:eJxdlE8og2Ecx1+Ui4P8WyFFDi6zkIt52VNy2kS0kDRWK2m1k4SrkyOFTcmf
ix05Ocj7bCtxUnKg5O9KKWJrdnEwPd+vep+33t769t33+f4+z681BSPDoWLD
MNoLb0nhbVv/CV5Ecp5Y9O9xCAOPC/pSKjVfN+MQrfGNzFT01UM9sXb6OHdd
I/oXwruHobyHOVMD/pWOp2qx23LcX+8rEk7o2WTaWFytEuqcUkF/91hxuPSj
QowELuO1y2WC+fdvZ5+V3+XiAV/qfvj4O+ZsITeDc6jvoQd7Ufeit8QczO/E
nJyb/vaclXh+PzbJiXqz8lv0M6dP5VsJLX9b9ZHT6EN9U/WXWa3/kJpXmphX
4yN1Pm7lk6PgxJwvlSu3wcllvy+5D070g4v0gZO2D7IPnLT9kYrTudmm+RvB
ifuQRL4JTtSD6BMDJ5d9f+QGONHfg3nJiee+gM8tvswBF0lOzNlBLjkx5wA9
AuhFfRy9LcxBfRJzLmJu6un8YMXs0dUJOVFvsO/bfx83uJMTdXAR5ER9Ffea
0/p7sQe9mJf6HfbmUePThT0bByenfX8EOdEPLiKu3Re4iAlw4rngIgLgpP//
qP25OfkF985g7Q==
       
       "]}]}, $CellContext`staticpolygons2823020081152327012047$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{CompressedData["
1:eJx11V1Ik1Ecx/HppEh2YThfiAfbWpsLsU03AyvrX5C9UDJdeBHrZrUwCxIL
irUgtBEYERHUhQSFRV2YBGmMIaRiNxHeJGgQVAQj0ELp5Uqo7Tnn+QU/6YFd
7MPDec45z/lu7vi5jkSxzWaL5j/2/Odu7+Nc6+wmOVW4crUTNn2tdMQrvnX7
xTmy/3Ny1AcvTV0p3nKwTqZ++WO3+rzwj90PBxNn6qWnpXRuKLIZfil+xLjh
DUhNeqE9U+OBX64v6Z8+HJS3hWvRDT8WmfXdWwxKsvDgrAs+b3tfNHixQfKD
pBfWb4SP7Yjc7FxukGf5aTpHDPiM/U1mV6xR1s0N9bQc2gD/vm3pjpFtlIS5
3ir49vmBvlZHSCbNdVXA9wwffzQVDen5l8PTpwfux26H9DzL4O/azi69eB2S
YXM+Dnhn08vxfcshOWk+dy38RImv/7wzLIY5vh3+INWcux4Iy1NznJVXlrs9
TUXZvWGpNu//8c+jP8cCbWEpM/0L/MnXA1v/tIdFffu0k+8Pqvt38/h+NT7c
mk9GzQduzd+l5i+83i61Xri1P8/V/sCv6f1Mqf2Ei95/NX45vFm/r2n1vuDW
+1XPrYJb58GhzgN8VJ8fNR8Dbp23o+q8wa3zqebpgif1eZ5R5xl+QZ9/NX8P
/IPupVf1Al+j+1Lr8sJ/6x4rVY/wq7pftd5aOHUNp67h1DWcuoZT13DqetW+
JWnfqGs4dQ2nruHUNZy6hlPXcOoaTl3DqWs4dQ2nrld1V03dUddw6nqc7w/S
7wB1Daeu4dT1BK+3i37HqGs4dQ2nruHUNZy6hlPXcOoaTl3DqWs4dQ2nruHU
NZy6hlPXcOoa/r//67+NQD56
       "], CompressedData["
1:eJx11V9IU1EcB/CrkyLZg+HUiIttrc1F2OyPgZXdX0H2h5LpwodYL6tFWZBY
UKwFoY3AiIigHiQoLOrBJEhjDOH+FHuJ8EVBg6AiGIEWSn+ehNru73APnMPv
wH35cjn3d875fc4NJC91psoNw4gXH0/xedj7vNA2uxEMMc6WRqEBVzqTNT+6
I27uGzn0NT0axsrMjfLNR7a4+eSfSOJeXwg/dz8dTF1odPOe1sq5odgmvJY8
bt4JRd28PrvQkasP4vXGiv6pY01u/qE0FgN4MjYbfrQo83Tpw3k/zhsfywav
bnPz4iTZhbUbcGxP7G7XssxfFcv0jZg47Xmf25fY7uZr5oZ6Wo+ux5+7lh6Y
eZmnnPXW4e75gb427w43n3DWVYP7h089m4zLnOqvxuz5gceJ+zKnOqtwpv3i
0pt3Mh926vFiV/Pb8YPLMj/jfHc1nq4I91/27XRz05nfg08yLYXbUZm/dOZZ
sQPB5rL8AZmvc97/ZQfiv8ei7TKvcvJv9ovvh7f+65A5jS971feb6H1LnT9C
81tqPTmqx1Lr91P9oK73HK0X1P15TfsDt5T9zNB+Aij7T/NXQ4tyXlN0XqCe
L323DtR+8FI/wKjSP1SPCWq/naB+A7U/qU4/pJV+nqZ+hitK/1P9QfikeOkl
L7BK8UXrCsFfxWMteYSbil9abwMwroFxDYxrYFwD4xoY19q+CdfaPgvXwLjW
zlG41s5duAbGNTCugXGt9a1wrfW5cA2Ma2Bca+6Ea4txbTGuxxnX2r0hXNuM
a5txrd1jwrV27wnXyLhGxjUyrrV7W7jW7nnhGhnX2n9EuNb+O8I1Mq6RcY2M
a2RcI+MaGdfI/a//AwmRPno=
       "], CompressedData["
1:eJx1l31M1WUUx2+QNLKYU1z2olxQuUKgWy2TlHgSzYTp7IJtTWxC6Gyr0bI0
/4D15lZqUH/kW3YdNsjZlqFYDkTOStbMSkUJYgkoC5Mxt1aTuWRGPd/vab+z
wcbYvjuce55zzuecc1PLKqJr40KhUO3ob/zo745X6gaevJDm1v37MxBxIfzE
oKft/+XCF5cirjOrv6s2oSeP9i/k99x873zEPXNj3LeNoWuqFw0d2zDSHHG5
SSVl4c3XVf/r5KQtEz+OuIsVn1bccXVE9YT0ojk/vxxxc++Phj6oj3PUM2te
nfZsbsT9+nrPnrynExzjuX5tc92h0GicT+26lfJnouqXOp7/6o+mdHd0uCP8
zda7XQ301hMtXY+9mO5KMuKrVm+boPpgRKYdTE53b9VXJrcXTFR90Xd33VvW
ONN90tHwcFJ8suqlXyaeerdwpjvTMXVy+ZHJqn92pu/DJd0z3G3nqyZkrLpH
9Wh9xqzTa2a42tzZvUdvTNE4o035b+T3TneD0YyeddX36XvDDeub+1dOd2W/
HVi+d8oDqldVV066fDLNzRqY81HTzqnqvybp87ZNWWlu2enhjZnjU9R+aXXb
333bU934gnMHs3LCqm986f3GkoGw/qVOO/4f/dMvP4f2jINxUWfcfAf1IbyT
76Z/5oV5oj3zWI+8Mm9nkfc1qAN11ikfdaP/t1FX1pn6avQB+4J+vkbfsI8Y
Txz6jH1H/SL6kn1KfR76mH1NvQ99Tw6oO3BCbqiXgCtyxjj7wSG5pP2iuUcW
3iz5fgE5pv0pb99q7Vd4/630Tz3Hx9Nq4+n28bfa+B/x7xW+l3nu9vmRB5Ef
xnNryX/5FJvPwz7/ctnkf5Wvl7Be9A9uxdZ3t+8HWYx+oJ+ffP8IOaZ9nO83
Yb9R3+f7U4rQn9Sv+H6WYvSz6X+x/Z/heRHyYvgS8sX8JHoepQA8Gn6F/NIe
3Mqdhvdq71eWk2PolT4OyTLzBHFLOTimXuTfKZxXZr7JfnDMz63zeZTbwTHj
BLdy1sxPzFvZa+Yt6irvgGP6P+H7QErBMXVwK8fAsdkXMuL7zu4X6QXHZh9J
ntlH6HvpB8f0D05kntl34ErKwbHZpxLODu5TcCue4+4F1n4IHFv/S8GxjScT
HMdM/J3g2L43BxxTB7fSBY7pZxj5HAbHtAe30gCOY6Zez4HjHaa+b4Jj6uBW
doFj6uBWfgTH1MGtYG+I9i36kxxTB7dCjqmnov9LwbHZv0KO+S5wK4XkGHoh
eCTH9LMJ/L6Gv/QDboUc6x0Fv9vxOfQPboUcUy8Pzh/1D24F+1ftY8H5pp87
Dnkkx9TPIe/kmH6wf4Uc034r6vo76qx1RB+wL6g3oW/I8Rj7Qu07gvtF9SeC
+0j1K8H9pfr84L7Td+0O7ke1z84O7FPVD69PeKilrf84OWb8PcF9rfYbgvtd
7SPBe0D19uD9oH4eDd4bqv+AuZaF/Og8xBwcNvk8hLlJjse4l9R+C+byVVPf
nZjji00/gFvleIx77//8Y6+sNP05gD1UbPoZ3CrHY9yrar8Ce7Ha8AVulWP6
AbfK8Rj3tvoBt67YzAdw62aDY/pJwd2w1swf3s1DZl7xLomZ+QZuXQI4ph/e
ze3gmP2QH/y+o/bg1m0Dx7RvwR1WZuY57+ZmM//N9zW7X1wnOGb8vCMXmn3E
u3PQ7C/eqY+DY/rhXbsPHNOed/D87OA+5d3s9+/g8X8Atd86pA==
       
       "]}]}, $CellContext`th$$ = 
    0., $CellContext`x$$ = -4.933553197300771, $CellContext`xoffth$$ = 
    0.5980074999999999, $CellContext`xth$$ = -4.3355456973007716`, \
$CellContext`y$$ = 1.0700160179314686`, $CellContext`yoffth$$ = 
    0., $CellContext`yth$$ = 1.0700160179314686`, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$, Typeset`name$$ = "\"untitled\"", 
    Typeset`specs$$ = {{{
       Hold[$CellContext`th$$], 0.}, -180., 180.}, {{
       Hold[$CellContext`x$$], -5.}, -10, -0.05}, {{
       Hold[$CellContext`y$$], 0.}, -10, 10}, {{
       Hold[$CellContext`focus$$], 0}, -10, 10}, {
      Hold[
       Style[
        Grid[{{"focus", 
           InputField[
            Dynamic[$CellContext`minfocus$$], Number, FieldSize -> 5], 
           Manipulator[
            
            Dynamic[$CellContext`nonexistantvariable1593230200811523213626529; \
$CellContext`focus$$, ($CellContext`focus$$ = #)& ], {
             Dynamic[$CellContext`minfocus$$], 
             Dynamic[$CellContext`maxfocus$$]}, ImageSize -> 800], 
           InputField[
            Dynamic[$CellContext`maxfocus$$], Number, FieldSize -> 5], 
           
           Dynamic[$CellContext`nonexistantvariable1593230200811523213626529; \
$CellContext`focus$$, ($CellContext`focus$$ = #)& ]}}]]], 
      Manipulate`Dump`ThisIsNotAControl}, {{
       Hold[$CellContext`minfocus$$], -10}}, {{
       Hold[$CellContext`maxfocus$$], 10}}, {{
       Hold[$CellContext`minth$$], -180.}}, {{
       Hold[$CellContext`maxth$$], 180.}}, {{
       Hold[$CellContext`minx$$], -10}}, {{
       Hold[$CellContext`maxx$$], -0.05}}, {{
       Hold[$CellContext`miny$$], -10}}, {{
       Hold[$CellContext`maxy$$], 10}}, {
      Hold[
       Button["Report", 
        Print[
         InputForm[
          StringJoin["SymbolicValues -> ", 
           ToString[
            MapThread[StringJoin[#, "->", 
              ToString[#2, InputForm]]& , {{
              "focus", "th", "x", 
               "y"}, {$CellContext`focus$$, $CellContext`th$$, \
$CellContext`x$$, $CellContext`y$$}}]]]]], ImageSize -> Automatic]], 
      Manipulate`Dump`ThisIsNotAControl}, {{
       Hold[$CellContext`xth$$], -4.4019925}}, {{
       Hold[$CellContext`yth$$], 0.}}, {{
       Hold[$CellContext`radiusth$$], 0.5980074999999999}}, {{
       Hold[$CellContext`xoffth$$], 0.5980074999999999}}, {{
       Hold[$CellContext`yoffth$$], 0.}}, {{
       Hold[$CellContext`laststartposth$$], {-5., 0.}}}, {{
       Hold[$CellContext`lastlocposth$$], {-4.4019925, 0.}}}, {{
       Hold[$CellContext`lastth$$], 0}}, {{
       Hold[$CellContext`staticpolygons11230200811523132827920$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{-0.654121133468629, -6.25}, {-1.6633250356081046`, \
-5.208333333333334}, {-2.407409854982819, -4.166666666666667}, \
{-2.9470796165773505`, -3.1250000000000004`}, {-3.3150010468778817`, \
-2.083333333333334}, {-3.5294851698846217`, -1.0416666666666679`}, \
{-3.5999999999999996`, -8.881784197001252*^-16}, {-3.529485169884622, 
         1.041666666666666}, {-3.315001046877882, 
         2.083333333333332}, {-2.947079616577352, 
         3.1249999999999982`}, {-2.40740985498282, 
         4.166666666666664}, {-1.6633250356081057`, 
         5.208333333333332}, {-0.6541211334686317, 
         6.249999999999998}, {-0.654121133468629, 
         6.25}, {-1.6633250356081046`, 
         5.208333333333334}, {-2.407409854982819, 
         4.166666666666667}, {-2.9470796165773505`, 
         3.1250000000000004`}, {-3.3150010468778817`, 
         2.083333333333334}, {-3.5294851698846217`, 
         1.0416666666666679`}, {-3.5999999999999996`, 
         8.881784197001252*^-16}, {-3.529485169884622, -1.041666666666666}, \
{-3.315001046877882, -2.083333333333332}, {-2.947079616577352, \
-3.1249999999999982`}, {-2.40740985498282, -4.166666666666664}, \
{-1.6633250356081057`, -5.208333333333332}, {-0.6541211334686317, \
-6.249999999999998}, {-0.654121133468629, -6.25}}}]}}}, {{
       Hold[$CellContext`staticpolygons12230200811523132833440$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{-0.7033119314590373, -5.}, {-1.538876515698588, \
-4.166666666666667}, {-2.1302230142610687`, -3.3333333333333335`}, {-2.55, \
-2.5}, {-2.8326922749902543`, -1.666666666666667}, {-2.9963598686045723`, \
-0.8333333333333339}, {-3.05, 0.}, {-2.9963598686045723`, 
         0.833333333333333}, {-2.8326922749902543`, 
         1.666666666666666}, {-2.5500000000000007`, 
         2.499999999999999}, {-2.1302230142610696`, 
         3.333333333333332}, {-1.5388765156985889`, 
         4.166666666666666}, {-0.7033119314590373, 5.}, {-0.7033119314590373, 
         5.}, {-1.538876515698588, 4.166666666666667}, {-2.1302230142610687`, 
         3.3333333333333335`}, {-2.55, 2.5}, {-2.8326922749902543`, 
         1.666666666666667}, {-2.9963598686045723`, 
         0.8333333333333339}, {-3.05, 
         0.}, {-2.9963598686045723`, -0.833333333333333}, \
{-2.8326922749902543`, -1.666666666666666}, {-2.5500000000000007`, \
-2.499999999999999}, {-2.1302230142610696`, -3.333333333333332}, \
{-1.5388765156985889`, -4.166666666666666}, {-0.7033119314590373, -5.}, \
{-0.7033119314590373, -5.}}}]}}}, {{
       Hold[$CellContext`staticpolygons13230200811523132837510$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{-0.05, -2.5}, {-0.05, -2.0833333333333335`}, {-0.05, \
-1.6666666666666667`}, {-0.05, -1.25}, {-0.05, -0.8333333333333335}, {-0.05, \
-0.41666666666666696`}, {-0.05, 0.}, {-0.05, 0.4166666666666665}, {-0.05, 
         0.833333333333333}, {-0.05, 1.2499999999999996`}, {-0.05, 
         1.666666666666666}, {-0.05, 2.083333333333333}, {-0.05, 2.5}, {-0.05,
          2.5}, {-0.05, 2.0833333333333335`}, {-0.05, 
         1.6666666666666667`}, {-0.05, 1.25}, {-0.05, 
         0.8333333333333335}, {-0.05, 0.41666666666666696`}, {-0.05, 
         0.}, {-0.05, -0.4166666666666665}, {-0.05, -0.833333333333333}, \
{-0.05, -1.2499999999999996`}, {-0.05, -1.666666666666666}, {-0.05, \
-2.083333333333333}, {-0.05, -2.5}, {-0.05, -2.5}}}]}}}, {{
       Hold[$CellContext`staticpolygons14230200811523132845095$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{-0.05, -5.}, {-0.05, -4.791666666666667}, {-0.05, \
-4.583333333333333}, {-0.05, -4.375}, {-0.05, -4.166666666666667}, {-0.05, \
-3.9583333333333335`}, {-0.05, -3.75}, {-0.05, -3.541666666666667}, {-0.05, \
-3.3333333333333335`}, {-0.05, -3.125}, {-0.05, -2.916666666666667}, {-0.05, \
-2.7083333333333335`}, {-0.05, -2.5}, {-0.05, -2.5}, {-0.05, \
-2.7083333333333335`}, {-0.05, -2.9166666666666665`}, {-0.05, -3.125}, \
{-0.05, -3.333333333333333}, {-0.05, -3.5416666666666665`}, {-0.05, -3.75}, \
{-0.05, -3.958333333333333}, {-0.05, -4.166666666666666}, {-0.05, -4.375}, \
{-0.05, -4.583333333333333}, {-0.05, -4.791666666666666}, {-0.05, -5.}, \
{-0.05, -5.}}, {{-0.05, 2.5}, {-0.05, 2.7083333333333335`}, {-0.05, 
         2.9166666666666665`}, {-0.05, 3.125}, {-0.05, 
         3.333333333333333}, {-0.05, 3.5416666666666665`}, {-0.05, 
         3.75}, {-0.05, 3.958333333333333}, {-0.05, 
         4.166666666666666}, {-0.05, 4.375}, {-0.05, 
         4.583333333333333}, {-0.05, 4.791666666666666}, {-0.05, 5.}, {-0.05, 
         5.}, {-0.05, 4.791666666666667}, {-0.05, 4.583333333333333}, {-0.05, 
         4.375}, {-0.05, 4.166666666666667}, {-0.05, 
         3.9583333333333335`}, {-0.05, 3.75}, {-0.05, 
         3.541666666666667}, {-0.05, 3.3333333333333335`}, {-0.05, 
         3.125}, {-0.05, 2.916666666666667}, {-0.05, 
         2.7083333333333335`}, {-0.05, 2.5}, {-0.05, 2.5}}}]}}}, {{
       Hold[$CellContext`staticpolygons15230200811523132847446$$], {}}}, {{
       Hold[$CellContext`staticpolygons16230200811523132852836$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{1.3689976525819987`, -5.65}, {
         0.9852549276396352, -4.708333333333334}, {
         0.6511727483615684, -3.766666666666667}, {
         0.3764030171799524, -2.825}, {
         0.17082082737962523`, -1.8833333333333337`}, {
         0.043271803862861, -0.9416666666666673}, {0., 0.}, {
         0.04327180386286091, 0.9416666666666664}, {0.17082082737962506`, 
         1.8833333333333329`}, {0.3764030171799522, 2.8249999999999993`}, {
         0.6511727483615678, 3.7666666666666657`}, {0.9852549276396345, 
         4.708333333333332}, {1.3689976525819987`, 5.65}, {
         1.3689976525819987`, 5.65}, {0.9852549276396352, 
         4.708333333333334}, {0.6511727483615684, 3.766666666666667}, {
         0.3764030171799524, 2.825}, {0.17082082737962523`, 
         1.8833333333333337`}, {0.043271803862861, 0.9416666666666673}, {0., 
         0.}, {0.04327180386286091, -0.9416666666666664}, {
         0.17082082737962506`, -1.8833333333333329`}, {
         0.3764030171799522, -2.8249999999999993`}, {
         0.6511727483615678, -3.7666666666666657`}, {
         0.9852549276396345, -4.708333333333332}, {
         1.3689976525819987`, -5.65}, {1.3689976525819987`, -5.65}}}]}}}, {{
       Hold[$CellContext`staticpolygons17230200811523132856751$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{1.3397916666666667`, -5.65}, {
         2.1526331018518516`, -4.708333333333334}, {
         2.817685185185185, -3.766666666666667}, {
         3.3349479166666667`, -2.825}, {
         3.7044212962962964`, -1.8833333333333337`}, {
         3.926105324074074, -0.9416666666666673}, {4., 0.}, {
         3.926105324074074, 0.9416666666666664}, {3.7044212962962964`, 
         1.8833333333333329`}, {3.334947916666667, 2.8249999999999993`}, {
         2.817685185185186, 3.7666666666666657`}, {2.152633101851853, 
         4.708333333333332}, {1.3397916666666667`, 5.65}, {
         1.3397916666666667`, 5.65}, {2.1526331018518516`, 
         4.708333333333334}, {2.817685185185185, 3.766666666666667}, {
         3.3349479166666667`, 2.825}, {3.7044212962962964`, 
         1.8833333333333337`}, {3.926105324074074, 0.9416666666666673}, {4., 
         0.}, {3.926105324074074, -0.9416666666666664}, {
         3.7044212962962964`, -1.8833333333333329`}, {
         3.334947916666667, -2.8249999999999993`}, {
         2.817685185185186, -3.7666666666666657`}, {
         2.152633101851853, -4.708333333333332}, {
         1.3397916666666667`, -5.65}, {1.3397916666666667`, -5.65}}}]}}}, {{
       Hold[$CellContext`staticpolygons18230200811523132905507$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[CompressedData["
1:eJxd1F9I01EUB/DNSZHswXBmxLCttWmEbboZWNnvW5D9oWS68CHWy2pRFiQW
FGtBaCMwIiKoBwkKi3owCdIYQ/gdxV4ifEnQIKgIRqCF0p8nobbfvb+X74X7
MO7vnnPuOR/mT13sTrscDoeztBOlXVHaD/qfFTvmtuBMeRUbZLU7VfujtxGe
sYNfM+Mhqcper9h2eDum/zQm7w4E5XPvk+H0+Sb0tVfNj8S3ytXUMe/tYBj1
ucWufH1ArjVVDs4cjeB9eS355UR8LvRwKYJMOWDBJwuOj87hK80ofZxbXL9Z
JnbH7/SsNONlKZ1nzCuzrnf5vckWrJsf6Ws/skl+7ly+7y20IG3VVye7FoYG
OtxRTFn11Mq+0ZNPpxNRnb9GcueGHiXvRXW+avnQeWH59dsoRq34bulpfTN5
YCWK01a8tXKqMjR4yROD17rvksfZtuKtcAwvrO9XTX+g1VnYH8NG6/yX6U/8
ngh3xlBt/f5mPv9+aMe/rhgc1vqyxz6PqHPDvt+o7ht2/LyKb9j5fSo/7PrO
qvpg1/9K1Y+b+n1Z9T5Av1/dr0Gb7s+M6g/s/ql4dbD761b9xbjuv4rvhT2f
42o+sOen8vmQ0fOdVfPFZT1/lT+AT9pHv/KBNdqPqieIv9rXBuULN7Q/VV8D
yCPII8gjyCPII8gjyCPII8gjyCPII8gjyCPII8gjyCPII8ijQR4N8miQx0ny
aJJHkzya5FHIo5BHIY9CHoU8CnkU8ijkUcijkEchj0IehTwKeRTyKORR+P/x
P4VLPns=
         "]]}}}, {{
       Hold[$CellContext`staticpolygons2123020081152326925122$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{-0.654121133468629, -6.25, 
          0.}, {-1.6633250356081046`, -5.208333333333334, 
          0.}, {-2.407409854982819, -4.166666666666667, 
          0.}, {-2.9470796165773505`, -3.1250000000000004`, 
          0.}, {-3.3150010468778817`, -2.083333333333334, 
          0.}, {-3.5294851698846217`, -1.0416666666666679`, 
          0.}, {-3.5999999999999996`, -8.881784197001252*^-16, 
          0.}, {-3.529485169884622, 1.041666666666666, 
          0.}, {-3.315001046877882, 2.083333333333332, 
          0.}, {-2.947079616577352, 3.1249999999999982`, 
          0.}, {-2.40740985498282, 4.166666666666664, 
          0.}, {-1.6633250356081057`, 5.208333333333332, 
          0.}, {-0.6541211334686317, 6.249999999999998, 
          0.}, {-0.654121133468629, 6.25, 0.}, {-1.6633250356081046`, 
          5.208333333333334, 0.}, {-2.407409854982819, 4.166666666666667, 
          0.}, {-2.9470796165773505`, 3.1250000000000004`, 
          0.}, {-3.3150010468778817`, 2.083333333333334, 
          0.}, {-3.5294851698846217`, 1.0416666666666679`, 
          0.}, {-3.5999999999999996`, 8.881784197001252*^-16, 
          0.}, {-3.529485169884622, -1.041666666666666, 
          0.}, {-3.315001046877882, -2.083333333333332, 
          0.}, {-2.947079616577352, -3.1249999999999982`, 
          0.}, {-2.40740985498282, -4.166666666666664, 
          0.}, {-1.6633250356081057`, -5.208333333333332, 
          0.}, {-0.6541211334686317, -6.249999999999998, 
          0.}, {-0.654121133468629, -6.25, 0.}}, {{-0.654121133468629, 
          0., -6.25}, {-1.6633250356081046`, 
          0., -5.208333333333334}, {-2.407409854982819, 
          0., -4.166666666666667}, {-2.9470796165773505`, 
          0., -3.1250000000000004`}, {-3.3150010468778817`, 
          0., -2.083333333333334}, {-3.5294851698846217`, 
          0., -1.0416666666666679`}, {-3.5999999999999996`, 
          0., -8.881784197001252*^-16}, {-3.529485169884622, 0., 
          1.041666666666666}, {-3.315001046877882, 0., 
          2.083333333333332}, {-2.947079616577352, 0., 
          3.1249999999999982`}, {-2.40740985498282, 0., 
          4.166666666666664}, {-1.6633250356081057`, 0., 
          5.208333333333332}, {-0.6541211334686317, 0., 
          6.249999999999998}, {-0.654121133468629, 0., 
          6.25}, {-1.6633250356081046`, 0., 
          5.208333333333334}, {-2.407409854982819, 0., 
          4.166666666666667}, {-2.9470796165773505`, 0., 
          3.1250000000000004`}, {-3.3150010468778817`, 0., 
          2.083333333333334}, {-3.5294851698846217`, 0., 
          1.0416666666666679`}, {-3.5999999999999996`, 0., 
          8.881784197001252*^-16}, {-3.529485169884622, 
          0., -1.041666666666666}, {-3.315001046877882, 
          0., -2.083333333333332}, {-2.947079616577352, 
          0., -3.1249999999999982`}, {-2.40740985498282, 
          0., -4.166666666666664}, {-1.6633250356081057`, 
          0., -5.208333333333332}, {-0.6541211334686317, 
          0., -6.249999999999998}, {-0.654121133468629, 
          0., -6.25}}, CompressedData["
1:eJxdlN8rg1Ecxt+IuFGMbEhR+wOURMkON+OCIgw1lpo7IT9uVrtyb0wuyK07
v4pso5ziYtpqLrZaTS1hLQl3kvw+z7PaOfX21tOz532+n/NtDZMzA+4CwzCa
fp/C3yec9MytPN+fG//HIgycKPTgYbjLdmUW7r7a7GvNoy0OvTtxkH6ymkVn
aNF7eftuY86EN90WN1eLoYXWitHGQkE987Fc5NupQn5pTvdX3tQtJUyi7mVk
3jpbJpLQT6ZM0rNbLgJ4018P3xp+R70AuQ/4DvVh9GAvzmVHb85BfRpzcm7m
RGKx/S3/aTs5UR9T/vMQ/OTTofJznKj3qz5S7/P1/XdKZEbrb1HzynXMq/GR
Op9V5ZMN4HQN/U7lyiKNP3pIBzhF8+9X9mj3Cy7SC07a/kjFKdJOHVykA5yY
34P8FnCi7kKfPnCK5u+P/AQn5oOLJCf6Q+BzjDf94CLJiXyKFRdJTtSd6OFE
L+Y40NuOOejfxJwBzE1/MpW6ONqLn5ETew6CIzlRbwZ3cqLei3tyaX3eFBeR
RX/qJuzBBuYN5++PCIIP833Ys0Zw0vZHkBP94CLGwYn54CJGwIk54CK2wUn/
/1H7kzr7ASJqdIk=
          "]}]}}}, {{
       Hold[$CellContext`staticpolygons2223020081152326930050$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{-0.7033119314590373, -5., 
          0.}, {-1.538876515698588, -4.166666666666667, 
          0.}, {-2.1302230142610687`, -3.3333333333333335`, 0.}, {-2.55, -2.5,
           0.}, {-2.8326922749902543`, -1.666666666666667, 
          0.}, {-2.9963598686045723`, -0.8333333333333339, 0.}, {-3.05, 0., 
          0.}, {-2.9963598686045723`, 0.833333333333333, 
          0.}, {-2.8326922749902543`, 1.666666666666666, 
          0.}, {-2.5500000000000007`, 2.499999999999999, 
          0.}, {-2.1302230142610696`, 3.333333333333332, 
          0.}, {-1.5388765156985889`, 4.166666666666666, 
          0.}, {-0.7033119314590373, 5., 0.}, {-0.7033119314590373, 5., 
          0.}, {-1.538876515698588, 4.166666666666667, 
          0.}, {-2.1302230142610687`, 3.3333333333333335`, 0.}, {-2.55, 2.5, 
          0.}, {-2.8326922749902543`, 1.666666666666667, 
          0.}, {-2.9963598686045723`, 0.8333333333333339, 0.}, {-3.05, 0., 
          0.}, {-2.9963598686045723`, -0.833333333333333, 
          0.}, {-2.8326922749902543`, -1.666666666666666, 
          0.}, {-2.5500000000000007`, -2.499999999999999, 
          0.}, {-2.1302230142610696`, -3.333333333333332, 
          0.}, {-1.5388765156985889`, -4.166666666666666, 
          0.}, {-0.7033119314590373, -5., 0.}, {-0.7033119314590373, -5., 
          0.}}, {{-0.7033119314590373, 0., -5.}, {-1.538876515698588, 
          0., -4.166666666666667}, {-2.1302230142610687`, 
          0., -3.3333333333333335`}, {-2.55, 0., -2.5}, {-2.8326922749902543`,
           0., -1.666666666666667}, {-2.9963598686045723`, 
          0., -0.8333333333333339}, {-3.05, 0., 0.}, {-2.9963598686045723`, 
          0., 0.833333333333333}, {-2.8326922749902543`, 0., 
          1.666666666666666}, {-2.5500000000000007`, 0., 
          2.499999999999999}, {-2.1302230142610696`, 0., 
          3.333333333333332}, {-1.5388765156985889`, 0., 
          4.166666666666666}, {-0.7033119314590373, 0., 
          5.}, {-0.7033119314590373, 0., 5.}, {-1.538876515698588, 0., 
          4.166666666666667}, {-2.1302230142610687`, 0., 
          3.3333333333333335`}, {-2.55, 0., 2.5}, {-2.8326922749902543`, 0., 
          1.666666666666667}, {-2.9963598686045723`, 0., 
          0.8333333333333339}, {-3.05, 0., 0.}, {-2.9963598686045723`, 
          0., -0.833333333333333}, {-2.8326922749902543`, 
          0., -1.666666666666666}, {-2.5500000000000007`, 
          0., -2.499999999999999}, {-2.1302230142610696`, 
          0., -3.333333333333332}, {-1.5388765156985889`, 
          0., -4.166666666666666}, {-0.7033119314590373, 
          0., -5.}, {-0.7033119314590373, 0., -5.}}, CompressedData["
1:eJxdk8srhGEUxj8GuZVrykq2iExKpLyl3KJcNi4bpuwYC0VYSFmIZDul+RdM
inGZYV6XJBtEoixcJrehLBQrDO/zfOW89fXVrzPne87vPZPvGmzri7UsqzT6
OKLPdW56wvTkfcj6O9nKwiHv3T5dcJ5lqamUhvau23A1+cDIXNNMa5YqO/go
9S6/27zJM9FbM5apgu1dLd3eL5tHSspPUtsy0D9Oka+9FhW/BdLUXcfY/Gpn
os1DyXnWfn2q0niTh1Hnx+/IY9D3Gd8h30QO5noEr0DufszB+hnMybnJk4Yu
Q740fxU9kY+b+pBL1DtNf9sTud/ksT2Rf33/HoeOiPw3Zl69LuaFHy39rJg6
/SB8Ppm+Ok74Rw69BU/0Ay+6UtwvvGiP2Ad40cbTfhU5vOhReCJ3o38hPJE3
I48Pni7AX5Cfnli/gXnpiXwPfgJ4k8OLpifyeONF0xP5AXI0Ihd5LXLTE/ki
5uzB3HZ9zt3R7uxxkJ7Ih+HRJeoL4N0t++OemkWeT+NFvYr8V9iDTTHvFvZm
R/hZxp49Cp/wouiJHF7UITxd/98fVSfuF17UktgH/q/M/pwHfwCgXQqn
          "]}]}}}, {{
      
       Hold[$CellContext`staticpolygons2323020081152326934944$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{-0.05, -2.5, 0.}, {-0.05, -2.0833333333333335`, 
          0.}, {-0.05, -1.6666666666666667`, 0.}, {-0.05, -1.25, 
          0.}, {-0.05, -0.8333333333333335, 
          0.}, {-0.05, -0.41666666666666696`, 0.}, {-0.05, 0., 0.}, {-0.05, 
          0.4166666666666665, 0.}, {-0.05, 0.833333333333333, 0.}, {-0.05, 
          1.2499999999999996`, 0.}, {-0.05, 1.666666666666666, 0.}, {-0.05, 
          2.083333333333333, 0.}, {-0.05, 2.5, 0.}, {-0.05, 2.5, 0.}, {-0.05, 
          2.0833333333333335`, 0.}, {-0.05, 1.6666666666666667`, 0.}, {-0.05, 
          1.25, 0.}, {-0.05, 0.8333333333333335, 0.}, {-0.05, 
          0.41666666666666696`, 0.}, {-0.05, 0., 
          0.}, {-0.05, -0.4166666666666665, 0.}, {-0.05, -0.833333333333333, 
          0.}, {-0.05, -1.2499999999999996`, 0.}, {-0.05, -1.666666666666666, 
          0.}, {-0.05, -2.083333333333333, 0.}, {-0.05, -2.5, 
          0.}, {-0.05, -2.5, 0.}}, {{-0.05, 0., -2.5}, {-0.05, 
          0., -2.0833333333333335`}, {-0.05, 
          0., -1.6666666666666667`}, {-0.05, 0., -1.25}, {-0.05, 
          0., -0.8333333333333335}, {-0.05, 
          0., -0.41666666666666696`}, {-0.05, 0., 0.}, {-0.05, 0., 
          0.4166666666666665}, {-0.05, 0., 0.833333333333333}, {-0.05, 0., 
          1.2499999999999996`}, {-0.05, 0., 1.666666666666666}, {-0.05, 0., 
          2.083333333333333}, {-0.05, 0., 2.5}, {-0.05, 0., 2.5}, {-0.05, 0., 
          2.0833333333333335`}, {-0.05, 0., 1.6666666666666667`}, {-0.05, 0., 
          1.25}, {-0.05, 0., 0.8333333333333335}, {-0.05, 0., 
          0.41666666666666696`}, {-0.05, 0., 0.}, {-0.05, 
          0., -0.4166666666666665}, {-0.05, 0., -0.833333333333333}, {-0.05, 
          0., -1.2499999999999996`}, {-0.05, 0., -1.666666666666666}, {-0.05, 
          0., -2.083333333333333}, {-0.05, 0., -2.5}, {-0.05, 
          0., -2.5}}, CompressedData["
1:eJxdkzlIA1EURSdGCxewsxVbFSUiiCJkQHAjAZfGpdGAnUshKMbCxkoR26jY
CjYGIcYlifNdELERMY1g4wKuEUHBFGKM/nt/8T4MA4eXl/vOf1MWGOsayrEs
y5N93NlneenvrDvW/8m1LRzywYPLlZqk254tbOvuu016yUcmF3xznW679vTL
sxq5N9wXmhlsCubY8e6+jv7VN8Nfqusuirpc6P9p+E6qsuo9lvHe9QQXt3vT
hjsFpdZJ67dX4U1+j7oofkfuQt9n/A95AjmYi7weuYcxB/kc5uTc5PnjV064
eK2Rnsindb0TEPU1ur/xRB7VeRyZ5yfzdz6MJ/IbPa+zK+aFH0f62dJ1zoPw
+aT7qlzhHznUvrgveFEN4n7hRYXEPsCL0p6ijeTwoqbgiXwU/SvgidyPPGF4
In9Ffnoi38O89ER+DD8xvMnhxXgiz9NejCfyU+RoRy7yZuSmJ/INzDmAuU19
yd350byK0xP5BDwGRH05vI/K/rgnv8iT1l68KZH/GnuQEPPuY28OhZ8I9uxR
+IQXm57I4cU+E/fF76pF3C+82JtiH/hd6f05if8CUaliEQ==
          "]}]}}}, {{
       Hold[$CellContext`staticpolygons2423020081152326944061$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{-0.05, -5., 0.}, {-0.05, -4.791666666666667, 
          0.}, {-0.05, -4.583333333333333, 0.}, {-0.05, -4.375, 
          0.}, {-0.05, -4.166666666666667, 0.}, {-0.05, -3.9583333333333335`, 
          0.}, {-0.05, -3.75, 0.}, {-0.05, -3.541666666666667, 
          0.}, {-0.05, -3.3333333333333335`, 0.}, {-0.05, -3.125, 
          0.}, {-0.05, -2.916666666666667, 0.}, {-0.05, -2.7083333333333335`, 
          0.}, {-0.05, -2.5, 0.}, {-0.05, -2.5, 
          0.}, {-0.05, -2.7083333333333335`, 
          0.}, {-0.05, -2.9166666666666665`, 0.}, {-0.05, -3.125, 
          0.}, {-0.05, -3.333333333333333, 0.}, {-0.05, -3.5416666666666665`, 
          0.}, {-0.05, -3.75, 0.}, {-0.05, -3.958333333333333, 
          0.}, {-0.05, -4.166666666666666, 0.}, {-0.05, -4.375, 
          0.}, {-0.05, -4.583333333333333, 0.}, {-0.05, -4.791666666666666, 
          0.}, {-0.05, -5., 0.}, {-0.05, -5., 0.}}, {{-0.05, 2.5, 0.}, {-0.05,
           2.7083333333333335`, 0.}, {-0.05, 2.9166666666666665`, 0.}, {-0.05,
           3.125, 0.}, {-0.05, 3.333333333333333, 0.}, {-0.05, 
          3.5416666666666665`, 0.}, {-0.05, 3.75, 0.}, {-0.05, 
          3.958333333333333, 0.}, {-0.05, 4.166666666666666, 0.}, {-0.05, 
          4.375, 0.}, {-0.05, 4.583333333333333, 0.}, {-0.05, 
          4.791666666666666, 0.}, {-0.05, 5., 0.}, {-0.05, 5., 0.}, {-0.05, 
          4.791666666666667, 0.}, {-0.05, 4.583333333333333, 0.}, {-0.05, 
          4.375, 0.}, {-0.05, 4.166666666666667, 0.}, {-0.05, 
          3.9583333333333335`, 0.}, {-0.05, 3.75, 0.}, {-0.05, 
          3.541666666666667, 0.}, {-0.05, 3.3333333333333335`, 0.}, {-0.05, 
          3.125, 0.}, {-0.05, 2.916666666666667, 0.}, {-0.05, 
          2.7083333333333335`, 0.}, {-0.05, 2.5, 0.}, {-0.05, 2.5, 
          0.}}, {{-0.05, 0., -5.}, {-0.05, 0., -4.791666666666667}, {-0.05, 
          0., -4.583333333333333}, {-0.05, 0., -4.375}, {-0.05, 
          0., -4.166666666666667}, {-0.05, 0., -3.9583333333333335`}, {-0.05, 
          0., -3.75}, {-0.05, 0., -3.541666666666667}, {-0.05, 
          0., -3.3333333333333335`}, {-0.05, 0., -3.125}, {-0.05, 
          0., -2.916666666666667}, {-0.05, 0., -2.7083333333333335`}, {-0.05, 
          0., -2.5}, {-0.05, 0., -2.5}, {-0.05, 
          0., -2.7083333333333335`}, {-0.05, 
          0., -2.9166666666666665`}, {-0.05, 0., -3.125}, {-0.05, 
          0., -3.333333333333333}, {-0.05, 0., -3.5416666666666665`}, {-0.05, 
          0., -3.75}, {-0.05, 0., -3.958333333333333}, {-0.05, 
          0., -4.166666666666666}, {-0.05, 0., -4.375}, {-0.05, 
          0., -4.583333333333333}, {-0.05, 0., -4.791666666666666}, {-0.05, 
          0., -5.}, {-0.05, 0., -5.}}, {{-0.05, 0., 2.5}, {-0.05, 0., 
          2.7083333333333335`}, {-0.05, 0., 2.9166666666666665`}, {-0.05, 0., 
          3.125}, {-0.05, 0., 3.333333333333333}, {-0.05, 0., 
          3.5416666666666665`}, {-0.05, 0., 3.75}, {-0.05, 0., 
          3.958333333333333}, {-0.05, 0., 4.166666666666666}, {-0.05, 0., 
          4.375}, {-0.05, 0., 4.583333333333333}, {-0.05, 0., 
          4.791666666666666}, {-0.05, 0., 5.}, {-0.05, 0., 5.}, {-0.05, 0., 
          4.791666666666667}, {-0.05, 0., 4.583333333333333}, {-0.05, 0., 
          4.375}, {-0.05, 0., 4.166666666666667}, {-0.05, 0., 
          3.9583333333333335`}, {-0.05, 0., 3.75}, {-0.05, 0., 
          3.541666666666667}, {-0.05, 0., 3.3333333333333335`}, {-0.05, 0., 
          3.125}, {-0.05, 0., 2.916666666666667}, {-0.05, 0., 
          2.7083333333333335`}, {-0.05, 0., 2.5}, {-0.05, 0., 
          2.5}}, CompressedData["
1:eJxdkzlIA1EURSdGCxewsxVbFSUiiCJkQHAjAZfGpdGAnUshKMbCxkoR26jY
CjYGIcYlifNdELERMY1g4wKuEUHBFGKM/nt/8T4MA4eXl/vOf1MWGOsayrEs
y5N93NlneenvrDvW/8m1LRzywYPLlZqk254tbOvuu016yUcmF3xznW679vTL
sxq5N9wXmhlsCubY8e6+jv7VN8Nfqusuirpc6P9p+E6qsuo9lvHe9QQXt3vT
hjsFpdZJ67dX4U1+j7oofkfuQt9n/A95AjmYi7weuYcxB/kc5uTc5PnjV064
eK2Rnsindb0TEPU1ur/xRB7VeRyZ5yfzdz6MJ/IbPa+zK+aFH0f62dJ1zoPw
+aT7qlzhHznUvrgveFEN4n7hRYXEPsCL0p6ijeTwoqbgiXwU/SvgidyPPGF4
In9Ffnoi38O89ER+DD8xvMnhxXgiz9NejCfyU+RoRy7yZuSmJ/INzDmAuU19
yd350byK0xP5BDwGRH05vI/K/rgnv8iT1l68KZH/GnuQEPPuY28OhZ8I9uxR
+IQXm57I4cU+E/fF76pF3C+82JtiH/hd6f05if8CUaliEQ==
          
          "], CompressedData["
1:eJxdk8srRGEYxg9GuUzJJVvZIhopkfKVcmummNkwNmbKzmWhCAsbK5KtS/MH
2JAa4zLD+VyaJhtEStm4lHtZKFau3/OcxfvV6dSvd9553t/3ntLwkL8v3bIs
z++T8fssLvydZdv6P0XKwiEP7Z0tVZ8XqqnctkDw5q6RfGB01jvdWahqUh+e
SPTd4d75yVDTeIFKBIIdPZEvhz9X1Z66/fno71Lkm68VlW/xPHXbNT630Z3l
cDunxEq2upXGm/wOdTH8jjwNfZ/wP+Q7yMFc5HXI3Y85yKcxJ+cmzx6+tFfz
Yg30RD5h6u2wqK82/R1P5DGTx5Z5vr7/ToZ+Fvmvzbx6S8wLP1r6WTd1+l74
fDR9tUv4Rw69K+4LXnS9uF940fNiH+BFG0/JBnJ40WPwRD6I/uXwRO5DnlV4
In9Bfnoi38a89ER+CD9xvMnhRdMTeabxoumJPIUc7chF3ozc9ES+gjl7MbdT
X3x7fDBzkqAn8hF4DIv6MngflP1xTz6R59N4Ua8i/xX2YEfMu4u92Rd+otiz
B+ETXhQ9kcOLOhL3xe+qRdwvvKg1sQ/8rsz+XCR+AHt0SEE=
          "]}]}}}, {{
       Hold[$CellContext`staticpolygons2523020081152326945592$$], {}}}, {{
       Hold[$CellContext`staticpolygons2623020081152326970402$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{1.3689976525819987`, -5.65, 0.}, {
          0.9852549276396352, -4.708333333333334, 0.}, {
          0.6511727483615684, -3.766666666666667, 0.}, {
          0.3764030171799524, -2.825, 0.}, {
          0.17082082737962523`, -1.8833333333333337`, 0.}, {
          0.043271803862861, -0.9416666666666673, 0.}, {0., 0., 0.}, {
          0.04327180386286091, 0.9416666666666664, 0.}, {0.17082082737962506`,
           1.8833333333333329`, 0.}, {0.3764030171799522, 2.8249999999999993`,
           0.}, {0.6511727483615678, 3.7666666666666657`, 0.}, {
          0.9852549276396345, 4.708333333333332, 0.}, {1.3689976525819987`, 
          5.65, 0.}, {1.3689976525819987`, 5.65, 0.}, {0.9852549276396352, 
          4.708333333333334, 0.}, {0.6511727483615684, 3.766666666666667, 
          0.}, {0.3764030171799524, 2.825, 0.}, {0.17082082737962523`, 
          1.8833333333333337`, 0.}, {0.043271803862861, 0.9416666666666673, 
          0.}, {0., 0., 0.}, {0.04327180386286091, -0.9416666666666664, 0.}, {
          0.17082082737962506`, -1.8833333333333329`, 0.}, {
          0.3764030171799522, -2.8249999999999993`, 0.}, {
          0.6511727483615678, -3.7666666666666657`, 0.}, {
          0.9852549276396345, -4.708333333333332, 0.}, {
          1.3689976525819987`, -5.65, 0.}, {1.3689976525819987`, -5.65, 
          0.}}, {{1.3689976525819987`, 0., -5.65}, {0.9852549276396352, 
          0., -4.708333333333334}, {0.6511727483615684, 
          0., -3.766666666666667}, {0.3764030171799524, 0., -2.825}, {
          0.17082082737962523`, 0., -1.8833333333333337`}, {0.043271803862861,
           0., -0.9416666666666673}, {0., 0., 0.}, {0.04327180386286091, 0., 
          0.9416666666666664}, {0.17082082737962506`, 0., 
          1.8833333333333329`}, {0.3764030171799522, 0., 
          2.8249999999999993`}, {0.6511727483615678, 0., 
          3.7666666666666657`}, {0.9852549276396345, 0., 4.708333333333332}, {
          1.3689976525819987`, 0., 5.65}, {1.3689976525819987`, 0., 5.65}, {
          0.9852549276396352, 0., 4.708333333333334}, {0.6511727483615684, 0.,
           3.766666666666667}, {0.3764030171799524, 0., 2.825}, {
          0.17082082737962523`, 0., 1.8833333333333337`}, {0.043271803862861, 
          0., 0.9416666666666673}, {0., 0., 0.}, {0.04327180386286091, 
          0., -0.9416666666666664}, {0.17082082737962506`, 
          0., -1.8833333333333329`}, {0.3764030171799522, 
          0., -2.8249999999999993`}, {0.6511727483615678, 
          0., -3.7666666666666657`}, {0.9852549276396345, 
          0., -4.708333333333332}, {1.3689976525819987`, 0., -5.65}, {
          1.3689976525819987`, 0., -5.65}}, CompressedData["
1:eJxdlD1IQmEYhW8FLg1hf1AR9DM0NRQtmeUH4mRWFFIRYQVCSNAUka1NjTaY
BtLPkmNNDpKfBtEWRENB9A9BUJRirRXfOYLvhcuFw7nvPef5Xm77wvJ4sNKy
rJ6/u+rv9rk6GkKvRVc89n81KgsX9fXT09XmxUbVnYzm52KvLurZrZOHlasG
5Vlb2jsK/pT0OZ9/s/exXu11pTwtwxVqBHoh92KFI3XKfMem6B+YqlyyfdjV
ROAi2bRRXdLv3s4+a79r1D2e1P3w8T3qO5ibx3eo7yMHc1H3IrdGD+p96Mne
1HuKmezTe8pJTtQ7jT8j/W4zP5MV8xMmj54XebZNfl0Q+cdMX+0UfcFHSz4O
49OTgueXmasTgj+46ANwog4uelicL3pqt9gHcNGG07lT+tvAifuQw3wnONG/
gDxxcPKV74+OghPnDKIvOdH/DD43eFIHF01O1Hcxl5yoHyJHALmoTyN3Bj2o
z6JnGL2pv/yM2kPHl2lyot5avm+lXg5wz4n54KLIif4IzrUo8nuxB0Oi7y32
5kHw6ceeTQue4KLIiTq4qKQ4L3BRM+J8wUUFwEn+f8z+XKd/AdLmInA=
          "]}]}}}, {{
      
       Hold[$CellContext`staticpolygons2723020081152326975689$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{1.3397916666666667`, -5.65, 0.}, {
          2.1526331018518516`, -4.708333333333334, 0.}, {
          2.817685185185185, -3.766666666666667, 0.}, {
          3.3349479166666667`, -2.825, 0.}, {
          3.7044212962962964`, -1.8833333333333337`, 0.}, {
          3.926105324074074, -0.9416666666666673, 0.}, {4., 0., 0.}, {
          3.926105324074074, 0.9416666666666664, 0.}, {3.7044212962962964`, 
          1.8833333333333329`, 0.}, {3.334947916666667, 2.8249999999999993`, 
          0.}, {2.817685185185186, 3.7666666666666657`, 0.}, {
          2.152633101851853, 4.708333333333332, 0.}, {1.3397916666666667`, 
          5.65, 0.}, {1.3397916666666667`, 5.65, 0.}, {2.1526331018518516`, 
          4.708333333333334, 0.}, {2.817685185185185, 3.766666666666667, 
          0.}, {3.3349479166666667`, 2.825, 0.}, {3.7044212962962964`, 
          1.8833333333333337`, 0.}, {3.926105324074074, 0.9416666666666673, 
          0.}, {4., 0., 0.}, {3.926105324074074, -0.9416666666666664, 0.}, {
          3.7044212962962964`, -1.8833333333333329`, 0.}, {
          3.334947916666667, -2.8249999999999993`, 0.}, {
          2.817685185185186, -3.7666666666666657`, 0.}, {
          2.152633101851853, -4.708333333333332, 0.}, {
          1.3397916666666667`, -5.65, 0.}, {1.3397916666666667`, -5.65, 
          0.}}, {{1.3397916666666667`, 0., -5.65}, {2.1526331018518516`, 
          0., -4.708333333333334}, {2.817685185185185, 
          0., -3.766666666666667}, {3.3349479166666667`, 0., -2.825}, {
          3.7044212962962964`, 0., -1.8833333333333337`}, {3.926105324074074, 
          0., -0.9416666666666673}, {4., 0., 0.}, {3.926105324074074, 0., 
          0.9416666666666664}, {3.7044212962962964`, 0., 
          1.8833333333333329`}, {3.334947916666667, 0., 
          2.8249999999999993`}, {2.817685185185186, 0., 
          3.7666666666666657`}, {2.152633101851853, 0., 4.708333333333332}, {
          1.3397916666666667`, 0., 5.65}, {1.3397916666666667`, 0., 5.65}, {
          2.1526331018518516`, 0., 4.708333333333334}, {2.817685185185185, 0.,
           3.766666666666667}, {3.3349479166666667`, 0., 2.825}, {
          3.7044212962962964`, 0., 1.8833333333333337`}, {3.926105324074074, 
          0., 0.9416666666666673}, {4., 0., 0.}, {3.926105324074074, 
          0., -0.9416666666666664}, {3.7044212962962964`, 
          0., -1.8833333333333329`}, {3.334947916666667, 
          0., -2.8249999999999993`}, {2.817685185185186, 
          0., -3.7666666666666657`}, {2.152633101851853, 
          0., -4.708333333333332}, {1.3397916666666667`, 0., -5.65}, {
          1.3397916666666667`, 0., -5.65}}, CompressedData["
1:eJxdlE8og2Ecx1+Ui4P8WyFFDi6zkIt52VNy2kS0kDRWK2m1k4SrkyOFTcmf
ix05Ocj7bCtxUnKg5O9KKWJrdnEwPd+vep+33t769t33+f4+z681BSPDoWLD
MNoLb0nhbVv/CV5Ecp5Y9O9xCAOPC/pSKjVfN+MQrfGNzFT01UM9sXb6OHdd
I/oXwruHobyHOVMD/pWOp2qx23LcX+8rEk7o2WTaWFytEuqcUkF/91hxuPSj
QowELuO1y2WC+fdvZ5+V3+XiAV/qfvj4O+ZsITeDc6jvoQd7Ufeit8QczO/E
nJyb/vaclXh+PzbJiXqz8lv0M6dP5VsJLX9b9ZHT6EN9U/WXWa3/kJpXmphX
4yN1Pm7lk6PgxJwvlSu3wcllvy+5D070g4v0gZO2D7IPnLT9kYrTudmm+RvB
ifuQRL4JTtSD6BMDJ5d9f+QGONHfg3nJiee+gM8tvswBF0lOzNlBLjkx5wA9
AuhFfRy9LcxBfRJzLmJu6un8YMXs0dUJOVFvsO/bfx83uJMTdXAR5ER9Ffea
0/p7sQe9mJf6HfbmUePThT0bByenfX8EOdEPLiKu3Re4iAlw4rngIgLgpP//
qP25OfkF985g7Q==
          "]}]}}}, {{
       Hold[$CellContext`staticpolygons2823020081152327012047$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{CompressedData["
1:eJx11V1Ik1Ecx/HppEh2YThfiAfbWpsLsU03AyvrX5C9UDJdeBHrZrUwCxIL
irUgtBEYERHUhQSFRV2YBGmMIaRiNxHeJGgQVAQj0ELp5Uqo7Tnn+QU/6YFd
7MPDec45z/lu7vi5jkSxzWaL5j/2/Odu7+Nc6+wmOVW4crUTNn2tdMQrvnX7
xTmy/3Ny1AcvTV0p3nKwTqZ++WO3+rzwj90PBxNn6qWnpXRuKLIZfil+xLjh
DUhNeqE9U+OBX64v6Z8+HJS3hWvRDT8WmfXdWwxKsvDgrAs+b3tfNHixQfKD
pBfWb4SP7Yjc7FxukGf5aTpHDPiM/U1mV6xR1s0N9bQc2gD/vm3pjpFtlIS5
3ir49vmBvlZHSCbNdVXA9wwffzQVDen5l8PTpwfux26H9DzL4O/azi69eB2S
YXM+Dnhn08vxfcshOWk+dy38RImv/7wzLIY5vh3+INWcux4Iy1NznJVXlrs9
TUXZvWGpNu//8c+jP8cCbWEpM/0L/MnXA1v/tIdFffu0k+8Pqvt38/h+NT7c
mk9GzQduzd+l5i+83i61Xri1P8/V/sCv6f1Mqf2Ei95/NX45vFm/r2n1vuDW
+1XPrYJb58GhzgN8VJ8fNR8Dbp23o+q8wa3zqebpgif1eZ5R5xl+QZ9/NX8P
/IPupVf1Al+j+1Lr8sJ/6x4rVY/wq7pftd5aOHUNp67h1DWcuoZT13DqetW+
JWnfqGs4dQ2nruHUNZy6hlPXcOoaTl3DqWs4dQ2nrld1V03dUddw6nqc7w/S
7wB1Daeu4dT1BK+3i37HqGs4dQ2nruHUNZy6hlPXcOoaTl3DqWs4dQ2nruHU
NZy6hlPXcOoa/r//67+NQD56
          "], CompressedData["
1:eJx11V9IU1EcB/CrkyLZg+HUiIttrc1F2OyPgZXdX0H2h5LpwodYL6tFWZBY
UKwFoY3AiIigHiQoLOrBJEhjDOH+FHuJ8EVBg6AiGIEWSn+ehNru73APnMPv
wH35cjn3d875fc4NJC91psoNw4gXH0/xedj7vNA2uxEMMc6WRqEBVzqTNT+6
I27uGzn0NT0axsrMjfLNR7a4+eSfSOJeXwg/dz8dTF1odPOe1sq5odgmvJY8
bt4JRd28PrvQkasP4vXGiv6pY01u/qE0FgN4MjYbfrQo83Tpw3k/zhsfywav
bnPz4iTZhbUbcGxP7G7XssxfFcv0jZg47Xmf25fY7uZr5oZ6Wo+ux5+7lh6Y
eZmnnPXW4e75gb427w43n3DWVYP7h089m4zLnOqvxuz5gceJ+zKnOqtwpv3i
0pt3Mh926vFiV/Pb8YPLMj/jfHc1nq4I91/27XRz05nfg08yLYXbUZm/dOZZ
sQPB5rL8AZmvc97/ZQfiv8ei7TKvcvJv9ovvh7f+65A5jS971feb6H1LnT9C
81tqPTmqx1Lr91P9oK73HK0X1P15TfsDt5T9zNB+Aij7T/NXQ4tyXlN0XqCe
L323DtR+8FI/wKjSP1SPCWq/naB+A7U/qU4/pJV+nqZ+hitK/1P9QfikeOkl
L7BK8UXrCsFfxWMteYSbil9abwMwroFxDYxrYFwD4xoY19q+CdfaPgvXwLjW
zlG41s5duAbGNTCugXGt9a1wrfW5cA2Ma2Bca+6Ea4txbTGuxxnX2r0hXNuM
a5txrd1jwrV27wnXyLhGxjUyrrV7W7jW7nnhGhnX2n9EuNb+O8I1Mq6RcY2M
a2RcI+MaGdfI/a//AwmRPno=
          "], CompressedData["
1:eJx1l31M1WUUx2+QNLKYU1z2olxQuUKgWy2TlHgSzYTp7IJtTWxC6Gyr0bI0
/4D15lZqUH/kW3YdNsjZlqFYDkTOStbMSkUJYgkoC5Mxt1aTuWRGPd/vab+z
wcbYvjuce55zzuecc1PLKqJr40KhUO3ob/zo745X6gaevJDm1v37MxBxIfzE
oKft/+XCF5cirjOrv6s2oSeP9i/k99x873zEPXNj3LeNoWuqFw0d2zDSHHG5
SSVl4c3XVf/r5KQtEz+OuIsVn1bccXVE9YT0ojk/vxxxc++Phj6oj3PUM2te
nfZsbsT9+nrPnrynExzjuX5tc92h0GicT+26lfJnouqXOp7/6o+mdHd0uCP8
zda7XQ301hMtXY+9mO5KMuKrVm+boPpgRKYdTE53b9VXJrcXTFR90Xd33VvW
ONN90tHwcFJ8suqlXyaeerdwpjvTMXVy+ZHJqn92pu/DJd0z3G3nqyZkrLpH
9Wh9xqzTa2a42tzZvUdvTNE4o035b+T3TneD0YyeddX36XvDDeub+1dOd2W/
HVi+d8oDqldVV066fDLNzRqY81HTzqnqvybp87ZNWWlu2enhjZnjU9R+aXXb
333bU934gnMHs3LCqm986f3GkoGw/qVOO/4f/dMvP4f2jINxUWfcfAf1IbyT
76Z/5oV5oj3zWI+8Mm9nkfc1qAN11ikfdaP/t1FX1pn6avQB+4J+vkbfsI8Y
Txz6jH1H/SL6kn1KfR76mH1NvQ99Tw6oO3BCbqiXgCtyxjj7wSG5pP2iuUcW
3iz5fgE5pv0pb99q7Vd4/630Tz3Hx9Nq4+n28bfa+B/x7xW+l3nu9vmRB5Ef
xnNryX/5FJvPwz7/ctnkf5Wvl7Be9A9uxdZ3t+8HWYx+oJ+ffP8IOaZ9nO83
Yb9R3+f7U4rQn9Sv+H6WYvSz6X+x/Z/heRHyYvgS8sX8JHoepQA8Gn6F/NIe
3Mqdhvdq71eWk2PolT4OyTLzBHFLOTimXuTfKZxXZr7JfnDMz63zeZTbwTHj
BLdy1sxPzFvZa+Yt6irvgGP6P+H7QErBMXVwK8fAsdkXMuL7zu4X6QXHZh9J
ntlH6HvpB8f0D05kntl34ErKwbHZpxLODu5TcCue4+4F1n4IHFv/S8GxjScT
HMdM/J3g2L43BxxTB7fSBY7pZxj5HAbHtAe30gCOY6Zez4HjHaa+b4Jj6uBW
doFj6uBWfgTH1MGtYG+I9i36kxxTB7dCjqmnov9LwbHZv0KO+S5wK4XkGHoh
eCTH9LMJ/L6Gv/QDboUc6x0Fv9vxOfQPboUcUy8Pzh/1D24F+1ftY8H5pp87
Dnkkx9TPIe/kmH6wf4Uc034r6vo76qx1RB+wL6g3oW/I8Rj7Qu07gvtF9SeC
+0j1K8H9pfr84L7Td+0O7ke1z84O7FPVD69PeKilrf84OWb8PcF9rfYbgvtd
7SPBe0D19uD9oH4eDd4bqv+AuZaF/Og8xBwcNvk8hLlJjse4l9R+C+byVVPf
nZjji00/gFvleIx77//8Y6+sNP05gD1UbPoZ3CrHY9yrar8Ce7Ha8AVulWP6
AbfK8Rj3tvoBt67YzAdw62aDY/pJwd2w1swf3s1DZl7xLomZ+QZuXQI4ph/e
ze3gmP2QH/y+o/bg1m0Dx7RvwR1WZuY57+ZmM//N9zW7X1wnOGb8vCMXmn3E
u3PQ7C/eqY+DY/rhXbsPHNOed/D87OA+5d3s9+/g8X8Atd86pA==
          "]}]}}}}, 
    Typeset`size$$ = {842., {230.375, 235.625}}, Typeset`update$$ = 0, 
    Typeset`initDone$$, Typeset`skipInitDone$$ = 
    False, $CellContext`th$26494$$ = 0, $CellContext`x$26495$$ = 
    0, $CellContext`y$26496$$ = 0, $CellContext`focus$26497$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`focus$$ = 
        0, $CellContext`lastlocposth$$ = {-4.4019925, 
         0.}, $CellContext`laststartposth$$ = {-5., 
         0.}, $CellContext`lastth$$ = 0, $CellContext`maxfocus$$ = 
        10, $CellContext`maxth$$ = 
        180., $CellContext`maxx$$ = -0.05, $CellContext`maxy$$ = 
        10, $CellContext`minfocus$$ = -10, $CellContext`minth$$ = -180., \
$CellContext`minx$$ = -10, $CellContext`miny$$ = -10, $CellContext`radiusth$$ = 
        0.5980074999999999, \
$CellContext`staticpolygons11230200811523132827920$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{-0.654121133468629, -6.25}, {-1.6633250356081046`, \
-5.208333333333334}, {-2.407409854982819, -4.166666666666667}, \
{-2.9470796165773505`, -3.1250000000000004`}, {-3.3150010468778817`, \
-2.083333333333334}, {-3.5294851698846217`, -1.0416666666666679`}, \
{-3.5999999999999996`, -8.881784197001252*^-16}, {-3.529485169884622, 
           1.041666666666666}, {-3.315001046877882, 
           2.083333333333332}, {-2.947079616577352, 
           3.1249999999999982`}, {-2.40740985498282, 
           4.166666666666664}, {-1.6633250356081057`, 
           5.208333333333332}, {-0.6541211334686317, 
           6.249999999999998}, {-0.654121133468629, 
           6.25}, {-1.6633250356081046`, 
           5.208333333333334}, {-2.407409854982819, 
           4.166666666666667}, {-2.9470796165773505`, 
           3.1250000000000004`}, {-3.3150010468778817`, 
           2.083333333333334}, {-3.5294851698846217`, 
           1.0416666666666679`}, {-3.5999999999999996`, 
           8.881784197001252*^-16}, {-3.529485169884622, -1.041666666666666}, \
{-3.315001046877882, -2.083333333333332}, {-2.947079616577352, \
-3.1249999999999982`}, {-2.40740985498282, -4.166666666666664}, \
{-1.6633250356081057`, -5.208333333333332}, {-0.6541211334686317, \
-6.249999999999998}, {-0.654121133468629, -6.25}}}]}, \
$CellContext`staticpolygons12230200811523132833440$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{-0.7033119314590373, -5.}, {-1.538876515698588, \
-4.166666666666667}, {-2.1302230142610687`, -3.3333333333333335`}, {-2.55, \
-2.5}, {-2.8326922749902543`, -1.666666666666667}, {-2.9963598686045723`, \
-0.8333333333333339}, {-3.05, 0.}, {-2.9963598686045723`, 
           0.833333333333333}, {-2.8326922749902543`, 
           1.666666666666666}, {-2.5500000000000007`, 
           2.499999999999999}, {-2.1302230142610696`, 
           3.333333333333332}, {-1.5388765156985889`, 
           4.166666666666666}, {-0.7033119314590373, 
           5.}, {-0.7033119314590373, 5.}, {-1.538876515698588, 
           4.166666666666667}, {-2.1302230142610687`, 
           3.3333333333333335`}, {-2.55, 2.5}, {-2.8326922749902543`, 
           1.666666666666667}, {-2.9963598686045723`, 
           0.8333333333333339}, {-3.05, 
           0.}, {-2.9963598686045723`, -0.833333333333333}, \
{-2.8326922749902543`, -1.666666666666666}, {-2.5500000000000007`, \
-2.499999999999999}, {-2.1302230142610696`, -3.333333333333332}, \
{-1.5388765156985889`, -4.166666666666666}, {-0.7033119314590373, -5.}, \
{-0.7033119314590373, -5.}}}]}, \
$CellContext`staticpolygons13230200811523132837510$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{-0.05, -2.5}, {-0.05, -2.0833333333333335`}, {-0.05, \
-1.6666666666666667`}, {-0.05, -1.25}, {-0.05, -0.8333333333333335}, {-0.05, \
-0.41666666666666696`}, {-0.05, 0.}, {-0.05, 0.4166666666666665}, {-0.05, 
           0.833333333333333}, {-0.05, 1.2499999999999996`}, {-0.05, 
           1.666666666666666}, {-0.05, 2.083333333333333}, {-0.05, 
           2.5}, {-0.05, 2.5}, {-0.05, 2.0833333333333335`}, {-0.05, 
           1.6666666666666667`}, {-0.05, 1.25}, {-0.05, 
           0.8333333333333335}, {-0.05, 0.41666666666666696`}, {-0.05, 
           0.}, {-0.05, -0.4166666666666665}, {-0.05, -0.833333333333333}, \
{-0.05, -1.2499999999999996`}, {-0.05, -1.666666666666666}, {-0.05, \
-2.083333333333333}, {-0.05, -2.5}, {-0.05, -2.5}}}]}, \
$CellContext`staticpolygons14230200811523132845095$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{-0.05, -5.}, {-0.05, -4.791666666666667}, {-0.05, \
-4.583333333333333}, {-0.05, -4.375}, {-0.05, -4.166666666666667}, {-0.05, \
-3.9583333333333335`}, {-0.05, -3.75}, {-0.05, -3.541666666666667}, {-0.05, \
-3.3333333333333335`}, {-0.05, -3.125}, {-0.05, -2.916666666666667}, {-0.05, \
-2.7083333333333335`}, {-0.05, -2.5}, {-0.05, -2.5}, {-0.05, \
-2.7083333333333335`}, {-0.05, -2.9166666666666665`}, {-0.05, -3.125}, \
{-0.05, -3.333333333333333}, {-0.05, -3.5416666666666665`}, {-0.05, -3.75}, \
{-0.05, -3.958333333333333}, {-0.05, -4.166666666666666}, {-0.05, -4.375}, \
{-0.05, -4.583333333333333}, {-0.05, -4.791666666666666}, {-0.05, -5.}, \
{-0.05, -5.}}, {{-0.05, 2.5}, {-0.05, 2.7083333333333335`}, {-0.05, 
           2.9166666666666665`}, {-0.05, 3.125}, {-0.05, 
           3.333333333333333}, {-0.05, 3.5416666666666665`}, {-0.05, 
           3.75}, {-0.05, 3.958333333333333}, {-0.05, 
           4.166666666666666}, {-0.05, 4.375}, {-0.05, 
           4.583333333333333}, {-0.05, 4.791666666666666}, {-0.05, 
           5.}, {-0.05, 5.}, {-0.05, 4.791666666666667}, {-0.05, 
           4.583333333333333}, {-0.05, 4.375}, {-0.05, 
           4.166666666666667}, {-0.05, 3.9583333333333335`}, {-0.05, 
           3.75}, {-0.05, 3.541666666666667}, {-0.05, 
           3.3333333333333335`}, {-0.05, 3.125}, {-0.05, 
           2.916666666666667}, {-0.05, 2.7083333333333335`}, {-0.05, 
           2.5}, {-0.05, 
           2.5}}}]}, $CellContext`staticpolygons15230200811523132847446$$ = \
{}, $CellContext`staticpolygons16230200811523132852836$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{1.3689976525819987`, -5.65}, {
           0.9852549276396352, -4.708333333333334}, {
           0.6511727483615684, -3.766666666666667}, {
           0.3764030171799524, -2.825}, {
           0.17082082737962523`, -1.8833333333333337`}, {
           0.043271803862861, -0.9416666666666673}, {0., 0.}, {
           0.04327180386286091, 0.9416666666666664}, {0.17082082737962506`, 
           1.8833333333333329`}, {0.3764030171799522, 2.8249999999999993`}, {
           0.6511727483615678, 3.7666666666666657`}, {0.9852549276396345, 
           4.708333333333332}, {1.3689976525819987`, 5.65}, {
           1.3689976525819987`, 5.65}, {0.9852549276396352, 
           4.708333333333334}, {0.6511727483615684, 3.766666666666667}, {
           0.3764030171799524, 2.825}, {0.17082082737962523`, 
           1.8833333333333337`}, {0.043271803862861, 0.9416666666666673}, {0.,
            0.}, {0.04327180386286091, -0.9416666666666664}, {
           0.17082082737962506`, -1.8833333333333329`}, {
           0.3764030171799522, -2.8249999999999993`}, {
           0.6511727483615678, -3.7666666666666657`}, {
           0.9852549276396345, -4.708333333333332}, {
           1.3689976525819987`, -5.65}, {
           1.3689976525819987`, -5.65}}}]}, \
$CellContext`staticpolygons17230200811523132856751$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{1.3397916666666667`, -5.65}, {
           2.1526331018518516`, -4.708333333333334}, {
           2.817685185185185, -3.766666666666667}, {
           3.3349479166666667`, -2.825}, {
           3.7044212962962964`, -1.8833333333333337`}, {
           3.926105324074074, -0.9416666666666673}, {4., 0.}, {
           3.926105324074074, 0.9416666666666664}, {3.7044212962962964`, 
           1.8833333333333329`}, {3.334947916666667, 2.8249999999999993`}, {
           2.817685185185186, 3.7666666666666657`}, {2.152633101851853, 
           4.708333333333332}, {1.3397916666666667`, 5.65}, {
           1.3397916666666667`, 5.65}, {2.1526331018518516`, 
           4.708333333333334}, {2.817685185185185, 3.766666666666667}, {
           3.3349479166666667`, 2.825}, {3.7044212962962964`, 
           1.8833333333333337`}, {3.926105324074074, 0.9416666666666673}, {4.,
            0.}, {3.926105324074074, -0.9416666666666664}, {
           3.7044212962962964`, -1.8833333333333329`}, {
           3.334947916666667, -2.8249999999999993`}, {
           2.817685185185186, -3.7666666666666657`}, {
           2.152633101851853, -4.708333333333332}, {
           1.3397916666666667`, -5.65}, {
           1.3397916666666667`, -5.65}}}]}, \
$CellContext`staticpolygons18230200811523132905507$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          Line[CompressedData["
1:eJxd1F9I01EUB/DNSZHswXBmxLCttWmEbboZWNnvW5D9oWS68CHWy2pRFiQW
FGtBaCMwIiKoBwkKi3owCdIYQ/gdxV4ifEnQIKgIRqCF0p8nobbfvb+X74X7
MO7vnnPuOR/mT13sTrscDoeztBOlXVHaD/qfFTvmtuBMeRUbZLU7VfujtxGe
sYNfM+Mhqcper9h2eDum/zQm7w4E5XPvk+H0+Sb0tVfNj8S3ytXUMe/tYBj1
ucWufH1ArjVVDs4cjeB9eS355UR8LvRwKYJMOWDBJwuOj87hK80ofZxbXL9Z
JnbH7/SsNONlKZ1nzCuzrnf5vckWrJsf6Ws/skl+7ly+7y20IG3VVye7FoYG
OtxRTFn11Mq+0ZNPpxNRnb9GcueGHiXvRXW+avnQeWH59dsoRq34bulpfTN5
YCWK01a8tXKqMjR4yROD17rvksfZtuKtcAwvrO9XTX+g1VnYH8NG6/yX6U/8
ngh3xlBt/f5mPv9+aMe/rhgc1vqyxz6PqHPDvt+o7ht2/LyKb9j5fSo/7PrO
qvpg1/9K1Y+b+n1Z9T5Av1/dr0Gb7s+M6g/s/ql4dbD761b9xbjuv4rvhT2f
42o+sOen8vmQ0fOdVfPFZT1/lT+AT9pHv/KBNdqPqieIv9rXBuULN7Q/VV8D
yCPII8gjyCPII8gjyCPII8gjyCPII8gjyCPII8gjyCPII8ijQR4N8miQx0ny
aJJHkzya5FHIo5BHIY9CHoU8CnkU8ijkUcijkEchj0IehTwKeRTyKORR+P/x
P4VLPns=
           
           "]]}, $CellContext`staticpolygons2123020081152326925122$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{-0.654121133468629, -6.25, 
            0.}, {-1.6633250356081046`, -5.208333333333334, 
            0.}, {-2.407409854982819, -4.166666666666667, 
            0.}, {-2.9470796165773505`, -3.1250000000000004`, 
            0.}, {-3.3150010468778817`, -2.083333333333334, 
            0.}, {-3.5294851698846217`, -1.0416666666666679`, 
            0.}, {-3.5999999999999996`, -8.881784197001252*^-16, 
            0.}, {-3.529485169884622, 1.041666666666666, 
            0.}, {-3.315001046877882, 2.083333333333332, 
            0.}, {-2.947079616577352, 3.1249999999999982`, 
            0.}, {-2.40740985498282, 4.166666666666664, 
            0.}, {-1.6633250356081057`, 5.208333333333332, 
            0.}, {-0.6541211334686317, 6.249999999999998, 
            0.}, {-0.654121133468629, 6.25, 0.}, {-1.6633250356081046`, 
            5.208333333333334, 0.}, {-2.407409854982819, 4.166666666666667, 
            0.}, {-2.9470796165773505`, 3.1250000000000004`, 
            0.}, {-3.3150010468778817`, 2.083333333333334, 
            0.}, {-3.5294851698846217`, 1.0416666666666679`, 
            0.}, {-3.5999999999999996`, 8.881784197001252*^-16, 
            0.}, {-3.529485169884622, -1.041666666666666, 
            0.}, {-3.315001046877882, -2.083333333333332, 
            0.}, {-2.947079616577352, -3.1249999999999982`, 
            0.}, {-2.40740985498282, -4.166666666666664, 
            0.}, {-1.6633250356081057`, -5.208333333333332, 
            0.}, {-0.6541211334686317, -6.249999999999998, 
            0.}, {-0.654121133468629, -6.25, 0.}}, {{-0.654121133468629, 
            0., -6.25}, {-1.6633250356081046`, 
            0., -5.208333333333334}, {-2.407409854982819, 
            0., -4.166666666666667}, {-2.9470796165773505`, 
            0., -3.1250000000000004`}, {-3.3150010468778817`, 
            0., -2.083333333333334}, {-3.5294851698846217`, 
            0., -1.0416666666666679`}, {-3.5999999999999996`, 
            0., -8.881784197001252*^-16}, {-3.529485169884622, 0., 
            1.041666666666666}, {-3.315001046877882, 0., 
            2.083333333333332}, {-2.947079616577352, 0., 
            3.1249999999999982`}, {-2.40740985498282, 0., 
            4.166666666666664}, {-1.6633250356081057`, 0., 
            5.208333333333332}, {-0.6541211334686317, 0., 
            6.249999999999998}, {-0.654121133468629, 0., 
            6.25}, {-1.6633250356081046`, 0., 
            5.208333333333334}, {-2.407409854982819, 0., 
            4.166666666666667}, {-2.9470796165773505`, 0., 
            3.1250000000000004`}, {-3.3150010468778817`, 0., 
            2.083333333333334}, {-3.5294851698846217`, 0., 
            1.0416666666666679`}, {-3.5999999999999996`, 0., 
            8.881784197001252*^-16}, {-3.529485169884622, 
            0., -1.041666666666666}, {-3.315001046877882, 
            0., -2.083333333333332}, {-2.947079616577352, 
            0., -3.1249999999999982`}, {-2.40740985498282, 
            0., -4.166666666666664}, {-1.6633250356081057`, 
            0., -5.208333333333332}, {-0.6541211334686317, 
            0., -6.249999999999998}, {-0.654121133468629, 
            0., -6.25}}, CompressedData["
1:eJxdlN8rg1Ecxt+IuFGMbEhR+wOURMkON+OCIgw1lpo7IT9uVrtyb0wuyK07
v4pso5ziYtpqLrZaTS1hLQl3kvw+z7PaOfX21tOz532+n/NtDZMzA+4CwzCa
fp/C3yec9MytPN+fG//HIgycKPTgYbjLdmUW7r7a7GvNoy0OvTtxkH6ymkVn
aNF7eftuY86EN90WN1eLoYXWitHGQkE987Fc5NupQn5pTvdX3tQtJUyi7mVk
3jpbJpLQT6ZM0rNbLgJ4018P3xp+R70AuQ/4DvVh9GAvzmVHb85BfRpzcm7m
RGKx/S3/aTs5UR9T/vMQ/OTTofJznKj3qz5S7/P1/XdKZEbrb1HzynXMq/GR
Op9V5ZMN4HQN/U7lyiKNP3pIBzhF8+9X9mj3Cy7SC07a/kjFKdJOHVykA5yY
34P8FnCi7kKfPnCK5u+P/AQn5oOLJCf6Q+BzjDf94CLJiXyKFRdJTtSd6OFE
L+Y40NuOOejfxJwBzE1/MpW6ONqLn5ETew6CIzlRbwZ3cqLei3tyaX3eFBeR
RX/qJuzBBuYN5++PCIIP833Ys0Zw0vZHkBP94CLGwYn54CJGwIk54CK2wUn/
/1H7kzr7ASJqdIk=
            
            "]}]}, $CellContext`staticpolygons2223020081152326930050$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{-0.7033119314590373, -5., 
            0.}, {-1.538876515698588, -4.166666666666667, 
            0.}, {-2.1302230142610687`, -3.3333333333333335`, 
            0.}, {-2.55, -2.5, 0.}, {-2.8326922749902543`, -1.666666666666667,
             0.}, {-2.9963598686045723`, -0.8333333333333339, 0.}, {-3.05, 0.,
             0.}, {-2.9963598686045723`, 0.833333333333333, 
            0.}, {-2.8326922749902543`, 1.666666666666666, 
            0.}, {-2.5500000000000007`, 2.499999999999999, 
            0.}, {-2.1302230142610696`, 3.333333333333332, 
            0.}, {-1.5388765156985889`, 4.166666666666666, 
            0.}, {-0.7033119314590373, 5., 0.}, {-0.7033119314590373, 5., 
            0.}, {-1.538876515698588, 4.166666666666667, 
            0.}, {-2.1302230142610687`, 3.3333333333333335`, 0.}, {-2.55, 2.5,
             0.}, {-2.8326922749902543`, 1.666666666666667, 
            0.}, {-2.9963598686045723`, 0.8333333333333339, 0.}, {-3.05, 0., 
            0.}, {-2.9963598686045723`, -0.833333333333333, 
            0.}, {-2.8326922749902543`, -1.666666666666666, 
            0.}, {-2.5500000000000007`, -2.499999999999999, 
            0.}, {-2.1302230142610696`, -3.333333333333332, 
            0.}, {-1.5388765156985889`, -4.166666666666666, 
            0.}, {-0.7033119314590373, -5., 0.}, {-0.7033119314590373, -5., 
            0.}}, {{-0.7033119314590373, 0., -5.}, {-1.538876515698588, 
            0., -4.166666666666667}, {-2.1302230142610687`, 
            0., -3.3333333333333335`}, {-2.55, 
            0., -2.5}, {-2.8326922749902543`, 
            0., -1.666666666666667}, {-2.9963598686045723`, 
            0., -0.8333333333333339}, {-3.05, 0., 0.}, {-2.9963598686045723`, 
            0., 0.833333333333333}, {-2.8326922749902543`, 0., 
            1.666666666666666}, {-2.5500000000000007`, 0., 
            2.499999999999999}, {-2.1302230142610696`, 0., 
            3.333333333333332}, {-1.5388765156985889`, 0., 
            4.166666666666666}, {-0.7033119314590373, 0., 
            5.}, {-0.7033119314590373, 0., 5.}, {-1.538876515698588, 0., 
            4.166666666666667}, {-2.1302230142610687`, 0., 
            3.3333333333333335`}, {-2.55, 0., 2.5}, {-2.8326922749902543`, 0.,
             1.666666666666667}, {-2.9963598686045723`, 0., 
            0.8333333333333339}, {-3.05, 0., 0.}, {-2.9963598686045723`, 
            0., -0.833333333333333}, {-2.8326922749902543`, 
            0., -1.666666666666666}, {-2.5500000000000007`, 
            0., -2.499999999999999}, {-2.1302230142610696`, 
            0., -3.333333333333332}, {-1.5388765156985889`, 
            0., -4.166666666666666}, {-0.7033119314590373, 
            0., -5.}, {-0.7033119314590373, 0., -5.}}, CompressedData["
1:eJxdk8srhGEUxj8GuZVrykq2iExKpLyl3KJcNi4bpuwYC0VYSFmIZDul+RdM
inGZYV6XJBtEoixcJrehLBQrDO/zfOW89fXVrzPne87vPZPvGmzri7UsqzT6
OKLPdW56wvTkfcj6O9nKwiHv3T5dcJ5lqamUhvau23A1+cDIXNNMa5YqO/go
9S6/27zJM9FbM5apgu1dLd3eL5tHSspPUtsy0D9Oka+9FhW/BdLUXcfY/Gpn
os1DyXnWfn2q0niTh1Hnx+/IY9D3Gd8h30QO5noEr0DufszB+hnMybnJk4Yu
Q740fxU9kY+b+pBL1DtNf9sTud/ksT2Rf33/HoeOiPw3Zl69LuaFHy39rJg6
/SB8Ppm+Ok74Rw69BU/0Ay+6UtwvvGiP2Ad40cbTfhU5vOhReCJ3o38hPJE3
I48Pni7AX5Cfnli/gXnpiXwPfgJ4k8OLpifyeONF0xP5AXI0Ihd5LXLTE/ki
5uzB3HZ9zt3R7uxxkJ7Ih+HRJeoL4N0t++OemkWeT+NFvYr8V9iDTTHvFvZm
R/hZxp49Cp/wouiJHF7UITxd/98fVSfuF17UktgH/q/M/pwHfwCgXQqn
            
            "]}]}, $CellContext`staticpolygons2323020081152326934944$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{-0.05, -2.5, 0.}, {-0.05, -2.0833333333333335`, 
            0.}, {-0.05, -1.6666666666666667`, 0.}, {-0.05, -1.25, 
            0.}, {-0.05, -0.8333333333333335, 
            0.}, {-0.05, -0.41666666666666696`, 0.}, {-0.05, 0., 0.}, {-0.05, 
            0.4166666666666665, 0.}, {-0.05, 0.833333333333333, 0.}, {-0.05, 
            1.2499999999999996`, 0.}, {-0.05, 1.666666666666666, 0.}, {-0.05, 
            2.083333333333333, 0.}, {-0.05, 2.5, 0.}, {-0.05, 2.5, 
            0.}, {-0.05, 2.0833333333333335`, 0.}, {-0.05, 
            1.6666666666666667`, 0.}, {-0.05, 1.25, 0.}, {-0.05, 
            0.8333333333333335, 0.}, {-0.05, 0.41666666666666696`, 
            0.}, {-0.05, 0., 0.}, {-0.05, -0.4166666666666665, 
            0.}, {-0.05, -0.833333333333333, 
            0.}, {-0.05, -1.2499999999999996`, 
            0.}, {-0.05, -1.666666666666666, 0.}, {-0.05, -2.083333333333333, 
            0.}, {-0.05, -2.5, 0.}, {-0.05, -2.5, 0.}}, {{-0.05, 
            0., -2.5}, {-0.05, 0., -2.0833333333333335`}, {-0.05, 
            0., -1.6666666666666667`}, {-0.05, 0., -1.25}, {-0.05, 
            0., -0.8333333333333335}, {-0.05, 
            0., -0.41666666666666696`}, {-0.05, 0., 0.}, {-0.05, 0., 
            0.4166666666666665}, {-0.05, 0., 0.833333333333333}, {-0.05, 0., 
            1.2499999999999996`}, {-0.05, 0., 1.666666666666666}, {-0.05, 0., 
            2.083333333333333}, {-0.05, 0., 2.5}, {-0.05, 0., 2.5}, {-0.05, 
            0., 2.0833333333333335`}, {-0.05, 0., 
            1.6666666666666667`}, {-0.05, 0., 1.25}, {-0.05, 0., 
            0.8333333333333335}, {-0.05, 0., 0.41666666666666696`}, {-0.05, 
            0., 0.}, {-0.05, 0., -0.4166666666666665}, {-0.05, 
            0., -0.833333333333333}, {-0.05, 
            0., -1.2499999999999996`}, {-0.05, 
            0., -1.666666666666666}, {-0.05, 0., -2.083333333333333}, {-0.05, 
            0., -2.5}, {-0.05, 0., -2.5}}, CompressedData["
1:eJxdkzlIA1EURSdGCxewsxVbFSUiiCJkQHAjAZfGpdGAnUshKMbCxkoR26jY
CjYGIcYlifNdELERMY1g4wKuEUHBFGKM/nt/8T4MA4eXl/vOf1MWGOsayrEs
y5N93NlneenvrDvW/8m1LRzywYPLlZqk254tbOvuu016yUcmF3xznW679vTL
sxq5N9wXmhlsCubY8e6+jv7VN8Nfqusuirpc6P9p+E6qsuo9lvHe9QQXt3vT
hjsFpdZJ67dX4U1+j7oofkfuQt9n/A95AjmYi7weuYcxB/kc5uTc5PnjV064
eK2Rnsindb0TEPU1ur/xRB7VeRyZ5yfzdz6MJ/IbPa+zK+aFH0f62dJ1zoPw
+aT7qlzhHznUvrgveFEN4n7hRYXEPsCL0p6ijeTwoqbgiXwU/SvgidyPPGF4
In9Ffnoi38O89ER+DD8xvMnhxXgiz9NejCfyU+RoRy7yZuSmJ/INzDmAuU19
yd350byK0xP5BDwGRH05vI/K/rgnv8iT1l68KZH/GnuQEPPuY28OhZ8I9uxR
+IQXm57I4cU+E/fF76pF3C+82JtiH/hd6f05if8CUaliEQ==
            
            "]}]}, $CellContext`staticpolygons2423020081152326944061$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{-0.05, -5., 0.}, {-0.05, -4.791666666666667, 
            0.}, {-0.05, -4.583333333333333, 0.}, {-0.05, -4.375, 
            0.}, {-0.05, -4.166666666666667, 
            0.}, {-0.05, -3.9583333333333335`, 0.}, {-0.05, -3.75, 
            0.}, {-0.05, -3.541666666666667, 
            0.}, {-0.05, -3.3333333333333335`, 0.}, {-0.05, -3.125, 
            0.}, {-0.05, -2.916666666666667, 
            0.}, {-0.05, -2.7083333333333335`, 0.}, {-0.05, -2.5, 
            0.}, {-0.05, -2.5, 0.}, {-0.05, -2.7083333333333335`, 
            0.}, {-0.05, -2.9166666666666665`, 0.}, {-0.05, -3.125, 
            0.}, {-0.05, -3.333333333333333, 
            0.}, {-0.05, -3.5416666666666665`, 0.}, {-0.05, -3.75, 
            0.}, {-0.05, -3.958333333333333, 0.}, {-0.05, -4.166666666666666, 
            0.}, {-0.05, -4.375, 0.}, {-0.05, -4.583333333333333, 
            0.}, {-0.05, -4.791666666666666, 0.}, {-0.05, -5., 
            0.}, {-0.05, -5., 0.}}, {{-0.05, 2.5, 0.}, {-0.05, 
            2.7083333333333335`, 0.}, {-0.05, 2.9166666666666665`, 
            0.}, {-0.05, 3.125, 0.}, {-0.05, 3.333333333333333, 0.}, {-0.05, 
            3.5416666666666665`, 0.}, {-0.05, 3.75, 0.}, {-0.05, 
            3.958333333333333, 0.}, {-0.05, 4.166666666666666, 0.}, {-0.05, 
            4.375, 0.}, {-0.05, 4.583333333333333, 0.}, {-0.05, 
            4.791666666666666, 0.}, {-0.05, 5., 0.}, {-0.05, 5., 0.}, {-0.05, 
            4.791666666666667, 0.}, {-0.05, 4.583333333333333, 0.}, {-0.05, 
            4.375, 0.}, {-0.05, 4.166666666666667, 0.}, {-0.05, 
            3.9583333333333335`, 0.}, {-0.05, 3.75, 0.}, {-0.05, 
            3.541666666666667, 0.}, {-0.05, 3.3333333333333335`, 0.}, {-0.05, 
            3.125, 0.}, {-0.05, 2.916666666666667, 0.}, {-0.05, 
            2.7083333333333335`, 0.}, {-0.05, 2.5, 0.}, {-0.05, 2.5, 
            0.}}, {{-0.05, 0., -5.}, {-0.05, 0., -4.791666666666667}, {-0.05, 
            0., -4.583333333333333}, {-0.05, 0., -4.375}, {-0.05, 
            0., -4.166666666666667}, {-0.05, 
            0., -3.9583333333333335`}, {-0.05, 0., -3.75}, {-0.05, 
            0., -3.541666666666667}, {-0.05, 
            0., -3.3333333333333335`}, {-0.05, 0., -3.125}, {-0.05, 
            0., -2.916666666666667}, {-0.05, 
            0., -2.7083333333333335`}, {-0.05, 0., -2.5}, {-0.05, 
            0., -2.5}, {-0.05, 0., -2.7083333333333335`}, {-0.05, 
            0., -2.9166666666666665`}, {-0.05, 0., -3.125}, {-0.05, 
            0., -3.333333333333333}, {-0.05, 
            0., -3.5416666666666665`}, {-0.05, 0., -3.75}, {-0.05, 
            0., -3.958333333333333}, {-0.05, 0., -4.166666666666666}, {-0.05, 
            0., -4.375}, {-0.05, 0., -4.583333333333333}, {-0.05, 
            0., -4.791666666666666}, {-0.05, 0., -5.}, {-0.05, 
            0., -5.}}, {{-0.05, 0., 2.5}, {-0.05, 0., 
            2.7083333333333335`}, {-0.05, 0., 2.9166666666666665`}, {-0.05, 
            0., 3.125}, {-0.05, 0., 3.333333333333333}, {-0.05, 0., 
            3.5416666666666665`}, {-0.05, 0., 3.75}, {-0.05, 0., 
            3.958333333333333}, {-0.05, 0., 4.166666666666666}, {-0.05, 0., 
            4.375}, {-0.05, 0., 4.583333333333333}, {-0.05, 0., 
            4.791666666666666}, {-0.05, 0., 5.}, {-0.05, 0., 5.}, {-0.05, 0., 
            4.791666666666667}, {-0.05, 0., 4.583333333333333}, {-0.05, 0., 
            4.375}, {-0.05, 0., 4.166666666666667}, {-0.05, 0., 
            3.9583333333333335`}, {-0.05, 0., 3.75}, {-0.05, 0., 
            3.541666666666667}, {-0.05, 0., 3.3333333333333335`}, {-0.05, 0., 
            3.125}, {-0.05, 0., 2.916666666666667}, {-0.05, 0., 
            2.7083333333333335`}, {-0.05, 0., 2.5}, {-0.05, 0., 
            2.5}}, CompressedData["
1:eJxdkzlIA1EURSdGCxewsxVbFSUiiCJkQHAjAZfGpdGAnUshKMbCxkoR26jY
CjYGIcYlifNdELERMY1g4wKuEUHBFGKM/nt/8T4MA4eXl/vOf1MWGOsayrEs
y5N93NlneenvrDvW/8m1LRzywYPLlZqk254tbOvuu016yUcmF3xznW679vTL
sxq5N9wXmhlsCubY8e6+jv7VN8Nfqusuirpc6P9p+E6qsuo9lvHe9QQXt3vT
hjsFpdZJ67dX4U1+j7oofkfuQt9n/A95AjmYi7weuYcxB/kc5uTc5PnjV064
eK2Rnsindb0TEPU1ur/xRB7VeRyZ5yfzdz6MJ/IbPa+zK+aFH0f62dJ1zoPw
+aT7qlzhHznUvrgveFEN4n7hRYXEPsCL0p6ijeTwoqbgiXwU/SvgidyPPGF4
In9Ffnoi38O89ER+DD8xvMnhxXgiz9NejCfyU+RoRy7yZuSmJ/INzDmAuU19
yd350byK0xP5BDwGRH05vI/K/rgnv8iT1l68KZH/GnuQEPPuY28OhZ8I9uxR
+IQXm57I4cU+E/fF76pF3C+82JtiH/hd6f05if8CUaliEQ==
            
            "], CompressedData["
1:eJxdk8srRGEYxg9GuUzJJVvZIhopkfKVcmummNkwNmbKzmWhCAsbK5KtS/MH
2JAa4zLD+VyaJhtEStm4lHtZKFau3/OcxfvV6dSvd9553t/3ntLwkL8v3bIs
z++T8fssLvydZdv6P0XKwiEP7Z0tVZ8XqqnctkDw5q6RfGB01jvdWahqUh+e
SPTd4d75yVDTeIFKBIIdPZEvhz9X1Z66/fno71Lkm68VlW/xPHXbNT630Z3l
cDunxEq2upXGm/wOdTH8jjwNfZ/wP+Q7yMFc5HXI3Y85yKcxJ+cmzx6+tFfz
Yg30RD5h6u2wqK82/R1P5DGTx5Z5vr7/ToZ+Fvmvzbx6S8wLP1r6WTd1+l74
fDR9tUv4Rw69K+4LXnS9uF940fNiH+BFG0/JBnJ40WPwRD6I/uXwRO5DnlV4
In9Bfnoi38a89ER+CD9xvMnhRdMTeabxoumJPIUc7chF3ozc9ES+gjl7MbdT
X3x7fDBzkqAn8hF4DIv6MngflP1xTz6R59N4Ua8i/xX2YEfMu4u92Rd+otiz
B+ETXhQ9kcOLOhL3xe+qRdwvvKg1sQ/8rsz+XCR+AHt0SEE=
            
            "]}]}, $CellContext`staticpolygons2523020081152326945592$$ = {}, \
$CellContext`staticpolygons2623020081152326970402$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{1.3689976525819987`, -5.65, 0.}, {
            0.9852549276396352, -4.708333333333334, 0.}, {
            0.6511727483615684, -3.766666666666667, 0.}, {
            0.3764030171799524, -2.825, 0.}, {
            0.17082082737962523`, -1.8833333333333337`, 0.}, {
            0.043271803862861, -0.9416666666666673, 0.}, {0., 0., 0.}, {
            0.04327180386286091, 0.9416666666666664, 0.}, {
            0.17082082737962506`, 1.8833333333333329`, 0.}, {
            0.3764030171799522, 2.8249999999999993`, 0.}, {0.6511727483615678,
             3.7666666666666657`, 0.}, {0.9852549276396345, 4.708333333333332,
             0.}, {1.3689976525819987`, 5.65, 0.}, {1.3689976525819987`, 5.65,
             0.}, {0.9852549276396352, 4.708333333333334, 0.}, {
            0.6511727483615684, 3.766666666666667, 0.}, {0.3764030171799524, 
            2.825, 0.}, {0.17082082737962523`, 1.8833333333333337`, 0.}, {
            0.043271803862861, 0.9416666666666673, 0.}, {0., 0., 0.}, {
            0.04327180386286091, -0.9416666666666664, 0.}, {
            0.17082082737962506`, -1.8833333333333329`, 0.}, {
            0.3764030171799522, -2.8249999999999993`, 0.}, {
            0.6511727483615678, -3.7666666666666657`, 0.}, {
            0.9852549276396345, -4.708333333333332, 0.}, {
            1.3689976525819987`, -5.65, 0.}, {1.3689976525819987`, -5.65, 
            0.}}, {{1.3689976525819987`, 0., -5.65}, {0.9852549276396352, 
            0., -4.708333333333334}, {0.6511727483615684, 
            0., -3.766666666666667}, {0.3764030171799524, 0., -2.825}, {
            0.17082082737962523`, 0., -1.8833333333333337`}, {
            0.043271803862861, 0., -0.9416666666666673}, {0., 0., 0.}, {
            0.04327180386286091, 0., 0.9416666666666664}, {
            0.17082082737962506`, 0., 1.8833333333333329`}, {
            0.3764030171799522, 0., 2.8249999999999993`}, {0.6511727483615678,
             0., 3.7666666666666657`}, {0.9852549276396345, 0., 
            4.708333333333332}, {1.3689976525819987`, 0., 5.65}, {
            1.3689976525819987`, 0., 5.65}, {0.9852549276396352, 0., 
            4.708333333333334}, {0.6511727483615684, 0., 3.766666666666667}, {
            0.3764030171799524, 0., 2.825}, {0.17082082737962523`, 0., 
            1.8833333333333337`}, {0.043271803862861, 0., 
            0.9416666666666673}, {0., 0., 0.}, {0.04327180386286091, 
            0., -0.9416666666666664}, {0.17082082737962506`, 
            0., -1.8833333333333329`}, {0.3764030171799522, 
            0., -2.8249999999999993`}, {0.6511727483615678, 
            0., -3.7666666666666657`}, {0.9852549276396345, 
            0., -4.708333333333332}, {1.3689976525819987`, 0., -5.65}, {
            1.3689976525819987`, 0., -5.65}}, CompressedData["
1:eJxdlD1IQmEYhW8FLg1hf1AR9DM0NRQtmeUH4mRWFFIRYQVCSNAUka1NjTaY
BtLPkmNNDpKfBtEWRENB9A9BUJRirRXfOYLvhcuFw7nvPef5Xm77wvJ4sNKy
rJ6/u+rv9rk6GkKvRVc89n81KgsX9fXT09XmxUbVnYzm52KvLurZrZOHlasG
5Vlb2jsK/pT0OZ9/s/exXu11pTwtwxVqBHoh92KFI3XKfMem6B+YqlyyfdjV
ROAi2bRRXdLv3s4+a79r1D2e1P3w8T3qO5ibx3eo7yMHc1H3IrdGD+p96Mne
1HuKmezTe8pJTtQ7jT8j/W4zP5MV8xMmj54XebZNfl0Q+cdMX+0UfcFHSz4O
49OTgueXmasTgj+46ANwog4uelicL3pqt9gHcNGG07lT+tvAifuQw3wnONG/
gDxxcPKV74+OghPnDKIvOdH/DD43eFIHF01O1Hcxl5yoHyJHALmoTyN3Bj2o
z6JnGL2pv/yM2kPHl2lyot5avm+lXg5wz4n54KLIif4IzrUo8nuxB0Oi7y32
5kHw6ceeTQue4KLIiTq4qKQ4L3BRM+J8wUUFwEn+f8z+XKd/AdLmInA=
            
            "]}]}, $CellContext`staticpolygons2723020081152326975689$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{1.3397916666666667`, -5.65, 0.}, {
            2.1526331018518516`, -4.708333333333334, 0.}, {
            2.817685185185185, -3.766666666666667, 0.}, {
            3.3349479166666667`, -2.825, 0.}, {
            3.7044212962962964`, -1.8833333333333337`, 0.}, {
            3.926105324074074, -0.9416666666666673, 0.}, {4., 0., 0.}, {
            3.926105324074074, 0.9416666666666664, 0.}, {3.7044212962962964`, 
            1.8833333333333329`, 0.}, {3.334947916666667, 2.8249999999999993`,
             0.}, {2.817685185185186, 3.7666666666666657`, 0.}, {
            2.152633101851853, 4.708333333333332, 0.}, {1.3397916666666667`, 
            5.65, 0.}, {1.3397916666666667`, 5.65, 0.}, {2.1526331018518516`, 
            4.708333333333334, 0.}, {2.817685185185185, 3.766666666666667, 
            0.}, {3.3349479166666667`, 2.825, 0.}, {3.7044212962962964`, 
            1.8833333333333337`, 0.}, {3.926105324074074, 0.9416666666666673, 
            0.}, {4., 0., 0.}, {3.926105324074074, -0.9416666666666664, 0.}, {
            3.7044212962962964`, -1.8833333333333329`, 0.}, {
            3.334947916666667, -2.8249999999999993`, 0.}, {
            2.817685185185186, -3.7666666666666657`, 0.}, {
            2.152633101851853, -4.708333333333332, 0.}, {
            1.3397916666666667`, -5.65, 0.}, {1.3397916666666667`, -5.65, 
            0.}}, {{1.3397916666666667`, 0., -5.65}, {2.1526331018518516`, 
            0., -4.708333333333334}, {2.817685185185185, 
            0., -3.766666666666667}, {3.3349479166666667`, 0., -2.825}, {
            3.7044212962962964`, 0., -1.8833333333333337`}, {
            3.926105324074074, 0., -0.9416666666666673}, {4., 0., 0.}, {
            3.926105324074074, 0., 0.9416666666666664}, {3.7044212962962964`, 
            0., 1.8833333333333329`}, {3.334947916666667, 0., 
            2.8249999999999993`}, {2.817685185185186, 0., 
            3.7666666666666657`}, {2.152633101851853, 0., 
            4.708333333333332}, {1.3397916666666667`, 0., 5.65}, {
            1.3397916666666667`, 0., 5.65}, {2.1526331018518516`, 0., 
            4.708333333333334}, {2.817685185185185, 0., 3.766666666666667}, {
            3.3349479166666667`, 0., 2.825}, {3.7044212962962964`, 0., 
            1.8833333333333337`}, {3.926105324074074, 0., 
            0.9416666666666673}, {4., 0., 0.}, {3.926105324074074, 
            0., -0.9416666666666664}, {3.7044212962962964`, 
            0., -1.8833333333333329`}, {3.334947916666667, 
            0., -2.8249999999999993`}, {2.817685185185186, 
            0., -3.7666666666666657`}, {2.152633101851853, 
            0., -4.708333333333332}, {1.3397916666666667`, 0., -5.65}, {
            1.3397916666666667`, 0., -5.65}}, CompressedData["
1:eJxdlE8og2Ecx1+Ui4P8WyFFDi6zkIt52VNy2kS0kDRWK2m1k4SrkyOFTcmf
ix05Ocj7bCtxUnKg5O9KKWJrdnEwPd+vep+33t769t33+f4+z681BSPDoWLD
MNoLb0nhbVv/CV5Ecp5Y9O9xCAOPC/pSKjVfN+MQrfGNzFT01UM9sXb6OHdd
I/oXwruHobyHOVMD/pWOp2qx23LcX+8rEk7o2WTaWFytEuqcUkF/91hxuPSj
QowELuO1y2WC+fdvZ5+V3+XiAV/qfvj4O+ZsITeDc6jvoQd7Ufeit8QczO/E
nJyb/vaclXh+PzbJiXqz8lv0M6dP5VsJLX9b9ZHT6EN9U/WXWa3/kJpXmphX
4yN1Pm7lk6PgxJwvlSu3wcllvy+5D070g4v0gZO2D7IPnLT9kYrTudmm+RvB
ifuQRL4JTtSD6BMDJ5d9f+QGONHfg3nJiee+gM8tvswBF0lOzNlBLjkx5wA9
AuhFfRy9LcxBfRJzLmJu6un8YMXs0dUJOVFvsO/bfx83uJMTdXAR5ER9Ffea
0/p7sQe9mJf6HfbmUePThT0bByenfX8EOdEPLiKu3Re4iAlw4rngIgLgpP//
qP25OfkF985g7Q==
            
            "]}]}, $CellContext`staticpolygons2823020081152327012047$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          Line[{CompressedData["
1:eJx11V1Ik1Ecx/HppEh2YThfiAfbWpsLsU03AyvrX5C9UDJdeBHrZrUwCxIL
irUgtBEYERHUhQSFRV2YBGmMIaRiNxHeJGgQVAQj0ELp5Uqo7Tnn+QU/6YFd
7MPDec45z/lu7vi5jkSxzWaL5j/2/Odu7+Nc6+wmOVW4crUTNn2tdMQrvnX7
xTmy/3Ny1AcvTV0p3nKwTqZ++WO3+rzwj90PBxNn6qWnpXRuKLIZfil+xLjh
DUhNeqE9U+OBX64v6Z8+HJS3hWvRDT8WmfXdWwxKsvDgrAs+b3tfNHixQfKD
pBfWb4SP7Yjc7FxukGf5aTpHDPiM/U1mV6xR1s0N9bQc2gD/vm3pjpFtlIS5
3ir49vmBvlZHSCbNdVXA9wwffzQVDen5l8PTpwfux26H9DzL4O/azi69eB2S
YXM+Dnhn08vxfcshOWk+dy38RImv/7wzLIY5vh3+INWcux4Iy1NznJVXlrs9
TUXZvWGpNu//8c+jP8cCbWEpM/0L/MnXA1v/tIdFffu0k+8Pqvt38/h+NT7c
mk9GzQduzd+l5i+83i61Xri1P8/V/sCv6f1Mqf2Ei95/NX45vFm/r2n1vuDW
+1XPrYJb58GhzgN8VJ8fNR8Dbp23o+q8wa3zqebpgif1eZ5R5xl+QZ9/NX8P
/IPupVf1Al+j+1Lr8sJ/6x4rVY/wq7pftd5aOHUNp67h1DWcuoZT13DqetW+
JWnfqGs4dQ2nruHUNZy6hlPXcOoaTl3DqWs4dQ2nrld1V03dUddw6nqc7w/S
7wB1Daeu4dT1BK+3i37HqGs4dQ2nruHUNZy6hlPXcOoaTl3DqWs4dQ2nruHU
NZy6hlPXcOoa/r//67+NQD56
            "], CompressedData["
1:eJx11V9IU1EcB/CrkyLZg+HUiIttrc1F2OyPgZXdX0H2h5LpwodYL6tFWZBY
UKwFoY3AiIigHiQoLOrBJEhjDOH+FHuJ8EVBg6AiGIEWSn+ehNru73APnMPv
wH35cjn3d875fc4NJC91psoNw4gXH0/xedj7vNA2uxEMMc6WRqEBVzqTNT+6
I27uGzn0NT0axsrMjfLNR7a4+eSfSOJeXwg/dz8dTF1odPOe1sq5odgmvJY8
bt4JRd28PrvQkasP4vXGiv6pY01u/qE0FgN4MjYbfrQo83Tpw3k/zhsfywav
bnPz4iTZhbUbcGxP7G7XssxfFcv0jZg47Xmf25fY7uZr5oZ6Wo+ux5+7lh6Y
eZmnnPXW4e75gb427w43n3DWVYP7h089m4zLnOqvxuz5gceJ+zKnOqtwpv3i
0pt3Mh926vFiV/Pb8YPLMj/jfHc1nq4I91/27XRz05nfg08yLYXbUZm/dOZZ
sQPB5rL8AZmvc97/ZQfiv8ei7TKvcvJv9ovvh7f+65A5jS971feb6H1LnT9C
81tqPTmqx1Lr91P9oK73HK0X1P15TfsDt5T9zNB+Aij7T/NXQ4tyXlN0XqCe
L323DtR+8FI/wKjSP1SPCWq/naB+A7U/qU4/pJV+nqZ+hitK/1P9QfikeOkl
L7BK8UXrCsFfxWMteYSbil9abwMwroFxDYxrYFwD4xoY19q+CdfaPgvXwLjW
zlG41s5duAbGNTCugXGt9a1wrfW5cA2Ma2Bca+6Ea4txbTGuxxnX2r0hXNuM
a5txrd1jwrV27wnXyLhGxjUyrrV7W7jW7nnhGhnX2n9EuNb+O8I1Mq6RcY2M
a2RcI+MaGdfI/a//AwmRPno=
            "], CompressedData["
1:eJx1l31M1WUUx2+QNLKYU1z2olxQuUKgWy2TlHgSzYTp7IJtTWxC6Gyr0bI0
/4D15lZqUH/kW3YdNsjZlqFYDkTOStbMSkUJYgkoC5Mxt1aTuWRGPd/vab+z
wcbYvjuce55zzuecc1PLKqJr40KhUO3ob/zo745X6gaevJDm1v37MxBxIfzE
oKft/+XCF5cirjOrv6s2oSeP9i/k99x873zEPXNj3LeNoWuqFw0d2zDSHHG5
SSVl4c3XVf/r5KQtEz+OuIsVn1bccXVE9YT0ojk/vxxxc++Phj6oj3PUM2te
nfZsbsT9+nrPnrynExzjuX5tc92h0GicT+26lfJnouqXOp7/6o+mdHd0uCP8
zda7XQ301hMtXY+9mO5KMuKrVm+boPpgRKYdTE53b9VXJrcXTFR90Xd33VvW
ONN90tHwcFJ8suqlXyaeerdwpjvTMXVy+ZHJqn92pu/DJd0z3G3nqyZkrLpH
9Wh9xqzTa2a42tzZvUdvTNE4o035b+T3TneD0YyeddX36XvDDeub+1dOd2W/
HVi+d8oDqldVV066fDLNzRqY81HTzqnqvybp87ZNWWlu2enhjZnjU9R+aXXb
333bU934gnMHs3LCqm986f3GkoGw/qVOO/4f/dMvP4f2jINxUWfcfAf1IbyT
76Z/5oV5oj3zWI+8Mm9nkfc1qAN11ikfdaP/t1FX1pn6avQB+4J+vkbfsI8Y
Txz6jH1H/SL6kn1KfR76mH1NvQ99Tw6oO3BCbqiXgCtyxjj7wSG5pP2iuUcW
3iz5fgE5pv0pb99q7Vd4/630Tz3Hx9Nq4+n28bfa+B/x7xW+l3nu9vmRB5Ef
xnNryX/5FJvPwz7/ctnkf5Wvl7Be9A9uxdZ3t+8HWYx+oJ+ffP8IOaZ9nO83
Yb9R3+f7U4rQn9Sv+H6WYvSz6X+x/Z/heRHyYvgS8sX8JHoepQA8Gn6F/NIe
3Mqdhvdq71eWk2PolT4OyTLzBHFLOTimXuTfKZxXZr7JfnDMz63zeZTbwTHj
BLdy1sxPzFvZa+Yt6irvgGP6P+H7QErBMXVwK8fAsdkXMuL7zu4X6QXHZh9J
ntlH6HvpB8f0D05kntl34ErKwbHZpxLODu5TcCue4+4F1n4IHFv/S8GxjScT
HMdM/J3g2L43BxxTB7fSBY7pZxj5HAbHtAe30gCOY6Zez4HjHaa+b4Jj6uBW
doFj6uBWfgTH1MGtYG+I9i36kxxTB7dCjqmnov9LwbHZv0KO+S5wK4XkGHoh
eCTH9LMJ/L6Gv/QDboUc6x0Fv9vxOfQPboUcUy8Pzh/1D24F+1ftY8H5pp87
Dnkkx9TPIe/kmH6wf4Uc034r6vo76qx1RB+wL6g3oW/I8Rj7Qu07gvtF9SeC
+0j1K8H9pfr84L7Td+0O7ke1z84O7FPVD69PeKilrf84OWb8PcF9rfYbgvtd
7SPBe0D19uD9oH4eDd4bqv+AuZaF/Og8xBwcNvk8hLlJjse4l9R+C+byVVPf
nZjji00/gFvleIx77//8Y6+sNP05gD1UbPoZ3CrHY9yrar8Ce7Ha8AVulWP6
AbfK8Rj3tvoBt67YzAdw62aDY/pJwd2w1swf3s1DZl7xLomZ+QZuXQI4ph/e
ze3gmP2QH/y+o/bg1m0Dx7RvwR1WZuY57+ZmM//N9zW7X1wnOGb8vCMXmn3E
u3PQ7C/eqY+DY/rhXbsPHNOed/D87OA+5d3s9+/g8X8Atd86pA==
            
            "]}]}, $CellContext`th$$ = 
        0., $CellContext`x$$ = -5., $CellContext`xoffth$$ = 
        0.5980074999999999, $CellContext`xth$$ = -4.4019925, $CellContext`y$$ = 
        0., $CellContext`yoffth$$ = 0., $CellContext`yth$$ = 0.}, 
      "ControllerVariables" :> {
        Hold[$CellContext`th$$, $CellContext`th$26494$$, 0], 
        Hold[$CellContext`x$$, $CellContext`x$26495$$, 0], 
        Hold[$CellContext`y$$, $CellContext`y$26496$$, 0], 
        Hold[$CellContext`focus$$, $CellContext`focus$26497$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Column[{
         Grid[{{
            OpenerView[{
              ToString[Optica`Optica`TopView], 
              Show[{
                Graphics[{{
                   Opacity[
                   0.8], $CellContext`staticpolygons11230200811523132827920$$,\
 $CellContext`staticpolygons12230200811523132833440$$, \
$CellContext`staticpolygons13230200811523132837510$$, \
$CellContext`staticpolygons14230200811523132845095$$, \
$CellContext`staticpolygons15230200811523132847446$$, \
$CellContext`staticpolygons16230200811523132852836$$, \
$CellContext`staticpolygons17230200811523132856751$$, \
$CellContext`staticpolygons18230200811523132905507$$, 
                   Opacity[1], 
                   RGBColor[
                   0.038747429704798886`, 0.9161617552424038, 
                    0.039847212269181365`], 
                   AbsoluteThickness[Medium], 
                   Line[
                    Dynamic[
                    Refresh[
                    Map[{
                    Part[#, {1, 2}], 
                    Part[#, {4, 5}]}& , 
                    Select[
                    $CellContext`raytracefunction1230200811523132919248[$\
CellContext`th$$, $CellContext`x$$, $CellContext`y$$, $CellContext`focus$$], 
                    And[Length[#] == 6, Part[#, 1] > -9.87654321*^8]& ]], 
                    TrackedSymbols :> {$CellContext`th$$, $CellContext`x$$, \
$CellContext`y$$, $CellContext`focus$$}], SynchronousUpdating -> True]], 
                   Arrowheads[Large], 
                   Thickness[Large], 
                   Dashing[{Small, Small}], 
                   RGBColor[1, 1, 0], 
                   Arrow[
                    Dynamic[If[
                    
                    Or[$CellContext`laststartposth$$ != {$CellContext`x$$, \
$CellContext`y$$}, $CellContext`lastth$$ =!= $CellContext`th$$], \
$CellContext`laststartposth$$ = {$CellContext`x$$, $CellContext`y$$}; \
$CellContext`lastth$$ = $CellContext`th$$; {$CellContext`xth$$, \
$CellContext`yth$$} = $CellContext`laststartposth$$ + $CellContext`radiusth$$ \
{
                    Cos[$CellContext`th$$ Degree], 
                    
                    Sin[$CellContext`th$$ 
                    Degree]}]; {$CellContext`laststartposth$$, \
{$CellContext`xth$$, $CellContext`yth$$}}, ({$CellContext`laststartposth$$, \
{$CellContext`xth$$, $CellContext`yth$$}} = #)& ]], 
                   Tooltip[
                    Locator[
                    Dynamic[BesselJ[1., 3.]; (If[
                    
                    Or[{$CellContext`xth$$, $CellContext`yth$$} != \
$CellContext`lastlocposth$$, $CellContext`lastth$$ != $CellContext`th$$], \
$CellContext`lastlocposth$$ = {$CellContext`xth$$, $CellContext`yth$$}; \
$CellContext`lastth$$ = $CellContext`th$$; {$CellContext`xth$$, \
$CellContext`yth$$} = $CellContext`laststartposth$$ + $CellContext`radiusth$$ \
{
                    Cos[$CellContext`th$$ Degree], 
                    
                    Sin[$CellContext`th$$ 
                    Degree]}]; {$CellContext`xth$$, $CellContext`yth$$}), \
({$CellContext`xth$$, $CellContext`yth$$} = #; $CellContext`xoffth$$ = \
$CellContext`xth$$ - $CellContext`x$$; $CellContext`yoffth$$ = \
$CellContext`yth$$ - $CellContext`y$$; $CellContext`radiusth$$ = 
                    Sqrt[$CellContext`xoffth$$^2 + $CellContext`yoffth$$^2]; \
$CellContext`th$$ = Chop[
                    ArcTan[$CellContext`xoffth$$, $CellContext`yoffth$$]/
                    Degree]; {$CellContext`xth$$, $CellContext`yth$$})& ], 
                    Graphics[{
                    RGBColor[1/3, 1/3, 1], 
                    Disk[{0, 0}, 0.5]}, ImageSize -> 10]], 
                    Dynamic[
                    StringJoin["th = ", 
                    ToString[$CellContext`th$$]]]], 
                   Tooltip[
                    Locator[
                    Dynamic[
                    BesselJ[
                    1., 3.]; {$CellContext`x$$, $CellContext`y$$}, \
({$CellContext`x$$, $CellContext`y$$} = Chop[#])& ], 
                    Graphics[{
                    RGBColor[1, 1/3, 1/3], 
                    Disk[{0, 0}, 0.8]}, ImageSize -> 10]], 
                    Dynamic[
                    StringJoin["{x, y} = ", 
                    ToString[
                    Chop[{$CellContext`x$$, $CellContext`y$$}]]]]]}}]}, {
               PlotLabel -> "Eye Model", ImageSize -> 400, ImageSize -> 800, 
                AspectRatio -> Automatic}]}, True], 
            OpenerView[{
              ToString[Optica`Optica`Full3D], 
              Show[{
                Graphics3D[{{
                   Opacity[
                   1], $CellContext`staticpolygons2123020081152326925122$$, \
$CellContext`staticpolygons2223020081152326930050$$, \
$CellContext`staticpolygons2323020081152326934944$$, \
$CellContext`staticpolygons2423020081152326944061$$, \
$CellContext`staticpolygons2523020081152326945592$$, \
$CellContext`staticpolygons2623020081152326970402$$, \
$CellContext`staticpolygons2723020081152326975689$$, \
$CellContext`staticpolygons2823020081152327012047$$, 
                   Opacity[1], 
                   RGBColor[
                   0.038747429704798886`, 0.9161617552424038, 
                    0.039847212269181365`], 
                   AbsoluteThickness[Medium], 
                   Line[
                    Dynamic[
                    Refresh[
                    Map[{
                    Part[#, {1, 2, 3}], 
                    Part[#, {4, 5, 6}]}& , 
                    Select[
                    $CellContext`raytracefunction223020081152327020446[$\
CellContext`th$$, $CellContext`x$$, $CellContext`y$$, $CellContext`focus$$], 
                    And[Length[#] == 6, Part[#, 1] > -9.87654321*^8]& ]], 
                    TrackedSymbols :> {$CellContext`th$$, $CellContext`x$$, \
$CellContext`y$$, $CellContext`focus$$}], SynchronousUpdating -> True]]}}]}, {
               PlotLabel -> None, ImageSize -> 400, ImageSize -> 800, 
                AspectRatio -> Automatic}]}, True]}}], 
         Tooltip[
          Row[{
            Style["", Italic, 10], 
            Hyperlink[
             Style["<< Crafted with Optica\[Trademark] >>", Italic, 10], 
             "http://www.opticasoftware.com"], 
            Style["", Italic, 10]}], 
          "Click here to visit www.opticasoftware.com"]}, Center], 
      "Specifications" :> {{{$CellContext`th$$, 0.}, -180., 180., ControlType -> 
         None}, {{$CellContext`x$$, -5.}, -10, -0.05, ControlType -> 
         None}, {{$CellContext`y$$, 0.}, -10, 10, ControlType -> 
         None}, {{$CellContext`focus$$, 0}, -10, 10, ControlType -> None}, 
        Style[
         Grid[{{"focus", 
            InputField[
             Dynamic[$CellContext`minfocus$$], Number, FieldSize -> 5], 
            Manipulator[
             
             Dynamic[$CellContext`\
nonexistantvariable1593230200811523213626529; $CellContext`focus$$, \
($CellContext`focus$$ = #)& ], {
              Dynamic[$CellContext`minfocus$$], 
              Dynamic[$CellContext`maxfocus$$]}, ImageSize -> 800], 
            InputField[
             Dynamic[$CellContext`maxfocus$$], Number, FieldSize -> 5], 
            
            Dynamic[$CellContext`nonexistantvariable1593230200811523213626529; \
$CellContext`focus$$, ($CellContext`focus$$ = #)& ]}}]], \
{{$CellContext`minfocus$$, -10}, ControlType -> 
         None}, {{$CellContext`maxfocus$$, 10}, ControlType -> 
         None}, {{$CellContext`minth$$, -180.}, ControlType -> 
         None}, {{$CellContext`maxth$$, 180.}, ControlType -> 
         None}, {{$CellContext`minx$$, -10}, ControlType -> 
         None}, {{$CellContext`maxx$$, -0.05}, ControlType -> 
         None}, {{$CellContext`miny$$, -10}, ControlType -> 
         None}, {{$CellContext`maxy$$, 10}, ControlType -> None}, 
        Button["Report", 
         Print[
          InputForm[
           StringJoin["SymbolicValues -> ", 
            ToString[
             MapThread[StringJoin[#, "->", 
               ToString[#2, InputForm]]& , {{
               "focus", "th", "x", 
                "y"}, {$CellContext`focus$$, $CellContext`th$$, \
$CellContext`x$$, $CellContext`y$$}}]]]]], ImageSize -> 
         Automatic], {{$CellContext`xth$$, -4.4019925}, ControlType -> 
         None}, {{$CellContext`yth$$, 0.}, ControlType -> 
         None}, {{$CellContext`radiusth$$, 0.5980074999999999}, ControlType -> 
         None}, {{$CellContext`xoffth$$, 0.5980074999999999}, ControlType -> 
         None}, {{$CellContext`yoffth$$, 0.}, ControlType -> 
         None}, {{$CellContext`laststartposth$$, {-5., 0.}}, ControlType -> 
         None}, {{$CellContext`lastlocposth$$, {-4.4019925, 0.}}, ControlType -> 
         None}, {{$CellContext`lastth$$, 0}, ControlType -> 
         None}, {{$CellContext`staticpolygons11230200811523132827920$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{-0.654121133468629, -6.25}, {-1.6633250356081046`, \
-5.208333333333334}, {-2.407409854982819, -4.166666666666667}, \
{-2.9470796165773505`, -3.1250000000000004`}, {-3.3150010468778817`, \
-2.083333333333334}, {-3.5294851698846217`, -1.0416666666666679`}, \
{-3.5999999999999996`, -8.881784197001252*^-16}, {-3.529485169884622, 
            1.041666666666666}, {-3.315001046877882, 
            2.083333333333332}, {-2.947079616577352, 
            3.1249999999999982`}, {-2.40740985498282, 
            4.166666666666664}, {-1.6633250356081057`, 
            5.208333333333332}, {-0.6541211334686317, 
            6.249999999999998}, {-0.654121133468629, 
            6.25}, {-1.6633250356081046`, 
            5.208333333333334}, {-2.407409854982819, 
            4.166666666666667}, {-2.9470796165773505`, 
            3.1250000000000004`}, {-3.3150010468778817`, 
            2.083333333333334}, {-3.5294851698846217`, 
            1.0416666666666679`}, {-3.5999999999999996`, 
            8.881784197001252*^-16}, {-3.529485169884622, \
-1.041666666666666}, {-3.315001046877882, -2.083333333333332}, \
{-2.947079616577352, -3.1249999999999982`}, {-2.40740985498282, \
-4.166666666666664}, {-1.6633250356081057`, -5.208333333333332}, \
{-0.6541211334686317, -6.249999999999998}, {-0.654121133468629, -6.25}}}]}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons12230200811523132833440$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{-0.7033119314590373, -5.}, {-1.538876515698588, \
-4.166666666666667}, {-2.1302230142610687`, -3.3333333333333335`}, {-2.55, \
-2.5}, {-2.8326922749902543`, -1.666666666666667}, {-2.9963598686045723`, \
-0.8333333333333339}, {-3.05, 0.}, {-2.9963598686045723`, 
            0.833333333333333}, {-2.8326922749902543`, 
            1.666666666666666}, {-2.5500000000000007`, 
            2.499999999999999}, {-2.1302230142610696`, 
            3.333333333333332}, {-1.5388765156985889`, 
            4.166666666666666}, {-0.7033119314590373, 
            5.}, {-0.7033119314590373, 5.}, {-1.538876515698588, 
            4.166666666666667}, {-2.1302230142610687`, 
            3.3333333333333335`}, {-2.55, 2.5}, {-2.8326922749902543`, 
            1.666666666666667}, {-2.9963598686045723`, 
            0.8333333333333339}, {-3.05, 
            0.}, {-2.9963598686045723`, -0.833333333333333}, \
{-2.8326922749902543`, -1.666666666666666}, {-2.5500000000000007`, \
-2.499999999999999}, {-2.1302230142610696`, -3.333333333333332}, \
{-1.5388765156985889`, -4.166666666666666}, {-0.7033119314590373, -5.}, \
{-0.7033119314590373, -5.}}}]}}, ControlType -> 
         None}, {{$CellContext`staticpolygons13230200811523132837510$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{-0.05, -2.5}, {-0.05, -2.0833333333333335`}, {-0.05, \
-1.6666666666666667`}, {-0.05, -1.25}, {-0.05, -0.8333333333333335}, {-0.05, \
-0.41666666666666696`}, {-0.05, 0.}, {-0.05, 0.4166666666666665}, {-0.05, 
            0.833333333333333}, {-0.05, 1.2499999999999996`}, {-0.05, 
            1.666666666666666}, {-0.05, 2.083333333333333}, {-0.05, 
            2.5}, {-0.05, 2.5}, {-0.05, 2.0833333333333335`}, {-0.05, 
            1.6666666666666667`}, {-0.05, 1.25}, {-0.05, 
            0.8333333333333335}, {-0.05, 0.41666666666666696`}, {-0.05, 
            0.}, {-0.05, -0.4166666666666665}, {-0.05, -0.833333333333333}, \
{-0.05, -1.2499999999999996`}, {-0.05, -1.666666666666666}, {-0.05, \
-2.083333333333333}, {-0.05, -2.5}, {-0.05, -2.5}}}]}}, ControlType -> 
         None}, {{$CellContext`staticpolygons14230200811523132845095$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{-0.05, -5.}, {-0.05, -4.791666666666667}, {-0.05, \
-4.583333333333333}, {-0.05, -4.375}, {-0.05, -4.166666666666667}, {-0.05, \
-3.9583333333333335`}, {-0.05, -3.75}, {-0.05, -3.541666666666667}, {-0.05, \
-3.3333333333333335`}, {-0.05, -3.125}, {-0.05, -2.916666666666667}, {-0.05, \
-2.7083333333333335`}, {-0.05, -2.5}, {-0.05, -2.5}, {-0.05, \
-2.7083333333333335`}, {-0.05, -2.9166666666666665`}, {-0.05, -3.125}, \
{-0.05, -3.333333333333333}, {-0.05, -3.5416666666666665`}, {-0.05, -3.75}, \
{-0.05, -3.958333333333333}, {-0.05, -4.166666666666666}, {-0.05, -4.375}, \
{-0.05, -4.583333333333333}, {-0.05, -4.791666666666666}, {-0.05, -5.}, \
{-0.05, -5.}}, {{-0.05, 2.5}, {-0.05, 2.7083333333333335`}, {-0.05, 
            2.9166666666666665`}, {-0.05, 3.125}, {-0.05, 
            3.333333333333333}, {-0.05, 3.5416666666666665`}, {-0.05, 
            3.75}, {-0.05, 3.958333333333333}, {-0.05, 
            4.166666666666666}, {-0.05, 4.375}, {-0.05, 
            4.583333333333333}, {-0.05, 4.791666666666666}, {-0.05, 
            5.}, {-0.05, 5.}, {-0.05, 4.791666666666667}, {-0.05, 
            4.583333333333333}, {-0.05, 4.375}, {-0.05, 
            4.166666666666667}, {-0.05, 3.9583333333333335`}, {-0.05, 
            3.75}, {-0.05, 3.541666666666667}, {-0.05, 
            3.3333333333333335`}, {-0.05, 3.125}, {-0.05, 
            2.916666666666667}, {-0.05, 2.7083333333333335`}, {-0.05, 
            2.5}, {-0.05, 2.5}}}]}}, ControlType -> 
         None}, {{$CellContext`staticpolygons15230200811523132847446$$, {}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons16230200811523132852836$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{1.3689976525819987`, -5.65}, {
            0.9852549276396352, -4.708333333333334}, {
            0.6511727483615684, -3.766666666666667}, {
            0.3764030171799524, -2.825}, {
            0.17082082737962523`, -1.8833333333333337`}, {
            0.043271803862861, -0.9416666666666673}, {0., 0.}, {
            0.04327180386286091, 0.9416666666666664}, {0.17082082737962506`, 
            1.8833333333333329`}, {0.3764030171799522, 2.8249999999999993`}, {
            0.6511727483615678, 3.7666666666666657`}, {0.9852549276396345, 
            4.708333333333332}, {1.3689976525819987`, 5.65}, {
            1.3689976525819987`, 5.65}, {0.9852549276396352, 
            4.708333333333334}, {0.6511727483615684, 3.766666666666667}, {
            0.3764030171799524, 2.825}, {0.17082082737962523`, 
            1.8833333333333337`}, {0.043271803862861, 0.9416666666666673}, {
            0., 0.}, {0.04327180386286091, -0.9416666666666664}, {
            0.17082082737962506`, -1.8833333333333329`}, {
            0.3764030171799522, -2.8249999999999993`}, {
            0.6511727483615678, -3.7666666666666657`}, {
            0.9852549276396345, -4.708333333333332}, {
            1.3689976525819987`, -5.65}, {1.3689976525819987`, -5.65}}}]}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons17230200811523132856751$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{1.3397916666666667`, -5.65}, {
            2.1526331018518516`, -4.708333333333334}, {
            2.817685185185185, -3.766666666666667}, {
            3.3349479166666667`, -2.825}, {
            3.7044212962962964`, -1.8833333333333337`}, {
            3.926105324074074, -0.9416666666666673}, {4., 0.}, {
            3.926105324074074, 0.9416666666666664}, {3.7044212962962964`, 
            1.8833333333333329`}, {3.334947916666667, 2.8249999999999993`}, {
            2.817685185185186, 3.7666666666666657`}, {2.152633101851853, 
            4.708333333333332}, {1.3397916666666667`, 5.65}, {
            1.3397916666666667`, 5.65}, {2.1526331018518516`, 
            4.708333333333334}, {2.817685185185185, 3.766666666666667}, {
            3.3349479166666667`, 2.825}, {3.7044212962962964`, 
            1.8833333333333337`}, {3.926105324074074, 0.9416666666666673}, {
            4., 0.}, {3.926105324074074, -0.9416666666666664}, {
            3.7044212962962964`, -1.8833333333333329`}, {
            3.334947916666667, -2.8249999999999993`}, {
            2.817685185185186, -3.7666666666666657`}, {
            2.152633101851853, -4.708333333333332}, {
            1.3397916666666667`, -5.65}, {1.3397916666666667`, -5.65}}}]}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons18230200811523132905507$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           Line[CompressedData["
1:eJxd1F9I01EUB/DNSZHswXBmxLCttWmEbboZWNnvW5D9oWS68CHWy2pRFiQW
FGtBaCMwIiKoBwkKi3owCdIYQ/gdxV4ifEnQIKgIRqCF0p8nobbfvb+X74X7
MO7vnnPuOR/mT13sTrscDoeztBOlXVHaD/qfFTvmtuBMeRUbZLU7VfujtxGe
sYNfM+Mhqcper9h2eDum/zQm7w4E5XPvk+H0+Sb0tVfNj8S3ytXUMe/tYBj1
ucWufH1ArjVVDs4cjeB9eS355UR8LvRwKYJMOWDBJwuOj87hK80ofZxbXL9Z
JnbH7/SsNONlKZ1nzCuzrnf5vckWrJsf6Ws/skl+7ly+7y20IG3VVye7FoYG
OtxRTFn11Mq+0ZNPpxNRnb9GcueGHiXvRXW+avnQeWH59dsoRq34bulpfTN5
YCWK01a8tXKqMjR4yROD17rvksfZtuKtcAwvrO9XTX+g1VnYH8NG6/yX6U/8
ngh3xlBt/f5mPv9+aMe/rhgc1vqyxz6PqHPDvt+o7ht2/LyKb9j5fSo/7PrO
qvpg1/9K1Y+b+n1Z9T5Av1/dr0Gb7s+M6g/s/ql4dbD761b9xbjuv4rvhT2f
42o+sOen8vmQ0fOdVfPFZT1/lT+AT9pHv/KBNdqPqieIv9rXBuULN7Q/VV8D
yCPII8gjyCPII8gjyCPII8gjyCPII8gjyCPII8gjyCPII8ijQR4N8miQx0ny
aJJHkzya5FHIo5BHIY9CHoU8CnkU8ijkUcijkEchj0IehTwKeRTyKORR+P/x
P4VLPns=
            "]]}}, ControlType -> 
         None}, {{$CellContext`staticpolygons2123020081152326925122$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{-0.654121133468629, -6.25, 
             0.}, {-1.6633250356081046`, -5.208333333333334, 
             0.}, {-2.407409854982819, -4.166666666666667, 
             0.}, {-2.9470796165773505`, -3.1250000000000004`, 
             0.}, {-3.3150010468778817`, -2.083333333333334, 
             0.}, {-3.5294851698846217`, -1.0416666666666679`, 
             0.}, {-3.5999999999999996`, -8.881784197001252*^-16, 
             0.}, {-3.529485169884622, 1.041666666666666, 
             0.}, {-3.315001046877882, 2.083333333333332, 
             0.}, {-2.947079616577352, 3.1249999999999982`, 
             0.}, {-2.40740985498282, 4.166666666666664, 
             0.}, {-1.6633250356081057`, 5.208333333333332, 
             0.}, {-0.6541211334686317, 6.249999999999998, 
             0.}, {-0.654121133468629, 6.25, 0.}, {-1.6633250356081046`, 
             5.208333333333334, 0.}, {-2.407409854982819, 4.166666666666667, 
             0.}, {-2.9470796165773505`, 3.1250000000000004`, 
             0.}, {-3.3150010468778817`, 2.083333333333334, 
             0.}, {-3.5294851698846217`, 1.0416666666666679`, 
             0.}, {-3.5999999999999996`, 8.881784197001252*^-16, 
             0.}, {-3.529485169884622, -1.041666666666666, 
             0.}, {-3.315001046877882, -2.083333333333332, 
             0.}, {-2.947079616577352, -3.1249999999999982`, 
             0.}, {-2.40740985498282, -4.166666666666664, 
             0.}, {-1.6633250356081057`, -5.208333333333332, 
             0.}, {-0.6541211334686317, -6.249999999999998, 
             0.}, {-0.654121133468629, -6.25, 0.}}, {{-0.654121133468629, 
             0., -6.25}, {-1.6633250356081046`, 
             0., -5.208333333333334}, {-2.407409854982819, 
             0., -4.166666666666667}, {-2.9470796165773505`, 
             0., -3.1250000000000004`}, {-3.3150010468778817`, 
             0., -2.083333333333334}, {-3.5294851698846217`, 
             0., -1.0416666666666679`}, {-3.5999999999999996`, 
             0., -8.881784197001252*^-16}, {-3.529485169884622, 0., 
             1.041666666666666}, {-3.315001046877882, 0., 
             2.083333333333332}, {-2.947079616577352, 0., 
             3.1249999999999982`}, {-2.40740985498282, 0., 
             4.166666666666664}, {-1.6633250356081057`, 0., 
             5.208333333333332}, {-0.6541211334686317, 0., 
             6.249999999999998}, {-0.654121133468629, 0., 
             6.25}, {-1.6633250356081046`, 0., 
             5.208333333333334}, {-2.407409854982819, 0., 
             4.166666666666667}, {-2.9470796165773505`, 0., 
             3.1250000000000004`}, {-3.3150010468778817`, 0., 
             2.083333333333334}, {-3.5294851698846217`, 0., 
             1.0416666666666679`}, {-3.5999999999999996`, 0., 
             8.881784197001252*^-16}, {-3.529485169884622, 
             0., -1.041666666666666}, {-3.315001046877882, 
             0., -2.083333333333332}, {-2.947079616577352, 
             0., -3.1249999999999982`}, {-2.40740985498282, 
             0., -4.166666666666664}, {-1.6633250356081057`, 
             0., -5.208333333333332}, {-0.6541211334686317, 
             0., -6.249999999999998}, {-0.654121133468629, 
             0., -6.25}}, CompressedData["
1:eJxdlN8rg1Ecxt+IuFGMbEhR+wOURMkON+OCIgw1lpo7IT9uVrtyb0wuyK07
v4pso5ziYtpqLrZaTS1hLQl3kvw+z7PaOfX21tOz532+n/NtDZMzA+4CwzCa
fp/C3yec9MytPN+fG//HIgycKPTgYbjLdmUW7r7a7GvNoy0OvTtxkH6ymkVn
aNF7eftuY86EN90WN1eLoYXWitHGQkE987Fc5NupQn5pTvdX3tQtJUyi7mVk
3jpbJpLQT6ZM0rNbLgJ4018P3xp+R70AuQ/4DvVh9GAvzmVHb85BfRpzcm7m
RGKx/S3/aTs5UR9T/vMQ/OTTofJznKj3qz5S7/P1/XdKZEbrb1HzynXMq/GR
Op9V5ZMN4HQN/U7lyiKNP3pIBzhF8+9X9mj3Cy7SC07a/kjFKdJOHVykA5yY
34P8FnCi7kKfPnCK5u+P/AQn5oOLJCf6Q+BzjDf94CLJiXyKFRdJTtSd6OFE
L+Y40NuOOejfxJwBzE1/MpW6ONqLn5ETew6CIzlRbwZ3cqLei3tyaX3eFBeR
RX/qJuzBBuYN5++PCIIP833Ys0Zw0vZHkBP94CLGwYn54CJGwIk54CK2wUn/
/1H7kzr7ASJqdIk=
             "]}]}}, ControlType -> 
         None}, {{$CellContext`staticpolygons2223020081152326930050$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{-0.7033119314590373, -5., 
             0.}, {-1.538876515698588, -4.166666666666667, 
             0.}, {-2.1302230142610687`, -3.3333333333333335`, 
             0.}, {-2.55, -2.5, 
             0.}, {-2.8326922749902543`, -1.666666666666667, 
             0.}, {-2.9963598686045723`, -0.8333333333333339, 0.}, {-3.05, 0.,
              0.}, {-2.9963598686045723`, 0.833333333333333, 
             0.}, {-2.8326922749902543`, 1.666666666666666, 
             0.}, {-2.5500000000000007`, 2.499999999999999, 
             0.}, {-2.1302230142610696`, 3.333333333333332, 
             0.}, {-1.5388765156985889`, 4.166666666666666, 
             0.}, {-0.7033119314590373, 5., 0.}, {-0.7033119314590373, 5., 
             0.}, {-1.538876515698588, 4.166666666666667, 
             0.}, {-2.1302230142610687`, 3.3333333333333335`, 0.}, {-2.55, 
             2.5, 0.}, {-2.8326922749902543`, 1.666666666666667, 
             0.}, {-2.9963598686045723`, 0.8333333333333339, 0.}, {-3.05, 0., 
             0.}, {-2.9963598686045723`, -0.833333333333333, 
             0.}, {-2.8326922749902543`, -1.666666666666666, 
             0.}, {-2.5500000000000007`, -2.499999999999999, 
             0.}, {-2.1302230142610696`, -3.333333333333332, 
             0.}, {-1.5388765156985889`, -4.166666666666666, 
             0.}, {-0.7033119314590373, -5., 0.}, {-0.7033119314590373, -5., 
             0.}}, {{-0.7033119314590373, 0., -5.}, {-1.538876515698588, 
             0., -4.166666666666667}, {-2.1302230142610687`, 
             0., -3.3333333333333335`}, {-2.55, 
             0., -2.5}, {-2.8326922749902543`, 
             0., -1.666666666666667}, {-2.9963598686045723`, 
             0., -0.8333333333333339}, {-3.05, 0., 0.}, {-2.9963598686045723`,
              0., 0.833333333333333}, {-2.8326922749902543`, 0., 
             1.666666666666666}, {-2.5500000000000007`, 0., 
             2.499999999999999}, {-2.1302230142610696`, 0., 
             3.333333333333332}, {-1.5388765156985889`, 0., 
             4.166666666666666}, {-0.7033119314590373, 0., 
             5.}, {-0.7033119314590373, 0., 5.}, {-1.538876515698588, 0., 
             4.166666666666667}, {-2.1302230142610687`, 0., 
             3.3333333333333335`}, {-2.55, 0., 2.5}, {-2.8326922749902543`, 
             0., 1.666666666666667}, {-2.9963598686045723`, 0., 
             0.8333333333333339}, {-3.05, 0., 0.}, {-2.9963598686045723`, 
             0., -0.833333333333333}, {-2.8326922749902543`, 
             0., -1.666666666666666}, {-2.5500000000000007`, 
             0., -2.499999999999999}, {-2.1302230142610696`, 
             0., -3.333333333333332}, {-1.5388765156985889`, 
             0., -4.166666666666666}, {-0.7033119314590373, 
             0., -5.}, {-0.7033119314590373, 0., -5.}}, CompressedData["
1:eJxdk8srhGEUxj8GuZVrykq2iExKpLyl3KJcNi4bpuwYC0VYSFmIZDul+RdM
inGZYV6XJBtEoixcJrehLBQrDO/zfOW89fXVrzPne87vPZPvGmzri7UsqzT6
OKLPdW56wvTkfcj6O9nKwiHv3T5dcJ5lqamUhvau23A1+cDIXNNMa5YqO/go
9S6/27zJM9FbM5apgu1dLd3eL5tHSspPUtsy0D9Oka+9FhW/BdLUXcfY/Gpn
os1DyXnWfn2q0niTh1Hnx+/IY9D3Gd8h30QO5noEr0DufszB+hnMybnJk4Yu
Q740fxU9kY+b+pBL1DtNf9sTud/ksT2Rf33/HoeOiPw3Zl69LuaFHy39rJg6
/SB8Ppm+Ok74Rw69BU/0Ay+6UtwvvGiP2Ad40cbTfhU5vOhReCJ3o38hPJE3
I48Pni7AX5Cfnli/gXnpiXwPfgJ4k8OLpifyeONF0xP5AXI0Ihd5LXLTE/ki
5uzB3HZ9zt3R7uxxkJ7Ih+HRJeoL4N0t++OemkWeT+NFvYr8V9iDTTHvFvZm
R/hZxp49Cp/wouiJHF7UITxd/98fVSfuF17UktgH/q/M/pwHfwCgXQqn
             "]}]}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons2323020081152326934944$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{-0.05, -2.5, 0.}, {-0.05, -2.0833333333333335`, 
             0.}, {-0.05, -1.6666666666666667`, 0.}, {-0.05, -1.25, 
             0.}, {-0.05, -0.8333333333333335, 
             0.}, {-0.05, -0.41666666666666696`, 0.}, {-0.05, 0., 0.}, {-0.05,
              0.4166666666666665, 0.}, {-0.05, 0.833333333333333, 0.}, {-0.05,
              1.2499999999999996`, 0.}, {-0.05, 1.666666666666666, 
             0.}, {-0.05, 2.083333333333333, 0.}, {-0.05, 2.5, 0.}, {-0.05, 
             2.5, 0.}, {-0.05, 2.0833333333333335`, 0.}, {-0.05, 
             1.6666666666666667`, 0.}, {-0.05, 1.25, 0.}, {-0.05, 
             0.8333333333333335, 0.}, {-0.05, 0.41666666666666696`, 
             0.}, {-0.05, 0., 0.}, {-0.05, -0.4166666666666665, 
             0.}, {-0.05, -0.833333333333333, 
             0.}, {-0.05, -1.2499999999999996`, 
             0.}, {-0.05, -1.666666666666666, 0.}, {-0.05, -2.083333333333333,
              0.}, {-0.05, -2.5, 0.}, {-0.05, -2.5, 0.}}, {{-0.05, 
             0., -2.5}, {-0.05, 0., -2.0833333333333335`}, {-0.05, 
             0., -1.6666666666666667`}, {-0.05, 0., -1.25}, {-0.05, 
             0., -0.8333333333333335}, {-0.05, 
             0., -0.41666666666666696`}, {-0.05, 0., 0.}, {-0.05, 0., 
             0.4166666666666665}, {-0.05, 0., 0.833333333333333}, {-0.05, 0., 
             1.2499999999999996`}, {-0.05, 0., 1.666666666666666}, {-0.05, 0.,
              2.083333333333333}, {-0.05, 0., 2.5}, {-0.05, 0., 2.5}, {-0.05, 
             0., 2.0833333333333335`}, {-0.05, 0., 
             1.6666666666666667`}, {-0.05, 0., 1.25}, {-0.05, 0., 
             0.8333333333333335}, {-0.05, 0., 0.41666666666666696`}, {-0.05, 
             0., 0.}, {-0.05, 0., -0.4166666666666665}, {-0.05, 
             0., -0.833333333333333}, {-0.05, 
             0., -1.2499999999999996`}, {-0.05, 
             0., -1.666666666666666}, {-0.05, 0., -2.083333333333333}, {-0.05,
              0., -2.5}, {-0.05, 0., -2.5}}, CompressedData["
1:eJxdkzlIA1EURSdGCxewsxVbFSUiiCJkQHAjAZfGpdGAnUshKMbCxkoR26jY
CjYGIcYlifNdELERMY1g4wKuEUHBFGKM/nt/8T4MA4eXl/vOf1MWGOsayrEs
y5N93NlneenvrDvW/8m1LRzywYPLlZqk254tbOvuu016yUcmF3xznW679vTL
sxq5N9wXmhlsCubY8e6+jv7VN8Nfqusuirpc6P9p+E6qsuo9lvHe9QQXt3vT
hjsFpdZJ67dX4U1+j7oofkfuQt9n/A95AjmYi7weuYcxB/kc5uTc5PnjV064
eK2Rnsindb0TEPU1ur/xRB7VeRyZ5yfzdz6MJ/IbPa+zK+aFH0f62dJ1zoPw
+aT7qlzhHznUvrgveFEN4n7hRYXEPsCL0p6ijeTwoqbgiXwU/SvgidyPPGF4
In9Ffnoi38O89ER+DD8xvMnhxXgiz9NejCfyU+RoRy7yZuSmJ/INzDmAuU19
yd350byK0xP5BDwGRH05vI/K/rgnv8iT1l68KZH/GnuQEPPuY28OhZ8I9uxR
+IQXm57I4cU+E/fF76pF3C+82JtiH/hd6f05if8CUaliEQ==
             "]}]}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons2423020081152326944061$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{-0.05, -5., 0.}, {-0.05, -4.791666666666667, 
             0.}, {-0.05, -4.583333333333333, 0.}, {-0.05, -4.375, 
             0.}, {-0.05, -4.166666666666667, 
             0.}, {-0.05, -3.9583333333333335`, 0.}, {-0.05, -3.75, 
             0.}, {-0.05, -3.541666666666667, 
             0.}, {-0.05, -3.3333333333333335`, 0.}, {-0.05, -3.125, 
             0.}, {-0.05, -2.916666666666667, 
             0.}, {-0.05, -2.7083333333333335`, 0.}, {-0.05, -2.5, 
             0.}, {-0.05, -2.5, 0.}, {-0.05, -2.7083333333333335`, 
             0.}, {-0.05, -2.9166666666666665`, 0.}, {-0.05, -3.125, 
             0.}, {-0.05, -3.333333333333333, 
             0.}, {-0.05, -3.5416666666666665`, 0.}, {-0.05, -3.75, 
             0.}, {-0.05, -3.958333333333333, 0.}, {-0.05, -4.166666666666666,
              0.}, {-0.05, -4.375, 0.}, {-0.05, -4.583333333333333, 
             0.}, {-0.05, -4.791666666666666, 0.}, {-0.05, -5., 
             0.}, {-0.05, -5., 0.}}, {{-0.05, 2.5, 0.}, {-0.05, 
             2.7083333333333335`, 0.}, {-0.05, 2.9166666666666665`, 
             0.}, {-0.05, 3.125, 0.}, {-0.05, 3.333333333333333, 0.}, {-0.05, 
             3.5416666666666665`, 0.}, {-0.05, 3.75, 0.}, {-0.05, 
             3.958333333333333, 0.}, {-0.05, 4.166666666666666, 0.}, {-0.05, 
             4.375, 0.}, {-0.05, 4.583333333333333, 0.}, {-0.05, 
             4.791666666666666, 0.}, {-0.05, 5., 0.}, {-0.05, 5., 0.}, {-0.05,
              4.791666666666667, 0.}, {-0.05, 4.583333333333333, 0.}, {-0.05, 
             4.375, 0.}, {-0.05, 4.166666666666667, 0.}, {-0.05, 
             3.9583333333333335`, 0.}, {-0.05, 3.75, 0.}, {-0.05, 
             3.541666666666667, 0.}, {-0.05, 3.3333333333333335`, 0.}, {-0.05,
              3.125, 0.}, {-0.05, 2.916666666666667, 0.}, {-0.05, 
             2.7083333333333335`, 0.}, {-0.05, 2.5, 0.}, {-0.05, 2.5, 
             0.}}, {{-0.05, 0., -5.}, {-0.05, 0., -4.791666666666667}, {-0.05,
              0., -4.583333333333333}, {-0.05, 0., -4.375}, {-0.05, 
             0., -4.166666666666667}, {-0.05, 
             0., -3.9583333333333335`}, {-0.05, 0., -3.75}, {-0.05, 
             0., -3.541666666666667}, {-0.05, 
             0., -3.3333333333333335`}, {-0.05, 0., -3.125}, {-0.05, 
             0., -2.916666666666667}, {-0.05, 
             0., -2.7083333333333335`}, {-0.05, 0., -2.5}, {-0.05, 
             0., -2.5}, {-0.05, 0., -2.7083333333333335`}, {-0.05, 
             0., -2.9166666666666665`}, {-0.05, 0., -3.125}, {-0.05, 
             0., -3.333333333333333}, {-0.05, 
             0., -3.5416666666666665`}, {-0.05, 0., -3.75}, {-0.05, 
             0., -3.958333333333333}, {-0.05, 0., -4.166666666666666}, {-0.05,
              0., -4.375}, {-0.05, 0., -4.583333333333333}, {-0.05, 
             0., -4.791666666666666}, {-0.05, 0., -5.}, {-0.05, 
             0., -5.}}, {{-0.05, 0., 2.5}, {-0.05, 0., 
             2.7083333333333335`}, {-0.05, 0., 2.9166666666666665`}, {-0.05, 
             0., 3.125}, {-0.05, 0., 3.333333333333333}, {-0.05, 0., 
             3.5416666666666665`}, {-0.05, 0., 3.75}, {-0.05, 0., 
             3.958333333333333}, {-0.05, 0., 4.166666666666666}, {-0.05, 0., 
             4.375}, {-0.05, 0., 4.583333333333333}, {-0.05, 0., 
             4.791666666666666}, {-0.05, 0., 5.}, {-0.05, 0., 5.}, {-0.05, 0.,
              4.791666666666667}, {-0.05, 0., 4.583333333333333}, {-0.05, 0., 
             4.375}, {-0.05, 0., 4.166666666666667}, {-0.05, 0., 
             3.9583333333333335`}, {-0.05, 0., 3.75}, {-0.05, 0., 
             3.541666666666667}, {-0.05, 0., 3.3333333333333335`}, {-0.05, 0.,
              3.125}, {-0.05, 0., 2.916666666666667}, {-0.05, 0., 
             2.7083333333333335`}, {-0.05, 0., 2.5}, {-0.05, 0., 
             2.5}}, CompressedData["
1:eJxdkzlIA1EURSdGCxewsxVbFSUiiCJkQHAjAZfGpdGAnUshKMbCxkoR26jY
CjYGIcYlifNdELERMY1g4wKuEUHBFGKM/nt/8T4MA4eXl/vOf1MWGOsayrEs
y5N93NlneenvrDvW/8m1LRzywYPLlZqk254tbOvuu016yUcmF3xznW679vTL
sxq5N9wXmhlsCubY8e6+jv7VN8Nfqusuirpc6P9p+E6qsuo9lvHe9QQXt3vT
hjsFpdZJ67dX4U1+j7oofkfuQt9n/A95AjmYi7weuYcxB/kc5uTc5PnjV064
eK2Rnsindb0TEPU1ur/xRB7VeRyZ5yfzdz6MJ/IbPa+zK+aFH0f62dJ1zoPw
+aT7qlzhHznUvrgveFEN4n7hRYXEPsCL0p6ijeTwoqbgiXwU/SvgidyPPGF4
In9Ffnoi38O89ER+DD8xvMnhxXgiz9NejCfyU+RoRy7yZuSmJ/INzDmAuU19
yd350byK0xP5BDwGRH05vI/K/rgnv8iT1l68KZH/GnuQEPPuY28OhZ8I9uxR
+IQXm57I4cU+E/fF76pF3C+82JtiH/hd6f05if8CUaliEQ==
             
             "], CompressedData["
1:eJxdk8srRGEYxg9GuUzJJVvZIhopkfKVcmummNkwNmbKzmWhCAsbK5KtS/MH
2JAa4zLD+VyaJhtEStm4lHtZKFau3/OcxfvV6dSvd9553t/3ntLwkL8v3bIs
z++T8fssLvydZdv6P0XKwiEP7Z0tVZ8XqqnctkDw5q6RfGB01jvdWahqUh+e
SPTd4d75yVDTeIFKBIIdPZEvhz9X1Z66/fno71Lkm68VlW/xPHXbNT630Z3l
cDunxEq2upXGm/wOdTH8jjwNfZ/wP+Q7yMFc5HXI3Y85yKcxJ+cmzx6+tFfz
Yg30RD5h6u2wqK82/R1P5DGTx5Z5vr7/ToZ+Fvmvzbx6S8wLP1r6WTd1+l74
fDR9tUv4Rw69K+4LXnS9uF940fNiH+BFG0/JBnJ40WPwRD6I/uXwRO5DnlV4
In9Bfnoi38a89ER+CD9xvMnhRdMTeabxoumJPIUc7chF3ozc9ES+gjl7MbdT
X3x7fDBzkqAn8hF4DIv6MngflP1xTz6R59N4Ua8i/xX2YEfMu4u92Rd+otiz
B+ETXhQ9kcOLOhL3xe+qRdwvvKg1sQ/8rsz+XCR+AHt0SEE=
             "]}]}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons2523020081152326945592$$, {}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons2623020081152326970402$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{1.3689976525819987`, -5.65, 0.}, {
             0.9852549276396352, -4.708333333333334, 0.}, {
             0.6511727483615684, -3.766666666666667, 0.}, {
             0.3764030171799524, -2.825, 0.}, {
             0.17082082737962523`, -1.8833333333333337`, 0.}, {
             0.043271803862861, -0.9416666666666673, 0.}, {0., 0., 0.}, {
             0.04327180386286091, 0.9416666666666664, 0.}, {
             0.17082082737962506`, 1.8833333333333329`, 0.}, {
             0.3764030171799522, 2.8249999999999993`, 0.}, {
             0.6511727483615678, 3.7666666666666657`, 0.}, {
             0.9852549276396345, 4.708333333333332, 0.}, {1.3689976525819987`,
              5.65, 0.}, {1.3689976525819987`, 5.65, 0.}, {0.9852549276396352,
              4.708333333333334, 0.}, {0.6511727483615684, 3.766666666666667, 
             0.}, {0.3764030171799524, 2.825, 0.}, {0.17082082737962523`, 
             1.8833333333333337`, 0.}, {0.043271803862861, 0.9416666666666673,
              0.}, {0., 0., 0.}, {0.04327180386286091, -0.9416666666666664, 
             0.}, {0.17082082737962506`, -1.8833333333333329`, 0.}, {
             0.3764030171799522, -2.8249999999999993`, 0.}, {
             0.6511727483615678, -3.7666666666666657`, 0.}, {
             0.9852549276396345, -4.708333333333332, 0.}, {
             1.3689976525819987`, -5.65, 0.}, {1.3689976525819987`, -5.65, 
             0.}}, {{1.3689976525819987`, 0., -5.65}, {0.9852549276396352, 
             0., -4.708333333333334}, {0.6511727483615684, 
             0., -3.766666666666667}, {0.3764030171799524, 0., -2.825}, {
             0.17082082737962523`, 0., -1.8833333333333337`}, {
             0.043271803862861, 0., -0.9416666666666673}, {0., 0., 0.}, {
             0.04327180386286091, 0., 0.9416666666666664}, {
             0.17082082737962506`, 0., 1.8833333333333329`}, {
             0.3764030171799522, 0., 2.8249999999999993`}, {
             0.6511727483615678, 0., 3.7666666666666657`}, {
             0.9852549276396345, 0., 4.708333333333332}, {1.3689976525819987`,
              0., 5.65}, {1.3689976525819987`, 0., 5.65}, {0.9852549276396352,
              0., 4.708333333333334}, {0.6511727483615684, 0., 
             3.766666666666667}, {0.3764030171799524, 0., 2.825}, {
             0.17082082737962523`, 0., 1.8833333333333337`}, {
             0.043271803862861, 0., 0.9416666666666673}, {0., 0., 0.}, {
             0.04327180386286091, 0., -0.9416666666666664}, {
             0.17082082737962506`, 0., -1.8833333333333329`}, {
             0.3764030171799522, 0., -2.8249999999999993`}, {
             0.6511727483615678, 0., -3.7666666666666657`}, {
             0.9852549276396345, 0., -4.708333333333332}, {
             1.3689976525819987`, 0., -5.65}, {1.3689976525819987`, 
             0., -5.65}}, CompressedData["
1:eJxdlD1IQmEYhW8FLg1hf1AR9DM0NRQtmeUH4mRWFFIRYQVCSNAUka1NjTaY
BtLPkmNNDpKfBtEWRENB9A9BUJRirRXfOYLvhcuFw7nvPef5Xm77wvJ4sNKy
rJ6/u+rv9rk6GkKvRVc89n81KgsX9fXT09XmxUbVnYzm52KvLurZrZOHlasG
5Vlb2jsK/pT0OZ9/s/exXu11pTwtwxVqBHoh92KFI3XKfMem6B+YqlyyfdjV
ROAi2bRRXdLv3s4+a79r1D2e1P3w8T3qO5ibx3eo7yMHc1H3IrdGD+p96Mne
1HuKmezTe8pJTtQ7jT8j/W4zP5MV8xMmj54XebZNfl0Q+cdMX+0UfcFHSz4O
49OTgueXmasTgj+46ANwog4uelicL3pqt9gHcNGG07lT+tvAifuQw3wnONG/
gDxxcPKV74+OghPnDKIvOdH/DD43eFIHF01O1Hcxl5yoHyJHALmoTyN3Bj2o
z6JnGL2pv/yM2kPHl2lyot5avm+lXg5wz4n54KLIif4IzrUo8nuxB0Oi7y32
5kHw6ceeTQue4KLIiTq4qKQ4L3BRM+J8wUUFwEn+f8z+XKd/AdLmInA=
             "]}]}}, 
         ControlType -> 
         None}, {{$CellContext`staticpolygons2723020081152326975689$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{1.3397916666666667`, -5.65, 0.}, {
             2.1526331018518516`, -4.708333333333334, 0.}, {
             2.817685185185185, -3.766666666666667, 0.}, {
             3.3349479166666667`, -2.825, 0.}, {
             3.7044212962962964`, -1.8833333333333337`, 0.}, {
             3.926105324074074, -0.9416666666666673, 0.}, {4., 0., 0.}, {
             3.926105324074074, 0.9416666666666664, 0.}, {3.7044212962962964`,
              1.8833333333333329`, 0.}, {3.334947916666667, 
             2.8249999999999993`, 0.}, {2.817685185185186, 
             3.7666666666666657`, 0.}, {2.152633101851853, 4.708333333333332, 
             0.}, {1.3397916666666667`, 5.65, 0.}, {1.3397916666666667`, 5.65,
              0.}, {2.1526331018518516`, 4.708333333333334, 0.}, {
             2.817685185185185, 3.766666666666667, 0.}, {3.3349479166666667`, 
             2.825, 0.}, {3.7044212962962964`, 1.8833333333333337`, 0.}, {
             3.926105324074074, 0.9416666666666673, 0.}, {4., 0., 0.}, {
             3.926105324074074, -0.9416666666666664, 0.}, {
             3.7044212962962964`, -1.8833333333333329`, 0.}, {
             3.334947916666667, -2.8249999999999993`, 0.}, {
             2.817685185185186, -3.7666666666666657`, 0.}, {
             2.152633101851853, -4.708333333333332, 0.}, {
             1.3397916666666667`, -5.65, 0.}, {1.3397916666666667`, -5.65, 
             0.}}, {{1.3397916666666667`, 0., -5.65}, {2.1526331018518516`, 
             0., -4.708333333333334}, {2.817685185185185, 
             0., -3.766666666666667}, {3.3349479166666667`, 0., -2.825}, {
             3.7044212962962964`, 0., -1.8833333333333337`}, {
             3.926105324074074, 0., -0.9416666666666673}, {4., 0., 0.}, {
             3.926105324074074, 0., 0.9416666666666664}, {3.7044212962962964`,
              0., 1.8833333333333329`}, {3.334947916666667, 0., 
             2.8249999999999993`}, {2.817685185185186, 0., 
             3.7666666666666657`}, {2.152633101851853, 0., 
             4.708333333333332}, {1.3397916666666667`, 0., 5.65}, {
             1.3397916666666667`, 0., 5.65}, {2.1526331018518516`, 0., 
             4.708333333333334}, {2.817685185185185, 0., 3.766666666666667}, {
             3.3349479166666667`, 0., 2.825}, {3.7044212962962964`, 0., 
             1.8833333333333337`}, {3.926105324074074, 0., 
             0.9416666666666673}, {4., 0., 0.}, {3.926105324074074, 
             0., -0.9416666666666664}, {3.7044212962962964`, 
             0., -1.8833333333333329`}, {3.334947916666667, 
             0., -2.8249999999999993`}, {2.817685185185186, 
             0., -3.7666666666666657`}, {2.152633101851853, 
             0., -4.708333333333332}, {1.3397916666666667`, 0., -5.65}, {
             1.3397916666666667`, 0., -5.65}}, CompressedData["
1:eJxdlE8og2Ecx1+Ui4P8WyFFDi6zkIt52VNy2kS0kDRWK2m1k4SrkyOFTcmf
ix05Ocj7bCtxUnKg5O9KKWJrdnEwPd+vep+33t769t33+f4+z681BSPDoWLD
MNoLb0nhbVv/CV5Ecp5Y9O9xCAOPC/pSKjVfN+MQrfGNzFT01UM9sXb6OHdd
I/oXwruHobyHOVMD/pWOp2qx23LcX+8rEk7o2WTaWFytEuqcUkF/91hxuPSj
QowELuO1y2WC+fdvZ5+V3+XiAV/qfvj4O+ZsITeDc6jvoQd7Ufeit8QczO/E
nJyb/vaclXh+PzbJiXqz8lv0M6dP5VsJLX9b9ZHT6EN9U/WXWa3/kJpXmphX
4yN1Pm7lk6PgxJwvlSu3wcllvy+5D070g4v0gZO2D7IPnLT9kYrTudmm+RvB
ifuQRL4JTtSD6BMDJ5d9f+QGONHfg3nJiee+gM8tvswBF0lOzNlBLjkx5wA9
AuhFfRy9LcxBfRJzLmJu6un8YMXs0dUJOVFvsO/bfx83uJMTdXAR5ER9Ffea
0/p7sQe9mJf6HfbmUePThT0bByenfX8EOdEPLiKu3Re4iAlw4rngIgLgpP//
qP25OfkF985g7Q==
             "]}]}}, ControlType -> 
         None}, {{$CellContext`staticpolygons2823020081152327012047$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           Line[{CompressedData["
1:eJx11V1Ik1Ecx/HppEh2YThfiAfbWpsLsU03AyvrX5C9UDJdeBHrZrUwCxIL
irUgtBEYERHUhQSFRV2YBGmMIaRiNxHeJGgQVAQj0ELp5Uqo7Tnn+QU/6YFd
7MPDec45z/lu7vi5jkSxzWaL5j/2/Odu7+Nc6+wmOVW4crUTNn2tdMQrvnX7
xTmy/3Ny1AcvTV0p3nKwTqZ++WO3+rzwj90PBxNn6qWnpXRuKLIZfil+xLjh
DUhNeqE9U+OBX64v6Z8+HJS3hWvRDT8WmfXdWwxKsvDgrAs+b3tfNHixQfKD
pBfWb4SP7Yjc7FxukGf5aTpHDPiM/U1mV6xR1s0N9bQc2gD/vm3pjpFtlIS5
3ir49vmBvlZHSCbNdVXA9wwffzQVDen5l8PTpwfux26H9DzL4O/azi69eB2S
YXM+Dnhn08vxfcshOWk+dy38RImv/7wzLIY5vh3+INWcux4Iy1NznJVXlrs9
TUXZvWGpNu//8c+jP8cCbWEpM/0L/MnXA1v/tIdFffu0k+8Pqvt38/h+NT7c
mk9GzQduzd+l5i+83i61Xri1P8/V/sCv6f1Mqf2Ei95/NX45vFm/r2n1vuDW
+1XPrYJb58GhzgN8VJ8fNR8Dbp23o+q8wa3zqebpgif1eZ5R5xl+QZ9/NX8P
/IPupVf1Al+j+1Lr8sJ/6x4rVY/wq7pftd5aOHUNp67h1DWcuoZT13DqetW+
JWnfqGs4dQ2nruHUNZy6hlPXcOoaTl3DqWs4dQ2nrld1V03dUddw6nqc7w/S
7wB1Daeu4dT1BK+3i37HqGs4dQ2nruHUNZy6hlPXcOoaTl3DqWs4dQ2nruHU
NZy6hlPXcOoa/r//67+NQD56
             "], CompressedData["
1:eJx11V9IU1EcB/CrkyLZg+HUiIttrc1F2OyPgZXdX0H2h5LpwodYL6tFWZBY
UKwFoY3AiIigHiQoLOrBJEhjDOH+FHuJ8EVBg6AiGIEWSn+ehNru73APnMPv
wH35cjn3d875fc4NJC91psoNw4gXH0/xedj7vNA2uxEMMc6WRqEBVzqTNT+6
I27uGzn0NT0axsrMjfLNR7a4+eSfSOJeXwg/dz8dTF1odPOe1sq5odgmvJY8
bt4JRd28PrvQkasP4vXGiv6pY01u/qE0FgN4MjYbfrQo83Tpw3k/zhsfywav
bnPz4iTZhbUbcGxP7G7XssxfFcv0jZg47Xmf25fY7uZr5oZ6Wo+ux5+7lh6Y
eZmnnPXW4e75gb427w43n3DWVYP7h089m4zLnOqvxuz5gceJ+zKnOqtwpv3i
0pt3Mh926vFiV/Pb8YPLMj/jfHc1nq4I91/27XRz05nfg08yLYXbUZm/dOZZ
sQPB5rL8AZmvc97/ZQfiv8ei7TKvcvJv9ovvh7f+65A5jS971feb6H1LnT9C
81tqPTmqx1Lr91P9oK73HK0X1P15TfsDt5T9zNB+Aij7T/NXQ4tyXlN0XqCe
L323DtR+8FI/wKjSP1SPCWq/naB+A7U/qU4/pJV+nqZ+hitK/1P9QfikeOkl
L7BK8UXrCsFfxWMteYSbil9abwMwroFxDYxrYFwD4xoY19q+CdfaPgvXwLjW
zlG41s5duAbGNTCugXGt9a1wrfW5cA2Ma2Bca+6Ea4txbTGuxxnX2r0hXNuM
a5txrd1jwrV27wnXyLhGxjUyrrV7W7jW7nnhGhnX2n9EuNb+O8I1Mq6RcY2M
a2RcI+MaGdfI/a//AwmRPno=
             "], CompressedData["
1:eJx1l31M1WUUx2+QNLKYU1z2olxQuUKgWy2TlHgSzYTp7IJtTWxC6Gyr0bI0
/4D15lZqUH/kW3YdNsjZlqFYDkTOStbMSkUJYgkoC5Mxt1aTuWRGPd/vab+z
wcbYvjuce55zzuecc1PLKqJr40KhUO3ob/zo745X6gaevJDm1v37MxBxIfzE
oKft/+XCF5cirjOrv6s2oSeP9i/k99x873zEPXNj3LeNoWuqFw0d2zDSHHG5
SSVl4c3XVf/r5KQtEz+OuIsVn1bccXVE9YT0ojk/vxxxc++Phj6oj3PUM2te
nfZsbsT9+nrPnrynExzjuX5tc92h0GicT+26lfJnouqXOp7/6o+mdHd0uCP8
zda7XQ301hMtXY+9mO5KMuKrVm+boPpgRKYdTE53b9VXJrcXTFR90Xd33VvW
ONN90tHwcFJ8suqlXyaeerdwpjvTMXVy+ZHJqn92pu/DJd0z3G3nqyZkrLpH
9Wh9xqzTa2a42tzZvUdvTNE4o035b+T3TneD0YyeddX36XvDDeub+1dOd2W/
HVi+d8oDqldVV066fDLNzRqY81HTzqnqvybp87ZNWWlu2enhjZnjU9R+aXXb
333bU934gnMHs3LCqm986f3GkoGw/qVOO/4f/dMvP4f2jINxUWfcfAf1IbyT
76Z/5oV5oj3zWI+8Mm9nkfc1qAN11ikfdaP/t1FX1pn6avQB+4J+vkbfsI8Y
Txz6jH1H/SL6kn1KfR76mH1NvQ99Tw6oO3BCbqiXgCtyxjj7wSG5pP2iuUcW
3iz5fgE5pv0pb99q7Vd4/630Tz3Hx9Nq4+n28bfa+B/x7xW+l3nu9vmRB5Ef
xnNryX/5FJvPwz7/ctnkf5Wvl7Be9A9uxdZ3t+8HWYx+oJ+ffP8IOaZ9nO83
Yb9R3+f7U4rQn9Sv+H6WYvSz6X+x/Z/heRHyYvgS8sX8JHoepQA8Gn6F/NIe
3Mqdhvdq71eWk2PolT4OyTLzBHFLOTimXuTfKZxXZr7JfnDMz63zeZTbwTHj
BLdy1sxPzFvZa+Yt6irvgGP6P+H7QErBMXVwK8fAsdkXMuL7zu4X6QXHZh9J
ntlH6HvpB8f0D05kntl34ErKwbHZpxLODu5TcCue4+4F1n4IHFv/S8GxjScT
HMdM/J3g2L43BxxTB7fSBY7pZxj5HAbHtAe30gCOY6Zez4HjHaa+b4Jj6uBW
doFj6uBWfgTH1MGtYG+I9i36kxxTB7dCjqmnov9LwbHZv0KO+S5wK4XkGHoh
eCTH9LMJ/L6Gv/QDboUc6x0Fv9vxOfQPboUcUy8Pzh/1D24F+1ftY8H5pp87
Dnkkx9TPIe/kmH6wf4Uc034r6vo76qx1RB+wL6g3oW/I8Rj7Qu07gvtF9SeC
+0j1K8H9pfr84L7Td+0O7ke1z84O7FPVD69PeKilrf84OWb8PcF9rfYbgvtd
7SPBe0D19uD9oH4eDd4bqv+AuZaF/Og8xBwcNvk8hLlJjse4l9R+C+byVVPf
nZjji00/gFvleIx77//8Y6+sNP05gD1UbPoZ3CrHY9yrar8Ce7Ha8AVulWP6
AbfK8Rj3tvoBt67YzAdw62aDY/pJwd2w1swf3s1DZl7xLomZ+QZuXQI4ph/e
ze3gmP2QH/y+o/bg1m0Dx7RvwR1WZuY57+ZmM//N9zW7X1wnOGb8vCMXmn3E
u3PQ7C/eqY+DY/rhXbsPHNOed/D87OA+5d3s9+/g8X8Atd86pA==
             "]}]}}, 
         ControlType -> None}}, 
      "Options" :> {
       Deployed -> False, AutorunSequencing -> {1, 2, 3, 4}, 
        SynchronousInitialization -> True, SynchronousUpdating -> True}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{884., {305.375, 310.625}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>(($CellContext`raytracefunction1230200811523132919248 = 
       Compile[{{$CellContext`th$$, 
           Blank[Real]}, {$CellContext`x$$, 
           Blank[Real]}, {$CellContext`y$$, 
           Blank[Real]}, {$CellContext`focus$$, 
           Blank[Real]}}, 
         Module[{$CellContext`activeregion$, \
$CellContext`allcreatedamplitudes$, $CellContext`allcreatedrays$, \
$CellContext`allowzeroraylength$, $CellContext`alternateindex$, \
$CellContext`amplitude$, $CellContext`axismagnitude$, \
$CellContext`axismatrix$, $CellContext`clonedata$, \
$CellContext`clonegenerationnumber$, $CellContext`cloneinput$, \
$CellContext`clonenumber$, $CellContext`cloneposition$, \
$CellContext`clonereportedrays$, $CellContext`clonerotation$, \
$CellContext`clonescale$, $CellContext`clonescalevector$, \
$CellContext`clonesorthistogram$, $CellContext`clonetraceinput$, \
$CellContext`clonetraceoutput$, $CellContext`closestdistances$, \
$CellContext`closestposition$, $CellContext`closestpositions$, \
$CellContext`closestraylength$, $CellContext`completedray$, \
$CellContext`componentnumber$, $CellContext`cosangle$, \
$CellContext`crossmatrix$, $CellContext`deflecteddummyrayspresent$, \
$CellContext`deflectedlocalrays$, $CellContext`deflectedrays$, \
$CellContext`deflectedrayspresent$, $CellContext`dr1$, \
$CellContext`dummymatrix$, $CellContext`dummymatrixlist$, \
$CellContext`dummyvector$, $CellContext`exitvalue$, $CellContext`frontid$, \
$CellContext`generationlimit$, $CellContext`generationnumber$, \
$CellContext`holeintersections$, $CellContext`holeQ$, \
$CellContext`holeQlist$, $CellContext`hor$, $CellContext`index$, \
$CellContext`index1$, $CellContext`index2$, $CellContext`inrays$, \
$CellContext`intensity$, $CellContext`intensityscale$, \
$CellContext`intersectionnumber$, $CellContext`intersections$, \
$CellContext`intersectionslist$, $CellContext`intersectionspresent$, \
$CellContext`localdummyoutrayspresent$, $CellContext`localoutrays$, \
$CellContext`localoutrayspresent$, $CellContext`magnitude$, \
$CellContext`maxclonegenerationnumber$, $CellContext`maximumposition$, \
$CellContext`minimumraylength$, $CellContext`minresonateraylength$, \
$CellContext`n12$, $CellContext`newcomponentnumber$, \
$CellContext`newdeflectedrays$, $CellContext`newdistance$, \
$CellContext`newsurfaceid$, $CellContext`newsurfacenumber$, \
$CellContext`nonintersectingrays$, $CellContext`normalizedpolarization$, \
$CellContext`oldgenerationnumber$, $CellContext`opticallength$, \
$CellContext`originalray$, $CellContext`originalraytilt$, \
$CellContext`originalrotation$, $CellContext`originalsurfnorm$, \
$CellContext`outrays$, $CellContext`parallelamplitude$, $CellContext`PAxis$, \
$CellContext`perpendicularamplitude$, $CellContext`phaseshift$, \
$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$, \
$CellContext`previoustilt$, $CellContext`propagate$, \
$CellContext`propagatedrays$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, $CellContext`ray1$, \
$CellContext`ray2$, $CellContext`ray3$, $CellContext`LocRayL$, \
$CellContext`rayslot$, $CellContext`raysreported$, $CellContext`raytiltx$, \
$CellContext`raytiltz$, $CellContext`reporteddummyrayspresent$, \
$CellContext`reportedlocalrays$, $CellContext`reportedrays$, \
$CellContext`reportedrayspresent$, $CellContext`resonateintersections$, \
$CellContext`resonatenumber$, $CellContext`resonateraylength$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`rotationaxis$, $CellContext`rsx$, $CellContext`LocRSx$, \
$CellContext`rsy$, $CellContext`LocRSy$, $CellContext`rsz$, \
$CellContext`LocRSz$, 
           Optica`Optica`RTx$, $CellContext`LocRTy$, $CellContext`LocRTz$, \
$CellContext`rx$, $CellContext`rxhlp$, $CellContext`ry$, $CellContext`ryhlp$, \
$CellContext`rz$, $CellContext`rzhlp$, $CellContext`LocSCx$, \
$CellContext`LocSCy$, $CellContext`sid$, $CellContext`sinangle$, \
$CellContext`sno1$, $CellContext`sno2$, $CellContext`sno3$, \
$CellContext`sno4$, $CellContext`surfaceid$, $CellContext`surfacenumber$, \
$CellContext`surfacerotationmatrix$, $CellContext`surfacetranslationvector$, \
$CellContext`surfnorm$, $CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$, $CellContext`tempclonedata$, \
$CellContext`terminatedeflection$, $CellContext`thresholdintensity$, \
$CellContext`tiltmagnitude$, $CellContext`transmatrix$, $CellContext`LocTV1$, \
$CellContext`LocTV10$, $CellContext`LocTV2$, $CellContext`LocTV3$, \
$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$, \
$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$, \
$CellContext`u$, $CellContext`unfilteredintersections$, $CellContext`unit$, \
$CellContext`uu$, $CellContext`ver$, $CellContext`wavelength$, \
$CellContext`XAxis$, $CellContext`xunit$, $CellContext`YAxis$, \
$CellContext`yunit$, $CellContext`ZAxis$, $CellContext`zunit$}, \
$CellContext`activeregion$ = 
           1.; $CellContext`allcreatedamplitudes$ = {{
             0. + 0. I, 0. + 0. I, 0. + 
              0. I}}; $CellContext`allcreatedrays$ = {{
            1.}}; $CellContext`allowzeroraylength$ = 
           True; $CellContext`alternateindex$ = 
           1.; $CellContext`amplitude$ = {
            1. + 0. I, 0. + 0. I, 0. + 0. I}; $CellContext`axismagnitude$ = 
           1.; $CellContext`axismatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 
            0., 1.}}; $CellContext`clonedata$ = {{
            1.}}; $CellContext`clonegenerationnumber$ = 
           1.; $CellContext`cloneinput$ = {1.}; $CellContext`clonenumber$ = 
           1; $CellContext`cloneposition$ = {0., 0., 
            0.}; $CellContext`clonereportedrays$ = {{
            1.}}; $CellContext`clonerotation$ = {{
            1.}}; $CellContext`clonescale$ = 
           1.; $CellContext`clonescalevector$ = {
            1.}; $CellContext`clonesorthistogram$ = {
            1}; $CellContext`clonetraceinput$ = {{
            1.}}; $CellContext`clonetraceoutput$ = {{
            1.}}; $CellContext`closestdistances$ = {
            1.}; $CellContext`closestposition$ = 
           0; $CellContext`closestpositions$ = {
            0}; $CellContext`closestraylength$ = 
           1.; $CellContext`completedray$ = {
            1.}; $CellContext`componentnumber$ = -1.; $CellContext`cosangle$ = 
           1.; $CellContext`crossmatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 
            0., 1.}}; $CellContext`deflecteddummyrayspresent$ = 
           False; $CellContext`deflectedlocalrays$ = {{
            1.}}; $CellContext`deflectedrays$ = {{
            1.}}; $CellContext`deflectedrayspresent$ = 
           False; $CellContext`dummymatrix$ = {{
            1.}}; $CellContext`dummymatrixlist$ = {{{
            1.}}}; $CellContext`dummyvector$ = {1.}; $CellContext`exitvalue$ = 
           1.; $CellContext`frontid$ = 1.; $CellContext`generationlimit$ = 
           200.; $CellContext`generationnumber$ = 
           1.; $CellContext`holeintersections$ = {{-1., 0., 
            0.}}; $CellContext`holeQ$ = 
           False; $CellContext`holeQlist$ = {0}; $CellContext`hor$ = 
           1. + 0. I; $CellContext`index$ = 1.; $CellContext`index1$ = 
           1.; $CellContext`index2$ = 
           1.; $CellContext`inrays$ = {{1.}}; $CellContext`intensity$ = 
           1.; $CellContext`intensityscale$ = 
           1.; $CellContext`intersectionnumber$ = 
           1.; $CellContext`intersections$ = {{-1., 0., 
            0.}}; $CellContext`intersectionslist$ = {{{-1., 0., 
            0.}}}; $CellContext`intersectionspresent$ = 
           False; $CellContext`localdummyoutrayspresent$ = 
           False; $CellContext`localoutrays$ = {{
            1.}}; $CellContext`localoutrayspresent$ = 
           False; $CellContext`magnitude$ = 
           1.; $CellContext`maxclonegenerationnumber$ = 
           1.; $CellContext`maximumposition$ = 
           1; $CellContext`minimumraylength$ = 
           0.0001; $CellContext`minresonateraylength$ = 1.; $CellContext`n12$ = 
           1.; $CellContext`newcomponentnumber$ = -1.; \
$CellContext`newdeflectedrays$ = {{1.}}; $CellContext`newdistance$ = 
           1.; $CellContext`newsurfaceid$ = -1.; \
$CellContext`newsurfacenumber$ = -1.; $CellContext`nonintersectingrays$ = {{
            1.}}; $CellContext`normalizedpolarization$ = {1., 
            1.}; $CellContext`oldgenerationnumber$ = 
           1.; $CellContext`opticallength$ = 
           1.; $CellContext`originalray$ = {
            1.}; $CellContext`originalraytilt$ = {
            1.}; $CellContext`originalrotation$ = {{1., 0., 0.}, {0., 1., 
            0.}, {0., 0., 1.}}; $CellContext`originalsurfnorm$ = {{
            1.}}; $CellContext`outrays$ = {{
            1.}}; $CellContext`parallelamplitude$ = 
           1. + 0. I; $CellContext`PAxis$ = {1., 0., 
            0.}; $CellContext`perpendicularamplitude$ = 
           1. + 0. I; $CellContext`phaseshift$ = 0.; $CellContext`pol1$ = 
           1.; $CellContext`pol2$ = 1.; $CellContext`pol3$ = 
           1.; $CellContext`previoustilt$ = {1., 0., 
            0.}; $CellContext`propagate$ = 
           True; $CellContext`propagatedrays$ = {{1.}}; $CellContext`r1$ = 
           1.; $CellContext`r2$ = 1.; $CellContext`r3$ = 1.; $CellContext`r4$ = 
           1.; $CellContext`r5$ = 1.; $CellContext`r6$ = 1.; $CellContext`r7$ = 
           1.; $CellContext`r8$ = 1.; $CellContext`r9$ = 
           1.; $CellContext`ray1$ = 1.; $CellContext`ray2$ = 
           1.; $CellContext`ray3$ = 1.; $CellContext`LocRayL$ = 
           1.; $CellContext`rayslot$ = 1.; $CellContext`raysreported$ = 
           False; $CellContext`raytiltx$ = 1.; $CellContext`raytiltz$ = 
           1.; $CellContext`reporteddummyrayspresent$ = 
           False; $CellContext`reportedlocalrays$ = {{
            1.}}; $CellContext`reportedrays$ = {{
            1.}}; $CellContext`reportedrayspresent$ = 
           False; $CellContext`resonateintersections$ = {{-1., 0., 
            0.}}; $CellContext`resonatenumber$ = 
           0; $CellContext`resonateraylength$ = 1.; $CellContext`rex$ = 
           1.; $CellContext`rey$ = 1.; $CellContext`rez$ = 
           1.; $CellContext`rsx$ = 1.; $CellContext`LocRSx$ = 
           1.; $CellContext`rsy$ = 1.; $CellContext`LocRSy$ = 
           1.; $CellContext`rsz$ = 1.; $CellContext`LocRSz$ = 1.; 
          Optica`Optica`RTx$ = 1.; $CellContext`LocRTy$ = 
           1.; $CellContext`LocRTz$ = 1.; $CellContext`rx$ = 
           1.; $CellContext`rxhlp$ = 1.; $CellContext`ry$ = 
           1.; $CellContext`ryhlp$ = 1.; $CellContext`rz$ = 
           1.; $CellContext`rzhlp$ = 1.; $CellContext`LocSCx$ = 
           1.; $CellContext`LocSCy$ = 1.; $CellContext`sid$ = 
           1.; $CellContext`sinangle$ = 1.; $CellContext`sno1$ = 
           1.; $CellContext`sno2$ = 1.; $CellContext`sno3$ = 
           1.; $CellContext`sno4$ = 
           1.; $CellContext`surfaceid$ = -1.; $CellContext`surfacenumber$ = \
-1.; $CellContext`surfacerotationmatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 
            0., 1.}}; $CellContext`surfacetranslationvector$ = {0., 0., 
            0.}; $CellContext`surfnorm$ = {{1.}}; $CellContext`symr1$ = 
           1.; $CellContext`symr2$ = 1.; $CellContext`symr3$ = 
           1.; $CellContext`symr4$ = 1.; $CellContext`symr5$ = 
           1.; $CellContext`symr6$ = 1.; $CellContext`symr7$ = 
           1.; $CellContext`symr8$ = 1.; $CellContext`symr9$ = 
           1.; $CellContext`tempclonedata$ = {{
            1.}}; $CellContext`terminatedeflection$ = 
           False; $CellContext`thresholdintensity$ = 
           1.; $CellContext`tiltmagnitude$ = 
           1.; $CellContext`transmatrix$ = {{{1., 0., 0.}, {0., 1., 0.}, {0., 
            0., 1.}}}; $CellContext`LocTV1$ = 1.; $CellContext`LocTV10$ = 
           1.; $CellContext`LocTV2$ = 1.; $CellContext`LocTV3$ = 
           1.; $CellContext`LocTV4$ = 1.; $CellContext`LocTV5$ = 
           1.; $CellContext`LocTV6$ = 1.; $CellContext`LocTV7$ = 
           1.; $CellContext`LocTV8$ = 1.; $CellContext`LocTV9$ = 
           1.; $CellContext`u$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
            1.}}; $CellContext`unfilteredintersections$ = {{-1., 0., 
            0.}}; $CellContext`unit$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
            1.}}; $CellContext`uu$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
            1.}}; $CellContext`ver$ = 0. + 0. I; $CellContext`wavelength$ = 
           1.; $CellContext`XAxis$ = {1., 0., 0.}; $CellContext`xunit$ = 
           1.; $CellContext`YAxis$ = {1., 0., 0.}; $CellContext`yunit$ = 
           1.; $CellContext`ZAxis$ = {1., 0., 0.}; $CellContext`zunit$ = 
           1.; {$CellContext`r1$, $CellContext`dr1$} = {1., 
            1.}; {$CellContext`rx$, $CellContext`ry$, $CellContext`rz$} = {1.,
             1., 1.}; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = {1., 1., 1.}; $CellContext`propagatedrays$ = 
           Join[{$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = Re[{
                 Cos[Degree $CellContext`th$$], 
                 Sin[Degree $CellContext`th$$], 0, -
                 Sin[Degree $CellContext`th$$], 
                 Cos[Degree $CellContext`th$$], 0, 0, 0, 1}]; 
             Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$, $CellContext`rsx$ $CellContext`symr2$ + $CellContext`rsy$ \
$CellContext`symr5$ + $CellContext`rsz$ $CellContext`symr8$ + \
$CellContext`y$$, $CellContext`rsx$ $CellContext`symr3$ + $CellContext`rsy$ \
$CellContext`symr6$ + $CellContext`rsz$ $CellContext`symr9$}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}; \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$} = \
{$CellContext`rex$ $CellContext`symr1$ + $CellContext`rey$ \
$CellContext`symr4$ + $CellContext`rez$ $CellContext`symr7$ + \
$CellContext`x$$, $CellContext`rex$ $CellContext`symr2$ + $CellContext`rey$ \
$CellContext`symr5$ + $CellContext`rez$ $CellContext`symr8$ + \
$CellContext`y$$, $CellContext`rex$ $CellContext`symr3$ + $CellContext`rey$ \
$CellContext`symr6$ + $CellContext`rez$ $CellContext`symr9$}; \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$} = \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}; \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$} = \
{$CellContext`r1$ $CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + \
$CellContext`r3$ $CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + \
$CellContext`r2$ $CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, \
$CellContext`r1$ $CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + \
$CellContext`r3$ $CellContext`symr9$}; {$CellContext`LocTV4$, \
$CellContext`LocTV5$, $CellContext`LocTV6$} = {$CellContext`r4$ \
$CellContext`symr1$ + $CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ \
$CellContext`symr7$, $CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ \
$CellContext`symr5$ + $CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ \
$CellContext`symr3$ + $CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ \
$CellContext`symr9$}; {$CellContext`LocTV7$, $CellContext`LocTV8$, \
$CellContext`LocTV9$} = {$CellContext`r7$ $CellContext`symr1$ + \
$CellContext`r8$ $CellContext`symr4$ + $CellContext`r9$ $CellContext`symr7$, \
$CellContext`r7$ $CellContext`symr2$ + $CellContext`r8$ $CellContext`symr5$ + \
$CellContext`r9$ $CellContext`symr8$, $CellContext`r7$ $CellContext`symr3$ + \
$CellContext`r8$ $CellContext`symr6$ + $CellContext`r9$ $CellContext`symr9$}; \
{{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}} = {{$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$}, {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$}, {$CellContext`LocTV7$, $CellContext`LocTV8$, \
$CellContext`LocTV9$}}; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , CompressedData["
1:eJxTTMoPSmViYGDgBmJ1BnTwYz+GEFbxD/bY1REvv0BK/64K20OoukgHN/HY
kouu2+H6nigFd0kx4jKHkPkQ4FB9wwGZRuhTQ+MT7250EWMw+IwRbtjFh2q4
MUBpNTQ+8e5GFzkDBm8wwg27+FANNw4orYbGJ97d6CJG4HT1GCPcsIsP1XAT
gNJqaHzi3Y0uYgAOn8sY4YZdfKiGmwiUVkPjE+9u7OIbbIgTH6rhJgGl1dD4
xLsbXcQCkq6IFB+q4SYDpdXQ+MS7G13EDFKOESk+VMNNAUqrofGJdze6yAVI
vUmk+FANNyUorYbGJ97d6CKmkHYakeJDNdxUoLQaGp94d6OLMIHJH0SKD9Vw
U8NBE+9uGAsATW8z/Q==
               "]]]; $CellContext`propagatedrays$ = 
           Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`componentnumber$ = 
              1.; $CellContext`frontid$ = 
              1.; {$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`propagatedrays$]; \
$CellContext`thresholdintensity$ = 1.; $CellContext`generationlimit$ = 
           200.; $CellContext`reportedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`generationnumber$ = 0.; (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  3.5999999999999996` + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1. + I 0.; $CellContext`LocSCx$ = 
                    1. + I 0.; $CellContext`LocSCy$ = 1. + I 0.; Re[
                    Select[{{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {(
                    386. $CellContext`xunit$ - (
                    37. $CellContext`rx$) $CellContext`xunit$ - (
                    50. $CellContext`ry$) $CellContext`yunit$ - (
                    50. $CellContext`rz$) $CellContext`zunit$ - 
                    1.4142135623730951` 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`ry$) $CellContext`xunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`yunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`yunit$ - ((
                    50. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + (50. $CellContext`ry$) $CellContext`zunit$^2 - (
                    1.4142135623730951` $CellContext`yunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`rz$) $CellContext`xunit$^2 + (
                    50. $CellContext`rz$) $CellContext`yunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`zunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`zunit$ - ((
                    50. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ - (1.4142135623730951` $CellContext`zunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2)}, {(
                    386. $CellContext`xunit$ - (
                    37. $CellContext`rx$) $CellContext`xunit$ - (
                    50. $CellContext`ry$) $CellContext`yunit$ - (
                    50. $CellContext`rz$) $CellContext`zunit$ + 
                    1.4142135623730951` 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`ry$) $CellContext`xunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`yunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`yunit$ - ((
                    50. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + (50. $CellContext`ry$) $CellContext`zunit$^2 + (
                    1.4142135623730951` $CellContext`yunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`rz$) $CellContext`xunit$^2 + (
                    50. $CellContext`rz$) $CellContext`yunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`zunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`zunit$ - ((
                    50. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ + (1.4142135623730951` $CellContext`zunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2)}}, ({$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[
                    Re[$CellContext`LocRayL$]]] >= 0., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ - (25 ($CellContext`LocSCx$^2 + $CellContext`LocSCy$^2))/(
                    193 (1 + Sqrt[
                    1 - (925 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/74498]))] < 1.*^-7, 
                    Re[$CellContext`LocSCx$]^2 + Re[$CellContext`LocSCy$]^2 <= 
                    39.0625]])& ]]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24990.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 1., 
                    24990.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 1., 
                    24990.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-3.5999999999999996` + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., ((-0.0016083472422043674`) $CellContext`ray2$^3)/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - ((
                    0.0016083472422043674` $CellContext`ray2$) \
$CellContext`ray3$^2)/(Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.2590673575129534 $CellContext`ray2$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), (((-0.0016083472422043674`) $CellContext`ray2$^2) \
$CellContext`ray3$)/(Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.0016083472422043674` $CellContext`ray3$^3)/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.2590673575129534 $CellContext`ray3$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])}, {((
                    0.0016083472422043674` $CellContext`ray2$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.2590673575129534 $CellContext`ray2$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 1., 
                    0.}, {((
                    0.0016083472422043674` $CellContext`ray3$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.2590673575129534 $CellContext`ray3$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 
                    1. Re[{{1., ((-0.0016083472422043674`) (
                    1.*^-6 + $CellContext`ray2$)^3)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - ((
                    0.0016083472422043674` (1.*^-6 + $CellContext`ray2$)) (
                    1.*^-6 + $CellContext`ray3$)^2)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), \
(((-0.0016083472422043674`) (1.*^-6 + $CellContext`ray2$)^2) (
                    1.*^-6 + $CellContext`ray3$))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.0016083472422043674` (1.*^-6 + $CellContext`ray3$)^3)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])}, {((
                    0.0016083472422043674` (
                    1.*^-6 + $CellContext`ray2$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 1., 
                    0.}, {((0.0016083472422043674` (
                    1.*^-6 + $CellContext`ray3$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-3.5999999999999996`, 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[
                    1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  3.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - 6.5 $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) 6.5; 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    25., Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-6.5 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[42.25 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    25., Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-6.5 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[42.25 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24991.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 2., 
                    24991.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 2., 
                    24991.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-3.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., -($CellContext`ray2$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1))), -($CellContext`ray3$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)))}, {$CellContext`ray2$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 1., 
                    0.}, {$CellContext`ray3$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 0., 1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-3.05, 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  0.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 
                    6.25], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24992.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 3., 
                    
                    24992.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 3., 
                    24992.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-0.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-0.05, 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
{$CellContext`rx$, $CellContext`ry$, $CellContext`rz$} = 
                    Dot[{$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} - {-0.05, 0, 0}, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}/Sqrt[
                    
                    Dot[{$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}, {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}]]; $CellContext`r1$ = $CellContext`ry$; \
$CellContext`dr1$ = $CellContext`yunit$/
                    Abs[$CellContext`xunit$]; $CellContext`ry$ = 
                    Plus[$CellContext`r1$]; $CellContext`dry = \
((-$CellContext`focus$$)/
                    1000) $CellContext`r1$ + $CellContext`dr1$; \
$CellContext`r1$ = $CellContext`rz$; $CellContext`dr1$ = $CellContext`zunit$/
                    Abs[$CellContext`xunit$]; $CellContext`rz$ = 
                    Plus[$CellContext`r1$]; $CellContext`drz = \
((-$CellContext`focus$$)/
                    1000) $CellContext`r1$ + $CellContext`dr1$; \
$CellContext`exitvalue$ = (0& )[
                    First[{$CellContext`ray2$, $CellContext`ray3$}], 
                    Last[{$CellContext`ray2$, $CellContext`ray3$}]] 
                    1.0000001; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`exitvalue$; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = 
                    Dot[{Sign[$CellContext`xunit$] $CellContext`exitvalue$, \
$CellContext`ry$, $CellContext`rz$}, {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}] + {-0.05, 0, 
                    0}; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = Dot[{
                    Sign[$CellContext`xunit$]/(Sqrt[1 + $CellContext`dry^2] 
                    Sqrt[1 + $CellContext`drz^2]), $CellContext`dry/Sqrt[
                    1 + $CellContext`dry^2], $CellContext`drz/(
                    Sqrt[1 + $CellContext`drz^2] 
                    Sqrt[1 + $CellContext`dry^2])}, {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}]; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}/Sqrt[
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  0.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 25.], {
                    
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24993.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; $CellContext`intersections$ = Union[
                    Map[
                    If[Part[#, 2]^2 + Part[#, 3]^2 <= 
                    6.25, $CellContext`holeQ$ = True; {-1., 0., 
                    0.}, #]& , $CellContext`unfilteredintersections$]]; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 4., 
                    24993.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 4., 
                    24993.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-0.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-0.05, 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 
                    35.19455625000001], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24994.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; $CellContext`intersections$ = Union[
                    Map[
                    If[Part[#, 2]^2 + Part[#, 3]^2 <= 
                    28.810056249999995`, $CellContext`holeQ$ = True; {-1., 0.,
                     0.}, #]& , $CellContext`unfilteredintersections$]]; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 5., 
                    24994.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 5., 
                    24994.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`surfaceapprox, \
$CellContext`tempapprox, $CellContext`intersects, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1.; $CellContext`LocSCx$ = 1.; $CellContext`LocSCy$ = 
                    1.; $CellContext`surfaceapprox = {{-1., 0., 
                    0.}}; $CellContext`tempapprox = {{-1., 0., 
                    0.}}; $CellContext`intersects = {{-1., 0., 
                    0.}}; $CellContext`surfaceapprox = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - 10.2 $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) 10.2; 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-10.2 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[104.03999999999999` - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-10.2 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[104.03999999999999` - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 
                    0.}}]]; $CellContext`tempapprox = Union[
                    Join[
                    Map[Take[#, 3]& , $CellContext`surfaceapprox], {{-1., 0., 
                    0.}}]]; If[Length[
                    Select[$CellContext`tempapprox, Chop[
                    First[#]] <= 0& ]] != 
                    Length[$CellContext`tempapprox], \
$CellContext`surfaceapprox = Select[$CellContext`tempapprox, Chop[
                    First[#]] > 0& ], $CellContext`surfaceapprox = {{-1., 0., 
                    0.}}]; If[$CellContext`surfaceapprox != {{-1., 0., 
                    0.}}, $CellContext`intersects = {{-1., 0., 0.}}; 
                    Scan[(AppendTo[$CellContext`intersects, \
{$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}; If[Apply[Plus, 
                    
                    Abs[{$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$, $CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$, $CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$} - {(
                    0.09803921568627452 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/(1 + Sqrt[
                    1 + 0.020488273740868906` ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2)]), $CellContext`LocSCx$, $CellContext`LocSCy$}]] < 
                    1.*^-9, {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 0.99 $CellContext`LocRayL$; 
                    Function[{$CellContext`rx, $CellContext`ry, \
$CellContext`rz, $CellContext`xunit, $CellContext`yunit, $CellContext`zunit, \
$CellContext`startpoint}, 
                    
                    Block[{$CellContext`values, $CellContext`stepsizes, \
$CellContext`fvector, $CellContext`success, $CellContext`steps, \
$CellContext`denominator}, $CellContext`values = {
                    1.}; $CellContext`stepsizes = {
                    1.}; $CellContext`fvector = {1.}; $CellContext`success = 
                    False; $CellContext`steps = 0; $CellContext`denominator = 
                    1.; $CellContext`stepsizes = 
                    Table[1.0000000000000001`*^-7, {
                    3}]; $CellContext`values = $CellContext`startpoint; 
                    While[
                    
                    And[$CellContext`steps < 50, $CellContext`success = True; 
                    Map[If[Abs[#] > 1.*^-9, $CellContext`success = False; 1., 
                    1.]& , $CellContext`stepsizes]; 
                    Not[$CellContext`success]], $CellContext`steps = \
$CellContext`steps + 
                    1; $CellContext`fvector = {$CellContext`rx + \
$CellContext`xunit Part[$CellContext`values, 
                    1], $CellContext`ry + $CellContext`yunit 
                    Part[$CellContext`values, 
                    1], $CellContext`rz + $CellContext`zunit 
                    Part[$CellContext`values, 1]} - {(
                    0.09803921568627452 (Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)]), 
                    Part[$CellContext`values, 2], 
                    
                    Part[$CellContext`values, 
                    3]}; $CellContext`denominator = $CellContext`xunit - \
$CellContext`yunit ((((0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) (-1)) - $CellContext`zunit ((((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) (-1)); 
                    If[Chop[$CellContext`denominator] != 
                    0, $CellContext`denominator, $CellContext`denominator = 
                    1.]; $CellContext`stepsizes = -
                    Map[Dot[#, $CellContext`fvector]& , {{
                    1, -((((0.002008654288320481 
                    Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) (-1)), -((((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) (-1))}, {$CellContext`yunit, -$CellContext`xunit - \
(((0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) $CellContext`zunit, (((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`yunit}, {$CellContext`zunit, (((
                    0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`zunit, -$CellContext`xunit - (((
                    0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`yunit}}/$CellContext`denominator]; \
$CellContext`values = $CellContext`values + $CellContext`stepsizes]; 
                    If[$CellContext`steps >= 50, 
                    If[First[$CellContext`values] > 
                    0, $CellContext`values = -$CellContext`values; 1., 
                    1.]; $CellContext`denominator = 1., 
                    1.]; $CellContext`values]][$CellContext`rx$, \
$CellContext`ry$, $CellContext`rz$, $CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$, {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}]]]; {-1., 0., 0.})& , $CellContext`surfaceapprox]; 
                    Union[
                    Re[
                    
                    Select[$CellContext`intersects, ({$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, Apply[Plus, 
                    
                    Abs[{$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$, $CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$, $CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$} - {(
                    0.09803921568627452 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/(1 + Sqrt[1 + 
                    0.020488273740868906` ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2)]), $CellContext`LocSCx$, $CellContext`LocSCy$}]] < 
                    1.*^-9]])& ]]], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24995.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 6., 
                    24995.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 6., 
                    24995.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., (0.002008654288320481 $CellContext`ray2$^3)/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + ((
                    0.002008654288320481 $CellContext`ray2$) \
$CellContext`ray3$^2)/(Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.19607843137254904` $CellContext`ray2$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), ((
                    0.002008654288320481 $CellContext`ray2$^2) \
$CellContext`ray3$)/(Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.002008654288320481 $CellContext`ray3$^3)/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.19607843137254904` $CellContext`ray3$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])}, {(((-0.002008654288320481) $CellContext`ray2$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.19607843137254904` $CellContext`ray2$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 1., 
                    0.}, {(((-0.002008654288320481) $CellContext`ray3$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.19607843137254904` $CellContext`ray3$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 
                    1. Re[{{1., (
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)^3)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + ((
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)) (
                    1.*^-6 + $CellContext`ray3$)^2)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), ((
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)^2) (
                    1.*^-6 + $CellContext`ray3$))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.002008654288320481 (1.*^-6 + $CellContext`ray3$)^3)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])}, \
{(((-0.002008654288320481) (1.*^-6 + $CellContext`ray2$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 1., 
                    0.}, {(((-0.002008654288320481) (
                    1.*^-6 + $CellContext`ray3$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -4. + \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1. + I 0.; $CellContext`LocSCx$ = 
                    1. + I 0.; $CellContext`LocSCy$ = 1. + I 0.; Re[
                    Select[
                    
                    If[$CellContext`yunit$^2 + $CellContext`zunit$^2 == 
                    0., {{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {(((-0.08333333333333333) (
                    12. $CellContext`rx$ + $CellContext`ry$^2 + \
$CellContext`rz$^2)) 
                    Sqrt[$CellContext`xunit$^2])/$CellContext`xunit$^2, \
($CellContext`ry$ 
                    Sqrt[$CellContext`xunit$^2])/$CellContext`xunit$, \
$CellContext`rz$}}, {{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {((-6.) $CellContext`xunit$ - (
                    1. $CellContext`ry$) $CellContext`yunit$ - (
                    1. $CellContext`rz$) $CellContext`zunit$ - 1. 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
(((-6.) $CellContext`xunit$) $CellContext`yunit$ - ((
                    1. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`ry$ $CellContext`zunit$^2 - (
                    1. $CellContext`yunit$) 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
($CellContext`rz$ $CellContext`yunit$^2 - (
                    6. $CellContext`xunit$) $CellContext`zunit$ - ((
                    1. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ - (1. $CellContext`zunit$) 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2)}, \
{((-6.) $CellContext`xunit$ - (1. $CellContext`ry$) $CellContext`yunit$ - (
                    1. $CellContext`rz$) $CellContext`zunit$ + 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
(((-6.) $CellContext`xunit$) $CellContext`yunit$ - ((
                    1. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`ry$ $CellContext`zunit$^2 + \
$CellContext`yunit$ Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
($CellContext`rz$ $CellContext`yunit$^2 - (
                    6. $CellContext`xunit$) $CellContext`zunit$ - ((
                    1. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`zunit$ 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2)}}], \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[
                    Re[$CellContext`LocRayL$]]] >= 0., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + ($CellContext`LocSCx$^2 + $CellContext`LocSCy$^2)/12] < 
                    1.*^-7, Re[$CellContext`LocSCx$]^2 + 
                    Re[$CellContext`LocSCy$]^2 <= 31.922500000000003`]])& ]]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24996.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 7., 
                    24996.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 7., 
                    24996.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    
                    4. + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 1. Re[{{1., 
                    Plus[(0.3333333333333333 $CellContext`ray2$)/(1. + Sqrt[
                    Plus[1.]])], 
                    Plus[(0.3333333333333333 $CellContext`ray3$)/(1. + Sqrt[
                    Plus[1.]])]}, {
                    
                    Plus[((-0.3333333333333333) $CellContext`ray2$)/(1. + 
                    Sqrt[
                    Plus[1.]])], 1., 0.}, {
                    
                    Plus[((-0.3333333333333333) $CellContext`ray3$)/(1. + 
                    Sqrt[
                    Plus[1.]])], 0., 1.}}]; If[
                    Or[Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 1. Re[{{1., 
                    
                    Plus[(0.3333333333333333 (1.*^-6 + $CellContext`ray2$))/(
                    1. + Sqrt[
                    Plus[1.]])], 
                    
                    Plus[(0.3333333333333333 (1.*^-6 + $CellContext`ray3$))/(
                    1. + Sqrt[
                    Plus[1.]])]}, {
                    
                    Plus[((-0.3333333333333333) (
                    1.*^-6 + $CellContext`ray2$))/(1. + Sqrt[
                    Plus[1.]])], 1., 0.}, {
                    
                    Plus[((-0.3333333333333333) (
                    1.*^-6 + $CellContext`ray3$))/(1. + Sqrt[
                    Plus[1.]])], 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    4., 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -20.3203 + \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - (-12) $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) (-12); 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    142.80249999999998`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[12 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ - 
                    Sqrt[144 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    142.80249999999998`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[12 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ - 
                    Sqrt[144 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24997.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 8., 
                    24997.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 8., 
                    24997.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    20.3203 + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., -((-$CellContext`ray2$)/(
                    144 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1))), -((-$CellContext`ray3$)/(
                    144 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)))}, {(-$CellContext`ray2$)/(
                    144 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 1., 
                    0.}, {(-$CellContext`ray3$)/(
                    144 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 0., 1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    20.3203, 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -4. + \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1. + I 0.; $CellContext`LocSCx$ = 
                    1. + I 0.; $CellContext`LocSCy$ = 1. + I 0.; Re[
                    Select[
                    
                    If[$CellContext`yunit$^2 + $CellContext`zunit$^2 == 
                    0., {{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {(((-0.08333333333333333) (
                    12. $CellContext`rx$ + $CellContext`ry$^2 + \
$CellContext`rz$^2)) 
                    Sqrt[$CellContext`xunit$^2])/$CellContext`xunit$^2, \
($CellContext`ry$ 
                    Sqrt[$CellContext`xunit$^2])/$CellContext`xunit$, \
$CellContext`rz$}}, {{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {((-6.) $CellContext`xunit$ - (
                    1. $CellContext`ry$) $CellContext`yunit$ - (
                    1. $CellContext`rz$) $CellContext`zunit$ - 1. 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
(((-6.) $CellContext`xunit$) $CellContext`yunit$ - ((
                    1. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`ry$ $CellContext`zunit$^2 - (
                    1. $CellContext`yunit$) 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
($CellContext`rz$ $CellContext`yunit$^2 - (
                    6. $CellContext`xunit$) $CellContext`zunit$ - ((
                    1. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ - (1. $CellContext`zunit$) 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2)}, \
{((-6.) $CellContext`xunit$ - (1. $CellContext`ry$) $CellContext`yunit$ - (
                    1. $CellContext`rz$) $CellContext`zunit$ + 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
(((-6.) $CellContext`xunit$) $CellContext`yunit$ - ((
                    1. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`ry$ $CellContext`zunit$^2 + \
$CellContext`yunit$ Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
($CellContext`rz$ $CellContext`yunit$^2 - (
                    6. $CellContext`xunit$) $CellContext`zunit$ - ((
                    1. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`zunit$ 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2)}}], \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[
                    Re[$CellContext`LocRayL$]]] >= 0., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + ($CellContext`LocSCx$^2 + $CellContext`LocSCy$^2)/12] < 
                    1.*^-7, Re[$CellContext`LocSCx$]^2 + 
                    Re[$CellContext`LocSCy$]^2 <= 31.922500000000003`]])& ]]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24998.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 9., 
                    24998.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 9., 
                    24998.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    4. + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 1. Re[{{1., 
                    Plus[(0.3333333333333333 $CellContext`ray2$)/(1. + Sqrt[
                    Plus[1.]])], 
                    Plus[(0.3333333333333333 $CellContext`ray3$)/(1. + Sqrt[
                    Plus[1.]])]}, {
                    
                    Plus[((-0.3333333333333333) $CellContext`ray2$)/(1. + 
                    Sqrt[
                    Plus[1.]])], 1., 0.}, {
                    
                    Plus[((-0.3333333333333333) $CellContext`ray3$)/(1. + 
                    Sqrt[
                    Plus[1.]])], 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 1. Re[{{1., 
                    
                    Plus[(0.3333333333333333 (1.*^-6 + $CellContext`ray2$))/(
                    1. + Sqrt[
                    Plus[1.]])], 
                    
                    Plus[(0.3333333333333333 (1.*^-6 + $CellContext`ray3$))/(
                    1. + Sqrt[
                    Plus[1.]])]}, {
                    
                    Plus[((-0.3333333333333333) (
                    1.*^-6 + $CellContext`ray2$))/(1. + Sqrt[
                    Plus[1.]])], 1., 0.}, {
                    
                    Plus[((-0.3333333333333333) (
                    1.*^-6 + $CellContext`ray3$))/(1. + Sqrt[
                    Plus[1.]])], 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    4., 0, 0}; $CellContext`activeregion$ = 
                    
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`surfaceapprox, \
$CellContext`tempapprox, $CellContext`intersects, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1.; $CellContext`LocSCx$ = 1.; $CellContext`LocSCy$ = 
                    1.; $CellContext`surfaceapprox = {{-1., 0., 
                    0.}}; $CellContext`tempapprox = {{-1., 0., 
                    0.}}; $CellContext`intersects = {{-1., 0., 
                    0.}}; $CellContext`surfaceapprox = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - 10.2 $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) 10.2; 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-10.2 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[104.03999999999999` - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-10.2 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[104.03999999999999` - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 
                    0.}}]]; $CellContext`tempapprox = Union[
                    Join[
                    Map[Take[#, 3]& , $CellContext`surfaceapprox], {{-1., 0., 
                    0.}}]]; If[Length[
                    Select[$CellContext`tempapprox, Chop[
                    First[#]] <= 0& ]] != 
                    Length[$CellContext`tempapprox], \
$CellContext`surfaceapprox = Select[$CellContext`tempapprox, Chop[
                    First[#]] > 0& ], $CellContext`surfaceapprox = {{-1., 0., 
                    0.}}]; If[$CellContext`surfaceapprox != {{-1., 0., 
                    0.}}, $CellContext`intersects = {{-1., 0., 0.}}; 
                    Scan[(AppendTo[$CellContext`intersects, \
{$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}; If[Apply[Plus, 
                    
                    Abs[{$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$, $CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$, $CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$} - {(
                    0.09803921568627452 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/(1 + Sqrt[
                    1 + 0.020488273740868906` ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2)]), $CellContext`LocSCx$, $CellContext`LocSCy$}]] < 
                    1.*^-9, {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 0.99 $CellContext`LocRayL$; 
                    Function[{$CellContext`rx, $CellContext`ry, \
$CellContext`rz, $CellContext`xunit, $CellContext`yunit, $CellContext`zunit, \
$CellContext`startpoint}, 
                    
                    Block[{$CellContext`values, $CellContext`stepsizes, \
$CellContext`fvector, $CellContext`success, $CellContext`steps, \
$CellContext`denominator}, $CellContext`values = {
                    1.}; $CellContext`stepsizes = {
                    1.}; $CellContext`fvector = {1.}; $CellContext`success = 
                    False; $CellContext`steps = 0; $CellContext`denominator = 
                    1.; $CellContext`stepsizes = 
                    Table[1.0000000000000001`*^-7, {
                    3}]; $CellContext`values = $CellContext`startpoint; 
                    While[
                    
                    And[$CellContext`steps < 50, $CellContext`success = True; 
                    Map[If[Abs[#] > 1.*^-9, $CellContext`success = False; 1., 
                    1.]& , $CellContext`stepsizes]; 
                    Not[$CellContext`success]], $CellContext`steps = \
$CellContext`steps + 
                    1; $CellContext`fvector = {$CellContext`rx + \
$CellContext`xunit Part[$CellContext`values, 
                    1], $CellContext`ry + $CellContext`yunit 
                    Part[$CellContext`values, 
                    1], $CellContext`rz + $CellContext`zunit 
                    Part[$CellContext`values, 1]} - {(
                    0.09803921568627452 (Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)]), 
                    Part[$CellContext`values, 2], 
                    
                    Part[$CellContext`values, 
                    3]}; $CellContext`denominator = $CellContext`xunit - \
$CellContext`yunit ((((0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) (-1)) - $CellContext`zunit ((((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) (-1)); 
                    If[Chop[$CellContext`denominator] != 
                    0, $CellContext`denominator, $CellContext`denominator = 
                    1.]; $CellContext`stepsizes = -
                    Map[Dot[#, $CellContext`fvector]& , {{
                    1, -((((0.002008654288320481 
                    Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) (-1)), -((((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) (-1))}, {$CellContext`yunit, -$CellContext`xunit - \
(((0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) $CellContext`zunit, (((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`yunit}, {$CellContext`zunit, (((
                    0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`zunit, -$CellContext`xunit - (((
                    0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`yunit}}/$CellContext`denominator]; \
$CellContext`values = $CellContext`values + $CellContext`stepsizes]; 
                    If[$CellContext`steps >= 50, 
                    If[First[$CellContext`values] > 
                    0, $CellContext`values = -$CellContext`values; 1., 
                    1.]; $CellContext`denominator = 1., 
                    1.]; $CellContext`values]][$CellContext`rx$, \
$CellContext`ry$, $CellContext`rz$, $CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$, {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}]]]; {-1., 0., 0.})& , $CellContext`surfaceapprox]; 
                    Union[
                    Re[
                    
                    Select[$CellContext`intersects, ({$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, Apply[Plus, 
                    
                    Abs[{$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$, $CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$, $CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$} - {(
                    0.09803921568627452 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/(1 + Sqrt[1 + 
                    0.020488273740868906` ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2)]), $CellContext`LocSCx$, $CellContext`LocSCy$}]] < 
                    1.*^-9]])& ]]], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24999.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 10., 
                    24999.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 10., 
                    24999.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., (0.002008654288320481 $CellContext`ray2$^3)/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + ((
                    0.002008654288320481 $CellContext`ray2$) \
$CellContext`ray3$^2)/(Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.19607843137254904` $CellContext`ray2$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), ((
                    0.002008654288320481 $CellContext`ray2$^2) \
$CellContext`ray3$)/(Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.002008654288320481 $CellContext`ray3$^3)/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.19607843137254904` $CellContext`ray3$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])}, {(((-0.002008654288320481) $CellContext`ray2$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.19607843137254904` $CellContext`ray2$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 1., 
                    0.}, {(((-0.002008654288320481) $CellContext`ray3$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.19607843137254904` $CellContext`ray3$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 
                    1. Re[{{1., (
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)^3)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + ((
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)) (
                    1.*^-6 + $CellContext`ray3$)^2)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), ((
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)^2) (
                    1.*^-6 + $CellContext`ray3$))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.002008654288320481 (1.*^-6 + $CellContext`ray3$)^3)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])}, \
{(((-0.002008654288320481) (1.*^-6 + $CellContext`ray2$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 1., 
                    0.}, {(((-0.002008654288320481) (
                    1.*^-6 + $CellContext`ray3$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 
                    32.56414225], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25000.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; $CellContext`intersections$ = Union[
                    Map[
                    If[Part[#, 2]^2 + Part[#, 3]^2 <= 
                    31.287242250000006`, $CellContext`holeQ$ = True; {-1., 0.,
                     0.}, #]& , $CellContext`unfilteredintersections$]]; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 11., 
                    25000.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 11., 
                    25000.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  0.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 
                    6.25], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25001.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 12., 
                    25001.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 12., 
                    25001.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-0.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 
                    1.}}; $CellContext`surfacetranslationvector$ = {-0.05, 0, 
                    0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
{$CellContext`rx$, $CellContext`ry$, $CellContext`rz$} = 
                    Dot[{$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} - {-0.05, 0, 0}, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}/Sqrt[
                    
                    Dot[{$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}, {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}]]; $CellContext`r1$ = $CellContext`ry$; \
$CellContext`dr1$ = $CellContext`yunit$/
                    Abs[$CellContext`xunit$]; $CellContext`ry$ = 
                    Plus[$CellContext`r1$]; $CellContext`dry = \
((-$CellContext`focus$$)/
                    1000) $CellContext`r1$ + $CellContext`dr1$; \
$CellContext`r1$ = $CellContext`rz$; $CellContext`dr1$ = $CellContext`zunit$/
                    Abs[$CellContext`xunit$]; $CellContext`rz$ = 
                    Plus[$CellContext`r1$]; $CellContext`drz = \
((-$CellContext`focus$$)/
                    1000) $CellContext`r1$ + $CellContext`dr1$; \
$CellContext`exitvalue$ = (0& )[
                    First[{$CellContext`ray2$, $CellContext`ray3$}], 
                    Last[{$CellContext`ray2$, $CellContext`ray3$}]] 
                    1.0000001; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`exitvalue$; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = 
                    Dot[{Sign[$CellContext`xunit$] $CellContext`exitvalue$, \
$CellContext`ry$, $CellContext`rz$}, {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}] + {-0.05, 0, 
                    0}; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = Dot[{
                    Sign[$CellContext`xunit$]/(Sqrt[1 + $CellContext`dry^2] 
                    Sqrt[1 + $CellContext`drz^2]), $CellContext`dry/Sqrt[
                    1 + $CellContext`dry^2], $CellContext`drz/(
                    Sqrt[1 + $CellContext`drz^2] 
                    Sqrt[1 + $CellContext`dry^2])}, {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}]; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}/Sqrt[
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  0.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 25.], {
                    
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25002.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; $CellContext`intersections$ = Union[
                    Map[
                    If[Part[#, 2]^2 + Part[#, 3]^2 <= 
                    6.25, $CellContext`holeQ$ = True; {-1., 0., 
                    0.}, #]& , $CellContext`unfilteredintersections$]]; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 13., 
                    25002.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 13., 
                    25002.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-0.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-0.05, 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  3.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - 6.5 $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) 6.5; 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    25., Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-6.5 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[42.25 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    25., Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-6.5 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[42.25 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25003.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 14., 
                    25003.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 14., 
                    25003.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-3.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., -($CellContext`ray2$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1))), -($CellContext`ray3$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)))}, {$CellContext`ray2$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 1., 
                    0.}, {$CellContext`ray3$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 0., 1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-3.05, 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  3.5999999999999996` + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1. + I 0.; $CellContext`LocSCx$ = 
                    1. + I 0.; $CellContext`LocSCy$ = 1. + I 0.; Re[
                    
                    Select[{{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {(
                    386. $CellContext`xunit$ - (
                    37. $CellContext`rx$) $CellContext`xunit$ - (
                    50. $CellContext`ry$) $CellContext`yunit$ - (
                    50. $CellContext`rz$) $CellContext`zunit$ - 
                    1.4142135623730951` 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`ry$) $CellContext`xunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`yunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`yunit$ - ((
                    50. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + (50. $CellContext`ry$) $CellContext`zunit$^2 - (
                    1.4142135623730951` $CellContext`yunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`rz$) $CellContext`xunit$^2 + (
                    50. $CellContext`rz$) $CellContext`yunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`zunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`zunit$ - ((
                    50. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ - (1.4142135623730951` $CellContext`zunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2)}, {(
                    386. $CellContext`xunit$ - (
                    37. $CellContext`rx$) $CellContext`xunit$ - (
                    50. $CellContext`ry$) $CellContext`yunit$ - (
                    50. $CellContext`rz$) $CellContext`zunit$ + 
                    1.4142135623730951` 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`ry$) $CellContext`xunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`yunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`yunit$ - ((
                    50. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + (50. $CellContext`ry$) $CellContext`zunit$^2 + (
                    1.4142135623730951` $CellContext`yunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`rz$) $CellContext`xunit$^2 + (
                    50. $CellContext`rz$) $CellContext`yunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`zunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`zunit$ - ((
                    50. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ + (1.4142135623730951` $CellContext`zunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2)}}, ({$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[
                    Re[$CellContext`LocRayL$]]] >= 0., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ - (25 ($CellContext`LocSCx$^2 + $CellContext`LocSCy$^2))/(
                    193 (1 + Sqrt[
                    1 - (925 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/74498]))] < 1.*^-7, 
                    Re[$CellContext`LocSCx$]^2 + Re[$CellContext`LocSCy$]^2 <= 
                    39.0625]])& ]]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25004.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 15., 
                    25004.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 15., 
                    25004.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-3.5999999999999996` + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., ((-0.0016083472422043674`) $CellContext`ray2$^3)/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - ((
                    0.0016083472422043674` $CellContext`ray2$) \
$CellContext`ray3$^2)/(Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.2590673575129534 $CellContext`ray2$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), (((-0.0016083472422043674`) $CellContext`ray2$^2) \
$CellContext`ray3$)/(Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.0016083472422043674` $CellContext`ray3$^3)/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.2590673575129534 $CellContext`ray3$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])}, {((
                    0.0016083472422043674` $CellContext`ray2$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.2590673575129534 $CellContext`ray2$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 1., 
                    0.}, {((
                    0.0016083472422043674` $CellContext`ray3$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.2590673575129534 $CellContext`ray3$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 
                    1. Re[{{1., ((-0.0016083472422043674`) (
                    1.*^-6 + $CellContext`ray2$)^3)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - ((
                    0.0016083472422043674` (1.*^-6 + $CellContext`ray2$)) (
                    1.*^-6 + $CellContext`ray3$)^2)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), \
(((-0.0016083472422043674`) (1.*^-6 + $CellContext`ray2$)^2) (
                    1.*^-6 + $CellContext`ray3$))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.0016083472422043674` (1.*^-6 + $CellContext`ray3$)^3)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])}, {((
                    0.0016083472422043674` (
                    1.*^-6 + $CellContext`ray2$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 1., 
                    0.}, {((0.0016083472422043674` (
                    1.*^-6 + $CellContext`ray3$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-3.5999999999999996`, 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[
                    1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); 
          If[Length[$CellContext`reportedrays$] > 
            2, $CellContext`reportedrays$ = 
            Drop[$CellContext`reportedrays$, 2], $CellContext`reportedrays$]; 
          Map[{
             Part[#, 1], 
             Part[#, 2], 
             Part[#, 3], 
             Part[#, 4], 
             Part[#, 5], 
             
             Part[#, 6]}& , $CellContext`reportedrays$]]]; \
$CellContext`raytracefunction223020081152327020446 = 
       Compile[{{$CellContext`th$$, 
           Blank[Real]}, {$CellContext`x$$, 
           Blank[Real]}, {$CellContext`y$$, 
           Blank[Real]}, {$CellContext`focus$$, 
           Blank[Real]}}, 
         Module[{$CellContext`activeregion$, \
$CellContext`allcreatedamplitudes$, $CellContext`allcreatedrays$, \
$CellContext`allowzeroraylength$, $CellContext`alternateindex$, \
$CellContext`amplitude$, $CellContext`axismagnitude$, \
$CellContext`axismatrix$, $CellContext`clonedata$, \
$CellContext`clonegenerationnumber$, $CellContext`cloneinput$, \
$CellContext`clonenumber$, $CellContext`cloneposition$, \
$CellContext`clonereportedrays$, $CellContext`clonerotation$, \
$CellContext`clonescale$, $CellContext`clonescalevector$, \
$CellContext`clonesorthistogram$, $CellContext`clonetraceinput$, \
$CellContext`clonetraceoutput$, $CellContext`closestdistances$, \
$CellContext`closestposition$, $CellContext`closestpositions$, \
$CellContext`closestraylength$, $CellContext`completedray$, \
$CellContext`componentnumber$, $CellContext`cosangle$, \
$CellContext`crossmatrix$, $CellContext`deflecteddummyrayspresent$, \
$CellContext`deflectedlocalrays$, $CellContext`deflectedrays$, \
$CellContext`deflectedrayspresent$, $CellContext`dr1$, \
$CellContext`dummymatrix$, $CellContext`dummymatrixlist$, \
$CellContext`dummyvector$, $CellContext`exitvalue$, $CellContext`frontid$, \
$CellContext`generationlimit$, $CellContext`generationnumber$, \
$CellContext`holeintersections$, $CellContext`holeQ$, \
$CellContext`holeQlist$, $CellContext`hor$, $CellContext`index$, \
$CellContext`index1$, $CellContext`index2$, $CellContext`inrays$, \
$CellContext`intensity$, $CellContext`intensityscale$, \
$CellContext`intersectionnumber$, $CellContext`intersections$, \
$CellContext`intersectionslist$, $CellContext`intersectionspresent$, \
$CellContext`localdummyoutrayspresent$, $CellContext`localoutrays$, \
$CellContext`localoutrayspresent$, $CellContext`magnitude$, \
$CellContext`maxclonegenerationnumber$, $CellContext`maximumposition$, \
$CellContext`minimumraylength$, $CellContext`minresonateraylength$, \
$CellContext`n12$, $CellContext`newcomponentnumber$, \
$CellContext`newdeflectedrays$, $CellContext`newdistance$, \
$CellContext`newsurfaceid$, $CellContext`newsurfacenumber$, \
$CellContext`nonintersectingrays$, $CellContext`normalizedpolarization$, \
$CellContext`oldgenerationnumber$, $CellContext`opticallength$, \
$CellContext`originalray$, $CellContext`originalraytilt$, \
$CellContext`originalrotation$, $CellContext`originalsurfnorm$, \
$CellContext`outrays$, $CellContext`parallelamplitude$, $CellContext`PAxis$, \
$CellContext`perpendicularamplitude$, $CellContext`phaseshift$, \
$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$, \
$CellContext`previoustilt$, $CellContext`propagate$, \
$CellContext`propagatedrays$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, $CellContext`ray1$, \
$CellContext`ray2$, $CellContext`ray3$, $CellContext`LocRayL$, \
$CellContext`rayslot$, $CellContext`raysreported$, $CellContext`raytiltx$, \
$CellContext`raytiltz$, $CellContext`reporteddummyrayspresent$, \
$CellContext`reportedlocalrays$, $CellContext`reportedrays$, \
$CellContext`reportedrayspresent$, $CellContext`resonateintersections$, \
$CellContext`resonatenumber$, $CellContext`resonateraylength$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`rotationaxis$, $CellContext`rsx$, $CellContext`LocRSx$, \
$CellContext`rsy$, $CellContext`LocRSy$, $CellContext`rsz$, \
$CellContext`LocRSz$, 
           Optica`Optica`RTx$, $CellContext`LocRTy$, $CellContext`LocRTz$, \
$CellContext`rx$, $CellContext`rxhlp$, $CellContext`ry$, $CellContext`ryhlp$, \
$CellContext`rz$, $CellContext`rzhlp$, $CellContext`LocSCx$, \
$CellContext`LocSCy$, $CellContext`sid$, $CellContext`sinangle$, \
$CellContext`sno1$, $CellContext`sno2$, $CellContext`sno3$, \
$CellContext`sno4$, $CellContext`surfaceid$, $CellContext`surfacenumber$, \
$CellContext`surfacerotationmatrix$, $CellContext`surfacetranslationvector$, \
$CellContext`surfnorm$, $CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$, $CellContext`tempclonedata$, \
$CellContext`terminatedeflection$, $CellContext`thresholdintensity$, \
$CellContext`tiltmagnitude$, $CellContext`transmatrix$, $CellContext`LocTV1$, \
$CellContext`LocTV10$, $CellContext`LocTV2$, $CellContext`LocTV3$, \
$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$, \
$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$, \
$CellContext`u$, $CellContext`unfilteredintersections$, $CellContext`unit$, \
$CellContext`uu$, $CellContext`ver$, $CellContext`wavelength$, \
$CellContext`XAxis$, $CellContext`xunit$, $CellContext`YAxis$, \
$CellContext`yunit$, $CellContext`ZAxis$, $CellContext`zunit$}, \
$CellContext`activeregion$ = 
           1.; $CellContext`allcreatedamplitudes$ = {{
             0. + 0. I, 0. + 0. I, 0. + 
              0. I}}; $CellContext`allcreatedrays$ = {{
            1.}}; $CellContext`allowzeroraylength$ = 
           True; $CellContext`alternateindex$ = 
           1.; $CellContext`amplitude$ = {
            1. + 0. I, 0. + 0. I, 0. + 0. I}; $CellContext`axismagnitude$ = 
           1.; $CellContext`axismatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 
            0., 1.}}; $CellContext`clonedata$ = {{
            1.}}; $CellContext`clonegenerationnumber$ = 
           1.; $CellContext`cloneinput$ = {1.}; $CellContext`clonenumber$ = 
           1; $CellContext`cloneposition$ = {0., 0., 
            0.}; $CellContext`clonereportedrays$ = {{
            1.}}; $CellContext`clonerotation$ = {{
            1.}}; $CellContext`clonescale$ = 
           1.; $CellContext`clonescalevector$ = {
            1.}; $CellContext`clonesorthistogram$ = {
            1}; $CellContext`clonetraceinput$ = {{
            1.}}; $CellContext`clonetraceoutput$ = {{
            1.}}; $CellContext`closestdistances$ = {
            1.}; $CellContext`closestposition$ = 
           0; $CellContext`closestpositions$ = {
            0}; $CellContext`closestraylength$ = 
           1.; $CellContext`completedray$ = {
            1.}; $CellContext`componentnumber$ = -1.; $CellContext`cosangle$ = 
           1.; $CellContext`crossmatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 
            0., 1.}}; $CellContext`deflecteddummyrayspresent$ = 
           False; $CellContext`deflectedlocalrays$ = {{
            1.}}; $CellContext`deflectedrays$ = {{
            1.}}; $CellContext`deflectedrayspresent$ = 
           False; $CellContext`dummymatrix$ = {{
            1.}}; $CellContext`dummymatrixlist$ = {{{
            1.}}}; $CellContext`dummyvector$ = {1.}; $CellContext`exitvalue$ = 
           1.; $CellContext`frontid$ = 1.; $CellContext`generationlimit$ = 
           200.; $CellContext`generationnumber$ = 
           1.; $CellContext`holeintersections$ = {{-1., 0., 
            0.}}; $CellContext`holeQ$ = 
           False; $CellContext`holeQlist$ = {0}; $CellContext`hor$ = 
           1. + 0. I; $CellContext`index$ = 1.; $CellContext`index1$ = 
           1.; $CellContext`index2$ = 
           1.; $CellContext`inrays$ = {{1.}}; $CellContext`intensity$ = 
           1.; $CellContext`intensityscale$ = 
           1.; $CellContext`intersectionnumber$ = 
           1.; $CellContext`intersections$ = {{-1., 0., 
            0.}}; $CellContext`intersectionslist$ = {{{-1., 0., 
            0.}}}; $CellContext`intersectionspresent$ = 
           False; $CellContext`localdummyoutrayspresent$ = 
           False; $CellContext`localoutrays$ = {{
            1.}}; $CellContext`localoutrayspresent$ = 
           False; $CellContext`magnitude$ = 
           1.; $CellContext`maxclonegenerationnumber$ = 
           1.; $CellContext`maximumposition$ = 
           1; $CellContext`minimumraylength$ = 
           0.0001; $CellContext`minresonateraylength$ = 1.; $CellContext`n12$ = 
           1.; $CellContext`newcomponentnumber$ = -1.; \
$CellContext`newdeflectedrays$ = {{1.}}; $CellContext`newdistance$ = 
           1.; $CellContext`newsurfaceid$ = -1.; \
$CellContext`newsurfacenumber$ = -1.; $CellContext`nonintersectingrays$ = {{
            1.}}; $CellContext`normalizedpolarization$ = {1., 
            1.}; $CellContext`oldgenerationnumber$ = 
           1.; $CellContext`opticallength$ = 
           1.; $CellContext`originalray$ = {
            1.}; $CellContext`originalraytilt$ = {
            1.}; $CellContext`originalrotation$ = {{1., 0., 0.}, {0., 1., 
            0.}, {0., 0., 1.}}; $CellContext`originalsurfnorm$ = {{
            1.}}; $CellContext`outrays$ = {{
            1.}}; $CellContext`parallelamplitude$ = 
           1. + 0. I; $CellContext`PAxis$ = {1., 0., 
            0.}; $CellContext`perpendicularamplitude$ = 
           1. + 0. I; $CellContext`phaseshift$ = 0.; $CellContext`pol1$ = 
           1.; $CellContext`pol2$ = 1.; $CellContext`pol3$ = 
           1.; $CellContext`previoustilt$ = {1., 0., 
            0.}; $CellContext`propagate$ = 
           True; $CellContext`propagatedrays$ = {{1.}}; $CellContext`r1$ = 
           1.; $CellContext`r2$ = 1.; $CellContext`r3$ = 1.; $CellContext`r4$ = 
           1.; $CellContext`r5$ = 1.; $CellContext`r6$ = 1.; $CellContext`r7$ = 
           1.; $CellContext`r8$ = 1.; $CellContext`r9$ = 
           1.; $CellContext`ray1$ = 1.; $CellContext`ray2$ = 
           1.; $CellContext`ray3$ = 1.; $CellContext`LocRayL$ = 
           1.; $CellContext`rayslot$ = 1.; $CellContext`raysreported$ = 
           False; $CellContext`raytiltx$ = 1.; $CellContext`raytiltz$ = 
           1.; $CellContext`reporteddummyrayspresent$ = 
           False; $CellContext`reportedlocalrays$ = {{
            1.}}; $CellContext`reportedrays$ = {{
            1.}}; $CellContext`reportedrayspresent$ = 
           False; $CellContext`resonateintersections$ = {{-1., 0., 
            0.}}; $CellContext`resonatenumber$ = 
           0; $CellContext`resonateraylength$ = 1.; $CellContext`rex$ = 
           1.; $CellContext`rey$ = 1.; $CellContext`rez$ = 
           1.; $CellContext`rsx$ = 1.; $CellContext`LocRSx$ = 
           1.; $CellContext`rsy$ = 1.; $CellContext`LocRSy$ = 
           1.; $CellContext`rsz$ = 1.; $CellContext`LocRSz$ = 1.; 
          Optica`Optica`RTx$ = 1.; $CellContext`LocRTy$ = 
           1.; $CellContext`LocRTz$ = 1.; $CellContext`rx$ = 
           1.; $CellContext`rxhlp$ = 1.; $CellContext`ry$ = 
           1.; $CellContext`ryhlp$ = 1.; $CellContext`rz$ = 
           1.; $CellContext`rzhlp$ = 1.; $CellContext`LocSCx$ = 
           1.; $CellContext`LocSCy$ = 1.; $CellContext`sid$ = 
           1.; $CellContext`sinangle$ = 1.; $CellContext`sno1$ = 
           1.; $CellContext`sno2$ = 1.; $CellContext`sno3$ = 
           1.; $CellContext`sno4$ = 
           1.; $CellContext`surfaceid$ = -1.; $CellContext`surfacenumber$ = \
-1.; $CellContext`surfacerotationmatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 
            0., 1.}}; $CellContext`surfacetranslationvector$ = {0., 0., 
            0.}; $CellContext`surfnorm$ = {{1.}}; $CellContext`symr1$ = 
           1.; $CellContext`symr2$ = 1.; $CellContext`symr3$ = 
           1.; $CellContext`symr4$ = 1.; $CellContext`symr5$ = 
           1.; $CellContext`symr6$ = 1.; $CellContext`symr7$ = 
           1.; $CellContext`symr8$ = 1.; $CellContext`symr9$ = 
           1.; $CellContext`tempclonedata$ = {{
            1.}}; $CellContext`terminatedeflection$ = 
           False; $CellContext`thresholdintensity$ = 
           1.; $CellContext`tiltmagnitude$ = 
           1.; $CellContext`transmatrix$ = {{{1., 0., 0.}, {0., 1., 0.}, {0., 
            0., 1.}}}; $CellContext`LocTV1$ = 1.; $CellContext`LocTV10$ = 
           1.; $CellContext`LocTV2$ = 1.; $CellContext`LocTV3$ = 
           1.; $CellContext`LocTV4$ = 1.; $CellContext`LocTV5$ = 
           1.; $CellContext`LocTV6$ = 1.; $CellContext`LocTV7$ = 
           1.; $CellContext`LocTV8$ = 1.; $CellContext`LocTV9$ = 
           1.; $CellContext`u$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
            1.}}; $CellContext`unfilteredintersections$ = {{-1., 0., 
            0.}}; $CellContext`unit$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
            1.}}; $CellContext`uu$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
            1.}}; $CellContext`ver$ = 0. + 0. I; $CellContext`wavelength$ = 
           1.; $CellContext`XAxis$ = {1., 0., 0.}; $CellContext`xunit$ = 
           1.; $CellContext`YAxis$ = {1., 0., 0.}; $CellContext`yunit$ = 
           1.; $CellContext`ZAxis$ = {1., 0., 0.}; $CellContext`zunit$ = 
           1.; {$CellContext`r1$, $CellContext`dr1$} = {1., 
            1.}; {$CellContext`rx$, $CellContext`ry$, $CellContext`rz$} = {1.,
             1., 1.}; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = {1., 1., 1.}; $CellContext`propagatedrays$ = 
           Join[{$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = Re[{
                 Cos[Degree $CellContext`th$$], 
                 Sin[Degree $CellContext`th$$], 0, -
                 Sin[Degree $CellContext`th$$], 
                 Cos[Degree $CellContext`th$$], 0, 0, 0, 1}]; 
             Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$, $CellContext`rsx$ $CellContext`symr2$ + $CellContext`rsy$ \
$CellContext`symr5$ + $CellContext`rsz$ $CellContext`symr8$ + \
$CellContext`y$$, $CellContext`rsx$ $CellContext`symr3$ + $CellContext`rsy$ \
$CellContext`symr6$ + $CellContext`rsz$ $CellContext`symr9$}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}; \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$} = \
{$CellContext`rex$ $CellContext`symr1$ + $CellContext`rey$ \
$CellContext`symr4$ + $CellContext`rez$ $CellContext`symr7$ + \
$CellContext`x$$, $CellContext`rex$ $CellContext`symr2$ + $CellContext`rey$ \
$CellContext`symr5$ + $CellContext`rez$ $CellContext`symr8$ + \
$CellContext`y$$, $CellContext`rex$ $CellContext`symr3$ + $CellContext`rey$ \
$CellContext`symr6$ + $CellContext`rez$ $CellContext`symr9$}; \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$} = \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}; \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$} = \
{$CellContext`r1$ $CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + \
$CellContext`r3$ $CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + \
$CellContext`r2$ $CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, \
$CellContext`r1$ $CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + \
$CellContext`r3$ $CellContext`symr9$}; {$CellContext`LocTV4$, \
$CellContext`LocTV5$, $CellContext`LocTV6$} = {$CellContext`r4$ \
$CellContext`symr1$ + $CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ \
$CellContext`symr7$, $CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ \
$CellContext`symr5$ + $CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ \
$CellContext`symr3$ + $CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ \
$CellContext`symr9$}; {$CellContext`LocTV7$, $CellContext`LocTV8$, \
$CellContext`LocTV9$} = {$CellContext`r7$ $CellContext`symr1$ + \
$CellContext`r8$ $CellContext`symr4$ + $CellContext`r9$ $CellContext`symr7$, \
$CellContext`r7$ $CellContext`symr2$ + $CellContext`r8$ $CellContext`symr5$ + \
$CellContext`r9$ $CellContext`symr8$, $CellContext`r7$ $CellContext`symr3$ + \
$CellContext`r8$ $CellContext`symr6$ + $CellContext`r9$ $CellContext`symr9$}; \
{{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}} = {{$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$}, {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$}, {$CellContext`LocTV7$, $CellContext`LocTV8$, \
$CellContext`LocTV9$}}; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , CompressedData["
1:eJxTTMoPSmViYGDgBmJ1BnTwYz+GEFbxD/bY1REvv0BK/64K20OoukgHN/HY
kouu2+H6nigFd0kx4jKHkPkQ4FB9wwGZRuhTQ+MT7250EWMw+IwRbtjFh2q4
MUBpNTQ+8e5GFzkDBm8wwg27+FANNw4orYbGJ97d6CJG4HT1GCPcsIsP1XAT
gNJqaHzi3Y0uYgAOn8sY4YZdfKiGmwiUVkPjE+9u7OIbbIgTH6rhJgGl1dD4
xLsbXcQCkq6IFB+q4SYDpdXQ+MS7G13EDFKOESk+VMNNAUqrofGJdze6yAVI
vUmk+FANNyUorYbGJ97d6CKmkHYakeJDNdxUoLQaGp94d6OLMIHJH0SKD9Vw
U8NBE+9uGAsATW8z/Q==
               "]]]; $CellContext`propagatedrays$ = 
           Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`componentnumber$ = 
              1.; $CellContext`frontid$ = 
              1.; {$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`propagatedrays$]; \
$CellContext`thresholdintensity$ = 1.; $CellContext`generationlimit$ = 
           200.; $CellContext`reportedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`generationnumber$ = 0.; (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  3.5999999999999996` + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1. + I 0.; $CellContext`LocSCx$ = 
                    1. + I 0.; $CellContext`LocSCy$ = 1. + I 0.; Re[
                    
                    Select[{{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {(
                    386. $CellContext`xunit$ - (
                    37. $CellContext`rx$) $CellContext`xunit$ - (
                    50. $CellContext`ry$) $CellContext`yunit$ - (
                    50. $CellContext`rz$) $CellContext`zunit$ - 
                    1.4142135623730951` 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`ry$) $CellContext`xunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`yunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`yunit$ - ((
                    50. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + (50. $CellContext`ry$) $CellContext`zunit$^2 - (
                    1.4142135623730951` $CellContext`yunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`rz$) $CellContext`xunit$^2 + (
                    50. $CellContext`rz$) $CellContext`yunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`zunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`zunit$ - ((
                    50. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ - (1.4142135623730951` $CellContext`zunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2)}, {(
                    386. $CellContext`xunit$ - (
                    37. $CellContext`rx$) $CellContext`xunit$ - (
                    50. $CellContext`ry$) $CellContext`yunit$ - (
                    50. $CellContext`rz$) $CellContext`zunit$ + 
                    1.4142135623730951` 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`ry$) $CellContext`xunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`yunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`yunit$ - ((
                    50. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + (50. $CellContext`ry$) $CellContext`zunit$^2 + (
                    1.4142135623730951` $CellContext`yunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`rz$) $CellContext`xunit$^2 + (
                    50. $CellContext`rz$) $CellContext`yunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`zunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`zunit$ - ((
                    50. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ + (1.4142135623730951` $CellContext`zunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    
                    50. $CellContext`zunit$^2)}}, ({$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[
                    Re[$CellContext`LocRayL$]]] >= 0., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ - (25 ($CellContext`LocSCx$^2 + $CellContext`LocSCy$^2))/(
                    193 (1 + Sqrt[
                    1 - (925 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/74498]))] < 1.*^-7, 
                    Re[$CellContext`LocSCx$]^2 + Re[$CellContext`LocSCy$]^2 <= 
                    39.0625]])& ]]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24990.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[
                    Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 1., 
                    24990.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 1., 
                    24990.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-3.5999999999999996` + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., ((-0.0016083472422043674`) $CellContext`ray2$^3)/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - ((
                    0.0016083472422043674` $CellContext`ray2$) \
$CellContext`ray3$^2)/(Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.2590673575129534 $CellContext`ray2$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), (((-0.0016083472422043674`) $CellContext`ray2$^2) \
$CellContext`ray3$)/(Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.0016083472422043674` $CellContext`ray3$^3)/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.2590673575129534 $CellContext`ray3$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])}, {((
                    0.0016083472422043674` $CellContext`ray2$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.2590673575129534 $CellContext`ray2$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 1., 
                    0.}, {((
                    0.0016083472422043674` $CellContext`ray3$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.2590673575129534 $CellContext`ray3$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 
                    1. Re[{{1., ((-0.0016083472422043674`) (
                    1.*^-6 + $CellContext`ray2$)^3)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - ((
                    0.0016083472422043674` (1.*^-6 + $CellContext`ray2$)) (
                    1.*^-6 + $CellContext`ray3$)^2)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), \
(((-0.0016083472422043674`) (1.*^-6 + $CellContext`ray2$)^2) (
                    1.*^-6 + $CellContext`ray3$))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.0016083472422043674` (1.*^-6 + $CellContext`ray3$)^3)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])}, {((
                    0.0016083472422043674` (
                    1.*^-6 + $CellContext`ray2$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 1., 
                    0.}, {((0.0016083472422043674` (
                    1.*^-6 + $CellContext`ray3$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-3.5999999999999996`, 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[
                    1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  3.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - 6.5 $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) 6.5; 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    25., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-6.5 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[42.25 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    25., Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-6.5 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[42.25 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24991.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 2., 
                    24991.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 2., 
                    24991.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-3.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., -($CellContext`ray2$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1))), -($CellContext`ray3$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)))}, {$CellContext`ray2$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 1., 
                    0.}, {$CellContext`ray3$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 0., 1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-3.05, 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  0.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 
                    6.25], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24992.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 3., 
                    24992.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 3., 
                    24992.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-0.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-0.05, 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
{$CellContext`rx$, $CellContext`ry$, $CellContext`rz$} = 
                    Dot[{$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} - {-0.05, 0, 0}, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}/Sqrt[
                    
                    Dot[{$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}, {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}]]; $CellContext`r1$ = $CellContext`ry$; \
$CellContext`dr1$ = $CellContext`yunit$/
                    Abs[$CellContext`xunit$]; $CellContext`ry$ = 
                    Plus[$CellContext`r1$]; $CellContext`dry = \
((-$CellContext`focus$$)/
                    1000) $CellContext`r1$ + $CellContext`dr1$; \
$CellContext`r1$ = $CellContext`rz$; $CellContext`dr1$ = $CellContext`zunit$/
                    Abs[$CellContext`xunit$]; $CellContext`rz$ = 
                    Plus[$CellContext`r1$]; $CellContext`drz = \
((-$CellContext`focus$$)/
                    1000) $CellContext`r1$ + $CellContext`dr1$; \
$CellContext`exitvalue$ = (0& )[
                    First[{$CellContext`ray2$, $CellContext`ray3$}], 
                    Last[{$CellContext`ray2$, $CellContext`ray3$}]] 
                    1.0000001; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`exitvalue$; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = 
                    Dot[{Sign[$CellContext`xunit$] $CellContext`exitvalue$, \
$CellContext`ry$, $CellContext`rz$}, {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}] + {-0.05, 0, 
                    0}; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = Dot[{
                    Sign[$CellContext`xunit$]/(Sqrt[1 + $CellContext`dry^2] 
                    Sqrt[1 + $CellContext`drz^2]), $CellContext`dry/Sqrt[
                    1 + $CellContext`dry^2], $CellContext`drz/(
                    Sqrt[1 + $CellContext`drz^2] 
                    Sqrt[1 + $CellContext`dry^2])}, {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}]; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}/Sqrt[
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  0.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 25.], {
                    
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24993.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; $CellContext`intersections$ = Union[
                    Map[
                    If[Part[#, 2]^2 + Part[#, 3]^2 <= 
                    6.25, $CellContext`holeQ$ = True; {-1., 0., 
                    0.}, #]& , $CellContext`unfilteredintersections$]]; 
                   If[
                    Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 4., 
                    24993.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 4., 
                    24993.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-0.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-0.05, 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 
                    35.19455625000001], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24994.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; $CellContext`intersections$ = Union[
                    Map[
                    If[Part[#, 2]^2 + Part[#, 3]^2 <= 
                    28.810056249999995`, $CellContext`holeQ$ = True; {-1., 0.,
                     0.}, #]& , $CellContext`unfilteredintersections$]]; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 5., 
                    24994.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 5., 
                    24994.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`surfaceapprox, \
$CellContext`tempapprox, $CellContext`intersects, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1.; $CellContext`LocSCx$ = 1.; $CellContext`LocSCy$ = 
                    1.; $CellContext`surfaceapprox = {{-1., 0., 
                    0.}}; $CellContext`tempapprox = {{-1., 0., 
                    0.}}; $CellContext`intersects = {{-1., 0., 
                    0.}}; $CellContext`surfaceapprox = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - 10.2 $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) 10.2; 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-10.2 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[104.03999999999999` - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-10.2 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[104.03999999999999` - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 
                    0.}}]]; $CellContext`tempapprox = Union[
                    Join[
                    Map[Take[#, 3]& , $CellContext`surfaceapprox], {{-1., 0., 
                    0.}}]]; If[Length[
                    Select[$CellContext`tempapprox, Chop[
                    First[#]] <= 0& ]] != 
                    Length[$CellContext`tempapprox], \
$CellContext`surfaceapprox = Select[$CellContext`tempapprox, Chop[
                    First[#]] > 0& ], $CellContext`surfaceapprox = {{-1., 0., 
                    0.}}]; If[$CellContext`surfaceapprox != {{-1., 0., 
                    0.}}, $CellContext`intersects = {{-1., 0., 0.}}; 
                    Scan[(AppendTo[$CellContext`intersects, \
{$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}; If[Apply[Plus, 
                    
                    Abs[{$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$, $CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$, $CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$} - {(
                    0.09803921568627452 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/(1 + Sqrt[
                    1 + 0.020488273740868906` ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2)]), $CellContext`LocSCx$, $CellContext`LocSCy$}]] < 
                    1.*^-9, {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 0.99 $CellContext`LocRayL$; 
                    Function[{$CellContext`rx, $CellContext`ry, \
$CellContext`rz, $CellContext`xunit, $CellContext`yunit, $CellContext`zunit, \
$CellContext`startpoint}, 
                    
                    Block[{$CellContext`values, $CellContext`stepsizes, \
$CellContext`fvector, $CellContext`success, $CellContext`steps, \
$CellContext`denominator}, $CellContext`values = {
                    1.}; $CellContext`stepsizes = {
                    1.}; $CellContext`fvector = {1.}; $CellContext`success = 
                    False; $CellContext`steps = 0; $CellContext`denominator = 
                    1.; $CellContext`stepsizes = 
                    Table[1.0000000000000001`*^-7, {
                    3}]; $CellContext`values = $CellContext`startpoint; 
                    While[
                    
                    And[$CellContext`steps < 50, $CellContext`success = True; 
                    Map[If[Abs[#] > 1.*^-9, $CellContext`success = False; 1., 
                    1.]& , $CellContext`stepsizes]; 
                    Not[$CellContext`success]], $CellContext`steps = \
$CellContext`steps + 
                    1; $CellContext`fvector = {$CellContext`rx + \
$CellContext`xunit Part[$CellContext`values, 
                    1], $CellContext`ry + $CellContext`yunit 
                    Part[$CellContext`values, 
                    1], $CellContext`rz + $CellContext`zunit 
                    Part[$CellContext`values, 1]} - {(
                    0.09803921568627452 (Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)]), 
                    Part[$CellContext`values, 2], 
                    
                    Part[$CellContext`values, 
                    3]}; $CellContext`denominator = $CellContext`xunit - \
$CellContext`yunit ((((0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) (-1)) - $CellContext`zunit ((((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) (-1)); 
                    If[Chop[$CellContext`denominator] != 
                    0, $CellContext`denominator, $CellContext`denominator = 
                    1.]; $CellContext`stepsizes = -
                    Map[Dot[#, $CellContext`fvector]& , {{
                    1, -((((0.002008654288320481 
                    Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) (-1)), -((((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) (-1))}, {$CellContext`yunit, -$CellContext`xunit - \
(((0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) $CellContext`zunit, (((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`yunit}, {$CellContext`zunit, (((
                    0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`zunit, -$CellContext`xunit - (((
                    0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`yunit}}/$CellContext`denominator]; \
$CellContext`values = $CellContext`values + $CellContext`stepsizes]; 
                    If[$CellContext`steps >= 50, 
                    If[First[$CellContext`values] > 
                    0, $CellContext`values = -$CellContext`values; 1., 
                    1.]; $CellContext`denominator = 1., 
                    1.]; $CellContext`values]][$CellContext`rx$, \
$CellContext`ry$, $CellContext`rz$, $CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$, {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}]]]; {-1., 0., 0.})& , $CellContext`surfaceapprox]; 
                    Union[
                    Re[
                    
                    Select[$CellContext`intersects, ({$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, Apply[Plus, 
                    
                    Abs[{$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$, $CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$, $CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$} - {(
                    0.09803921568627452 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/(1 + Sqrt[1 + 
                    0.020488273740868906` ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2)]), $CellContext`LocSCx$, $CellContext`LocSCy$}]] < 
                    1.*^-9]])& ]]], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24995.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 6., 
                    24995.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 6., 
                    24995.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., (0.002008654288320481 $CellContext`ray2$^3)/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + ((
                    0.002008654288320481 $CellContext`ray2$) \
$CellContext`ray3$^2)/(Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.19607843137254904` $CellContext`ray2$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), ((
                    0.002008654288320481 $CellContext`ray2$^2) \
$CellContext`ray3$)/(Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.002008654288320481 $CellContext`ray3$^3)/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.19607843137254904` $CellContext`ray3$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])}, {(((-0.002008654288320481) $CellContext`ray2$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.19607843137254904` $CellContext`ray2$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 1., 
                    0.}, {(((-0.002008654288320481) $CellContext`ray3$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.19607843137254904` $CellContext`ray3$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 
                    1. Re[{{1., (
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)^3)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + ((
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)) (
                    1.*^-6 + $CellContext`ray3$)^2)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), ((
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)^2) (
                    1.*^-6 + $CellContext`ray3$))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.002008654288320481 (1.*^-6 + $CellContext`ray3$)^3)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])}, \
{(((-0.002008654288320481) (1.*^-6 + $CellContext`ray2$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 1., 
                    0.}, {(((-0.002008654288320481) (
                    1.*^-6 + $CellContext`ray3$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -4. + \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1. + I 0.; $CellContext`LocSCx$ = 
                    1. + I 0.; $CellContext`LocSCy$ = 1. + I 0.; Re[
                    Select[
                    
                    If[$CellContext`yunit$^2 + $CellContext`zunit$^2 == 
                    0., {{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {(((-0.08333333333333333) (
                    12. $CellContext`rx$ + $CellContext`ry$^2 + \
$CellContext`rz$^2)) 
                    Sqrt[$CellContext`xunit$^2])/$CellContext`xunit$^2, \
($CellContext`ry$ 
                    Sqrt[$CellContext`xunit$^2])/$CellContext`xunit$, \
$CellContext`rz$}}, {{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {((-6.) $CellContext`xunit$ - (
                    1. $CellContext`ry$) $CellContext`yunit$ - (
                    1. $CellContext`rz$) $CellContext`zunit$ - 1. 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
(((-6.) $CellContext`xunit$) $CellContext`yunit$ - ((
                    1. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`ry$ $CellContext`zunit$^2 - (
                    1. $CellContext`yunit$) 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
($CellContext`rz$ $CellContext`yunit$^2 - (
                    6. $CellContext`xunit$) $CellContext`zunit$ - ((
                    1. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ - (1. $CellContext`zunit$) 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2)}, \
{((-6.) $CellContext`xunit$ - (1. $CellContext`ry$) $CellContext`yunit$ - (
                    1. $CellContext`rz$) $CellContext`zunit$ + 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
(((-6.) $CellContext`xunit$) $CellContext`yunit$ - ((
                    
                    1. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`ry$ $CellContext`zunit$^2 + \
$CellContext`yunit$ Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
($CellContext`rz$ $CellContext`yunit$^2 - (
                    6. $CellContext`xunit$) $CellContext`zunit$ - ((
                    1. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`zunit$ 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2)}}], \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[
                    Re[$CellContext`LocRayL$]]] >= 0., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + ($CellContext`LocSCx$^2 + $CellContext`LocSCy$^2)/12] < 
                    1.*^-7, Re[$CellContext`LocSCx$]^2 + 
                    Re[$CellContext`LocSCy$]^2 <= 31.922500000000003`]])& ]]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24996.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 7., 
                    24996.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 7., 
                    24996.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    4. + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 1. Re[{{1., 
                    Plus[(0.3333333333333333 $CellContext`ray2$)/(1. + Sqrt[
                    Plus[1.]])], 
                    Plus[(0.3333333333333333 $CellContext`ray3$)/(1. + Sqrt[
                    Plus[1.]])]}, {
                    Plus[((-0.3333333333333333) $CellContext`ray2$)/(1. + 
                    Sqrt[
                    Plus[1.]])], 1., 0.}, {
                    
                    Plus[((-0.3333333333333333) $CellContext`ray3$)/(1. + 
                    Sqrt[
                    Plus[1.]])], 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 1. Re[{{1., 
                    
                    Plus[(0.3333333333333333 (1.*^-6 + $CellContext`ray2$))/(
                    1. + Sqrt[
                    Plus[1.]])], 
                    
                    Plus[(0.3333333333333333 (1.*^-6 + $CellContext`ray3$))/(
                    1. + Sqrt[
                    Plus[1.]])]}, {
                    
                    Plus[((-0.3333333333333333) (
                    1.*^-6 + $CellContext`ray2$))/(1. + Sqrt[
                    Plus[1.]])], 1., 0.}, {
                    
                    Plus[((-0.3333333333333333) (
                    1.*^-6 + $CellContext`ray3$))/(1. + Sqrt[
                    Plus[1.]])], 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    4., 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -20.3203 + \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - (-12) $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) (-12); 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    142.80249999999998`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[12 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ - 
                    Sqrt[144 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    142.80249999999998`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[12 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ - 
                    Sqrt[144 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24997.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 8., 
                    24997.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 8., 
                    24997.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    20.3203 + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., -((-$CellContext`ray2$)/(
                    144 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1))), -((-$CellContext`ray3$)/(
                    144 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)))}, {(-$CellContext`ray2$)/(
                    144 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 1., 
                    0.}, {(-$CellContext`ray3$)/(
                    144 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 0., 1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    20.3203, 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -4. + \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1. + I 0.; $CellContext`LocSCx$ = 
                    1. + I 0.; $CellContext`LocSCy$ = 1. + I 0.; Re[
                    Select[
                    
                    If[$CellContext`yunit$^2 + $CellContext`zunit$^2 == 
                    0., {{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {(((-0.08333333333333333) (
                    12. $CellContext`rx$ + $CellContext`ry$^2 + \
$CellContext`rz$^2)) 
                    Sqrt[$CellContext`xunit$^2])/$CellContext`xunit$^2, \
($CellContext`ry$ 
                    Sqrt[$CellContext`xunit$^2])/$CellContext`xunit$, \
$CellContext`rz$}}, {{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {((-6.) $CellContext`xunit$ - (
                    1. $CellContext`ry$) $CellContext`yunit$ - (
                    1. $CellContext`rz$) $CellContext`zunit$ - 1. 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
(((-6.) $CellContext`xunit$) $CellContext`yunit$ - ((
                    1. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`ry$ $CellContext`zunit$^2 - (
                    1. $CellContext`yunit$) 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
($CellContext`rz$ $CellContext`yunit$^2 - (
                    6. $CellContext`xunit$) $CellContext`zunit$ - ((
                    1. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ - (1. $CellContext`zunit$) 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2)}, \
{((-6.) $CellContext`xunit$ - (1. $CellContext`ry$) $CellContext`yunit$ - (
                    1. $CellContext`rz$) $CellContext`zunit$ + 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
(((-6.) $CellContext`xunit$) $CellContext`yunit$ - ((
                    1. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`ry$ $CellContext`zunit$^2 + \
$CellContext`yunit$ Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2), \
($CellContext`rz$ $CellContext`yunit$^2 - (
                    6. $CellContext`xunit$) $CellContext`zunit$ - ((
                    1. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ + $CellContext`zunit$ 
                    Sqrt[36. $CellContext`xunit$^2 + ((
                    12. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ - (12. $CellContext`rx$) $CellContext`yunit$^2 - (
                    1. $CellContext`rz$^2) $CellContext`yunit$^2 + ((
                    12. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    2. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ - (
                    12. $CellContext`rx$) $CellContext`zunit$^2 - (
                    1. $CellContext`ry$^2) \
$CellContext`zunit$^2])/($CellContext`yunit$^2 + $CellContext`zunit$^2)}}], \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[
                    Re[$CellContext`LocRayL$]]] >= 0., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + ($CellContext`LocSCx$^2 + $CellContext`LocSCy$^2)/12] < 
                    1.*^-7, Re[$CellContext`LocSCx$]^2 + 
                    Re[$CellContext`LocSCy$]^2 <= 31.922500000000003`]])& ]]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24998.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 9., 
                    24998.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 9., 
                    24998.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    4. + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 1. Re[{{1., 
                    Plus[(0.3333333333333333 $CellContext`ray2$)/(1. + Sqrt[
                    Plus[1.]])], 
                    Plus[(0.3333333333333333 $CellContext`ray3$)/(1. + Sqrt[
                    Plus[1.]])]}, {
                    
                    Plus[((-0.3333333333333333) $CellContext`ray2$)/(1. + 
                    Sqrt[
                    Plus[1.]])], 1., 0.}, {
                    
                    Plus[((-0.3333333333333333) $CellContext`ray3$)/(1. + 
                    Sqrt[
                    Plus[1.]])], 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 1. Re[{{1., 
                    
                    Plus[(0.3333333333333333 (1.*^-6 + $CellContext`ray2$))/(
                    1. + Sqrt[
                    Plus[1.]])], 
                    
                    Plus[(0.3333333333333333 (1.*^-6 + $CellContext`ray3$))/(
                    1. + Sqrt[
                    Plus[1.]])]}, {
                    
                    Plus[((-0.3333333333333333) (
                    1.*^-6 + $CellContext`ray2$))/(1. + Sqrt[
                    Plus[1.]])], 1., 0.}, {
                    
                    Plus[((-0.3333333333333333) (
                    1.*^-6 + $CellContext`ray3$))/(1. + Sqrt[
                    Plus[1.]])], 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    4., 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    
                    0.9804493049167423 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.4992664079787237` - 
                    0.7232199522002112 $CellContext`wavelength$ + 
                    1.0984449372281133` $CellContext`wavelength$^2 - 
                    0.5792106405034075 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`surfaceapprox, \
$CellContext`tempapprox, $CellContext`intersects, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1.; $CellContext`LocSCx$ = 1.; $CellContext`LocSCy$ = 
                    1.; $CellContext`surfaceapprox = {{-1., 0., 
                    0.}}; $CellContext`tempapprox = {{-1., 0., 
                    0.}}; $CellContext`intersects = {{-1., 0., 
                    0.}}; $CellContext`surfaceapprox = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - 10.2 $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) 10.2; 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-10.2 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[104.03999999999999` - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-10.2 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[104.03999999999999` - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 
                    0.}}]]; $CellContext`tempapprox = Union[
                    Join[
                    Map[Take[#, 3]& , $CellContext`surfaceapprox], {{-1., 0., 
                    0.}}]]; If[Length[
                    Select[$CellContext`tempapprox, Chop[
                    First[#]] <= 0& ]] != 
                    Length[$CellContext`tempapprox], \
$CellContext`surfaceapprox = Select[$CellContext`tempapprox, Chop[
                    First[#]] > 0& ], $CellContext`surfaceapprox = {{-1., 0., 
                    0.}}]; If[$CellContext`surfaceapprox != {{-1., 0., 
                    0.}}, $CellContext`intersects = {{-1., 0., 0.}}; 
                    Scan[(AppendTo[$CellContext`intersects, \
{$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}; If[Apply[Plus, 
                    
                    Abs[{$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$, $CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$, $CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$} - {(
                    0.09803921568627452 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/(1 + Sqrt[
                    1 + 0.020488273740868906` ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2)]), $CellContext`LocSCx$, $CellContext`LocSCy$}]] < 
                    1.*^-9, {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 0.99 $CellContext`LocRayL$; 
                    Function[{$CellContext`rx, $CellContext`ry, \
$CellContext`rz, $CellContext`xunit, $CellContext`yunit, $CellContext`zunit, \
$CellContext`startpoint}, 
                    
                    Block[{$CellContext`values, $CellContext`stepsizes, \
$CellContext`fvector, $CellContext`success, $CellContext`steps, \
$CellContext`denominator}, $CellContext`values = {
                    1.}; $CellContext`stepsizes = {
                    1.}; $CellContext`fvector = {1.}; $CellContext`success = 
                    False; $CellContext`steps = 0; $CellContext`denominator = 
                    1.; $CellContext`stepsizes = 
                    Table[1.0000000000000001`*^-7, {
                    3}]; $CellContext`values = $CellContext`startpoint; 
                    While[
                    And[$CellContext`steps < 50, $CellContext`success = True; 
                    Map[If[Abs[#] > 1.*^-9, $CellContext`success = False; 1., 
                    1.]& , $CellContext`stepsizes]; 
                    Not[$CellContext`success]], $CellContext`steps = \
$CellContext`steps + 
                    1; $CellContext`fvector = {$CellContext`rx + \
$CellContext`xunit Part[$CellContext`values, 
                    1], $CellContext`ry + $CellContext`yunit 
                    Part[$CellContext`values, 
                    1], $CellContext`rz + $CellContext`zunit 
                    Part[$CellContext`values, 1]} - {(
                    0.09803921568627452 (Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)]), 
                    Part[$CellContext`values, 2], 
                    
                    Part[$CellContext`values, 
                    3]}; $CellContext`denominator = $CellContext`xunit - \
$CellContext`yunit ((((0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) (-1)) - $CellContext`zunit ((((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) (-1)); 
                    If[Chop[$CellContext`denominator] != 
                    0, $CellContext`denominator, $CellContext`denominator = 
                    1.]; $CellContext`stepsizes = -
                    Map[Dot[#, $CellContext`fvector]& , {{
                    1, -((((0.002008654288320481 
                    Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) (-1)), -((((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + Part[$CellContext`values,
                     3]^2)])^2) - (0.19607843137254904` 
                    Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) (-1))}, {$CellContext`yunit, -$CellContext`xunit - \
(((0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])) $CellContext`zunit, (((
                    0.002008654288320481 Part[$CellContext`values, 3]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 3])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`yunit}, {$CellContext`zunit, (((
                    0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`zunit, -$CellContext`xunit - (((
                    0.002008654288320481 Part[$CellContext`values, 2]) (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2))/(
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)] (1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 3]^2)])^2) - (
                    0.19607843137254904` Part[$CellContext`values, 2])/(1 + 
                    Sqrt[1 + 0.020488273740868906` (
                    Part[$CellContext`values, 2]^2 + 
                    Part[$CellContext`values, 
                    3]^2)])) $CellContext`yunit}}/$CellContext`denominator]; \
$CellContext`values = $CellContext`values + $CellContext`stepsizes]; 
                    If[$CellContext`steps >= 50, 
                    If[First[$CellContext`values] > 
                    0, $CellContext`values = -$CellContext`values; 1., 
                    1.]; $CellContext`denominator = 1., 
                    1.]; $CellContext`values]][$CellContext`rx$, \
$CellContext`ry$, $CellContext`rz$, $CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$, {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}]]]; {-1., 0., 0.})& , $CellContext`surfaceapprox]; 
                    Union[
                    Re[
                    
                    Select[$CellContext`intersects, ({$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    31.922500000000003`, Apply[Plus, 
                    
                    Abs[{$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$, $CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$, $CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$} - {(
                    0.09803921568627452 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/(1 + Sqrt[1 + 
                    0.020488273740868906` ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2)]), $CellContext`LocSCx$, $CellContext`LocSCy$}]] < 
                    1.*^-9]])& ]]], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 24999.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 10., 
                    24999.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 10., 
                    24999.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., (0.002008654288320481 $CellContext`ray2$^3)/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + ((
                    0.002008654288320481 $CellContext`ray2$) \
$CellContext`ray3$^2)/(Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.19607843137254904` $CellContext`ray2$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), ((
                    0.002008654288320481 $CellContext`ray2$^2) \
$CellContext`ray3$)/(Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.002008654288320481 $CellContext`ray3$^3)/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.19607843137254904` $CellContext`ray3$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])}, {(((-0.002008654288320481) $CellContext`ray2$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.19607843137254904` $CellContext`ray2$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 1., 
                    0.}, {(((-0.002008654288320481) $CellContext`ray3$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. + 0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.19607843137254904` $CellContext`ray3$)/(1. + 
                    Sqrt[1. + 
                    0.020488273740868906` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 
                    1. Re[{{1., (
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)^3)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + ((
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)) (
                    1.*^-6 + $CellContext`ray3$)^2)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), ((
                    0.002008654288320481 (1.*^-6 + $CellContext`ray2$)^2) (
                    1.*^-6 + $CellContext`ray3$))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.002008654288320481 (1.*^-6 + $CellContext`ray3$)^3)/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])}, \
{(((-0.002008654288320481) (1.*^-6 + $CellContext`ray2$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 1., 
                    0.}, {(((-0.002008654288320481) (
                    1.*^-6 + $CellContext`ray3$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.19607843137254904` (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. + 0.020488273740868906` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.676591682864066 - 
                    1.1701284013479643` $CellContext`wavelength$ + 
                    1.824530254455512 $CellContext`wavelength$^2 - 
                    0.9804493049167423 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 
                    32.56414225], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25000.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; $CellContext`intersections$ = Union[
                    Map[
                    If[Part[#, 2]^2 + Part[#, 3]^2 <= 
                    31.287242250000006`, $CellContext`holeQ$ = True; {-1., 0.,
                     0.}, #]& , $CellContext`unfilteredintersections$]]; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 11., 
                    25000.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 11., 
                    25000.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  0.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 
                    6.25], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25001.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 12., 
                    25001.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 12., 
                    25001.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-0.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 
                    1.}}; $CellContext`surfacetranslationvector$ = {-0.05, 0, 
                    0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
{$CellContext`rx$, $CellContext`ry$, $CellContext`rz$} = 
                    Dot[{$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} - {-0.05, 0, 0}, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$} = {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}/Sqrt[
                    
                    Dot[{$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}, {$CellContext`xunit$, $CellContext`yunit$, \
$CellContext`zunit$}]]; $CellContext`r1$ = $CellContext`ry$; \
$CellContext`dr1$ = $CellContext`yunit$/
                    Abs[$CellContext`xunit$]; $CellContext`ry$ = 
                    Plus[$CellContext`r1$]; $CellContext`dry = \
((-$CellContext`focus$$)/
                    1000) $CellContext`r1$ + $CellContext`dr1$; \
$CellContext`r1$ = $CellContext`rz$; $CellContext`dr1$ = $CellContext`zunit$/
                    Abs[$CellContext`xunit$]; $CellContext`rz$ = 
                    Plus[$CellContext`r1$]; $CellContext`drz = \
((-$CellContext`focus$$)/
                    1000) $CellContext`r1$ + $CellContext`dr1$; \
$CellContext`exitvalue$ = (0& )[
                    First[{$CellContext`ray2$, $CellContext`ray3$}], 
                    Last[{$CellContext`ray2$, $CellContext`ray3$}]] 
                    1.0000001; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`exitvalue$; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = 
                    Dot[{Sign[$CellContext`xunit$] $CellContext`exitvalue$, \
$CellContext`ry$, $CellContext`rz$}, {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}] + {-0.05, 0, 
                    0}; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = Dot[{
                    Sign[$CellContext`xunit$]/(Sqrt[1 + $CellContext`dry^2] 
                    Sqrt[1 + $CellContext`drz^2]), $CellContext`dry/Sqrt[
                    1 + $CellContext`dry^2], $CellContext`drz/(
                    Sqrt[1 + $CellContext`drz^2] 
                    Sqrt[1 + $CellContext`dry^2])}, {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}]; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}/Sqrt[
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  0.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., Part[#, 2]^2 + Part[#, 3]^2 <= 25.], {
                    
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25002.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; $CellContext`intersections$ = Union[
                    Map[
                    If[Part[#, 2]^2 + Part[#, 3]^2 <= 
                    6.25, $CellContext`holeQ$ = True; {-1., 0., 
                    0.}, #]& , $CellContext`unfilteredintersections$]]; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 13., 
                    25002.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 13., 
                    25002.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-0.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-0.05, 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}})); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  3.05 + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{Optica`Optica`TempVar, Optica`Optica`TempVar1, 
                    Optica`Optica`TempVar2, 
                    Optica`Optica`TempVar3, $CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$}, Optica`Optica`TempVar1 = 1.; 
                    Optica`Optica`TempVar2 = 1.; Optica`Optica`TempVar3 = 1.; 
                    Optica`Optica`TempVar = {{-1., 0., 
                    0.}}; $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; 
                    Optica`Optica`TempVar1 = $CellContext`rx$^2 + \
$CellContext`ry$^2 + $CellContext`rz$^2; 
                    Optica`Optica`TempVar2 = $CellContext`rx$ \
$CellContext`xunit$ + $CellContext`ry$ $CellContext`yunit$ + $CellContext`rz$ \
$CellContext`zunit$ - 6.5 $CellContext`xunit$; 
                    Optica`Optica`TempVar3 = -Optica`Optica`TempVar1 + 
                    Optica`Optica`TempVar2^2 + (2 $CellContext`rx$) 6.5; 
                    Optica`Optica`TempVar3 = Re[Optica`Optica`TempVar3]; 
                    If[N[
                    Chop[Optica`Optica`TempVar3]] >= 0., 
                    Optica`Optica`TempVar3 = Sqrt[Optica`Optica`TempVar3]; 
                    Optica`Optica`TempVar = {{$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = {-Optica`Optica`TempVar2 - 
                    Optica`Optica`TempVar3, $CellContext`ry$ - (
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ - (Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    25., Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-6.5 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[42.25 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 
                    0.}], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} = {-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3, $CellContext`ry$ + (-
                    Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`yunit$, \
$CellContext`rz$ + (-Optica`Optica`TempVar2 + 
                    Optica`Optica`TempVar3) $CellContext`zunit$}; If[
                    And[N[
                    Chop[$CellContext`LocRayL$]] >= 
                    0., $CellContext`LocSCx$^2 + $CellContext`LocSCy$^2 <= 
                    25., Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[-6.5 + $CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ + 
                    Sqrt[42.25 - $CellContext`LocSCx$^2 - \
$CellContext`LocSCy$^2]] < 
                    1.*^-7], {$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, {-1., 0., 0.}]}; 
                    If[Part[Optica`Optica`TempVar, 1] == 
                    Part[Optica`Optica`TempVar, 2], {
                    Part[Optica`Optica`TempVar, 1]}, 
                    Optica`Optica`TempVar], {{-1., 0., 0.}}]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25003.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 14., 
                    25003.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 14., 
                    25003.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-3.05 + $CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., -($CellContext`ray2$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1))), -($CellContext`ray3$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)))}, {$CellContext`ray2$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 1., 
                    0.}, {$CellContext`ray3$/(
                    42.25 - $CellContext`ray2$^2 - $CellContext`ray3$^2)^(
                    2^(-1)), 0., 1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-3.05, 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3], \
$CellContext`index2$ = 1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5532682085813037` - 
                    1.0054245500503685` $CellContext`wavelength$ + 
                    1.6027810806802343` $CellContext`wavelength$^2 - 
                    0.8794405514298376 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); (
           AddTo[$CellContext`generationnumber$, 
             1.]; $CellContext`reportedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, 
               0, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`deflectedlocalrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; ($CellContext`deflectedrayspresent$ = 
             False; $CellContext`reportedrayspresent$ = 
             False; $CellContext`deflecteddummyrayspresent$ = 
             False; $CellContext`reporteddummyrayspresent$ = 
             False; {$CellContext`deflectedlocalrays$, \
$CellContext`reportedlocalrays$} = Transpose[
               
               Map[(({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                  Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                  Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                  Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                  3.5999999999999996` + $CellContext`rex$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                  Chop[$CellContext`rx$]; $CellContext`ry$ = 
                  Chop[$CellContext`ry$]; $CellContext`rz$ = 
                  Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                  False; $CellContext`intersections$ = {{-1., 0., 0.}}); 
                If[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`deflectedrayspresent$ = 
                   True; ($CellContext`intersections$ = 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 
                    1. + I 0.; $CellContext`LocSCx$ = 
                    1. + I 0.; $CellContext`LocSCy$ = 1. + I 0.; Re[
                    
                    Select[{{-1. + 0. I, 0. + 0. I, 0. + 
                    0. I}, {(
                    386. $CellContext`xunit$ - (
                    37. $CellContext`rx$) $CellContext`xunit$ - (
                    50. $CellContext`ry$) $CellContext`yunit$ - (
                    50. $CellContext`rz$) $CellContext`zunit$ - 
                    1.4142135623730951` 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`ry$) $CellContext`xunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`yunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`yunit$ - ((
                    50. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + (50. $CellContext`ry$) $CellContext`zunit$^2 - (
                    1.4142135623730951` $CellContext`yunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`rz$) $CellContext`xunit$^2 + (
                    50. $CellContext`rz$) $CellContext`yunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`zunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`zunit$ - ((
                    50. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ - (1.4142135623730951` $CellContext`zunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2)}, {(
                    386. $CellContext`xunit$ - (
                    37. $CellContext`rx$) $CellContext`xunit$ - (
                    50. $CellContext`ry$) $CellContext`yunit$ - (
                    50. $CellContext`rz$) $CellContext`zunit$ + 
                    1.4142135623730951` 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`ry$) $CellContext`xunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`yunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`yunit$ - ((
                    50. $CellContext`rz$) $CellContext`yunit$) \
$CellContext`zunit$ + (50. $CellContext`ry$) $CellContext`zunit$^2 + (
                    1.4142135623730951` $CellContext`yunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2), ((
                    37. $CellContext`rz$) $CellContext`xunit$^2 + (
                    50. $CellContext`rz$) $CellContext`yunit$^2 + (
                    386. $CellContext`xunit$) $CellContext`zunit$ - ((
                    37. $CellContext`rx$) $CellContext`xunit$) \
$CellContext`zunit$ - ((
                    50. $CellContext`ry$) $CellContext`yunit$) \
$CellContext`zunit$ + (1.4142135623730951` $CellContext`zunit$) 
                    Sqrt[74498. $CellContext`xunit$^2 - (
                    925. $CellContext`ry$^2) $CellContext`xunit$^2 - (
                    925. $CellContext`rz$^2) $CellContext`xunit$^2 - ((
                    19300. $CellContext`ry$) $CellContext`xunit$) \
$CellContext`yunit$ + (((
                    1850. $CellContext`rx$) $CellContext`ry$) \
$CellContext`xunit$) $CellContext`yunit$ + (
                    19300. $CellContext`rx$) $CellContext`yunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`yunit$^2 - (
                    1250. $CellContext`rz$^2) $CellContext`yunit$^2 - ((
                    19300. $CellContext`rz$) $CellContext`xunit$) \
$CellContext`zunit$ + (((
                    1850. $CellContext`rx$) $CellContext`rz$) \
$CellContext`xunit$) $CellContext`zunit$ + (((
                    2500. $CellContext`ry$) $CellContext`rz$) \
$CellContext`yunit$) $CellContext`zunit$ + (
                    19300. $CellContext`rx$) $CellContext`zunit$^2 - (
                    925. $CellContext`rx$^2) $CellContext`zunit$^2 - (
                    1250. $CellContext`ry$^2) $CellContext`zunit$^2])/(
                    37. $CellContext`xunit$^2 + 50. $CellContext`yunit$^2 + 
                    50. $CellContext`zunit$^2)}}, ({$CellContext`LocRayL$, \
$CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, 
                    And[Chop[
                    Im[#]] == {0, 0, 0}, N[
                    Chop[
                    Re[$CellContext`LocRayL$]]] >= 0., 
                    Abs[$CellContext`ry$ + $CellContext`LocRayL$ \
$CellContext`yunit$ - $CellContext`LocSCx$] + 
                    Abs[$CellContext`rz$ + $CellContext`LocRayL$ \
$CellContext`zunit$ - $CellContext`LocSCy$] + 
                    Abs[$CellContext`rx$ + $CellContext`LocRayL$ \
$CellContext`xunit$ - (25 ($CellContext`LocSCx$^2 + $CellContext`LocSCy$^2))/(
                    193 (1 + Sqrt[
                    1 - (925 ($CellContext`LocSCx$^2 + \
$CellContext`LocSCy$^2))/74498]))] < 1.*^-7, 
                    Re[$CellContext`LocSCx$]^2 + Re[$CellContext`LocSCy$]^2 <= 
                    39.0625]])& ]]]; 
                   AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 25004.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                   Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                   If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]); 
                  If[$CellContext`intersections$ != {{-1., 0., 
                    0.}}, $CellContext`intersectionspresent$ = 
                    True; ({$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 15., 
                    25004.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 15., 
                    25004.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
-3.5999999999999996` + $CellContext`rxhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}); ($CellContext`reportedrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{
                    1., ((-0.0016083472422043674`) $CellContext`ray2$^3)/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - ((
                    0.0016083472422043674` $CellContext`ray2$) \
$CellContext`ray3$^2)/(Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.2590673575129534 $CellContext`ray2$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), (((-0.0016083472422043674`) $CellContext`ray2$^2) \
$CellContext`ray3$)/(Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.0016083472422043674` $CellContext`ray3$^3)/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) - (0.2590673575129534 $CellContext`ray3$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])}, {((
                    0.0016083472422043674` $CellContext`ray2$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.2590673575129534 $CellContext`ray2$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 1., 
                    0.}, {((
                    0.0016083472422043674` $CellContext`ray3$) \
($CellContext`ray2$^2 + $CellContext`ray3$^2))/(
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)] (1. + Sqrt[
                    1. - 0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)])^2) + (0.2590673575129534 $CellContext`ray3$)/(1. + 
                    Sqrt[1. - 
                    0.012416440709817716` ($CellContext`ray2$^2 + \
$CellContext`ray3$^2)]), 0., 1.}}]; If[
                    Or[
                    Part[$CellContext`surfnorm$, 1] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 2] == {0., 0., 0.}, 
                    Part[$CellContext`surfnorm$, 3] == {0., 0., 
                    0.}], $CellContext`surfnorm$ = 
                    1. Re[{{1., ((-0.0016083472422043674`) (
                    1.*^-6 + $CellContext`ray2$)^3)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - ((
                    0.0016083472422043674` (1.*^-6 + $CellContext`ray2$)) (
                    1.*^-6 + $CellContext`ray3$)^2)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), \
(((-0.0016083472422043674`) (1.*^-6 + $CellContext`ray2$)^2) (
                    1.*^-6 + $CellContext`ray3$))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.0016083472422043674` (1.*^-6 + $CellContext`ray3$)^3)/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) - (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])}, {((
                    0.0016083472422043674` (
                    1.*^-6 + $CellContext`ray2$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray2$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 1., 
                    0.}, {((0.0016083472422043674` (
                    1.*^-6 + $CellContext`ray3$)) ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2))/(
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)] (1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)])^2) + (
                    0.2590673575129534 (1.*^-6 + $CellContext`ray3$))/(1. + 
                    Sqrt[1. - 0.012416440709817716` ((
                    1.*^-6 + $CellContext`ray2$)^2 + (
                    1.*^-6 + $CellContext`ray3$)^2)]), 0., 1.}}]; 1., 
                    1.]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = \
{-3.5999999999999996`, 0, 0}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[
                    1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    1.5392664079785716` - 
                    0.7232199521994117 $CellContext`wavelength$ + 
                    1.0984449372267269` $CellContext`wavelength$^2 - 
                    0.5792106405020717 $CellContext`wavelength$^3]]; \
$CellContext`n12$ = $CellContext`index1$/$CellContext`index2$; \
$CellContext`index$ = $CellContext`index2$; 
                    If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 
                    0., -1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$])); {
                    
                    First[$CellContext`allcreatedrays$], \
$CellContext`completedray$}, $CellContext`reporteddummyrayspresent$ = 
                    True; {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}], $CellContext`reporteddummyrayspresent$ = 
                   True; $CellContext`deflecteddummyrayspresent$ = True; {{1.,
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}, {1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 
                   1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                   1.}}])& , $CellContext`propagatedrays$]]; If[
              
              And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]; If[
              
              And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
               Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
              1., 1.]); (
            If[$CellContext`reportedrayspresent$, $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`propagatedrays$ = \
$CellContext`deflectedlocalrays$); $CellContext`raysreported$ = \
$CellContext`reportedrayspresent$; 1.); 
          If[Length[$CellContext`reportedrays$] > 
            2, $CellContext`reportedrays$ = 
            Drop[$CellContext`reportedrays$, 2], $CellContext`reportedrays$]; 
          Map[{
             Part[#, 1], 
             Part[#, 2], 
             Part[#, 3], 
             Part[#, 4], 
             Part[#, 5], 
             Part[#, 6]}& , $CellContext`reportedrays$]]]); 
     Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{3.434966193111978*^9}]
}, {2}]]
},
WindowSize->{1136, 791},
WindowMargins->{{-86, Automatic}, {Automatic, 9}},
DockedCells->FEPrivate`If[
  FEPrivate`SameQ[FEPrivate`$ProductIDName, "MathematicaPlayer"], 
  FEPrivate`Join[{
    Cell[
     BoxData[
      Cell[
       GraphicsData[
       "CompressedBitmap", 
        "eJy9XGdcVUfevkuzu0mMXcOq9GYHUaqxgImiia6xxI3JakzUmDVl35Rd3Y3G\n\
tWGMigKKgtJFKdIEBCnSpPeuYP0l77vv5/fDPu/MOTPnzrn3XMCy+wHuvXPm\n\
zL/MzPP8/zNzzsqtX+7Ytnvrl598tPV3y/du/XzHJx998btle/aSIvPf6HRm\n\
FjqdzvF3Ovod5Cv79zq6urp0FqjJL8CVgLdREBmFjrY2S6l4GBrrG3DXLxB9\n\
U1xR7uSGFl8v9P4hCPc/24Dqzetx9/JlnblUdwi6OjtRc/0aCnbvQuH8hSgZ\n\
Z4/E2R6ovHJFB1qnSaqoG8tEZv1wAFcn2yF2205Ul5RYSMVj0EmaaXhnI3rt\n\
5qDbdh5aV/ihY0sgHu58F/ffD0LzB2tRH3EOdanXUBUehvxdn6JooRfqZrqg\n\
2NkZ4RNm4Nrqd9DR1KQh1gr11dVIcJmP+OFTcXG2J0pOnkZDTp6ZdPk1dLS0\n\
oH3tGvR6eKJ99gLULnRH88aluPfFOjz+YRMebCLqrHwTrUH+aFm3BJXec1Ax\n\
1xWVs2chxtoBoVT8mnckyc2y5HHSx0SkEIPTx0xHzhgbJJPPDPuZuL37c5Sf\n\
OYvSTRvxyMMd9/180OTlhTabWWj0nod7P6zFo7+9i64vg9C+LQDNy+ehZceb\n\
uOM3D4X+bkhwc8EFa1tcdHDCzc//pDOWOxm1JcVIsnNF7LgZ5M8GuZNtkD7F\n\
FnG2dii2c8Ajl3l44OuDrmV+6Jm7EJ2uLujesxQPwjej99RGdHwVgPKtvijb\n\
5Im8dQuQ/OZ8hNo54tjEKQhxckFVYiKVRAeAbqgk0xz1WVloyMuTfkk6lYs6\n\
TUJnezsy1vweV155A4lenrjztw9R+Y8dKD28A1VHd6Dx+Kdo+mk3Gk/vQePP\n\
n6H+2A7Uh+xCU+xXaLzyNZqiv0bthT+h+swuVIXsRsWpz1B29FNk7lqL07Pc\n\
cPPb71B05Kgl6/TO9jZUXr6MsrBQZG3ciIx31+FufLykWYWs2XjpYwbukN5I\n\
cHFC9YWv0XLtOOpiT6I54RQepIfhXnoo7qWdQ09aKLozLqAn8zy6rv6MrpgT\n\
6CLXOnLC0ZYbjibyvS7pDOriT6E+6Wc0p55B7pcf44qdCzI/24NyokoF/YuM\n\
ROm5c7i+aTMSg1YjiYzjHNL7N4mKTQUFsucqRf2mo/BYMOICvdF49SDuRoai\n\
6kokHqXFoic9Gv9Tm4P/vZuDXwpS8aggE48L0/E0NRq/3IjF45QYPEyLQV9q\n\
HNqT49ARHYXW6EuoDif6XoxEB9ElzM0JP063RrCDA445u+D8HDKo3ecgztEN\n\
d2Z6oHiBD7K3f4z2+gZ5jFmi7Xoaqp28UPWKE2qDNtPfuilsEJSUlMgDg/yy\n\
ZbM+PT0dO3fuxKFDh9DU1BQnG/dbdgfFEH6HBTO4vaUNiWtWI2bFItTH/0i6\n\
/zz6rkbh18IUXPD2QUpgINrSI/HfjbfQV5COB7eS8bQkGU+yY9GXRJyTeAkP\n\
oyPQfekCus6fx/1LEWg5F4rG6Gh03UjFEY+ZODxrOoJdZyDM1RHZZOaXvumP\n\
Wl9/5Hr6ko77ihrcwgzurKpBtftyVL0xVzKaGE/mmKx+VVUVQkJCpF92zAjq\n\
hKSkJHzzzTeIiIhQGWyPouPByP7wQ+LV7bi5+zMUHDqM6tQbqLmZjcJPtiOf\n\
zO3Ut33QEH8ID1Iv4nFmNJ7WZCFpkS/KdVNxY6oTcvfuQHvBVTypysYjYvjD\n\
vDj0plwmxl9CLzG+mxjfdvE8miLPE8Q8i7b4WPRmpyF5mRcKAhehaeUStPkv\n\
Q4tPACr8/ZHu64fbB3/UdTAL2vNvS5bSv5afQydpGOvAyqKJT6mh9FesbOlw\n\
6YOgRHExqiMvoik8FDWXo1AWHYOiyMso3LUL9TNno+e1aeh+dTo6Rk1Du4Mj\n\
Hs52wWMbZ9x6yxfV8QfJ3LuIexlX0Hc3HXE+/qgYZoe60Y64pZuGRJc5uPXj\n\
t+gpT8XDoiT0pEaiKzECnVcvoi0uAjWXwlAWegZ3z51CdxLpgps3UP7OW2hd\n\
uxId5LN7QxDqli1BhvtC3NhMBnFtbSezqHbxasnw+s0f6/qznHYzHdfkU225\n\
M+orK1BEgOfmO2tw18EFZeOnI3aMNWImzUC+rT0yJ1ijdsQ03H/dBl0uzujw\n\
no97s2Yhd7U/yqL+RmZrODozL6O7PAXRZFAWjLRDyXgXlE5wQcloOySPJu35\n\
LUbJmYPouBmD1oTzaIy/QJDhPMounEXhz8G4cyqYTJJEtN1MQ+XH63Hvuy3o\n\
3bGGUN1S5Ph6I3PzFjrIdSNZn7dExip9Tka6NBfN6S9iKr3GJ6kZI386K+o/\n\
+UKBAvpJf5NyOUAwYzc3/nmfcDMtsxDL6Hep2IIhNx18FFeYIlKjpEyqY6Zv\n\
WLsRM9Y59BqzhgYq/CYr0RSlEulpQeMRSh1uIp/4VCuqnQQGdGpExrJYyBJN\n\
B47pXUGuD2StOYu3KJoS+Wo3kt+0nNXX6W8w7dMRStlgtDbjLEnqir6mVihi\n\
xqgUp39UKVpdNJTWGYxIq/575tn0N+dzlelOIdlSGJi0LV5f8KjOzJQTh2hM\n\
dF5GJzklMT1FmSukxkhMcia9l5IcLad/+/fvR15enplw+cSJE9i7d690mdED\n\
n0+CFOmPVqdlBGDlGEtShAij99N2SGWmjqWoDhVJRRNbaf0RkkoCL0t1uQ6U\n\
pmgZE85MGa5ShlMZa1c0jScC4iVelX6SW9lQG2MkloQCkqfpb24SvY/+ptcE\n\
taRrvB5xmeJxLZ8Rc82Yp5iWzEfGnclHERXHVFOaph4TO5N5kVus5UQmnTl+\n\
uCh+YCcOINFSIVruYzouzPsZO1Q7qs1vZGoaybirjdhaRsL3uzt3o89+Fvps\n\
HVBs44R8e0LYc2aidZoTup3d0L7AE91LfJHzfgAKL+xDfUIYCXIvobUoAeE+\n\
vrj2ig0yJjojfaIT+XNG9gRnXBs9A6Ek5bgctBJFIUdRGUeC3UuhKDp9AkUn\n\
jqAq9hwab6WiKTcNjfu24NefPsDDr9ag+i1/pHh5k1g9bBSzVkAJ6Y+yipkQ\n\
gIrXKERyLymxGrtGyFyBYVpOrzMvPS8/cfCj+ERjBRYa/hv4SUAwFfrzOjRC\n\
Ya1SOy0UyGQwyZFHdBjVnvHTwHoOp9GfGBXoDZb9bkxppr2qLxus3gozyR3J\n\
79fSm+hpzoolFVkwQiT1J2gAThq8xuZitMSpW4yWDMak6MPnJyUGPAop0d+c\n\
lMyEeykUyIxAAXm4BKcUTqgcjn0MUqQ26CepLzITxziOZQygWPY/VPpNVaTX\n\
6B9HbPpJRPCpK2goARa5hWk1QoJDqgkHf6oRxUB6D+cvpgqb7q+rVONt0za4\n\
JVwNfj+3lrdL6wkwLqs5wkg0tUxsll7jhCF6ifOY2DTlKz6gDdmCdYwZs0no\n\
FxVf8X7mfEXrMJYw6meZgOT2uJrkmqKmoWnG4+O3qvExGK8ayx4hypbqcJ2J\n\
O6Q26CcPb7QGGu0pOiKovuQ7pzE5i34VzbeL0BJ8GD1LFqDD0RVtnvNQu9wT\n\
rcsX4t6cBehd6I+M9QHIC/8rymLOoTwuDLW5cQj28kLwb61xdoIdcVDIeDvS\n\
FvmOc+NscWzkFPwwxQYRmzYi/9wJZAUfQd7pI6hICkfd7RTUF6Si9fAf8Hjf\n\
WnRt8MXtxZ64/hbJKe9W6ThviZClDrblFEG8RkGFk7/Idxw/yOdg0HQg3jJn\n\
GCGygNR0lyqEpg28KH2Zi6mTThsPaZmlUo/jqIKDTLARG6iLpXxwkLpyEYq7\n\
zejtMmiKjQ5AX5ZK2WB15srR5IMrpxQPUeksZn9UOd4sDVcEcSakDUBjz645\n\
7SCR+FVBlnALaU7fE+o+eflMRu/jaMDRkaIIL7MSqEikK4pEPHAm9bTEchE0\n\
OmcYrpSJqvAQkIKTGHOztsxNNm2lyVTKLVYS1DHHKMkccRZXghfpEyorIzsZ\n\
QvMWeSrBLzPG5hkepyfxMm9N8PRwkyZZKGTK8hnDftIzlpX0m5snSOuvawUn\n\
KdG96CV2j5ICiyKYK3SDMZan5Iq3CSPQj1fQlZZMUqCluBfoge7VnmjbGoC2\n\
zcvRt8IPmZsCkBX6FxRdOIHiiJ9x90YUDnoswBejJuH7sdb4dpy1Bb4ba60b\n\
je/HTcO3r07FnpHj8a29E85/+AHuXAtFRUo4akuuozbnGlqPbMWv/3gPbR8u\n\
R46fN64HBY1mdolrLeq5q8+SlETBfbl+aYQtY9J4VavM5Fx9Vi4hGMX7UQCN\n\
F+aSIQpHcN7knjCImY3JhKihRlBDeFMLNR9IU3lMqiCR8psW7D4ziQykq5Ze\n\
GiLkOINxMNFTL1ZNgv2Ie2YWGdDNlhL1Me41GqB80JI8TTvpelnEwRbamEpy\n\
GUUSXqZFHCLCs08tsRzfuFhxuYf85puRfF2LX35OviBKcSTkxCdcVtjJkBgM\n\
wJaCnaE0MS8zUnCYshZpkIZJ35l3Schvmik4/jIxWh3DPSkapqG8Vl8K7tFp\n\
+YdraGFwjW/g0PRoIEvpPdQCutkj19W9Jn2MRmfJHbRvXo0ev3l4sJPQw963\n\
cG/zYmSu8kM+ST+qI0+iJjUCDfmJOLxwEb7/7RQcnGBjhQPjZ5DbD0yYQb/h\n\
LyMnY/9rUxAVFIjCmJ/QWpmGBpJxdJzZjn+e3YJ7nyxH0VJvJK8gGUd19Ujm\n\
L3Hi8ZlLQnolumeIr7WNYGkIKvpaz0UOygIZm9hsc5jj00tZIBsiLn6pjKbQ\n\
IrSuX0mT9hIYSRLIUmlgsBtk6CETdGCUOkj52zNnFFb65SWTKhruvQ2KDJRu\n\
JGXCgqcyHQcrzqL/vhiM/uoFTc4cQmar1k8u42t9cs7B855/Fz0IS1dyDXZm\n\
gU9/cs2SLZzxxQwR/zhDUMagMTeJJ01rYCmBCA9TOXDzqIqCjrBwZqbRjOky\n\
SyPKIKIUsSLAPxNfDFEWv6ihfG2ONyGqw3daZGuGaiVIok8tmMOFfQum0TAj\n\
jXimwRegDEWbomMTJNJfjzPHafmNZyMWTFchQ9GT/RAjW3kipt+v042RPkah\n\
PS8XPR8EonfLInR84I/eA79Hzq41KA77K5riQtCaEYn2kiSEePng/KszED3J\n\
mVh3ZZIT4Y3L4+wRM8EeN+Z5IHvbJqT94yuSUpxFT1ky2ooz0Hl2G/73/Cb0\n\
bVuM5rWLkOnvixub3ue8oWz3kynJo3kyfXlAwGNt6RKP91Qh6b+HPcylrV6G\n\
7UTGS6CMYUb5gbibTL/rVbMUF7DkBt+YK6vx3GxhLtICUUyTQQadNxjr9WIU\n\
wYOogdrV4gIzllzS7mJ1dZojxLhxfacoWRXpHPqbRywk65MbG9rvkHphBhii\n\
h2BlUd2S7eCK01hcL6BTWgCL/vCeVqXJhjFqWijb3/R6v+nAfwTvuXge6spu\n\
EcJ1Y5C3MgI79l1yqpUJNBdXY14UzcXe688Hg8JuQzfLTQvrVjz0l89Qj0Tb\n\
yQPoWOeD1t0B6Pz7OuR88S7KzpPAJeoMWpIi0HnrKs57+yJ1tC1uTnSxoLvk\n\
JG/IHueEm2McUOQwGyXvrcb1b/YgNy4MrWWp6CxKRM+da+i4lYLOM9vwz6Or\n\
8fTL5bi/KxAVfp5I9fJGyYlgtNXVDWe2KGE/mTnKLBmqTDyeHYiTSx1TvWwo\n\
5/OBkged5lqtvQCUC3SlglF2eEm/DmJ0ak1mF1quXy95sSRA2NPhqae4Oq7y\n\
5aD3x/tX+MXwfugg29XCewtWj4b7z6f7MKOsjCaJYieS38r9Rgt+oj6ESp6b\n\
FHjwZ8YwgWf7DA04EvI9cRF0k9hBni62sECXmS0YHGgs8UjfeehKv/MFBlLP\n\
StBITRvDFGoQtJK+85Ukqrc2aA2eL/Sc8FzrSZZMYeo8qhbb0TWtwTDReCMn\n\
qc80mYuO1vGHUwxX6ETHGjLJcy4u9dff/Tlt8ItMQzUXmXjeR7IECzXJtCQl\n\
ot1vPmrXLULVzmXI/Gw1qqP+jtZLZ9ARcwFdOQmI9vZD8XBbVI51MUP5WGfd\n\
WJSPcUL5aAfUTnVF3YplKNj3Oa6dOILrR4+iMTMeHXnX0Z6VgJ7CNHTfJkD9\n\
zSo8/moper9+G73v+aNz+QIUeXgg2X0hUtf9Hm01NaQHZD/yPWMOBIxWzNhB\n\
T4GM+luTeqk7Ewbr3nxumdyREDdlhTb4coSCl0bsww3itnM2YkDWD5g++2aE\n\
ppLyZoR4RF852SqsuAv+V1RiuY5KzYGwvD/VX3BvYoh201asA8WN6S4Wy/Dz\n\
XMRQbgyvQg21YlPGoEWpnkAmXCtOJLwfhN0KBUYUnjIcmDz66JdvLFk6YbDi\n\
QwFQta/NMgSlF8Ukg2908iVqccFJBFFODXSJur/lcmO6GWqSbpgsLaYScZ6q\n\
qy/T3rwgTYnbuOyWZ0tOrBSj+R/LJURlmN8U0uEnjwz9xX1LTz5xGBL8zvyl\n\
pk0mzuS+Cesrbswgtr3VPW9llF7247rB74APM7kDLuxvqZMbW7RejUPzGg9U\n\
rfVA4TYfpG0PQP2VA7gXE477KdHou5WMBC9/VFnZom6MM2pfc0bNKEc0jnVC\n\
+yJvlP/pj8i5eAolaQmoTUnArdNn0Jgehwfl6biffx0PirPIZxZq3vVF45rZ\n\
qF+zCK1LPdH5thda3d1RMmse0twXIHnVapT89BPJeGrZRNMvT7GQn89SM4YC\n\
bBLL85wxALmF+1hElpd82Iqu77DnKIStD6mq/gizSbqzUJbjpHPMVGMZ7Lgx\n\
wmEAMS+ScxjhAQnDbV+92paqdIc9W2EcXXMmMs1OVoa6qr08XMw1Ffzm+vB+\n\
E5iXmygSFpcgrwUx9fUMMrD6/TKUiSNY8ilxZZGG8wyTZTJDNVobkyelyNPq\n\
BFWddatNsTRiP5njZcOMD9QN1y+nCeu6PJgRqE9qnh/MozJpffEww+DW0V7n\n\
iy3KfgZlH+EcqHSdswoP94WzptJ1DkrKXoeFIophm7gmpU4GtNMmftbLkMeE\n\
c78s6ZssSeePagpJoSoq56dleZKhRWz9nYxVs5t+b0BDLtGLMreVqj3uIVKH\n\
wYQcT5g+ZDxcpWM/PWJlQG9CPqUcyDWkN+ODvlNVB31NuXOggTEYV76cQ8Ym\n\
YxMzkfzs0fTdf6FixUJUvk+I7CMv3PjjcjTG/oju2Ag8TIrGo4I0xC7yR9kw\n\
W2lqVb7qgEa3+aj5aAOyju5DXkwk2gtvoqsgk2Rb13En6hKqoy/iaWkKHhVd\n\
wy+VWei7Tchvy2K0LHZEzVw71Ds5onnOTNTYz0KZ/UxUuM5CgcscZM5dgIx3\n\
1qE05Bxd9lMGk1aUy7cZzKQg1kIFwArFWSjIwB6X4YDEIdsIB0UapFyrf6xm\n\
hIQu9EaKSsJmvP75PZaJ6NMAS+UZDQEZjaNrPZRWKdvChmUiL1uKDYiJH0cR\n\
Ht/LB5eM0zS2BCk4REzAmM68lvwcSJeQgUhPzdL7RqmQXdxCo2YZEI0R6Rmb\n\
bqXqGAHd9S4TtNanjZRvyJ28mHeU6iFPSy1dlRBHkktkNQpP3giizEUHKcBs\n\
goWFA2RCyqZpgt7xPP2iShmuFdCDYxyphAdBVQ9+GoxgC5UnhUNvg6O9Ecpy\n\
EH/Ckcfb4sN77KSTsuokPhfK6VJ5JkZPeaw5biVP5+jCkWnKs1QoqkufrilY\n\
ZyiZPdghydS9KsElP+hGxXHI5Uwn7onzOgYPLyqhl/EDsfpnLeU1UipzqMKk\n\
4uOMRk6x4qht+OQnT2cMs0Qt9w8xIDjOlfSYmNbhbrlsqKnnMLnWsiFDFEO0\n\
RBvyp5bjXtJjn4YbazyZY8/LyCcNSAhZV4eyNxej1MMVhW8tQFaQJ5I3LENz\n\
zI/ouRiOBwnReJCXivOLfJE8bBqK7WajfN1KZO/7AukhJ1EaFYmq6MuoSYhF\n\
S1Yy2nJSUHM1FnejIvAgNwGPcuLwtPgG+vIz0LDBB/eXu6LehSSGdjaod7BF\n\
82RbVEyyQamrGyrtZ6PKbhaq7d1QOs8DBe9tQNXFS2i5U6ocJNa/jEAZzLyM\n\
zmA+i9UrUcNVuY3yHLjwbAXLw4x2Ylh7bIfDUrXQx7hNJ0I+b1tBVxm29QG+\n\
0r78XLv4dgAKbfR+ylAGZepzsMpSXtBmZUrx/SblgUQDoxnki+8q4UZLSlnp\n\
UVlwsJyGSRCrXg+UPS899s9xk76RQdZWvjxKlaqILxSgsqmRbOFOLFPWJfrR\n\
VyFGy37oQ25ntHJqRHkxDWmTZ4r9yOgvczM8WalECEScyJkDmSAchzRMqeVw\n\
QnayidceqNJYZViSOs9AXpM0ykZqlBlSD4UyrXr8oRARPV/pp55YprWUOEpg\n\
Qo7SypMsajFap4yHadSboFHPUoREGzR8/SXq7VyQP8cNqY6uuOLoiMQgXzRJ\n\
kBiGThLCNyXF44z7QiTOd0f2lzuQevxHlMVeQsO1GNy9chEl4aG4FXIGBaHn\n\
UBUfhcrYSOSFnEZT3AV0JFzAg5vX0JtzA+UrfdC1wh21bs4onjsXOb5+KPhw\n\
K/I/+QS1sXGoS0gwI//iafCWEIeGK1GoiyF9fSvPcL1BOUEvQZVhSESnxEhD\n\
cNNPZ+MyW7GyuN/KW+azQIl8DWLm4Qb6GQR9amkOpi5M0WhFayWErXxomsLf\n\
y/OyZgP3PCVo/oTsqP/wbBCeif43zQb5FPs0NPz9B9yd7YYMG2fETLFH9BRb\n\
RFhPR0ygN2ou/4Dms6dQeuY0Ss+F4HLQKqTu/wqlVyPQU3gNDxty8KgxG/cq\n\
MqQtxYbkaJRGnEXWiWCkBx9D5vGjKDx1gpD8WbQnx6Iz+waKlvqh3HsBchcv\n\
RvE/DqNGwBpOIHris1A9QE++Kymd/hjBwANf5DZbZQ4ZbYzJ3hEFslBDUfBZ\n\
B/uAW2S0/jiN8c5eFaBPgdlpieedA+qDD+rDt2NNzgvTj/fT8alE7ebiNpJ8\n\
AMmMajKUGcYb6RIWxl5VammNZZPTg5/N4kG4OF+NJojUvNYs7WdavMKnRckd\n\
1Gz8AKWT7XBhvDWiRlsj6XVrXJxqjeOTpiLUyx0VFw8g79BhFJ84jrLTJ1AR\n\
eRbNuYnoupOMrspUdNO/0mvoKExAc2o0WjJi0JEZibroEOTTHfkfDiCN3F94\n\
7jQZiTfRW1mOHB935HrMR9GhQ7rRTE1jeLZQ4qp+AgxhWqjHobK/IPMHS7kJ\n\
M3bpl4ipTO5gowNOGjOD0oUUEPGp298old59ReYkXf0xWXmcJjXoY259aDaA\n\
NBObs+biiRDTk8BcqMyWMZUzUuKwf62fwf7GMzGAuZJS0oxV68VT459tTI/i\n\
3Utf25qahtwDB5FCAp9cW1dcc/NAQsAKxHstQca6DYheHoATTi649MpUZP/5\n\
MzQmE5i/W44nLXV42tmEJ/da8eRhF3552oOnT3rwS18rnt5rwqP2Rjxqq8fj\n\
DvLXXI0HtZXouVuBltIy3G9twf/961+4G3wcqU6OSPX2RsWlS076jjNejJKP\n\
g+kHKe+nN031tpt8QZ4jYqDyu2cZHzaCF/nbotw0emCqRj2rQd47QaOeqqeG\n\
oKO5GfE+/ri+4i0Uf/8d6pKT0VxdRd+lyuBuMhrKypCwJABXRk/EERsbJHz8\n\
ARpOHkbDmWA0Rp5B+/UIdKZfQXtqJNpToqQXZ7ZdD0PrpZNoDP0JjeeOounM\n\
ETSePk6+n0B18FFU0deLbf8Y52bYI9baBlc9F6Ei4qLuXxquqhdVJgDQ0YFK\n\
gsqdbS3ME5NRmZmNrAM/4vzqVdhnPQln585AwxIP1G5Ygo796/H44Ab8emkn\n\
fo3fi18jtuOXxI/x5ML76Nu2EJ1B89H6tita/BzQ4D8bjW/OQelcV2SSaD2e\n\
qBZubY/wqfTVti4oOXlSpSI/lsBUlB0+EVFrVuPg5InI8ZyJJq+FaN+6Ck8O\n\
bcWjr9bi0Q8b8OSv6/Fr8Cb8+vN6PNm/Cvd3+aNniTP6Ns1Hd+As1Pi5o2nh\n\
bNR7zcGdma7Id3BBPAmbTr9hh8iJ1kjfuEl+j2ujLHc8c0NLYxNO+vri9NiJ\n\
qJ/ngdZ3AtC7YzUe7X4XT/+yDj3bA/FgbxAefuiPp38OwMPvV6FrTyBal7ig\n\
eb4tOjwI+vl5osp1Nmrf9Ea5+zyUOrqg2G0mkmc4Iub16UhYtkIaHZL8BrX8\n\
0sREhFlPQ661A5rm+aJv3Sr0blmBe+8Hou2PK1AX6IvG1f5oD3THw93L8ODL\n\
lehY44023zlodLVDtb0NKny8Ubr/b6iOikL+F18gY81a3CI+vOPiipRJ9gh+\n\
dSpu7tuvIf81lF2OQuIMG1QtWoCuZUtx390HTUErUbxlE25/81+4c/wYcrZs\n\
Rr6fNxoCFuH+uoXofs8X7QtmoWmWI8odnVEVdo6vfrXV1aI8LAx5dP7MIvA1\n\
wQah8xfRlxDL4utF8UMQt349MkhX9Xj7oG91AFo/24P65CTpJcb8rEhrZSVu\n\
/P495BCTmgM9cW+VLzrmzkKbvT1uvb0C9dnZyrkQOjlLyAhLXuiDmOmOyP7+\n\
Lyq54xgaNNzKkyZxrfN84soVaE9PQ2dTkyWLkqjI9I0bUTh7DprnupOU1A31\n\
r0yTUkOiGj8kVUOmftZH2xDn6UVazJcE1YmCLJCz53NkzpqHSp/laLqZO5TJ\n\
r8vIkN6uVjV/NmocnFE+wwnlISHD2F3UjOxPd+Hm13+WJi8trpUb5u/tll7d\n\
/PZbyF+8FLW3bg1nDig+egy5JDFutnFAddC70glBHsXVEn7pbGuTfklN1ohN\n\
mqP01ClkBAag/k4Zu8eCdFwuUhb5osHaEWXvvS/d1i3f9joPQAh1pW7YiKqU\n\
FOXFpbQs65NPUUJorGj7DvE2Lq2zpUWBex6pVF9PRtrcBfRdvDrxHg79tF+S\n\
V7yN1PXrVddt2fXMP27D9VVr9BbKzet0v/l/ed5zfg=="], ImageSize -> {516, 41}, 
       ImageMargins -> {{0, 0}, {0, 0}}, ImageRegion -> {{0, 1}, {0, 1}}]], 
     "DockedCell", Background -> GrayLevel[0.866682], 
     CellFrame -> {{0, 0}, {0, 4}}, CellFrameColor -> 
     RGBColor[0.690074, 0.12871, 0.194598], CellMargins -> {{0, 0}, {-3, 0}}, 
     CellFrameMargins -> 0], 
    Cell[
     BoxData[
      GridBox[{{
         Cell[
          GraphicsData[
          "CompressedBitmap", 
           "eJzVV0tIVFEYvs4dx9FkFtZCAh+LyhLMDDNNXJio+UILKqOVqOHbUtEEH5BR\n\
ahmC2MuQHhNFJpJIUFRChK4qNwWuWrSsdfjI/s5/zn/unHvnTpoMRBfunfP4\n\
H9/3/+f850xJRVtNdWNFW21lRXx+S8XZmtrK1vi85hY2pIdomjbP3th4DdvA\n\
mvSZh56eHja5/k8W/9HB6/XC7Owsvto5/hVjbJZLbDWLo+hSezS+TBy/Yux/\n\
E9f5NxJWZmoAHxzHZ/l+AW+vvD5v7gs5B3ac2NLchg7OYXvt+2f4uTgl9bis\n\
FgGrC3f4lDSDbXzWvr71M625TBbx/fXjG6rIaRWwAkAnVoq24CjAhv+RIP1q\n\
DlKTiFHTwb9ibKk3Bo0LN+y7fCsT6CG5UAOfZIjyWzaTG5d/bibKEYLw5BRd\n\
a/wiueTq3CAHh68pS/07DdKYKUbKgYMsSxhmjIl0im1uws6L05QlnmuBCR34\n\
SZuzYjcmGLsDYjcx13mX4GsCf7iBX8UuVQkNk2Wj6IzlkVzRmBJsxsCIwUxN\n\
RJC2FaHAFWEQ2kicXAYhjAs3ycAzdaeMxXAyX6vMMsafqXgC7RHeRjMoz+NF\n\
Y5vKlp1cqB1ZDLHE6+Z4/ZajL0e6ylqpAhaImH2qKWJvBydFGBSjINikSG58\n\
dE96tPEjjDG5uHABYt5k6aMFt5EcybXM65BdlQzzi49EzbyJZSCgelSo9hTt\n\
4Qp1p9W9bo2Cb2tR6ZSrNHiJQQhqEG33TpSMr6gdbJHZ1j1S5cUDNwIWaEZa\n\
nl6sv15+jLpCtZHL+GqGQ6lkan4kCUIhuEYHBB2Isx1w7kqteCy7NrtJdRPs\n\
3aSr4aIdkWCAlgTQu1wfvLpTVmyzphBSzhm+fLk+ydodV4H8oCwdEbhee2NY\n\
miU2tfxLvwYuSjO2KVS6Uu4s8Im+x49+IAoWug5+ZfCYFp9SP6w5DMqBFeq/\n\
6VgdUWs/lQy6+viOS/mYyoZLVB1WWWRBpEucTrcHyzVQnA2hKg15mTQOFlzx\n\
SsHhQXKSN3nx5BH27QKlZDtNu0m5TkpuFqAmVUnGvwYK16Yrn+j/5Y3vn/01\n\
iCfx8YIi6G9q4r3tmzNxLy8fBmtrTSY2+OcqjsQvtrfDo+wcGCsp1R6qU064\n\
0tAAk4eywJuTC30dHV7z7EBjIzxOTYfpjCwYqK/3kL2e7m7D1YjQiOE/Lj41\n\
erIchhjiuwl74d3+DBg/eiySNK8yg7dPnYberi5tVGjGkuaD3HzwVp+BqT1J\n\
8CElDV4UF8JwVWUEaV5jmpOHc2Gkqkq7rmqGwQSj9jEtHV4lJ8JcUip8Kj0C\n\
02VlcKGzk50YgslQfT08O5AJT7Ky0TlZ2EbGL7e2wmBTs+TAvm641NcHLwtL\n\
YDFqBzzdvQvepxyEL8VFsFBUDDfr6sIUw2/2ZcDzuEQYO37ihjCshfwGPGMf\nPw=="], 
          Evaluatable -> False, ImageSize -> {199, 30}, 
          ImageMargins -> {{0, 0}, {0, 0}}, ImageRegion -> {{0, 1}, {0, 1}}], 
         
         ButtonBox[
          Cell[
           GraphicsData[
           "CompressedBitmap", 
            "eJylVb1uAjEMDuSAUqTr1J234A3aqQ9xQpVgqFpRZkZWNkZWRkZmRkZmVkZ2\n\
xtSfY0e+9MrSSLkY27E//4W3aj55/6jm03E1fJ1VX5Pp+Hv48jkjlm8550a0\n\
y6EDHYiUzygsFgsS1o42Hw9hs9mE6/UasHCu12tI+KTVYbUy7Ha7pIZ1uVys\n\
GtPL5ZJpmLzdbrgTvXgrol+0XBHO5zOr4irtyO7zTWHx3u/3CRTo1Wol4FMM\n\
WBBB5Xg8MlDQsE6rYLUnjkFVIdputwm7qCYvigLmCCi5AvSSZapnbUFPY89l\n\
hN4zhE44HA4J3el0EtMcjHusAUHG8gTX4ikZIwxqpmwM1gwcqh7xC8k//CtU\n\
YrcFIthaXS1Z7IJuKiMyqcBI3pIIvHUtcRU5rDYLe4zKZgvVkLS4qJObw3eA\n\
+qeIkQG9Z20obm0/U2lpP5/CB09jRxW18mhPyoO7F9xzY87zNrTIgF56ovEO\n\
PGri8BsoRSeyB7U2w7ZtbNsOg1JIYCioBixtczewwZ+BWW9IEcrVES8NerUu\n\
gGcZqMju/womz5vtPnWNHOqMUkf+v0AohmIDDT19T/I7pBc90Rd3ZBycrY5W\n\
AEOn49JUHW+qowMKm6STXgVvX4GUTfsqEB1no8uXbTZBk3EdJ9RLbsgY9FJj\n\
6kaXyMMRvelzjWRpIInt01MRX+KGPxo5XOsHSMiAwg=="], Evaluatable -> False, 
           ImageSize -> {55, 14}, ImageMargins -> {{0, 0}, {0, 0}}, 
           ImageRegion -> {{0, 1}, {0, 1}}], ButtonData -> {
            URL["http://store.wolfram.com/view/app/playerpro/"], None}, 
          ButtonNote -> "http://store.wolfram.com/view/app/playerpro/"], 
         Cell[
          GraphicsData[
          "CompressedBitmap", 
           "eJzzTSzJSM1NLMlMTlRwL0osyMhMLlZwyy8CCjEzMjAwMAExnwIDiP0fyIQS\n\
jP9bWloY/8+ZPZuBgfF/V2cn4//VK1cOFnZ7ezvj/+XLlgFdyggAJaVbgQ==\n"], Evaluatable -> 
          False, ImageSize -> {2, 14}, ImageMargins -> {{0, 0}, {0, 0}}, 
          ImageRegion -> {{0, 1}, {0, 1}}], 
         ButtonBox[
          Cell[
           GraphicsData[
           "CompressedBitmap", 
            "eJyVVj1vIjEQ9bIBRKKjyClFOn5NUvEjUBQpKU6JctSUtHSUtJSU1JSU1LSU\n\
9JTOPHued0x2SWJpWXvGOx/Pb8YMR+OX53+j8evTaPD4MXp/eX36P3h4+xBR\n\
WTjnhvL0Bw5zL1P9GfrJZCLK7NUKr9LP53OPgVWQlVi5O386nbC0G/x0Og3z\n\
xWKRybHGgN7KMYcdjPV67TrBzZXfbreeQ+aMBQOfYMWty+UybZV5S5XH4zGJ\n\
xTK9xeB7/nA4BBEfbFHLYT6bzVyRA8EcEhDuPllnvjZXmiJOVs78VqtVJocN\n\
yJgUwrgKvnrBFrISWXhgd7PZhO8Uc9dVUBQM2onhdlOocKHm6V5SgoFekFlk\n\
4AJuMd/tdn6/33+PTJlYUMn6GQtgktFbBJAVdOKG8lJNGnIlULCVx3seLfd2\n\
lBLWjdFH8+2MuwSlc6YDcMpfAQHGm0GIVCsDaJplxMVdJ5D5EWuCbz03Zg4T\n\
yErC0My7aRuzIWUS/PJLgKtDaEShpZlCDVcEsYq6zlysVDJczqxAZV1ixt+s\n\
Zs5xYG2wPCmHZzACMuiwjqSNfqDT2pAcILu5BFAWQwVqvwmcVMsYOAzwwcTX\n\
UpgotgAhXFJAgCoQ+29L5zYLzCZCOZIHORko25/dI+B0GsqGn3wtm95FTBRH\n\
V9ak09Zf08vYD6V2gLoTNrDrEV3Lip8wxXRXASvylMcANlBmbqrY6kgTUAlG\n\
2FYtNGcBpK7zHSQSmCMnTNCNPZaUZgMEpNpj1YJekikdFkidTNLUkm2nAmBj\n\
QfcutYNgv82ClxIquO4ilghrG1vF0z/Z5U40eDEiFl72X2PN7cWLzNX+M3HF\nJ/Rd8Mk="], 
           Evaluatable -> False, ImageSize -> {77, 14}, 
           ImageMargins -> {{0, 0}, {0, 0}}, ImageRegion -> {{0, 1}, {0, 1}}],
           ButtonData -> {
            URL[
            "http://www.wolfram.com/solutions/interactivedeployment/\
licensingterms.html"], None}, ButtonNote -> 
          "http://www.wolfram.com/solutions/interactivedeployment/\
licensingterms.html"]}}, ColumnsEqual -> False, 
       GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}]], 
     "DockedCell", Background -> GrayLevel[0.494118], 
     CellFrame -> {{0, 0}, {4, 0}}, CellFrameColor -> 
     RGBColor[0.690074, 0.12871, 0.194598], CellMargins -> 0, 
     CellFrameMargins -> {{0, 0}, {0, -1}}, 
     ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
          NotebookLocate[#2]}]& ), Appearance -> None, ButtonFrame -> None, 
       Evaluator -> None, Method -> "Queued"}]}, 
   FEPrivate`If[
    FEPrivate`SameQ[
     FrontEnd`CurrentValue[
      FrontEnd`EvaluationNotebook[], ScreenStyleEnvironment], "SlideShow"], {
    Inherited}, {}]], Inherited],
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (May 21, 2008)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[568, 21, 1911, 52, 88, "Input"],
Cell[CellGroupData[{
Cell[2504, 77, 575435, 8801, 70, "Input"],
Cell[577942, 8880, 1205114, 19890, 634, "Output"]
}, {2}]]
}
]
*)

(* End of internal cache information *)
(* NotebookSignature ix0Z9iuDXUf44CwiExprxfBo *)
